package de.bsvrz.buv.plugin.anlagendarstellung.dobj.editparts;

import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.XYLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.impl.EAttributeImpl;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.commands.CommandStack;
import org.eclipse.gef.editparts.AbstractGraphicalEditPart;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.editpolicies.ResizableEditPolicy;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.RGB;

import de.bsvrz.buv.plugin.anlagendarstellung.AnlagendarstellungPackage;
import de.bsvrz.buv.plugin.anlagendarstellung.DetektorModelTypAbstract;
import de.bsvrz.buv.plugin.anlagendarstellung.DoModelMitVerbLinie;
import de.bsvrz.buv.plugin.anlagendarstellung.FahrStreifenModel;
import de.bsvrz.buv.plugin.anlagendarstellung.PickerVertical;
import de.bsvrz.buv.plugin.anlagendarstellung.figures.FigurePickerVertical;
import de.bsvrz.buv.plugin.anlagendarstellung.model.KilometrierungZuordnung;
import de.bsvrz.buv.plugin.dobj.internal.DarstellungExtensionPoint;
import de.bsvrz.buv.plugin.dobj.model.ConfiguratedDoTyp;
import de.bsvrz.buv.plugin.dobj.model.DoModel;

public class EditPartPickerVertical extends DoMitVerbLinieEditPart
{

	/**
	 * Initialie Hhe
	 */
	public static final int INIT_BREITE = 25;

	/**
	 * Initiale Breite
	 */
	public static final int INIT_HOEHE = 150;
	
	@Override
	public void activate()
	{
	  // TODO Auto-generated method stub
	  
//	  System.out.println("EditPartPickerVertical.activate(): " + getModel().getName());
	  
	  super.activate();
	}
	
	
	@Override
	public void deactivate()
	{
	  // TODO Auto-generated method stub
	  super.deactivate();
	}

	@Override
	protected IFigure createFigure()
	{
		FigurePickerVertical figurePickerVertical = new FigurePickerVertical();
		// getLayer(CONNECTION_LAYER).add(figurePickerVertical.getLinie());

		
		
		
		PickerVertical castedModel = getCastedModel();
		if (castedModel != null)
		{

			/*
			 * Breite und Hhe bernehmen.
			 */
			int breite = castedModel.getBreite();
			int hoehe = castedModel.getHoehe();
			int distanz = castedModel.getDistanz();
			int yPosPickerTop = castedModel.getYPosPickerTop();
			
//			System.out.println("EditPartPickerVertical.createFigure(): " + breite + " " + hoehe + " "  + distanz + " "  + yPosPickerTop);
			

			/*
			 * Bei Bedarf die initiale Breite setzen.
			 */
			if (breite == 0)
			{
				breite = INIT_BREITE;
				castedModel.setBreite(breite);
			}

			/*
			 * Bei Bedarf die initiale Hhe setzen.
			 */
			if (hoehe == 0)
			{
				hoehe = INIT_HOEHE;
				castedModel.setHoehe(hoehe);
			}
			figurePickerVertical.setSize(breite, hoehe);

			/*
			 * Bei Bedarf die Distanz auf die initiale Hhe - yPosPickerTop setzen.
			 */
			if ((distanz == 0) && (yPosPickerTop == 0))
			{
				distanz = castedModel.getHoehe();
				castedModel.setDistanz(distanz);
			}
			 
			
			IFigure figurePickerParent = ((AbstractGraphicalEditPart)getParent()).getFigure();
			figurePickerVertical.setParent(figurePickerParent);
			
			
			
			addToolTipListener(figurePickerVertical);
			

		}

		return figurePickerVertical;

		// IFigure figure = new Figure();
		// figure.setSize(25, 150);
		// figure.setLayoutManager(new XYLayout());
		//		
		// figure.setBorder(new LineBorder(ColorConstants.red,2));
		//
		// return figure;
	}

	/**
	 * Liefert das Modell {@link PickerHorizontal} dieses EditParts.
	 * 
	 * @return
	 */
	public PickerVertical getCastedModel()
	{
		PickerVertical pickerVertical = null;

		DoModelMitVerbLinie model = getModel();
		if ((model != null) && (model instanceof PickerVertical))
		{
			pickerVertical = (PickerVertical) model;
		}

		return pickerVertical;
	}

	public FigurePickerVertical getCastedFigure()
	{
		FigurePickerVertical fig = null;

		if ((getFigure() != null) && (getFigure() instanceof FigurePickerVertical))
		{
			fig = (FigurePickerVertical) getFigure();
			fig.setModelAndStack(getCastedModel(), getCommandStack());
		}

		return fig;
	}

	@Override
	public void notifyChanged(Notification notification)
	{
	  
//	  System.out.println("EditPartPickerVertical.notifyChanged(): " + notification.getFeature() + " -> " + notification.getNewValue());
	  
		super.notifyChanged(notification);
		
	 final Object notifier = notification.getNotifier();
	 final int type = notification.getEventType();	
		
//	 if (notifier instanceof PickerVertical)
//    {
//      final int featureID = notification.getFeatureID(DoModel.class);
//      switch (type)
//      {
//        case Notification.SET:
//          switch (featureID)
//          {
//            case AnlagendarstellungPackage.PICKER_VERTICAL__LOCATION:
//              refresh();
//              break;                            
//          }
//          break;
//        default:
//      }
//    }
		

		if (AnlagendarstellungPackage.Literals.PICKER_VERTICAL__BREITE
				.equals(notification.getFeature()))
		{
			Object oNewBreite = notification.getNewValue();
			if ((oNewBreite != null) && (oNewBreite instanceof Integer))
			{
				IFigure figure = getFigure();
				if (figure != null)
				{
					Integer breite = (Integer) oNewBreite;
					Dimension sizeOld = figure.getSize();
					Dimension sizeNew = new Dimension(breite, sizeOld.height);
					figure.setSize(sizeNew);
					figure.repaint();
					refreshVisuals();
//					if (figure instanceof FigurePickerVertical)
//					{
//						((FigurePickerVertical) figure).rep();
//						refreshVisuals();
//					}
				}
			}

		} else if (AnlagendarstellungPackage.Literals.PICKER_VERTICAL__HOEHE
				.equals(notification.getFeature()))
		{
			Object oNewHoehe = notification.getNewValue();
			if ((oNewHoehe != null) && (oNewHoehe instanceof Integer))
			{
				IFigure figure = getFigure();
				if (figure != null)
				{
					Integer hoehe = (Integer) oNewHoehe;
					Dimension sizeOld = figure.getSize();
					Dimension sizeNew = new Dimension(sizeOld.width, hoehe);
					figure.setSize(sizeNew);
					figure.repaint();
					refreshVisuals();
//					if (figure instanceof FigurePickerVertical)
//					{
//						((FigurePickerVertical) figure).rep();
//						refreshVisuals();
//					}
				}
			}
		} else if (AnlagendarstellungPackage.Literals.PICKER_VERTICAL__YPOS_PICKER_TOP
				.equals(notification.getFeature()))
		{
			int oYPosPickerTop = notification.getNewIntValue();
			if (oYPosPickerTop != notification.getOldIntValue())
			{
				refreshVisuals();
			}
		} else if (AnlagendarstellungPackage.Literals.PICKER_VERTICAL__DISTANZ
				.equals(notification.getFeature()))
		{
			int oDistanz = notification.getNewIntValue();
			if (oDistanz != notification.getOldIntValue())
			{
				refreshVisuals();
			}
		} else if (AnlagendarstellungPackage.Literals.PICKER_VERTICAL__KILOMETRIERUNG_ZUORDNUNG
				.equals(notification.getFeature()))
		{
			refreshVisuals();
		} 
//		else if (AnlagendarstellungPackage.Literals.PICKER_VERTICAL__TICKS_ANZEIGEN
//				.equals(notification.getFeature()))
//		{
//			refreshVisuals();
//		}
		else if (AnlagendarstellungPackage.Literals.PICKER_VERTICAL__SICHTBAR
        .equals(notification.getFeature()))
    {
		  boolean bNew = notification.getNewBooleanValue();
		  boolean bOld = notification.getOldBooleanValue();
		  
		  
//		  System.out.println("Sichtbar: " + bNew + " - " + bOld);
		  
		  if (bNew != bOld)
		    getCastedFigure().setVisible(bNew);
		  
		  refreshVisuals();
		  		 
//		  if (!bNew && getViewer().getVisualPartMap().containsKey(getCastedFigure()))
//		    getViewer().getVisualPartMap().remove(getCastedFigure());		  
    }
		else if (AnlagendarstellungPackage.Literals.PICKER_VERTICAL__FARBE
		    .equals(notification.getFeature()))
		{
		  Object bNew = notification.getNewValue();
		  Object bOld = notification.getOldValue();
		  
		  
//		  System.out.println("Farbe: " + bNew + " - " + bOld);
		  
		  if (bNew != null && bNew != bOld){
		    getCastedFigure().setColor(new Color(null, (RGB)bNew));		    
		    refreshVisuals();
		  }
		  
		}
		else if (AnlagendarstellungPackage.Literals.PICKER_VERTICAL__DARSTELLUNG_UPDATE.equals(notification
        .getFeature()))
    {
		  
//		  System.out.println("EditPartPickerVertical.notifyChanged(PICKER_VERTICAL__DARSTELLUNG_UPDATE): " + notification.getNewValue());
		  
      Object object = notification.getNewValue();
      if (object instanceof String)
      {
        String s = (String)object;       
        getFigure().setToolTip(new Label(s));
      }
    }
		else{
		 		  		  
		}
	}

	@Override
	protected void createEditPolicies()
	{
		super.createEditPolicies();
		NonResizableEditPolicy policy = new NonResizableEditPolicy();
	  installEditPolicy(EditPolicy.LAYOUT_ROLE, policy);
	}

	protected void refreshVisuals()
	{
		/*
		 * Position und Gre der FigurePickerVertical setzen.
		 */
		Point pos = getModel().getLocation();
		Dimension dim = getFigure().getSize();
		
//		System.out.println("EditPartPickerVertical.refreshVisuals(): " + pos + " "  + dim);
		
		EditPart parent = getParent();
		IFigure figure = getFigure();
		
		
		if (pos != null && dim != null){
		  
		  getFigure().setLocation(pos);
		  getFigure().setSize(dim);
		  
//		  Rectangle constraint = new Rectangle(pos, dim);		  
//		  if (constraint != null){
//		    
////		    System.out.println(parent + " : "  + figure + " : " + constraint);
//		    
//		    ((GraphicalEditPart) parent).setLayoutConstraint(this, figure, constraint);
//		  }
//		  else
//		  {
//		    ((GraphicalEditPart) parent).setLayoutConstraint(this, figure,
//		        new Rectangle(pos.x, pos.y, -1, -1));
//		  }	
		  
		  if (figure.getParent() != null)
		    figure.getParent().add(figure);
		  parent.refresh();
		}else{
//		  System.out.println("EditPartPickerVertical.refreshVisuals(null): " + pos + " : " + dim);
		}
		

		PickerVertical castedModel = getCastedModel();
		if (castedModel != null)
		{
			int yPosPickerTop = castedModel.getYPosPickerTop();
			int distanz = castedModel.getDistanz();
			FigurePickerVertical castedFigure = getCastedFigure();
			if (castedFigure != null)
			{
				/*
				 * Pfeil obere Position und Distanz zur unteren Pfeilspitze.
				 */
				castedFigure.setPickerData(yPosPickerTop, distanz);

//				String strKM = castedModel.getKilometrierungZuordnung();
//				if (strKM != null)
//				{
//					/*
//					 * Tickpositionen setzen.
//					 */
//					LinkedList<KilometrierungZuordnung> lTicks = KilometrierungZuordnung
//							.deserFromMultipleString(strKM);
//					if (lTicks != null)
//					{
//						LinkedList<Integer> list = new LinkedList<Integer>();
//						for (KilometrierungZuordnung kilometrierungZuordnung : lTicks)
//						{
//							if (kilometrierungZuordnung.getyVon() != null)
//							{
//								list.add(kilometrierungZuordnung.getyVon());
//							}
//
//							if (kilometrierungZuordnung.getyBis() != null)
//							{
//								list.add(kilometrierungZuordnung.getyBis());
//							}
//						}
//
//						castedFigure.setTicks(list);
//					}
//				}
//
//				/*
//				 * Flag zum Zeichnen der Ticks
//				 */
//				castedFigure.setPaintTicks(castedModel.isTicksAnzeigen());
			}
		}
	}

	
	 /**
   * @see GraphicalEditPart#setLayoutConstraint(EditPart, IFigure, Object)
   */
	
	
//  public void setLayoutConstraint(EditPart child, IFigure childFigure,
//      Object constraint) {
//    childFigure.getParent().setConstraint(childFigure, constraint);
//  }
	
//	@Override
//	public void setLayoutConstraint(EditPart child, IFigure childFigure, Object constraint)
//	{
//	  childFigure.getParent().setConstraint(childFigure, constraint);
//	}
	
	public void test()
	{
		CommandStack commandStack = getCommandStack();

	}
}
