/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.anlagendarstellung.figures;

import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.PlatformUI;

import de.bsvrz.buv.plugin.anlagendarstellung.Activator;
import de.bsvrz.buv.plugin.anlagendarstellung.dav.DaVKommunikationDobj;
import de.bsvrz.buv.plugin.anlagendarstellung.figures.fonts.VisuAnzeigeFonts;
import de.bsvrz.buv.plugin.anlagendarstellung.figures.fonts.VisuAnzeigeFontsZeichen;
import de.bsvrz.buv.plugin.anlagendarstellung.figures.fonts.VisuAnzeigeKapsel;
import de.bsvrz.buv.plugin.anlagendarstellung.sonderprogramm.DynamischerWechselText.EnumDynamischerWechseltextTextAusrichtung;
import de.bsvrz.buv.plugin.anlagendarstellung.util.DaVHelper;
import de.bsvrz.dav.daf.main.ClientDavInterface;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.sys.funclib.debug.Debug;

/**
 * Definitionsdialog zur Definition des Freitextes einer entsprechenden Anzeige. <br>
 * 
 * <br>
 * <br>
 * 
 * @version $Revision: 1.9 $ / $Date: 2014/10/29 10:54:58 $ / ($Author: Pittner $)
 * @author Pittner
 * 
 */
public class AnzeigeInhaltFreiTextDialog extends Dialog implements Listener
{
  /**
   * Der Debugger
   */
  private Debug _debug = Debug.getLogger();

  private Shell shell = null;

  private Composite composite = null;

  private Composite compositeBottom = null;

  private Button buttonOk = null;

  private Button buttonAbbrechen = null;

  private Button buttonHilfe = null;

  private Group group = null;

  private Composite composite3 = null;

  private Text textName11 = null;

  private Group groupFilterDefinitionen1 = null;

  private Composite compositeFilterDef1 = null;

  private Button radioButtonMittelSchrift = null;

  private Button radioButtonSchmalSchrift = null;

  private Composite composite1 = null;

  private Label label = null;

  private Composite composite2 = null;

  private Group groupFilterDefinitionen111 = null;

  private Composite compositeFilterDef111 = null;

  private Button radioButtonLinks = null;

  private Button radioButtonZentral = null;

  private Button radioButtonRechts = null;

  private VisuAnzeigeKapsel _visuAnzeigeKapsel; // @jve:decl-index=0:

  private Dimension DIM = new Dimension(432, 20);

  // Ausrichtung
  private final static String LINKS = "Linksbndig";

  private final static String MITTE = "Zentriert";

  private final static String RECHTS = "Rechtsbndig";

//  // Schriftart, projektspezifisch, fuer A81
//  public final static String FONT1 = "bw.font.dZeile.A81.mittelschrift";
//
//  public final static String FONT2 = "bw.font.dZeile.A81.schmalschrift";
//
//  public final static String FONT3 = "bw.font.cZeichen.A81.Schmalschrift";
  
// Schriftart, projektspezifisch, fuer A8
  //public final static String FONT1 = "bw.font.dZeile.A8.mittelschrift";
  
  //public final static String FONT2 = "bw.font.dZeile.A8.schmalschrift";
  
  //public final static String FONT3 = "bw.font.cZeichen.A8.Schmalschrift";

  // Zulssige Zeichen
  private final static String ZULAESSIGE_ZEICHEN = " !()+,-./0123456789<>?" + "ABCDEFGHIJKLMNOPQRSTUVWXYZ" + "[]^"
      + "abcdefghijklmnopqrstuvwxyz" + "" + "<>[]{}^"; // @jve:decl-index=0:

  private final static int[] TASTATUR_CODES1 = new int[] { 180, 96, // BAB-Klammer 1-stellig auf, zu
      91, 93, // BAB-Klammer 2-stellig auf, zu
      60, 62, // BAB-Klammer 3-stellig auf, zu
      123, 125, // Klammer fr Knotenpunkt auf, zu
      94, // Pfeil senkrecht
      -1, 176, 178, 179, 36, 37, 38, 42, 181, 124, 61, // Ziffern mit Strichen
      195, 167, 64, 8364 // Buchstaben mit Strichen a,b,c,d
  };

  private final static int[] TASTATUR_CODES2 = new int[] { 40, 41, 91, 63, 34, 167, 36, 37, -1, -1,      
      35, 130, 125 };

//  private static int[] TASTATUR_CODES = null;

  private Button buttonAutomatik = null;

  private Label laengeLabel;

  private String _schriftart;

  private String _ausrichtung;

  private int _abstand;

  private String[] _pidsZeichen;

  private final VisuAnzeigeFonts _fonts = VisuAnzeigeFonts.getInstanz();

  private Shell _parent;

  private BuvWechselTextKombi _buvWechselTextKombi;
  private ClientDavInterface _connection;

  private SystemObject _anzeige;
  
  private boolean _mitBeibehalten;
  
  private Button buttonBeibehalten = null;

  /**
   * Konstruktor fr eine neue Instanz der Klasse {@link AnzeigeInhaltFreiTextDialog}
   * 
   * @param parent
   *          Eltern-Shell, die fr die Darstellung benutzt werden soll.
   */
  public AnzeigeInhaltFreiTextDialog(Shell parent)
  {

    super(parent);
    _parent = parent;
    _connection = DaVKommunikationDobj.getInstanz().holeDaVVerbindung();
    shell = new Shell(parent, SWT.TITLE | SWT.APPLICATION_MODAL | SWT.MIN | SWT.MAX | SWT.CLOSE);
    shell.setText("Freitexteingabe");
    shell.setLayout(new GridLayout());
  }
  
  /**
   * Konstruktor fr eine neue Instanz der Klasse {@link AnzeigeInhaltFreiTextDialog}
   * 
   * @param parent
   *          Eltern-Shell, die fr die Darstellung benutzt werden soll.
   */
  public AnzeigeInhaltFreiTextDialog(Shell parent, boolean mitBeibehalten)
  {

    this(parent);
    _mitBeibehalten = mitBeibehalten;
  }

  /**
   * ffnet den Dialog {@link AnzeigeInhaltFreiTextDialog} zur Definition des Freitextes
   * 
   * @return den Wrapper des Freitextes
   */
  public VisuAnzeigeKapsel oeffne(VisuAnzeigeKapsel kapsel, SystemObject anzeige)
  {
    if (kapsel != null)
    {
      _visuAnzeigeKapsel = kapsel;
      _anzeige = anzeige;
      String schriftart = _visuAnzeigeKapsel.getSchriftart();
      
            
      _buvWechselTextKombi = VisuAnzeigeFonts.getInstanz().getBuvWechselTextKombiUeberFont(schriftart);
      
      DIM = DaVHelper.holeDimensionVonAnzeige(_connection, anzeige);
      
      
      int abstand = _visuAnzeigeKapsel.getAbstand();
      if (schriftart != null)
      {
//        if (schriftart.equals(FONT1))
//        {
//          DIM = new Dimension(432, 20);
////          TASTATUR_CODES = TASTATUR_CODES1;
//        }
//        else if (schriftart.equals(FONT2))
//        {
//          DIM = new Dimension(432, 20);
////          TASTATUR_CODES = TASTATUR_CODES1;
//        }
//        else if (schriftart.equals(FONT3))
//        {
//          DIM = new Dimension(64, 12);
////          TASTATUR_CODES = TASTATUR_CODES2;
//        }
//        else
//        {
//          System.out.println("Schriftart unbekannt: " + schriftart);
//        }

        _schriftart = schriftart;
        _abstand = abstand;
      }
//      else
//      {
//        _schriftart = FONT1;
//      }

      String ausrichtung = _visuAnzeigeKapsel.getAusrichtung();
      if (ausrichtung != null)
      {
        _ausrichtung = ausrichtung;
      }
      else
      {
        System.out.println("Fehler Ausrichtung: " + ausrichtung);
        _ausrichtung = LINKS;
      }

      String[] pidsZeichen = _visuAnzeigeKapsel.getPidsZeichen();
      if (pidsZeichen != null)
      {
        _pidsZeichen = pidsZeichen;
      }
      else
      {
        _pidsZeichen = new String[] { "" };
      }

    }
    else
    {
      _visuAnzeigeKapsel = new VisuAnzeigeKapsel();
      _visuAnzeigeKapsel.setSchriftart(_buvWechselTextKombi.getFont().getPid());
      _visuAnzeigeKapsel.setAusrichtung(LINKS);
      _visuAnzeigeKapsel.setPidsZeichen(new String[] { "" });
      _schriftart = _visuAnzeigeKapsel.getSchriftart();
      _ausrichtung = _visuAnzeigeKapsel.getAusrichtung();
      _pidsZeichen = _visuAnzeigeKapsel.getPidsZeichen();
      _abstand = _visuAnzeigeKapsel.getAbstand();
    }

    createComposite();
    createCompositeBottom();

    if (_visuAnzeigeKapsel.getPidsZeichen() != null && _visuAnzeigeKapsel.getAusrichtung() != null
        && _visuAnzeigeKapsel.getSchriftart() != null)
    {
      String[] zeichen = _visuAnzeigeKapsel.getPidsZeichen();
      String text = "";

      for (String s : zeichen)
      {
        VisuAnzeigeFontsZeichen z = _fonts.getFontZeichenUeberPid(_visuAnzeigeKapsel.getSchriftart(), s);
        if (z != null)
        {
          char c = (char)z.getUniCode();
          text += c;
        }
      }

      if (text != null && text.length() > 0)
      {
        textName11.setText(text);
        textName11.setSelection(text.length());
      }

      Image image = _fonts.erstelleBitmapSWT(_visuAnzeigeKapsel.getPidsZeichen(), _visuAnzeigeKapsel.getAusrichtung(),
          _visuAnzeigeKapsel.getSchriftart(), DIM.width, DIM.height, _abstand);
      if (image != null){
        Image imageOld = label.getImage();
        if (imageOld != null){            
          imageOld.dispose();
          imageOld = null;
        }
        label.setImage(image);
      }

      String schriftart = _visuAnzeigeKapsel.getSchriftart();

      // System.out.println("ffne Schrift: " + schriftart);

      if (_buvWechselTextKombi.getBeschreibung().equals("Mittelschrift"))
        radioButtonMittelSchrift.setSelection(true);
      else if (_buvWechselTextKombi.getBeschreibung().equals("Schmalschrift") && DIM.width > 64)
        radioButtonSchmalSchrift.setSelection(true);
      else if (_buvWechselTextKombi.getBeschreibung().equals("Schmalschrift"))
      {
        radioButtonSchmalSchrift.setSelection(true);
        groupFilterDefinitionen1.setEnabled(false);
        groupFilterDefinitionen111.setEnabled(false);
      }

      String ausrichtung = _visuAnzeigeKapsel.getAusrichtung();      

      if (ausrichtung.equals(EnumDynamischerWechseltextTextAusrichtung.Linksbndig.toString()))
        radioButtonLinks.setSelection(true);
      else if (ausrichtung.equals(EnumDynamischerWechseltextTextAusrichtung.Zentriert.toString()))
        radioButtonZentral.setSelection(true);
      if (ausrichtung.equals(EnumDynamischerWechseltextTextAusrichtung.Rechtsbndig.toString()))
        radioButtonRechts.setSelection(true);

    }

    laengeLabel.setText("Textbreite in Pixel " + _fonts.berechneTextLaenge(_pidsZeichen, _schriftart, _abstand)
        + " (max. " + DIM.width + " Pixel)");
    composite1.layout();

    addListener();

    if (DIM.width > 64)
      shell.setSize(new Point(550, 430));
    else
    {
      shell.setSize(new Point(400, 410));
    }

    shell.open();

    Display display = _parent.getDisplay();

    while (!shell.isDisposed())
      if (!display.readAndDispatch())
        display.sleep();

    return _visuAnzeigeKapsel;
  }

  /**
   * bernimmt die aktuellen Einstellungen. Dabei wird geprft,
   * <ul>
   * <li>ob eine Filterdefinition eingegeben wurde</li>
   * <li>dass ein Name eingegeben wurde</li>
   * </ul>
   * 
   */
  private void aktionOk()
  {

    String[] pidsZeichen = getZeichen(_schriftart, textName11.getText());
    int len = _fonts.berechneTextLaenge(pidsZeichen, _schriftart, _abstand);
    if (len > DIM.width)
    {
      MessageBox mb = new MessageBox(textName11.getShell(), SWT.ERROR);
      mb.setText("Fehler Texteingabe");
      mb.setMessage("Der Text berschreitet die maximale Lnge!");
      mb.open();
    }
    else
    {
      if (_pidsZeichen != null)
        _visuAnzeigeKapsel.setPidsZeichen(_pidsZeichen);
      else
        _visuAnzeigeKapsel.setPidsZeichen(new String[0]);
      _visuAnzeigeKapsel.setAusrichtung(_ausrichtung);
      _visuAnzeigeKapsel.setSchriftart(_schriftart);
      dispose();
    }
  }

  /**
   * Schliet den Dialog {@link AnzeigeInhaltFreiTextDialog} ohne bernahme der Einstellungen.
   * 
   */
  private void aktionAbbrechen()
  {
    _visuAnzeigeKapsel = null;
    dispose();
  }

  /**
   * Zeigt die Hilfe zum Dialog {@link AnzeigeInhaltFreiTextDialog} an.
   * 
   */
  private void aktionHilfe()
  {
    String contextId = Activator.PLUGIN_ID + ".systemkalender";
    _debug.fine("ContextID: " + contextId);
    PlatformUI.getWorkbench().getHelpSystem().displayHelp(contextId);
  }

  /**
   * This method initializes composite
   * 
   */
  private void createComposite()
  {
    GridLayout gridLayout = new GridLayout();
    gridLayout.numColumns = 1;
    GridData gridData = new GridData();
    gridData.horizontalAlignment = GridData.FILL;
    gridData.grabExcessHorizontalSpace = true;
    gridData.verticalAlignment = GridData.CENTER;
    composite = new Composite(shell, SWT.NONE);
    composite.setLayoutData(gridData);
    createGroupTextEingabe();
    composite.setLayout(gridLayout);
    createGroupSchriftart();
    createGroupAusrichtung();
  }

  /**
   * This method initializes compositeBottom
   * 
   */
  private void createCompositeBottom()
  {
    RowLayout rowLayout = new RowLayout();
    rowLayout.pack = false;
    GridData gridData3 = new GridData();
    gridData3.horizontalAlignment = GridData.END;
    gridData3.grabExcessHorizontalSpace = true;
    gridData3.verticalAlignment = GridData.CENTER;
    compositeBottom = new Composite(shell, SWT.NONE);
    compositeBottom.setLayoutData(gridData3);
    compositeBottom.setLayout(rowLayout);
    buttonOk = new Button(compositeBottom, SWT.NONE);
    buttonOk.setText("Ok");
    if (_mitBeibehalten) {
      buttonBeibehalten = new Button(compositeBottom, SWT.NONE);
      buttonBeibehalten.setText("Beibehalten");
      buttonBeibehalten.addMouseListener(new MouseAdapter() {

        @Override
        public void mouseDown(MouseEvent e)
        {
          _visuAnzeigeKapsel.setBeibehalten(true);
          aktionOk();

        }

      });
    }
    buttonAutomatik = new Button(compositeBottom, SWT.NONE);
    buttonAutomatik.setText("Automatik");
    buttonAutomatik.addMouseListener(new MouseAdapter() {

      @Override
      public void mouseDown(MouseEvent e)
      {

        _visuAnzeigeKapsel.setInaktiv(true);
        aktionOk();

      }

    });
    buttonOk.addMouseListener(new MouseAdapter() {

      @Override
      public void mouseDown(MouseEvent e)
      {        
        super.mouseDown(e);
        _visuAnzeigeKapsel.setInaktiv(false);
        aktionOk();

      }

    });

    buttonAbbrechen = new Button(compositeBottom, SWT.NONE);
    buttonAbbrechen.setText("Abbrechen");
    buttonAbbrechen.addMouseListener(new MouseAdapter() {

      @Override
      public void mouseDown(MouseEvent e)
      {       
        super.mouseDown(e);
        aktionAbbrechen();
      }

    });
    buttonHilfe = new Button(compositeBottom, SWT.NONE);
    buttonHilfe.setText("Hilfe");
    buttonHilfe.addMouseListener(new MouseAdapter() {

      @Override
      public void mouseDown(MouseEvent e)
      {        
        super.mouseDown(e);
        aktionHilfe();
      }

    });
  }

  /**
   * This method initializes group
   * 
   */
  private void createGroupTextEingabe()
  {
    GridData gridData13 = new GridData();
    gridData13.horizontalAlignment = GridData.FILL;
    gridData13.grabExcessHorizontalSpace = true;
    gridData13.verticalAlignment = GridData.CENTER;
    group = new Group(composite, SWT.NONE);
    group.setLayout(new GridLayout());
    group.setLayoutData(gridData13);
    createComposite3();
    group.setText("Texteingabe");
  }

  /**
   * This method initializes composite3
   * 
   */
  private void createComposite3()
  {
    GridData gridData14 = new GridData();
    gridData14.horizontalAlignment = GridData.FILL;
    gridData14.grabExcessHorizontalSpace = true;
    gridData14.verticalAlignment = GridData.CENTER;
    GridData gridData1 = new GridData();
    gridData1.horizontalAlignment = GridData.FILL;
    gridData1.grabExcessHorizontalSpace = true;
    gridData1.grabExcessVerticalSpace = true;
    gridData1.verticalAlignment = GridData.FILL;
    composite3 = new Composite(group, SWT.NONE);
    composite3.setLayout(new GridLayout());
    composite3.setLayoutData(gridData1);
    textName11 = new Text(composite3, SWT.BORDER);
    textName11.setLayoutData(gridData14);
    createComposite1();
  }

  /**
   * This method initializes groupFilterDefinitionen1
   * 
   */
  private void createGroupSchriftart()
  {
    GridData gridData2 = new GridData();
    gridData2.horizontalAlignment = GridData.FILL;
    gridData2.grabExcessHorizontalSpace = true;
    gridData2.verticalAlignment = GridData.CENTER;
    groupFilterDefinitionen1 = new Group(composite, SWT.NONE);
    groupFilterDefinitionen1.setLayout(new GridLayout());
    groupFilterDefinitionen1.setText("Schriftart");
    groupFilterDefinitionen1.setLayoutData(gridData2);
    createCompositeFilterDef1();
  }

  /**
   * This method initializes compositeFilterDef1
   * 
   */
  private void createCompositeFilterDef1()
  {
    GridData gridData2 = new GridData();
    gridData2.horizontalAlignment = GridData.FILL;
    gridData2.grabExcessHorizontalSpace = true;
    gridData2.verticalAlignment = GridData.CENTER;
    GridLayout gridLayout12 = new GridLayout();
    gridLayout12.numColumns = 2;
    gridLayout12.makeColumnsEqualWidth = true;
    compositeFilterDef1 = new Composite(groupFilterDefinitionen1, SWT.NONE);
    compositeFilterDef1.setLayout(gridLayout12);
    compositeFilterDef1.setLayoutData(gridData2);
    radioButtonMittelSchrift = new Button(compositeFilterDef1, SWT.RADIO);
    radioButtonMittelSchrift.setText("Mittelschrift");
    radioButtonSchmalSchrift = new Button(compositeFilterDef1, SWT.RADIO);
    radioButtonSchmalSchrift.setText("Schmalschrift");
  }

  /**
   * This method initializes composite1
   * 
   */
  private void createComposite1()
  {
    GridData gridData10 = new GridData();
    gridData10.horizontalAlignment = GridData.CENTER;
    gridData10.grabExcessHorizontalSpace = true;
    gridData10.verticalAlignment = GridData.CENTER;
    GridData gridData11 = new GridData();
    gridData11.horizontalAlignment = GridData.CENTER;
    gridData11.grabExcessHorizontalSpace = true;
    gridData11.verticalAlignment = GridData.CENTER;
    GridData gridData5 = new GridData();
    gridData5.horizontalAlignment = GridData.FILL;
    gridData5.grabExcessHorizontalSpace = true;
    gridData5.verticalAlignment = GridData.CENTER;
    composite1 = new Composite(composite3, SWT.NONE);
    composite1.setLayout(new GridLayout());
    composite1.setLayoutData(gridData5);
    label = new Label(composite1, SWT.NONE);

    label.setLayoutData(gridData10);

    Image image = null;
    if (_pidsZeichen != null)
    {
      image = _fonts.erstelleBitmapSWT(_pidsZeichen, MITTE, _schriftart, DIM.width, DIM.height, _abstand);
    }
    else
    {
      image = _fonts.erstelleBitmapSWT(new String[] {}, MITTE, _schriftart, DIM.width, DIM.height, _abstand);
    }
    if (image != null){
      Image imageOld = label.getImage();
      if (imageOld != null){            
        imageOld.dispose();
        imageOld = null;
      }
      label.setImage(image);
    }
    
    laengeLabel = new Label(composite1, SWT.NONE);
    laengeLabel.setLayoutData(gridData11);
    laengeLabel.setText("Textbreite in Pixel " + "0" + " (max. " + DIM.width + " Pixel)");

    createComposite2();
  }

  /**
   * This method initializes composite2
   * 
   */
  private void createComposite2()
  {
    GridLayout gridLayout1 = new GridLayout();
    
    int numColumns = 9;
    if (DIM.width > 64)
    {
      
    }else{
      numColumns = 4;
    }
    gridLayout1.numColumns = numColumns;
//    gridLayout1.numColumns = 10;
    GridData gridData11 = new GridData();
    gridData11.horizontalAlignment = GridData.CENTER;
    gridData11.grabExcessHorizontalSpace = false;
    gridData11.grabExcessVerticalSpace = true;
    gridData11.verticalAlignment = GridData.FILL;
    composite2 = new Composite(composite1, SWT.NONE);
    composite2.setLayoutData(gridData11);
    composite2.setLayout(gridLayout1);

//    for (int i = 0; i < TASTATUR_CODES.length; i++)
//    {
//      int code = TASTATUR_CODES[i];
//      if (code == -1)
//      {
//        new Label(composite2, SWT.NONE);
//        // continue;
//      }
//      else
//      {
//        Button button = new Button(composite2, SWT.NONE);
//        final String buttonZeichen = new String(new char[] { (char)code });
//        String[] strArr = getZeichen(_schriftart, buttonZeichen);
//        Image image = _fonts.erstelleBitmapSWT(strArr, MITTE, _schriftart, 18, DIM.height, _abstand);
//        if (image != null){          
//          Image imageOld = button.getImage();
//          if (imageOld != null){            
//            imageOld.dispose();
//            imageOld = null;
//          }
//          button.setImage(image);
//        }
//        VisuAnzeigeFontsZeichen zeichen = _fonts.getFontZeichenUeberPid(_schriftart, strArr[0]);
//        button.setData(zeichen);
//        button.addListener(SWT.Selection, this);
//      } // if
//    } // for
    
    BuvWechselTextKombi buvWechselTextKombi = _fonts.getBuvWechselTextKombiUeberFont(_schriftart);
    if (buvWechselTextKombi != null){
      SystemObject[] zeilenZeichen = buvWechselTextKombi.getZeilenZeichen();
      for (SystemObject so : zeilenZeichen)
      {
        Button button = new Button(composite2, SWT.NONE);

        // Font ber Zeichen bestimmen, da bei TastenZeilen/ZeilenZeichen der Font der zeichen nicht angegeben ist 
        
        VisuAnzeigeFontsZeichen zeichen = null;
        
        SystemObject[] fonts = DaVHelper.holeFontsUeberAnzeige(_connection, _anzeige);
        
        if (fonts != null){
          for (SystemObject font : fonts)
          {
            zeichen = _fonts.getFontZeichenUeberPid(font.getPid(), so.getPid());
            
            if (zeichen != null) // Zeichen in Font gefunden
              break;
          }
        }
        
        if (zeichen != null){
          final String buttonZeichen = new String(new char[] { (char)zeichen.getUniCode() });
          String[] strArr = getZeichen(_schriftart, buttonZeichen);
          Image image = _fonts.erstelleBitmapSWT(strArr, MITTE, _schriftart, 18, DIM.height, _abstand);
          if (image != null){          
            Image imageOld = button.getImage();
            if (imageOld != null){            
              imageOld.dispose();
              imageOld = null;
            }
            button.setImage(image);
          }
          button.setData(zeichen);
          button.addListener(SWT.Selection, this);          
        }else {
          System.out.println("else Zeichen: " + so.getPid() + " -> " + _schriftart);
        }
      }
    }
    
    
//    for (int i = 0; i < TASTATUR_CODES.length; i++)
//    {
//      int code = TASTATUR_CODES[i];
//      if (code == -1)
//      {
//        new Label(composite2, SWT.NONE);
//        // continue;
//      }
//      else
//      {
//        Button button = new Button(composite2, SWT.NONE);
//        final String buttonZeichen = new String(new char[] { (char)code });
//        String[] strArr = getZeichen(_schriftart, buttonZeichen);
//        Image image = _fonts.erstelleBitmapSWT(strArr, MITTE, _schriftart, 18, DIM.height, _abstand);
//        if (image != null){          
//          Image imageOld = button.getImage();
//          if (imageOld != null){            
//            imageOld.dispose();
//            imageOld = null;
//          }
//          button.setImage(image);
//        }
//        VisuAnzeigeFontsZeichen zeichen = _fonts.getFontZeichenUeberPid(_schriftart, strArr[0]);
//        button.setData(zeichen);
//        button.addListener(SWT.Selection, this);
//      } // if
//    } // for

  }

  private void addListener()
  {
    // TODO Auto-generated method stub
    textName11.addListener(SWT.Modify, this);
    textName11.addListener(SWT.Verify, this);

    radioButtonMittelSchrift.addListener(SWT.Selection, this);
    radioButtonSchmalSchrift.addListener(SWT.Selection, this);

    radioButtonLinks.addListener(SWT.Selection, this);
    radioButtonZentral.addListener(SWT.Selection, this);
    radioButtonRechts.addListener(SWT.Selection, this);

  }

  @Override
  public void handleEvent(Event event)
  {
    String[] pidsZeichen = getZeichen(_schriftart, textName11.getText());

    if (event.type == SWT.Verify)
    {
      char c = event.character;
      if (c == '\b')
      {
        event.doit = true;
        return;
      }

      int len = _fonts.berechneTextLaenge(pidsZeichen, _schriftart, _abstand);
      VisuAnzeigeFontsZeichen zeichen = _fonts.getFontZeichenUeberUniCode(_schriftart, c);
      if (zeichen != null)
      {

        if (len + zeichen.getBreite() > DIM.width)
        {
          event.doit = false;
          return;

        }
        else
        {
          if (!ZULAESSIGE_ZEICHEN.contains("" + c))
          {
            BuvWechselTextKombi buvWechselTextKombi = _fonts.getBuvWechselTextKombiUeberFont(_schriftart);
            
            boolean gefunden = false;
            if (buvWechselTextKombi != null){
              SystemObject[] zeilenZeichen = buvWechselTextKombi.getZeilenZeichen();
              for (SystemObject so : zeilenZeichen)
              {
                Button button = new Button(composite2, SWT.NONE);
                VisuAnzeigeFontsZeichen zeichen2 = _fonts.getFontZeichenUeberPid(_schriftart, so.getPid());
                int code = zeichen2.getUniCode();
                if (code == zeichen.getUniCode())
                  gefunden = true;
             
              }
            }
            if (!gefunden)
            {
              event.doit = false;
              return;
            }
          }          
        }
      }
    }
    else if (event.type == SWT.Selection)
    {
      if (event.widget == radioButtonMittelSchrift || event.widget == radioButtonSchmalSchrift
          || event.widget == radioButtonLinks || event.widget == radioButtonZentral
          || event.widget == radioButtonRechts)
      {
        Button b = (Button)event.widget;

        if (event.widget == radioButtonMittelSchrift || event.widget == radioButtonSchmalSchrift)
        {
          if (b.getSelection())
          {
            String schriftTmp = _schriftart;

            if (DIM.width > 64)
            {
              
              SystemObject[] fonts = DaVHelper.holeFontsUeberAnzeige(_connection, _anzeige);
              
              if (event.widget == radioButtonSchmalSchrift)
              {
                schriftTmp = fonts[1].getPid();
              }
              else if (event.widget == radioButtonMittelSchrift)
              {
                schriftTmp = fonts[0].getPid();
              }
            }

            pidsZeichen = getZeichen(schriftTmp, textName11.getText());
            int len = _fonts.berechneTextLaenge(pidsZeichen, schriftTmp, _abstand);

            if (!(len > DIM.width))
            {
              _schriftart = schriftTmp;
              _visuAnzeigeKapsel.setSchriftart(_schriftart);
            }
            else
            {
              radioButtonSchmalSchrift.setSelection(true);
              radioButtonMittelSchrift.setSelection(false);

              MessageBox mb = new MessageBox(textName11.getShell(), SWT.ERROR);
              mb.setText("Fehler Texteingabe");
              mb.setMessage("berschreitung der MAX. Lnge.\nWechsel Schriftart nicht mglich!");
              mb.open();
              return;
            }
          }
        }
        else if (event.widget == radioButtonLinks || event.widget == radioButtonZentral
            || event.widget == radioButtonRechts)
        {
          if (b.getSelection())
          {
            _ausrichtung = (String)event.widget.getData();
            _visuAnzeigeKapsel.setAusrichtung(_ausrichtung);
          }
        }
      }
      else
      {
        Button b = (Button)event.widget;
        VisuAnzeigeFontsZeichen zeichen = (VisuAnzeigeFontsZeichen)b.getData();

        int len = _fonts.berechneTextLaenge(pidsZeichen, _schriftart, _abstand);
        if (len + zeichen.getBreite() > DIM.width)
        {
          event.doit = false;
          return;

        }
        String textTmp = textName11.getText();
        textTmp += (char)zeichen.getUniCode();

        Point sel = textName11.getSelection();
        if (sel != null)
        {
          if (sel.x > 0 || sel.y > 0)
          {
            textTmp = new StringBuffer(textName11.getText()).insert(textName11.getCaretPosition(),
                (char)zeichen.getUniCode()).toString();
          }
        }
        textName11.setText(textTmp);
      }

      pidsZeichen = getZeichen(_schriftart, textName11.getText());
      _pidsZeichen = pidsZeichen;
      _visuAnzeigeKapsel.setPidsZeichen(_pidsZeichen);

      Image image = _fonts.erstelleBitmapSWT(pidsZeichen, _ausrichtung, _schriftart, DIM.width, DIM.height, _abstand);
      if (image != null)
      {
        Image imageOld = label.getImage();
        if (imageOld != null){            
          imageOld.dispose();
          imageOld = null;
        }
        label.setImage(image);
      }

    }
    else if (event.type == SWT.Modify)
    {
      pidsZeichen = getZeichen(_schriftart, textName11.getText());
      Image image = _fonts.erstelleBitmapSWT(pidsZeichen, _ausrichtung, _schriftart, DIM.width, DIM.height, _abstand);

      if (image != null)
      {
        Image imageOld = label.getImage();
        if (imageOld != null){            
          imageOld.dispose();
          imageOld = null;
        }
        label.setImage(image);
      }

      _pidsZeichen = pidsZeichen;
      _visuAnzeigeKapsel.setPidsZeichen(_pidsZeichen);

    }
    else
    {
      System.err.println("else: " + event.type);
    }

    if (pidsZeichen != null)
    {
      int len = _fonts.berechneTextLaenge(pidsZeichen, _schriftart, _abstand);

      laengeLabel.setText("Textbreite in Pixel " + len + " (max. " + DIM.width + " Pixel)");
      composite1.layout();
      if (len > DIM.width)
      {
        event.doit = false;
        MessageBox mb = new MessageBox(textName11.getShell(), SWT.ERROR);
        mb.setText("Fehler Texteingabe");
        mb.setMessage("Der Text berschreitet die maximale Lnge!");
        mb.open();
        // return;
      }
    }

  }

  private static boolean isTextNonEmpty(Text t)
  {
    if (t != null)
    {
      String s = t.getText();
      if ((s != null) && (s.trim().length() > 0))
        return true;
    }
    return false;
  }

  /**
   * This method initializes groupFilterDefinitionen111
   * 
   */
  private void createGroupAusrichtung()
  {
    GridData gridData4 = new GridData();
    gridData4.horizontalAlignment = GridData.FILL;
    gridData4.grabExcessHorizontalSpace = true;
    gridData4.verticalAlignment = GridData.CENTER;
    groupFilterDefinitionen111 = new Group(composite, SWT.NONE);
    groupFilterDefinitionen111.setLayout(new GridLayout());
    groupFilterDefinitionen111.setText("Ausrichtung");
    groupFilterDefinitionen111.setLayoutData(gridData4);
    createCompositeFilterDef111();
  }

  /**
   * This method initializes compositeFilterDef111
   * 
   */
  private void createCompositeFilterDef111()
  {
    GridLayout gridLayout122 = new GridLayout();
    gridLayout122.numColumns = 3;
    gridLayout122.makeColumnsEqualWidth = true;
    GridData gridData22 = new GridData();
    gridData22.horizontalAlignment = GridData.FILL;
    gridData22.grabExcessHorizontalSpace = true;
    gridData22.verticalAlignment = GridData.CENTER;
    compositeFilterDef111 = new Composite(groupFilterDefinitionen111, SWT.NONE);
    compositeFilterDef111.setLayoutData(gridData22);
    compositeFilterDef111.setLayout(gridLayout122);
    radioButtonLinks = new Button(compositeFilterDef111, SWT.RADIO);
    radioButtonLinks.setText("Linksbndig");
    radioButtonLinks.setData("Linksbndig");
    radioButtonZentral = new Button(compositeFilterDef111, SWT.RADIO);
    radioButtonZentral.setText("Zentriert");
    radioButtonZentral.setData("Zentriert");
    radioButtonRechts = new Button(compositeFilterDef111, SWT.RADIO);
    radioButtonRechts.setText("Rechtsbndig");
    radioButtonRechts.setData("Rechtsbndig");
  }

  /**
   * Liefert den Inhalt des Textfeldes als Zeichen-Pid-Array
   * 
   * @return die Zeichen
   */
  private String[] getZeichen(String pidFont, String text)
  {
    String[] pidZeichen = new String[text.length()];
    for (int i = 0; i < pidZeichen.length; i++)
    {
      char c = text.charAt(i);
      int code = c;
      VisuAnzeigeFontsZeichen vafz = _fonts.getFontZeichenUeberUniCode(pidFont, code);
      if (vafz == null)
      {
        vafz = _fonts.getFontZeichenUeberAsciiCode(pidFont, code);
      }
      if (vafz != null)
      {
        pidZeichen[i] = vafz.getZeichenname();
      } // if
    } // for

    return pidZeichen;
  } // getZeichen

  public void dispose()
  {
    if (!shell.isDisposed())
    {
      shell.dispose();
    }
  }

  public Shell getShell()
  {
    return shell;
  }
}
