/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.anlagendarstellung.figures;

import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Font;

/**
 * Figure, welche die optionale MQ-Bezeichnung reprsentiert.               
 * 
 * @author Pittner
 * 
 */
public class BezeichnungMQFigure extends Label
{
  private int _x;

  private int _y;

  private Label _l1;

  private Label _l2;

  private static Font fFett = new Font(null, "Arial", 8, SWT.BOLD);

  private static Font fNorm = new Font(null, "Arial", 8, SWT.NORMAL);

  public BezeichnungMQFigure(int x, int y, String bezeichnung, String kilometer)
  {
    _x = x;
    _y = y;

    setOpaque(true);
    setLayoutManager(new ToolbarLayout());
    setToolTip(new Label(bezeichnung));

    _l1 = new Label();
    _l2 = new Label();

    _l1.setLabelAlignment(PositionConstants.LEFT);
    _l2.setLabelAlignment(PositionConstants.LEFT);

    _l1.setFont(fFett);
    _l1.setText(bezeichnung);

    _l2.setFont(fNorm);
    _l2.setText(kilometer);

    add(_l1);
    add(_l2);

    int w1 = _l1.getPreferredSize().width;
    int w2 = _l2.getPreferredSize().width;
    int h1 = _l1.getPreferredSize().height;
    int h2 = _l2.getPreferredSize().height;

    int w = 0;
    if (w1 >= w2)
      w = w1;
    else
      w = w2;

    int h = h1 + h2;

    setBounds(new Rectangle(x, y, w, h));
    // setBorder(new LineBorder(ColorConstants.black, 1));
  }

  public int getX()
  {
    return _x;
  }

  public void setX(int x)
  {
    _x = x;
  }

  public int getY()
  {
    return _y;
  }

  public void setY(int y)
  {
    _y = y;
  }

  public Label getLabelBezeichnung()
  {
    return _l1;
  }

  public void setLabelBezeichnung(Label l1)
  {
    _l1 = l1;
  }

  public Label getLabelKilometer()
  {
    return _l2;
  }

  public void setLabelKilometer(Label l2)
  {
    _l2 = l2;
  }

}
