/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.anlagendarstellung.figures;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.swt.graphics.Image;

/**
 * Figure, welche eine Streckenstation reprsentiert.               
 * 
 * @author Pittner
 * 
 */
public class StreckenstationFigure extends Figure
{

  private IFigure _links;

  public StreckenstationFigure(IFigure figure)
  {
    this._links = figure;
    setOpaque(false);
    ToolbarLayout tl = new ToolbarLayout();
    tl.setVertical(false);
    setLayoutManager(tl);
    add(figure);
  }

  public void setSelected(boolean isSelected)
  {
    LineBorder lineBorder = (LineBorder)getBorder();
    if (isSelected)
    {
      lineBorder.setWidth(1);
      lineBorder.setColor(ColorConstants.black);
    }
    else
    {
      lineBorder.setWidth(2);
      lineBorder.setColor(ColorConstants.orange);
    }
  }

  public IFigure getLinks()
  {
    return _links;
  }

  public void setLinks(IFigure links)
  {
    this._links = links;
  }

  public void repaint()
  {
    super.repaint();
  }

  public void setIcon(Image image)
  {
  }
}
