package de.bsvrz.buv.plugin.anlagendarstellung.legende;


/**
 * Umfeldaten-Messstelle Nssestufedefinition.
 * 
 * @author Pittner
 */
public enum LegendeDefinitionSbaUfdMessStelleNaesseStufe {

	/** Helligkeit */
	NASS_STOER("nicht ermittelbar/keine Daten", "icons/nass_stoer.png"),
	/** Helligkeit */
	NASS_STUFE_0("trocken", "icons/nass_0.png"),
	/** Helligkeit */
	NASS_STUFE_1("Nsse-Stufe 1", "icons/nass_1.png"),
	/** Helligkeit */
	NASS_STUFE_2("Nsse-Stufe 2", "icons/nass_2.png"),
	/** Helligkeit */
	NASS_STUFE_3("Nsse-Stufe 3", "icons/nass_3.png"),
	/** Helligkeit */
	NASS_STUFE_4("Nsse-Stufe 4", "icons/nass_4.png"),
	/** Helligkeit */
	NASS_STUFE_5("Platzregen/Nsse-Stufe 5", "icons/nass_5.png");
	
	public static final String BEZEICHNUNG = "Fahrbahnzustand (FBZ)";

  /** Name der Funktionsgruppe. */
	private String name;
	
	/** Farbe der Funktionsgruppe. */
	private String path;

	/**
	 * Privater Konstruktor.
	 * 
	 * @param name
	 *            Name des Zustandes
	 */
	private LegendeDefinitionSbaUfdMessStelleNaesseStufe(final String name, String path) {
		this.name = name;
		this.path = path;
	}

	/**
	 * Gibt den Namen der Funktionsgruppe zur&uuml;ck.
	 * 
	 * @return Name des Zustandes
	 */
	public String getName() {
		return name;
	}
	
	/**
	 * Gibt den Namen der Funktionsgruppe zur&uuml;ck.
	 * 
	 * @return Name des Zustandes
	 */
	public String getPfad() {
	  return path;
	}
	
	public String getBezeichnnung()
	{
	  // TODO Auto-generated method stub
	  return BEZEICHNUNG;
	}
}
