 
package de.bsvrz.buv.plugin.anlagendarstellung.legende;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.swt.graphics.Color;

/**
 * Anzeigequerschnittdefinition.
 * 
 * @author Pittner
 */
public enum LegendeDefinitionStreckenStationStatus {
	/** Unbekannt. */
	UNBEKANNT("undefiniert", ColorConstants.gray),

	/** Gest&ouml;rt. */
	GESTOERT("gestrt", ColorConstants.red),

	/** Teilgest&ouml;rt. */
	TEILGESTOERT("Teilstrung", ColorConstants.yellow),

	/** keine St&ouml;rung. */
	OK("keine Strung", ColorConstants.green);

	public static final String BEZEICHNUNG = "Zustand";

  /** Name des Zustandes. */
	private String name;
	
	/** Name des Zustandes. */
	private Color color;

	
	/**
	 * Privater Konstruktor.
	 * 
	 * @param name
	 *            Name des Zustandes
	 */
	private LegendeDefinitionStreckenStationStatus(final String name, Color color) {
	  this.name = name;
	  this.color = color;
	}

	/**
	 * Gibt den Namen des Zustandes zur&uuml;ck.
	 * 
	 * @return Name des Zustandes
	 */
	public String getName() {
		return name;
	}
	
	/**
	 * Gibt die Farbe des Zustandes zur&uuml;ck.
	 * 
	 * @return Farbe des Zustandes
	 */
	public Color getColor() {
	  return color;
	}
	
  public String getBezeichnnung()
  {
    // TODO Auto-generated method stub
    return BEZEICHNUNG;
  }
}
