/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.anlagendarstellung.model;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * Typklasse fr die Verkehrssituation
 * 
 * @author Pittner
 * 
 */
public class SituationTyp
{

  private static List typen = new ArrayList();

  public static SituationTyp STOERUNG = new SituationTyp("Strung");

  public static SituationTyp KEINE_AUSSAGE = new SituationTyp("keine Aussage");

  public static SituationTyp VERKEHR_FREI = new SituationTyp("freier Verkehr");

  public static SituationTyp VERKEHR_LEBHAFT = new SituationTyp("lebhafter Verkehr");

  public static SituationTyp VERKEHR_DICHT = new SituationTyp("dichter Verkehr");

  public static SituationTyp VERKEHR_ZAEHFLIESSEND = new SituationTyp("zhflieender Verkehr");

  public static SituationTyp VERKEHR_STOCKEND = new SituationTyp("stockender Verkehr");

  public static SituationTyp STAU = new SituationTyp("Stau");

  private String typ;

  private SituationTyp(String type)
  {
    this.typ = type;
    String typeToAdd = this.getType();
    typen.add(typeToAdd);
  }

  /**
   * @return Returns the type.
   */
  public String getType()
  {
    return typ;
  }

  public static boolean hasType(String type)
  {
    return typen.contains(type.toUpperCase());
  }

  public static String getTypes()
  {
    StringBuffer typeBuffer = new StringBuffer();
    for (Iterator iter = typen.iterator(); iter.hasNext();)
    {
      String element = (String)iter.next();
      typeBuffer.append(element).append(", ");
    }
    if (typen.size() >= 1)
    {
      typeBuffer.delete(typeBuffer.length() - 2, typeBuffer.length());
    }
    return typeBuffer.toString();
  }

  /*
   * (non-Javadoc)
   * 
   * @see de.bsvrz.buv.plugin.anlagendarstellung.status.Status#setStatus(java.lang.String)
   */
  public static SituationTyp setTyp(String s)
  {
    // TODO Auto-generated method stub
    SituationTyp zet = null;

    if (s.equals(STOERUNG.getType()))
      zet = STOERUNG;
    else if (s.equals(KEINE_AUSSAGE.getType()))
      zet = KEINE_AUSSAGE;
    else if (s.equals(VERKEHR_FREI.getType()))
      zet = VERKEHR_FREI;
    else if (s.equals(VERKEHR_LEBHAFT.getType()))
      zet = VERKEHR_LEBHAFT;
    else if (s.equals(VERKEHR_DICHT.getType()))
      zet = VERKEHR_DICHT;
    else if (s.equals(VERKEHR_STOCKEND.getType()))
      zet = VERKEHR_STOCKEND;
    else if (s.equals(VERKEHR_ZAEHFLIESSEND.getType()))
      zet = VERKEHR_ZAEHFLIESSEND;
    else if (s.equals(STAU.getType()))
      zet = STAU;
    else
    {

    }

    return zet;
  }

}
