/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.anlagendarstellung.model;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * Typklasse fr den Status von Datenendgerten
 * 
 * @author Pittner
 * 
 */
public class StatusTyp
{

  private static List typen = new ArrayList();

  public static StatusTyp OK = new StatusTyp("OK");

  public static StatusTyp GESTOERT = new StatusTyp("Gestrt");

  public static StatusTyp TEILSTOERUNG = new StatusTyp("Teilstrung");

  public static StatusTyp KOMMUNIKATIONSAUSFALL = new StatusTyp("Kommunikationsausfall");

  public static StatusTyp TUERKONTAKT = new StatusTyp("Trkontakt");

  public static StatusTyp STROMAUSFALL = new StatusTyp("Stromausfall");

  public static StatusTyp AUSWAHL = new StatusTyp("Auswahl");

  public static StatusTyp UNDEFINERT = new StatusTyp("Undefiniert");

  public static StatusTyp OK_DE = new StatusTyp("ok");

  public static StatusTyp STOER_SM = new StatusTyp("StrSM");

  public static StatusTyp STOER_EAK = new StatusTyp("StrEAK");

  public static StatusTyp PASSIVIERT = new StatusTyp("Passiviert");

  private String typ;

  private StatusTyp(String type)
  {
    this.typ = type;
    String typeToAdd = this.getType();
    typen.add(typeToAdd);
  }

  /**
   * @return Returns the type.
   */
  public String getType()
  {
    return typ;
  }

  public static boolean hasType(String type)
  {
    return typen.contains(type.toUpperCase());
  }

  public static String getTypes()
  {
    StringBuffer typeBuffer = new StringBuffer();
    for (Iterator iter = typen.iterator(); iter.hasNext();)
    {
      String element = (String)iter.next();
      typeBuffer.append(element).append(", ");
    }
    if (typen.size() >= 1)
    {
      typeBuffer.delete(typeBuffer.length() - 2, typeBuffer.length());
    }
    return typeBuffer.toString();
  }

  /*
   * (non-Javadoc)
   * 
   * @see de.bsvrz.buv.plugin.anlagendarstellung.status.Status#setStatus(java.lang.String)
   */
  public static StatusTyp setTyp(String s)
  {
    // TODO Auto-generated method stub
    StatusTyp zet = null;

    if (s.equals(OK.getType()))
      zet = OK;
    else if (s.equals(GESTOERT.getType()))
      zet = GESTOERT;
    else if (s.equals(TEILSTOERUNG.getType()))
      zet = TEILSTOERUNG;
    else if (s.equals(KOMMUNIKATIONSAUSFALL.getType()))
      zet = KOMMUNIKATIONSAUSFALL;
    else if (s.equals(TUERKONTAKT.getType()))
      zet = TUERKONTAKT;
    else if (s.equals(STROMAUSFALL.getType()))
      zet = STROMAUSFALL;
    else if (s.equals(AUSWAHL.getType()))
      zet = AUSWAHL;
    else if (s.equals(UNDEFINERT.getType()))
      zet = UNDEFINERT;
    else if (s.equals(OK_DE.getType()))
      zet = OK_DE;
    else if (s.equals(STOER_SM.getType()))
      zet = STOER_SM;
    else if (s.equals(STOER_EAK.getType()))
      zet = STOER_EAK;
    else
    {

    }

    return zet;
  }

}
