/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.anlagendarstellung.model;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * Typklasse fr Zusatzelemente
 * 
 * @author Pittner
 * 
 */
public class ZusatzElementTyp
{

  private static List typen = new ArrayList();

  public static ZusatzElementTyp HELLIGKEIT = new ZusatzElementTyp("Helligkeit");

  public static ZusatzElementTyp PROGRAMM = new ZusatzElementTyp("Programm");

  public static ZusatzElementTyp PROGRAMM_A14 = new ZusatzElementTyp("ProgrammA14");

  public static ZusatzElementTyp LSA = new ZusatzElementTyp("Lsa");

  public static final ZusatzElementTyp ZUFLUSS = new ZusatzElementTyp("Zufluss");

  public static ZusatzElementTyp OBERFLAECHE = new ZusatzElementTyp("Oberflaeche");

  public static ZusatzElementTyp NIEDERSCHLAG = new ZusatzElementTyp("Niederschlag");

  public static ZusatzElementTyp SICHTWEITE = new ZusatzElementTyp("Sichtweite");

  public static ZusatzElementTyp MESSSTELLE = new ZusatzElementTyp("MessStelle");

  public static ZusatzElementTyp PROGRAMM_SBA_HANDPROGRAMM = new ZusatzElementTyp("AQExterneSteuerung");

  public static ZusatzElementTyp PROGRAMM_SBA_SONDERPROGRAMM = new ZusatzElementTyp("Sonderprogramm");

  public static ZusatzElementTyp PROGRAMM_SBA_VORORTBETRIEB = new ZusatzElementTyp("AQVorortbetrieb");

  public static ZusatzElementTyp PROGRAMM_SBA_AUTOMATIKPROGRAMM = new ZusatzElementTyp("AQNormalbetrieb");

  public static ZusatzElementTyp PROGRAMM_SBA_AUTARKBETRIEB = new ZusatzElementTyp("AQAutarkbetrieb");

  public static ZusatzElementTyp PROGRAMM_SBA_HANDPROGRAMM_BLIND = new ZusatzElementTyp("Handprogramm_Blind");

  public static ZusatzElementTyp PROGRAMM_SBA_SONDERPROGRAMM_BLIND = new ZusatzElementTyp("Sonderprogramm_Blind");

  public static ZusatzElementTyp PROGRAMM_SBA_AUTOMATIKPROGRAMM_BLIND = new ZusatzElementTyp("AQBlindbetrieb");

  public static ZusatzElementTyp PROGRAMM_SBA_TUNNEL = new ZusatzElementTyp("Tunnel");

  public static ZusatzElementTyp PROGRAMM_SBA_TUNNELBETRIEB = new ZusatzElementTyp("AQTunnelbetrieb");

  public static ZusatzElementTyp PROGRAMM_SBA_TEST = new ZusatzElementTyp("Test");

  public static ZusatzElementTyp PROGRAMM_SBA_TESTBETRIEB = new ZusatzElementTyp("AQTestbetrieb");

  public static ZusatzElementTyp PROGRAMM_SBA_NOT = new ZusatzElementTyp("Not");

  public static ZusatzElementTyp PROGRAMM_SBA_NOTBETRIEB = new ZusatzElementTyp("AQNotbetrieb");

  public static ZusatzElementTyp HELLIGKEIT_AQ_UNDEFINERT = new ZusatzElementTyp("Helligkeit_AQ_undefinert");

  public static ZusatzElementTyp HELLIGKEIT_AQ_GESTOERT = new ZusatzElementTyp("Helligkeit_AQ_gestoert");

  public static ZusatzElementTyp HELLIGKEIT_AQ_MANUELL = new ZusatzElementTyp("Helligkeit_AQ_Manuell");

  public static ZusatzElementTyp HELLIGKEIT_AQ_AUTOMATIK = new ZusatzElementTyp("Helligkeit_AQ_Automatik");

  public static ZusatzElementTyp HELLIGKEIT_AQ_AUTOMATIK_LOKAL = new ZusatzElementTyp("Helligkeit_AQ_Automatik_Lokal");

  public static ZusatzElementTyp HELLIGKEIT_AQ_AUTOMATIK_STUFE = new ZusatzElementTyp("Helligkeit_AQ_Automatik_Stufe");

  public static ZusatzElementTyp HELLIGKEIT_AQ_STUFE_0_MANUELL = new ZusatzElementTyp("Helligkeit_AQ_Stufe_0_Manuell");

  public static ZusatzElementTyp HELLIGKEIT_AQ_STUFE_0_AUTOMATIK_LOKAL = new ZusatzElementTyp(
      "Helligkeit_AQ_Stufe_0_Automatik_Lokal");

  public static ZusatzElementTyp HELLIGKEIT_AQ_STUFE_0_AUTOMATIK_STUFE = new ZusatzElementTyp(
      "Helligkeit_AQ_Stufe_0_Automatik_Stufe");

  public static ZusatzElementTyp PROGRAMM_UNDEFINIERT = new ZusatzElementTyp("Undefiniert");

  public static ZusatzElementTyp LSA_AUTOMATIK = new ZusatzElementTyp("Automatik");

  public static ZusatzElementTyp LSA_AUS = new ZusatzElementTyp("aus");

  public static ZusatzElementTyp LSA_DAUERROT = new ZusatzElementTyp("Dauerrot");

  public static ZusatzElementTyp LSA_STOER = new ZusatzElementTyp("Stoerung");

  public static ZusatzElementTyp DE_ZR = new ZusatzElementTyp("DeZr");

  public static ZusatzElementTyp KEINE_REGELUNG = new ZusatzElementTyp("k. R.");

  public static ZusatzElementTyp OBERFLAECHE_SCHNEE = new ZusatzElementTyp("OFSchnee/Schneematsch");

  public static ZusatzElementTyp OBERFLAECHE_NASS_3 = new ZusatzElementTyp("OFnass3");

  public static ZusatzElementTyp OBERFLAECHE_NASS_2 = new ZusatzElementTyp("OFnass");

  public static ZusatzElementTyp OBERFLAECHE_NASS_1 = new ZusatzElementTyp("OFfeucht");

  public static ZusatzElementTyp OBERFLAECHE_TROCKEN = new ZusatzElementTyp("OFtrocken");

  public static ZusatzElementTyp OBERFLAECHE_GESTOERT = new ZusatzElementTyp("OFGestrt");

  public static ZusatzElementTyp OBERFLAECHE_UNDEFINIERT = new ZusatzElementTyp("OFUndefiniert");

  public static ZusatzElementTyp NIEDERSCHLAG_NASS_5 = new ZusatzElementTyp("NSnass5");

  public static ZusatzElementTyp NIEDERSCHLAG_NASS_4 = new ZusatzElementTyp("NSnass4");

  public static ZusatzElementTyp NIEDERSCHLAG_NASS_3 = new ZusatzElementTyp("NSnass3");

  public static ZusatzElementTyp NIEDERSCHLAG_NASS_2 = new ZusatzElementTyp("NSnass2");

  public static ZusatzElementTyp NIEDERSCHLAG_NASS_1 = new ZusatzElementTyp("NSnass1");

  public static ZusatzElementTyp NIEDERSCHLAG_TROCKEN = new ZusatzElementTyp("NStrocken");

  public static ZusatzElementTyp NIEDERSCHLAG_GESTOERT = new ZusatzElementTyp("NSGestrt");

  public static ZusatzElementTyp NIEDERSCHLAG_NICHT_ERMITTELBAR = new ZusatzElementTyp("NSNichtErmittelbar");

  public static ZusatzElementTyp NIEDERSCHLAG_UNDEFINIERT = new ZusatzElementTyp("NSUndefiniert");

  public static ZusatzElementTyp SICHTWEITE_STUFE_6 = new ZusatzElementTyp("SWStufe6");

  public static ZusatzElementTyp SICHTWEITE_STUFE_5 = new ZusatzElementTyp("SWStufe5");

  public static ZusatzElementTyp SICHTWEITE_STUFE_4 = new ZusatzElementTyp("SWStufe4");

  public static ZusatzElementTyp SICHTWEITE_STUFE_3 = new ZusatzElementTyp("SWStufe3");

  public static ZusatzElementTyp SICHTWEITE_STUFE_2 = new ZusatzElementTyp("SWStufe2");

  public static ZusatzElementTyp SICHTWEITE_STUFE_1 = new ZusatzElementTyp("SWStufe1");

  public static ZusatzElementTyp SICHTWEITE_GESTOERT = new ZusatzElementTyp("SWgestrt");

  public static ZusatzElementTyp SICHTWEITE_UNDEFINIERT = new ZusatzElementTyp("SWUndefiniert");

  public static ZusatzElementTyp HELLIGKEIT_STUFE_10 = new ZusatzElementTyp("HKStufe10");

  public static ZusatzElementTyp HELLIGKEIT_STUFE_9 = new ZusatzElementTyp("HKStufe9");

  public static ZusatzElementTyp HELLIGKEIT_STUFE_8 = new ZusatzElementTyp("HKStufe8");

  public static ZusatzElementTyp HELLIGKEIT_STUFE_7 = new ZusatzElementTyp("HKStufe7");

  public static ZusatzElementTyp HELLIGKEIT_STUFE_6 = new ZusatzElementTyp("HKStufe6");

  public static ZusatzElementTyp HELLIGKEIT_STUFE_5 = new ZusatzElementTyp("HKStufe5");

  public static ZusatzElementTyp HELLIGKEIT_STUFE_4 = new ZusatzElementTyp("HKStufe4");

  public static ZusatzElementTyp HELLIGKEIT_STUFE_3 = new ZusatzElementTyp("HKStufe3");

  public static ZusatzElementTyp HELLIGKEIT_STUFE_2 = new ZusatzElementTyp("HKStufe2");

  public static ZusatzElementTyp HELLIGKEIT_STUFE_1 = new ZusatzElementTyp("HKStufe1");

  public static ZusatzElementTyp HELLIGKEIT_GESTOERT = new ZusatzElementTyp("HKgestrt");

  public static ZusatzElementTyp HELLIGKEIT_UNDEFINIERT = new ZusatzElementTyp("HKUndefiniert");

  public static ZusatzElementTyp UFD_MESS_STELLE_UNDEFINERT = new ZusatzElementTyp("UfdMessStelleUndefiniert");

  public static ZusatzElementTyp UFD_MESS_STELLE_OK = new ZusatzElementTyp("UfdMessStelleOK");

  public static ZusatzElementTyp UFD_MESS_STELLE_TEILSTOERUNG = new ZusatzElementTyp("UfdMessStelleTeilStoerung");

  public static ZusatzElementTyp UFD_MESS_STELLE_GESTOERT = new ZusatzElementTyp("UfdMessStelleGestoert");

  private String typ;

  private ZusatzElementTyp(String type)
  {
    this.typ = type;
    String typeToAdd = this.getType();
    typen.add(typeToAdd);
  }

  /**
   * @return Returns the type.
   */
  public String getType()
  {
    return typ;
  }

  public static boolean hasType(String type)
  {
    return typen.contains(type.toUpperCase());
  }

  public static String getTypes()
  {
    StringBuffer typeBuffer = new StringBuffer();
    for (Iterator iter = typen.iterator(); iter.hasNext();)
    {
      String element = (String)iter.next();
      typeBuffer.append(element).append(", ");
    }
    if (typen.size() >= 1)
    {
      typeBuffer.delete(typeBuffer.length() - 2, typeBuffer.length());
    }
    return typeBuffer.toString();
  }

  /*
   * (non-Javadoc)
   * 
   * @see de.bsvrz.buv.plugin.anlagendarstellung.status.Status#setStatus(java.lang.String)
   */
  public static ZusatzElementTyp setTyp(String s)
  {
    // TODO Auto-generated method stub
    ZusatzElementTyp zet = null;

    if (s.equals(HELLIGKEIT.getType()))
      zet = HELLIGKEIT;
    else if (s.equals(PROGRAMM.getType()))
      zet = PROGRAMM;
    else if (s.equals(HELLIGKEIT_AQ_UNDEFINERT.getType()))
      zet = HELLIGKEIT_AQ_UNDEFINERT;
    else if (s.equals(HELLIGKEIT_AQ_GESTOERT.getType()))
      zet = HELLIGKEIT_AQ_GESTOERT;
    else if (s.equals(HELLIGKEIT_AQ_MANUELL.getType()))
      zet = HELLIGKEIT_AQ_MANUELL;
    else if (s.equals(HELLIGKEIT_AQ_AUTOMATIK.getType()))
      zet = HELLIGKEIT_AQ_AUTOMATIK;
    else if (s.equals(HELLIGKEIT_AQ_AUTOMATIK_LOKAL.getType()))
      zet = HELLIGKEIT_AQ_AUTOMATIK_LOKAL;
    else if (s.equals(HELLIGKEIT_AQ_AUTOMATIK_STUFE.getType()))
      zet = HELLIGKEIT_AQ_AUTOMATIK_STUFE;
    else if (s.equals(HELLIGKEIT_AQ_STUFE_0_MANUELL.getType()))
      zet = HELLIGKEIT_AQ_STUFE_0_MANUELL;
    else if (s.equals(HELLIGKEIT_AQ_STUFE_0_AUTOMATIK_LOKAL.getType()))
      zet = HELLIGKEIT_AQ_STUFE_0_AUTOMATIK_LOKAL;
    else if (s.equals(HELLIGKEIT_AQ_STUFE_0_AUTOMATIK_STUFE.getType()))
      zet = HELLIGKEIT_AQ_STUFE_0_AUTOMATIK_STUFE;
    else if (s.equals(PROGRAMM_UNDEFINIERT.getType()))
      zet = PROGRAMM_UNDEFINIERT;
    else if (s.equals(PROGRAMM_SBA_HANDPROGRAMM.getType()))
      zet = PROGRAMM_SBA_HANDPROGRAMM;
    else if (s.equals(PROGRAMM_SBA_SONDERPROGRAMM.getType()))
      zet = PROGRAMM_SBA_SONDERPROGRAMM;
    else if (s.equals(PROGRAMM_SBA_VORORTBETRIEB.getType()))
      zet = PROGRAMM_SBA_VORORTBETRIEB;
    else if (s.equals(PROGRAMM_SBA_AUTOMATIKPROGRAMM.getType()))
      zet = PROGRAMM_SBA_AUTOMATIKPROGRAMM;
    else if (s.equals(PROGRAMM_SBA_AUTARKBETRIEB.getType()))
      zet = PROGRAMM_SBA_AUTARKBETRIEB;
    else if (s.equals(PROGRAMM_SBA_HANDPROGRAMM_BLIND.getType()))
      zet = PROGRAMM_SBA_HANDPROGRAMM_BLIND;
    else if (s.equals(PROGRAMM_SBA_SONDERPROGRAMM_BLIND.getType()))
      zet = PROGRAMM_SBA_SONDERPROGRAMM_BLIND;
    else if (s.equals(PROGRAMM_SBA_AUTOMATIKPROGRAMM_BLIND.getType()))
      zet = PROGRAMM_SBA_AUTOMATIKPROGRAMM_BLIND;
    else if (s.equals(PROGRAMM_SBA_TUNNEL.getType()))
      zet = PROGRAMM_SBA_TUNNEL;
    else if (s.equals(PROGRAMM_SBA_TUNNELBETRIEB.getType()))
      zet = PROGRAMM_SBA_TUNNELBETRIEB;
    else if (s.equals(PROGRAMM_SBA_TEST.getType()))
      zet = PROGRAMM_SBA_TEST;
    else if (s.equals(PROGRAMM_SBA_TESTBETRIEB.getType()))
      zet = PROGRAMM_SBA_TESTBETRIEB;
    else if (s.equals(PROGRAMM_SBA_NOT.getType()))
      zet = PROGRAMM_SBA_NOT;
    else if (s.equals(PROGRAMM_SBA_NOTBETRIEB.getType()))
      zet = PROGRAMM_SBA_NOTBETRIEB;
    else if (s.equals(LSA_AUTOMATIK.getType()))
      zet = LSA_AUTOMATIK;
    else if (s.equals(LSA_AUS.getType()))
      zet = LSA_AUS;
    else if (s.equals(LSA_DAUERROT.getType()))
      zet = LSA_DAUERROT;
    else if (s.equals(LSA_STOER.getType()))
      zet = LSA_STOER;
    else if (s.equals(DE_ZR.getType()))
      zet = DE_ZR;
    else if (s.equals(KEINE_REGELUNG.getType()))
      zet = KEINE_REGELUNG;
    else if (s.equals(OBERFLAECHE_SCHNEE.getType()))
      zet = OBERFLAECHE_SCHNEE;
    else if (s.equals(OBERFLAECHE_TROCKEN.getType()))
      zet = OBERFLAECHE_TROCKEN;
    else if (s.equals(OBERFLAECHE_NASS_1.getType()))
      zet = OBERFLAECHE_NASS_1;
    else if (s.equals(OBERFLAECHE_NASS_2.getType()))
      zet = OBERFLAECHE_NASS_2;
    else if (s.equals(OBERFLAECHE_NASS_3.getType()))
      zet = OBERFLAECHE_NASS_3;
    else if (s.equals(OBERFLAECHE_SCHNEE.getType()))
      zet = OBERFLAECHE_SCHNEE;
    else if (s.equals(OBERFLAECHE_GESTOERT.getType()))
      zet = OBERFLAECHE_GESTOERT;
    else if (s.equals(OBERFLAECHE_UNDEFINIERT.getType()))
      zet = OBERFLAECHE_UNDEFINIERT;
    else if (s.equals(NIEDERSCHLAG_TROCKEN.getType()))
      zet = NIEDERSCHLAG_TROCKEN;
    else if (s.equals(NIEDERSCHLAG_NASS_1.getType()))
      zet = NIEDERSCHLAG_NASS_1;
    else if (s.equals(NIEDERSCHLAG_NASS_2.getType()))
      zet = NIEDERSCHLAG_NASS_2;
    else if (s.equals(NIEDERSCHLAG_NASS_3.getType()))
      zet = NIEDERSCHLAG_NASS_3;
    else if (s.equals(NIEDERSCHLAG_NASS_4.getType()))
      zet = NIEDERSCHLAG_NASS_5;
    else if (s.equals(NIEDERSCHLAG_NASS_5.getType()))
      zet = NIEDERSCHLAG_NASS_5;
    else if (s.equals(NIEDERSCHLAG_GESTOERT.getType()))
      zet = NIEDERSCHLAG_GESTOERT;
    else if (s.equals(NIEDERSCHLAG_UNDEFINIERT.getType()))
      zet = NIEDERSCHLAG_UNDEFINIERT;
    else if (s.equals(SICHTWEITE_STUFE_1.getType()))
      zet = SICHTWEITE_STUFE_2;
    else if (s.equals(SICHTWEITE_STUFE_2.getType()))
      zet = SICHTWEITE_STUFE_2;
    else if (s.equals(SICHTWEITE_STUFE_3.getType()))
      zet = SICHTWEITE_STUFE_3;
    else if (s.equals(SICHTWEITE_STUFE_4.getType()))
      zet = SICHTWEITE_STUFE_4;
    else if (s.equals(SICHTWEITE_STUFE_5.getType()))
      zet = SICHTWEITE_STUFE_5;
    else if (s.equals(SICHTWEITE_STUFE_6.getType()))
      zet = SICHTWEITE_STUFE_6;
    else if (s.equals(SICHTWEITE_GESTOERT.getType()))
      zet = SICHTWEITE_GESTOERT;
    else if (s.equals(SICHTWEITE_UNDEFINIERT.getType()))
      zet = SICHTWEITE_UNDEFINIERT;
    else if (s.equals(HELLIGKEIT_STUFE_1.getType()))
      zet = HELLIGKEIT_STUFE_1;
    else if (s.equals(HELLIGKEIT_STUFE_2.getType()))
      zet = HELLIGKEIT_STUFE_2;
    else if (s.equals(HELLIGKEIT_STUFE_3.getType()))
      zet = HELLIGKEIT_STUFE_3;
    else if (s.equals(HELLIGKEIT_STUFE_4.getType()))
      zet = HELLIGKEIT_STUFE_4;
    else if (s.equals(HELLIGKEIT_STUFE_5.getType()))
      zet = HELLIGKEIT_STUFE_5;
    else if (s.equals(HELLIGKEIT_STUFE_6.getType()))
      zet = HELLIGKEIT_STUFE_6;
    else if (s.equals(HELLIGKEIT_STUFE_7.getType()))
      zet = HELLIGKEIT_STUFE_7;
    else if (s.equals(HELLIGKEIT_STUFE_8.getType()))
      zet = HELLIGKEIT_STUFE_8;
    else if (s.equals(HELLIGKEIT_STUFE_9.getType()))
      zet = HELLIGKEIT_STUFE_9;
    else if (s.equals(HELLIGKEIT_STUFE_10.getType()))
      zet = HELLIGKEIT_STUFE_10;
    else if (s.equals(HELLIGKEIT_GESTOERT.getType()))
      zet = HELLIGKEIT_GESTOERT;
    else if (s.equals(HELLIGKEIT_UNDEFINIERT.getType()))
      zet = HELLIGKEIT_UNDEFINIERT;
    else if (s.equals(UFD_MESS_STELLE_UNDEFINERT.getType()))
      zet = UFD_MESS_STELLE_UNDEFINERT;
    else if (s.equals(UFD_MESS_STELLE_OK.getType()))
      zet = UFD_MESS_STELLE_OK;
    else if (s.equals(UFD_MESS_STELLE_TEILSTOERUNG.getType()))
      zet = UFD_MESS_STELLE_TEILSTOERUNG;
    else if (s.equals(UFD_MESS_STELLE_GESTOERT.getType()))
      zet = UFD_MESS_STELLE_GESTOERT;
    else
    {
      // System.out.println("else: " + s);
    }

    return zet;
  }

}
