/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/

package de.bsvrz.buv.plugin.anlagendarstellung.programmtyp;

import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.config.SystemObject;

/**
 * 
 * @author Pittner
 */
public class ParameterDaten
{  
  /**
   * WVZ-Inhalt dieser Stufe (typ.wvzInhalt aus TeilmodellAnzeigenGlobal (kb.tmAnzeigenGlobal))
   */
  private WVZInhalt m_wvzInhalt = null;

  /**
   * 
   */
  private String _anzeigeTyp;

  private String _blinkTakt; 

  /**
   * Parameterloser Konstruktor der Klasse
   */
  public ParameterDaten ()
  {
    
  }
  
  /**
   * Konstruktor der Klasse
   * @param von Von
   * @param bis Bis
   * @param inhalt WVZ Inhalt
   */
  public ParameterDaten (String anzeigeTyp, WVZInhalt inhalt, String blinktakt)
  {
    _anzeigeTyp = anzeigeTyp;
  	m_wvzInhalt = inhalt;
  	_blinkTakt = blinktakt;
  }

  

  /**
   * Methode zum Auswerten einer Attributliste
   * @param data Empfangene Daten vom DaV
   */
  public void auswerteAttributgruppe( Data data )
  {    
    SystemObject so = data.getReferenceValue( "AnzeigeInhalt" ).getSystemObject();  
    m_wvzInhalt = new WVZInhalt(so.getPid());
  }

  /**
   * Methode zum Ausgeben der Klasse als String
   */
  @Override
  public String toString ()
  {
    String s = "";
    
    if (getWvzInhalt() != null)
      s += getWvzInhalt().toString();
    if (getAnzeigeTyp() != null)
      s += getAnzeigeTyp().toString();
    
    s += "\n";
    
    return s;
  }

  /**
   * Methode liefert die Variable m_wvzInhalt zurck
   * @return Variable m_wvzInhalt
   */
  public WVZInhalt getWvzInhalt()
  {
    return m_wvzInhalt;
  }

  /**
   * Methode setzt die Variable m_wvzInhalt
   * @param wvzInhalt Wert auf den die Variable m_wvzInhalt gesetzt werden soll
   */
  public void setWvzInhalt( WVZInhalt wvzInhalt )
  {
    m_wvzInhalt = wvzInhalt;
  }
  
  /**
   * Methode liefert die Variable m_wvzInhalt zurck
   * @return Variable m_wvzInhalt
   */
  public String getAnzeigeTyp()
  {
    return _anzeigeTyp;
  }
  
  /**
   * Methode setzt die Variable m_wvzInhalt
   * @param wvzInhalt Wert auf den die Variable m_wvzInhalt gesetzt werden soll
   */
  public void setAnzeigeTyp( String anzeigeTyp )
  {
    _anzeigeTyp = anzeigeTyp;
  }
  
  public String getBlinkTakt()
  {
    return _blinkTakt;
  }

  public void setBlinkTakt(String blinkTakt)
  {
    _blinkTakt = blinkTakt;
  }
  
}
