package de.bsvrz.buv.plugin.anlagendarstellung.views;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.viewers.ArrayContentProvider;
import org.eclipse.jface.viewers.ColumnLabelProvider;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TableViewerColumn;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.ISharedImages;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.forms.events.HyperlinkAdapter;
import org.eclipse.ui.forms.events.HyperlinkEvent;
import org.eclipse.ui.forms.widgets.Form;
import org.eclipse.ui.forms.widgets.FormToolkit;
import org.eclipse.ui.forms.widgets.Hyperlink;
import org.eclipse.ui.forms.widgets.ScrolledForm;
import org.eclipse.ui.forms.widgets.Section;
import org.eclipse.ui.part.ViewPart;

public class ViewFormTest extends ViewPart
{
  public static final String ID = "de.bsvrz.buv.plugin.anlagendarstellung.views.ViewFormTest";

  /**
   * This is a callback that will allow us to create the viewer and initialize it.
   */

  public void createPartControl(Composite parent)
  {
    Composite composite = new Composite(parent, SWT.NULL);
    composite.setLayout(new FillLayout());

    // Sets up the toolkit.
    FormToolkit toolkit = new FormToolkit(parent.getDisplay());

    // Creates a form instance.
    // Form form = toolkit.createForm(composite);
    ScrolledForm form = toolkit.createScrolledForm(composite);
    form.setLayoutData(new GridData(GridData.FILL_BOTH));

    // Sets title.
    form.setText("Composing an Email Message");

    // Adds body contents.
    form.getBody().setLayout(new GridLayout(1, false));

    Text textSubject = toolkit.createText(form.getBody(), "");
    textSubject.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));

    // Creating the Screen
    Section section = toolkit.createSection(form.getBody(), Section.DESCRIPTION | Section.TITLE_BAR | Section.TREE_NODE
        | Section.EXPANDED);
    section.setText("Section 1 for demonstration"); //$NON-NLS-1$
    section.setDescription("This demonstrates the usage of section");
    // Composite for storing the data
    Composite client = toolkit.createComposite(section, SWT.WRAP);
    section.setClient(client);
    section.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));

  }

  /**
   * Passing the focus request to the viewer's control.
   */

  public void setFocus()
  {
  }
}