/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
/*
 * Rahmenwerk-Plug-in "Baustellen- und Unfalleingabe"
 * Copyright (C) 2009 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weissenfelser Strasse 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */
package de.bsvrz.buv.plugin.baueditor.sts.views;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import net.sf.paperclips.BigPrint;
import net.sf.paperclips.DefaultGridLook;
import net.sf.paperclips.GridColumn;
import net.sf.paperclips.GridPrint;
import net.sf.paperclips.ImagePrint;
import net.sf.paperclips.LineBorder;
import net.sf.paperclips.PagePrint;
import net.sf.paperclips.TextPrint;
import net.sf.paperclips.TextStyle;

import org.eclipse.core.databinding.observable.Realm;
import org.eclipse.core.databinding.observable.list.IObservableList;
import org.eclipse.core.databinding.observable.list.WritableList;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.ContributionItem;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.action.IMenuListener;
import org.eclipse.jface.action.IMenuManager;
import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.jface.action.MenuManager;
import org.eclipse.jface.action.Separator;
import org.eclipse.jface.databinding.swt.SWTObservables;
import org.eclipse.jface.databinding.viewers.ObservableListContentProvider;
import org.eclipse.jface.util.IPropertyChangeListener;
import org.eclipse.jface.util.PropertyChangeEvent;
import org.eclipse.jface.viewers.CellLabelProvider;
import org.eclipse.jface.viewers.DoubleClickEvent;
import org.eclipse.jface.viewers.IDoubleClickListener;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.ViewerCell;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ControlAdapter;
import org.eclipse.swt.events.ControlEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Cursor;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.ui.IActionBars;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.IViewSite;
import org.eclipse.ui.IWorkbenchActionConstants;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.PartInitException;

import com.bitctrl.lib.eclipse.help.DefaultHelpContext;

import de.bsvrz.buv.plugin.baueditor.sts.BauEditorPlugin;
import de.bsvrz.buv.plugin.baueditor.sts.BildDateiPfade;
import de.bsvrz.buv.plugin.baueditor.sts.Zeichenketten;
import de.bsvrz.buv.plugin.baueditor.sts.actions.BaustelleBearbeitenAktion;
import de.bsvrz.buv.plugin.baueditor.sts.actions.EngstellenVerwaltungPluginAktion;
import de.bsvrz.buv.plugin.baueditor.sts.actions.StauAnzeigenAktion;
import de.bsvrz.buv.plugin.baueditor.sts.actions.UnfallBearbeitenAktion;
import de.bsvrz.buv.plugin.baueditor.sts.editors.EngstellenEditor;
import de.bsvrz.buv.plugin.baueditor.sts.editors.EngstellenEditorInput;
import de.bsvrz.buv.plugin.baueditor.sts.util.EngstellenCache;
import de.bsvrz.buv.plugin.baueditor.sts.util.wrapper.BaustellenWrapper;
import de.bsvrz.buv.plugin.baueditor.sts.util.wrapper.EngstellenWrapper;
import de.bsvrz.buv.plugin.baueditor.sts.util.wrapper.StauWrapper;
import de.bsvrz.buv.plugin.baueditor.sts.util.wrapper.UnfallWrapper;
import de.bsvrz.buv.plugin.baueditor.sts.views.helper.BaustellenHelper;
import de.bsvrz.buv.plugin.baueditor.sts.views.helper.RichtungHelper;
import de.bsvrz.buv.plugin.baueditor.sts.views.helper.StauHelper;
import de.bsvrz.buv.plugin.baueditor.sts.views.helper.StrassenHelper;
import de.bsvrz.buv.plugin.baueditor.sts.views.helper.UnfallHelper;
import de.bsvrz.buv.plugin.selektion.SelektionsTransfer;
import de.bsvrz.buv.rw.basislib.einstellungen.EinstellungenWaehler.EinstellungsArt;
import de.bsvrz.buv.rw.bitctrl.eclipse.modell.java.JavaModellEinstellungen;
import de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.attribute.AttTmcRichtung;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.Strasse;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.StrassenKnoten;

/**
 * Die Ansicht "Engstellen".
 * 
 * @author BitCtrl Systems GmbH, Andreas Meissner
 * @version $Id: EngstellenViewPart.java,v 1.2 2014/11/14 07:29:42 Pittner Exp $
 */
public class EngstellenViewPart extends AbstractBauEditorViewPart {

	/**
	 * Die eindeutige ID dieser Ansicht/View.
	 */
	public static final String ID = "de.bsvrz.buv.plugin.baueditor.view.engstellen"; //$NON-NLS-1$

	/**
	 * Der Schlssel, welcher zum Merken der Spaltenbreite genutzt wird.
	 */
	private static final String KEY_WIDTH = "columnWidth";

	/** Die ObservableList der aktuell im System existierenden Engstellen. */
	private IObservableList engstellenWrapper;

	/**
	 * Flag, welches angibt, ob aktuell in der Ansicht Baustellen angezeigt
	 * werden sollen.
	 */
	private boolean inputZeigeBaustellen;

	/**
	 * Flag, welches angibt, ob aktuell in der Ansicht Staus angezeigt werden
	 * sollen.
	 */
	private boolean inputZeigeStaus;

	/**
	 * Flag, welches angibt, ob aktuell in der Ansicht Unflle angezeigt werden
	 * sollen.
	 */
	private boolean inputZeigeUnfaelle;

	/** Die Strae, auf welcher die angezeigten Engstellen liegen sollen. */
	private Strasse inputStrasse;

	/**
	 * Die Straerichtung, auf welcher die angezeigten Engstellen liegen sollen.
	 */
	private AttTmcRichtung inputRichtung;

	/** Die Engstelle, welche in dieser Ansicht angezeigt werden soll. */
	private EngstellenWrapper inputEngstelle;

	/** Der Kontext fr das DataBinding. */
	private Realm realm;

	/** Die Einstellungen dieser Ansicht. */
	private EngstellenViewPartEinstellungen einstellungen;

	/** Der TableViewer. */
	private TableViewer viewer;

	/** Der TableSorter der Tabelle dieser Ansicht. */
	private EngstellenTableSorter tableSorter;

	/** Liste der ColumnMenuHelper. */
	private List<ColumnMenuHelper> columnMenuHelpers;

	/**
	 * Flag, welches angibt, ob die Breiten einer Spalte gespeichert werden
	 * sollen.
	 */
	private boolean storeWidth;

	/** Aktion zum Aktivieren bzw. Deaktivieren der Verknpfung mit dem Editor. */
	private VerknuepfeMitEditorAction editorAction;

	/**
	 * Aktion zum Aktivieren bzw. Deaktivieren der Verknpfung mit dem
	 * Navigator.
	 */
	private VerknuepfeMitNavigatorAction navigatorAction;

	/** Aktion zum Bearbeiten einer Baustelle. */
	private BaustelleBearbeitenAktion baustelleBearbeitenAktion;

	/** Aktion zum Bearbeiten eines Unfalls. */
	private UnfallBearbeitenAktion unfallBearbeitenAktion;

	/** Aktion zum Anzeigen eines Staus. */
	private StauAnzeigenAktion stauAnzeigenAktion;

	/** Der LabelProvider des TableViewers dieser Ansicht. */
	private final CellLabelProvider labelProvider = new CellLabelProvider() {

		private final SimpleDateFormat simpleDateFormat = new SimpleDateFormat(
				"dd.MM.yyyy HH:mm:ss");

		@Override
		public void update(final ViewerCell cell) {
			final Object obj = cell.getElement();

			if (obj instanceof EngstellenWrapper) {

				final EngstellenWrapper wrapper = (EngstellenWrapper) obj;
				final int columnIndex = cell.getColumnIndex();

				if (columnIndex == 0) { // Typ
					if (obj instanceof BaustellenWrapper) {
						cell.setImage(BauEditorPlugin.getDefault().getImage(
								BildDateiPfade.BAUSTELLE));
					} else {
						cell.setImage(BauEditorPlugin.getDefault().getImage(
								BildDateiPfade.UNFALL));
					}
				} else if (columnIndex == 1) { // Name
					cell.setText(wrapper.getName());
				} else if (columnIndex == 2) { // Richtung
					if (wrapper.getRichtung() == AttTmcRichtung.ZUSTAND_1_POSITIV) {
						cell.setImage(BauEditorPlugin.getDefault().getImage(
								BildDateiPfade.RICHTUNG_POSITIV));
					} else if (wrapper.getRichtung() == AttTmcRichtung.ZUSTAND_1N_NEGATIV) {
						cell.setImage(BauEditorPlugin.getDefault().getImage(
								BildDateiPfade.RICHTUNG_NEGATIV));
					}
				} else if (columnIndex == 3) { // Strae
					String text = "unbekannt";
					final Strasse strasse = wrapper.getStrasse();
					if (strasse != null) {
						text = strasse.getName();
					}
					cell.setText(text);
				} else if (columnIndex == 4) { // Startknoten
					String text = "unbekannt";
					final StrassenKnoten startKnoten = wrapper.getStartKnoten();
					if (startKnoten != null) {
						text = startKnoten.getName();
					}
					cell.setText(text);
				} else if (columnIndex == 5) { // Endknoten
					String text = "unbekannt";
					final StrassenKnoten endKnoten = wrapper.getEndKnoten();
					if (endKnoten != null) {
						text = endKnoten.getName();
					}
					cell.setText(text);
				} else if (columnIndex == 6) { // Startzeit
					String text = "unbekannt";
					final Date startZeit = wrapper.getStartZeit();
					if (startZeit != null) {
						text = simpleDateFormat.format(startZeit);
					}
					cell.setText(text);
				} else if (columnIndex == 7) { // Endzeit
					String text = "unbekannt";
					final Date endZeit = wrapper.getEndZeit();
					final Long dauer = wrapper.getDauer();
					if (endZeit != null && dauer != null && dauer > 0) {
						text = simpleDateFormat.format(endZeit);
					}
					cell.setText(text);
				} else if (columnIndex == 8) { // Anzahl gesperrter
					// Fahrstreifen
					cell.setText(""
							+ wrapper.getLageGesperrterFahrstreifen().size());
				}
			}
		}
	};

	@Override
	public void init(final IViewSite site, final IMemento mem)
			throws PartInitException {
		super.init(site, mem);
		realm = SWTObservables.getRealm(site.getShell().getDisplay());
	}

	@Override
	public void erzeugePartControl(final Composite parent) {

		viewer = new TableViewer(parent, SWT.SINGLE | SWT.H_SCROLL
				| SWT.V_SCROLL | SWT.FULL_SELECTION);
		columnMenuHelpers = new ArrayList<ColumnMenuHelper>();

		viewer.getTable().setHeaderVisible(true);
		viewer.getTable().setLinesVisible(true);

		createTableColumn(viewer.getTable(), 0, "", "Typ", SWT.CENTER, 20,
				false);
		createTableColumn(viewer.getTable(), 1, "Name", "Name", SWT.LEFT, 200,
				false);
		createTableColumn(viewer.getTable(), 2, "R", "Richtung", SWT.CENTER,
				25, true);
		createTableColumn(viewer.getTable(), 3, "Strae", "Strae", SWT.LEFT,
				200, true);
		createTableColumn(viewer.getTable(), 4, "von", "von", SWT.LEFT, 200,
				true);
		createTableColumn(viewer.getTable(), 5, "bis", "bis", SWT.LEFT, 200,
				true);
		createTableColumn(viewer.getTable(), 6, "Startzeit", "Startzeit",
				SWT.LEFT, 200, true);
		createTableColumn(viewer.getTable(), 7, "Endzeit", "Endzeit", SWT.LEFT,
				200, true);
		createTableColumn(viewer.getTable(), 8, "#GFS",
				"Anzahl gesperrter Fahrstreifen", SWT.CENTER, 50, true);

		viewer.setLabelProvider(labelProvider);
		viewer.setContentProvider(new ObservableListContentProvider());
		viewer.addDoubleClickListener(new IDoubleClickListener() {

			public void doubleClick(final DoubleClickEvent event) {
				final ISelection sel = viewer.getSelection();
				if (sel instanceof StructuredSelection) {
					final Object first = ((StructuredSelection) sel)
							.getFirstElement();

					if (first != null) {

						EngstellenVerwaltungPluginAktion aktion = null;
						if (first instanceof BaustellenWrapper) {
							aktion = baustelleBearbeitenAktion;
						} else if (first instanceof UnfallWrapper) {
							aktion = unfallBearbeitenAktion;
						} else if (first instanceof StauWrapper) {
							aktion = stauAnzeigenAktion;
						}

						if (aktion != null && aktion.isEnabled()) {
							aktion.runWithEvent(null, first,
									EngstellenViewPart.this);
						}
					}
				}
			}
		});

		// setze ISelectionChangedListener
		viewer.addSelectionChangedListener(new ISelectionChangedListener() {
			@Override
			public void selectionChanged(final SelectionChangedEvent event) {
				final ISelection selection = event.getSelection();
				if (baustelleBearbeitenAktion != null) {
					baustelleBearbeitenAktion.selectionChanged(null, selection);
				}
				if (unfallBearbeitenAktion != null) {
					unfallBearbeitenAktion.selectionChanged(null, selection);
				}
				if (stauAnzeigenAktion != null) {
					stauAnzeigenAktion.selectionChanged(null, selection);
				}
			}
		});

		engstellenWrapper = new WritableList(realm,
				new ArrayList<EngstellenWrapper>(), EngstellenWrapper.class);
		viewer.setInput(engstellenWrapper);

		// Setze initiale Sortierung
		int column = 0;
		int richtung = EngstellenTableSorter.AUFSTEIGEND;
		if (einstellungen != null) {
			column = einstellungen.getSortierSpaltenIndex();
			richtung = einstellungen.getSortierReihenfolge();
		}
		tableSorter = new EngstellenTableSorter(column, richtung);
		viewer.setSorter(tableSorter);

		final int dir = (tableSorter.getRichtung() == EngstellenTableSorter.AUFSTEIGEND) ? SWT.UP
				: SWT.DOWN;
		viewer.getTable().setSortDirection(dir);
		viewer.getTable().setSortColumn(
				viewer.getTable().getColumn(tableSorter.getSpalte()));

		// abschlieende Initialisierung
		fuelleActionBars();
		erzeugeKontextMenu();
		getSite().setSelectionProvider(viewer);
		SelektionsTransfer.getInstanz().addSelektionsListener(this);

		DefaultHelpContext.registerDefaultHelpContext(viewer.getControl(),
				EngstellenViewPart.class);
	}

	/**
	 * Erzeugte eine neue Tabellenspalte.
	 * 
	 * @param parent
	 *            die Tabelle, die neu erzeugte Tabellenspalte enthalten soll
	 * @param columnIndex
	 *            der Spaltenindex
	 * @param name
	 *            der Name
	 * @param tooltip
	 *            der Tooltip
	 * @param alignment
	 *            die Ausrichtung
	 * @param width
	 *            die Breite
	 * @param createMenuEntry
	 *            <code>true</code>, wenn fr diese Spalte ein Meneintrag zum
	 *            Ein- bzw. Ausblenden der Spalte erzeugte werden soll,
	 *            ansonsten <code>false</code>
	 * 
	 * @return die neu erzeugte Tabellenspalte
	 */
	private TableColumn createTableColumn(final Table parent,
			final int columnIndex, final String name, final String tooltip,
			final int alignment, final int width, final boolean createMenuEntry) {

		int theWidth = width;
		final TableColumn column = new TableColumn(parent, alignment);
		column.setText(name);
		column.setToolTipText(tooltip);

		if (einstellungen != null) {
			final List<Integer> spaltenBreiten = einstellungen
					.getSpaltenBreiten();
			if (spaltenBreiten != null && spaltenBreiten.size() > columnIndex) {
				final int storedWidth = spaltenBreiten.get(columnIndex);
				if (storedWidth > 0) {
					theWidth = storedWidth;
				}
			}
		}
		column.setWidth(theWidth);
		column.setData(KEY_WIDTH, new Integer(theWidth));
		column.setResizable(true);
		column.setMoveable(false);
		column.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(final SelectionEvent e) {
				final Cursor loadCursor = new Cursor(parent.getDisplay(),
						SWT.CURSOR_WAIT);
				parent.setCursor(loadCursor);

				tableSorter.setSpalte(columnIndex);
				int dir = viewer.getTable().getSortDirection();
				if (viewer.getTable().getSortColumn() == column) {
					dir = dir == SWT.DOWN ? SWT.UP : SWT.DOWN;
				} else {
					dir = SWT.UP;
				}
				viewer.getTable().setSortDirection(dir);
				viewer.getTable().setSortColumn(column);
				viewer.refresh();

				parent.setCursor(null);
				loadCursor.dispose();
			}
		});

		column.addControlListener(new ControlAdapter() {
			@Override
			public void controlResized(final ControlEvent e) {
				if (storeWidth) {
					column.setData(KEY_WIDTH, new Integer(column.getWidth()));
				}
			}
		});

		boolean visibile = true;
		if (einstellungen != null) {
			final List<Boolean> spaltenSichtbarkeiten = einstellungen
					.getSpaltenSichtbarkeit();
			if (spaltenSichtbarkeiten != null
					&& spaltenSichtbarkeiten.size() > columnIndex) {
				visibile = spaltenSichtbarkeiten.get(columnIndex);
			}
		}
		setTableColumnVisible(column, visibile, theWidth);

		if (createMenuEntry) {
			columnMenuHelpers.add(new ColumnMenuHelper(visibile, column));
		}

		return column;
	}

	/**
	 * Setzt die Sichtbarkeit einer Tabellespalte.
	 * 
	 * @param column
	 *            die Tabellenspalte
	 * @param visible
	 *            die Sichtbarkeit
	 * @param columnWidth
	 *            die Spaltenbreite
	 */
	private void setTableColumnVisible(final TableColumn column,
			final boolean visible, final int columnWidth) {
		storeWidth = false;
		column.setWidth(visible ? columnWidth : 0);
		column.setResizable(visible);
		storeWidth = true;
	}

	/**
	 * Fllt das Men und die Symbolleiste dieser Ansicht mit Aktionen.
	 */
	private void fuelleActionBars() {

		navigatorAction = new VerknuepfeMitNavigatorAction();
		navigatorAction
				.addPropertyChangeListener(new IPropertyChangeListener() {
					public void propertyChange(final PropertyChangeEvent event) {
						if (event.getSource() == navigatorAction
								&& event.getProperty() == IAction.CHECKED
								&& navigatorAction.isChecked()) {

							final IWorkbenchPage page = getSite().getPage();
							final IViewPart view = page
									.findView(EngstellenNavigatorViewPart.ID);

							if (view != null
									&& view instanceof EngstellenNavigatorViewPart) {
								final EngstellenNavigatorViewPart navigatorView = (EngstellenNavigatorViewPart) view;
								if (navigatorView != null) {
									setInput(navigatorView.getSelection());
								}
							}
						}
					}
				});

		editorAction = new VerknuepfeMitEditorAction();
		editorAction.addPropertyChangeListener(new IPropertyChangeListener() {
			public void propertyChange(final PropertyChangeEvent event) {
				if (event.getSource() == editorAction
						&& event.getProperty() == IAction.CHECKED
						&& editorAction.isChecked()) {
					final IWorkbenchPage activePage = getSite()
							.getWorkbenchWindow().getActivePage();
					if (activePage == null) {
						return;
					}
					final IEditorPart editor = activePage.getActiveEditor();
					if (editor != null
							&& editor.getEditorInput() instanceof EngstellenEditorInput) {
						final EngstellenEditorInput input = (EngstellenEditorInput) editor
								.getEditorInput();
						final EngstellenWrapper element = input.getWrapper();
						if (element.isNeuesElement()) {
							return;
						}
						selectElement(element);
					}
				}
			}
		});

		final IActionBars bars = getViewSite().getActionBars();
		final IToolBarManager toolbar = bars.getToolBarManager();
		final IMenuManager menu = bars.getMenuManager();

		toolbar.add(navigatorAction);
		toolbar.add(editorAction);

		menu.add(navigatorAction);
		menu.add(editorAction);
		menu.add(new Separator("spaltenGruppe"));

		// add visibility actions
		final ContributionItem menuContributionItem = new ContributionItem() {
			@Override
			public void fill(final Menu menu, final int index) {
				final MenuItem columnsSubMenuItem = new MenuItem(menu,
						SWT.CASCADE);
				columnsSubMenuItem.setText("Spalten");
				final Menu columnsSubMenu = new Menu(columnsSubMenuItem);
				columnsSubMenuItem.setMenu(columnsSubMenu);

				for (final ColumnMenuHelper helper : columnMenuHelpers) {
					final TableColumn column = helper.getColumn();
					final MenuItem menuItem = new MenuItem(columnsSubMenu,
							SWT.CHECK);
					String text = column.getToolTipText();
					if ("".equals(column.getToolTipText())) {
						text = column.getText();
					}
					menuItem.setText(text);
					menuItem.setSelection(helper.getVisibility());
					menuItem.addSelectionListener(new SelectionAdapter() {
						@Override
						public void widgetSelected(final SelectionEvent e) {
							final MenuItem item = (MenuItem) e.getSource();
							final boolean visible = item.getSelection();
							final int width = (Integer) column
									.getData(KEY_WIDTH);
							setTableColumnVisible(column, visible, width);
						}
					});
				}
			}
		};
		bars.getMenuManager().appendToGroup(
				"spaltenGruppe", menuContributionItem); //$NON-NLS-1$

		// Initialisiere Check-State der Actions mit Hilfe des Mementos
		if (einstellungen != null) {
			editorAction.setChecked(einstellungen.isEditorActionChecked());
			navigatorAction.setChecked(einstellungen
					.isVerknuepfeActionChecked());
		} else {
			editorAction.setChecked(true);
			navigatorAction.setChecked(true);
		}

		bars.updateActionBars();
	}

	/**
	 * Erzeugt das Kontextmen.
	 */
	private void erzeugeKontextMenu() {

		// create menu manager
		final MenuManager menuMgr = new MenuManager();
		menuMgr.setRemoveAllWhenShown(true);
		menuMgr.addMenuListener(new IMenuListener() {
			public void menuAboutToShow(final IMenuManager mgr) {
				mgr.add(new Separator("gruppe_oben")); //$NON-NLS-1$
				mgr.add(new Separator("anlegen_gruppe")); //$NON-NLS-1$
				mgr.add(new Separator(IWorkbenchActionConstants.MB_ADDITIONS));
				mgr.add(new Separator("gruppe_unten")); //$NON-NLS-1$
			}
		});

		// create menu.
		final Menu menu = menuMgr.createContextMenu(viewer.getControl());
		viewer.getControl().setMenu(menu);

		// register menu for extension.
		getSite().registerContextMenu(menuMgr, viewer);
	}

	@Override
	protected void clearViewer() {
		if (viewer != null) {
			viewer.setInput(null);
		}
	}

	@Override
	protected void setEnablement(final boolean enabled) {
		if (viewer != null && viewer.getControl() != null
				&& !viewer.getControl().isDisposed()) {
			viewer.getControl().setEnabled(enabled);
		}
	}

	@Override
	public void setFocus() {
		if (viewer != null && viewer.getControl() != null
				&& !viewer.getControl().isDisposed()) {
			viewer.getControl().setFocus();
		}
	}

	@Override
	public void selectionChanged(final IWorkbenchPart part,
			final ISelection selection) {

		if (part == this) {
			return;
		}

		if (selection == null || selection.isEmpty()
				|| !(selection instanceof IStructuredSelection)) {
			return;
		}

		if (part instanceof EngstellenNavigatorViewPart
				&& navigatorAction != null && navigatorAction.isChecked()
				&& part instanceof EngstellenNavigatorViewPart) {
			setInput(selection);
		} else if (part instanceof EngstellenEditor && editorAction != null
				&& editorAction.isChecked()) {
			final Object firstElement = ((IStructuredSelection) selection)
					.getFirstElement();
			if (firstElement instanceof EngstellenWrapper) {
				selectElement((EngstellenWrapper) firstElement);
			}
		}
	}

	/**
	 * Setzt den neuen Input dieser View.
	 * 
	 * @param navigatorSelection
	 *            die aktuelle Selection der Ansicht Engstellen-Navigator
	 */
	public void setInput(final ISelection navigatorSelection) {

		boolean setzeContentDescription = false;

		inputZeigeBaustellen = false;
		inputZeigeUnfaelle = false;
		inputZeigeStaus = false;
		inputStrasse = null;
		inputRichtung = null;
		inputEngstelle = null;

		// Ermittel Viewer-Input ahngig von den gegebenen Werten.
		List<EngstellenWrapper> wrapper = new ArrayList<EngstellenWrapper>();

		Object selectedElement = null;
		if (navigatorSelection != null
				&& navigatorSelection instanceof IStructuredSelection) {
			selectedElement = ((IStructuredSelection) navigatorSelection)
					.getFirstElement();
		}

		if (selectedElement != null) {
			setzeContentDescription = true;
			final EngstellenCache cache = getCache();

			if (selectedElement instanceof BaustellenHelper) {
				wrapper = new ArrayList<EngstellenWrapper>(
						cache.getBaustellenWrapper());
				inputZeigeBaustellen = true;
				inputZeigeUnfaelle = false;
				inputZeigeStaus = false;
			} else if (selectedElement instanceof UnfallHelper) {
				wrapper = new ArrayList<EngstellenWrapper>(
						cache.getUnfallWrapper());
				inputZeigeBaustellen = false;
				inputZeigeUnfaelle = true;
				inputZeigeStaus = false;
			} else if (selectedElement instanceof StauHelper) {
				wrapper = new ArrayList<EngstellenWrapper>(
						cache.getStauWrapper());
				inputZeigeBaustellen = false;
				inputZeigeUnfaelle = false;
				inputZeigeStaus = true;
			} else if (selectedElement instanceof StrassenHelper) {
				final StrassenHelper strassenHelper = (StrassenHelper) selectedElement;
				inputStrasse = strassenHelper.getStrasse();
				if (strassenHelper.getParent() instanceof BaustellenHelper) {
					wrapper = new ArrayList<EngstellenWrapper>(
							cache.getBaustellenWrapper(inputStrasse));
					inputZeigeBaustellen = true;
					inputZeigeUnfaelle = false;
					inputZeigeStaus = false;
				} else if (strassenHelper.getParent() instanceof UnfallHelper) {
					wrapper = new ArrayList<EngstellenWrapper>(
							cache.getUnfallWrapper(inputStrasse));
					inputZeigeBaustellen = false;
					inputZeigeUnfaelle = true;
					inputZeigeStaus = false;
				} else if (strassenHelper.getParent() instanceof StauHelper) {
					wrapper = new ArrayList<EngstellenWrapper>(
							cache.getStauWrapper(inputStrasse));
					inputZeigeBaustellen = false;
					inputZeigeUnfaelle = false;
					inputZeigeStaus = true;
				}
			} else if (selectedElement instanceof RichtungHelper) {
				final RichtungHelper richtungHelper = (RichtungHelper) selectedElement;
				final StrassenHelper strassenHelper = (StrassenHelper) richtungHelper
						.getParent();
				inputStrasse = richtungHelper.getStrasse();
				inputRichtung = richtungHelper.getRichtung();
				if (strassenHelper.getParent() instanceof BaustellenHelper) {
					wrapper = new ArrayList<EngstellenWrapper>(
							cache.getBaustellenWrapper(inputStrasse,
									inputRichtung));
					inputZeigeBaustellen = true;
					inputZeigeUnfaelle = false;
					inputZeigeStaus = false;
				} else if (strassenHelper.getParent() instanceof UnfallHelper) {
					wrapper = new ArrayList<EngstellenWrapper>(
							cache.getUnfallWrapper(inputStrasse, inputRichtung));
					inputZeigeBaustellen = false;
					inputZeigeUnfaelle = true;
					inputZeigeStaus = false;
				} else if (strassenHelper.getParent() instanceof StauHelper) {
					wrapper = new ArrayList<EngstellenWrapper>(
							cache.getStauWrapper(inputStrasse, inputRichtung));
					inputZeigeBaustellen = false;
					inputZeigeUnfaelle = false;
					inputZeigeStaus = true;
				}
			} else if (selectedElement instanceof EngstellenWrapper) {
				final EngstellenWrapper engstelle = (EngstellenWrapper) selectedElement;
				wrapper.add(engstelle);
				inputEngstelle = engstelle;
				inputZeigeBaustellen = selectedElement instanceof BaustellenWrapper;
				inputZeigeUnfaelle = selectedElement instanceof UnfallWrapper;
				inputZeigeStaus = selectedElement instanceof StauWrapper;
			}
		}

		// Setze Input und ContentDescription
		engstellenWrapper = new WritableList(realm, wrapper,
				EngstellenWrapper.class);
		viewer.setInput(engstellenWrapper);

		if (setzeContentDescription) {
			setContentDescription();
		} else {
			setContentDescription("");
		}
	}

	/**
	 * Aktualisiert die Content-Description dieser Ansicht.
	 */
	private void setContentDescription() {
		if (getCache() == null || !getCache().isInitialisiert()) {
			setContentDescription(Zeichenketten.LADE_ENGSTELLEN + "...");
			return;
		}

		if (!BauEditorPlugin.getDefault().isAusfuehrbar()) {
			setContentDescription(Zeichenketten.FEHLERMELDUNG_NICHT_AUSFUEHRBAR);
			return;
		}

		final StringBuffer buf = new StringBuffer();
		final int anzahlElemente = viewer.getTable().getItemCount();
		buf.append(anzahlElemente);
		if (inputZeigeBaustellen) {
			if (anzahlElemente != 1) {
				buf.append(" Baustellen");
			} else {
				buf.append(" Baustelle");
			}
		} else if (inputZeigeStaus) {
			if (anzahlElemente != 1) {
				buf.append(" Staus");
			} else {
				buf.append(" Stau");
			}
		} else {
			if (anzahlElemente != 1) {
				buf.append(" Unflle");
			} else {
				buf.append(" Unfall");
			}
		}
		if (inputStrasse != null) {
			buf.append(" auf ");
			buf.append(inputStrasse.getName());
			if (inputRichtung != null) {
				buf.append(" (");
				buf.append(inputRichtung.toString());
				buf.append(")");
			}
		}
		setContentDescription(buf.toString());
	}

	/**
	 * Selektiert den gegebenen EngstellenWrapper in der Ansicht.
	 * 
	 * @param wrapper
	 *            der zu selektierende EngstellenWrapper
	 */
	public void selectElement(final EngstellenWrapper wrapper) {
		if (editorAction != null && editorAction.isChecked() && viewer != null) {
			final ISelection tempSelection = viewer.getSelection();
			viewer.setSelection(new StructuredSelection(wrapper));
			viewer.reveal(wrapper);
			final ISelection newSelection = viewer.getSelection();
			if (newSelection == null
					|| ((IStructuredSelection) newSelection).isEmpty()) {
				viewer.setSelection(tempSelection);
			}
		}
	}

	/**
	 * Aktion zum Aktivieren bzw. Deaktivieren der Verknpfung dieser Ansicht
	 * mit dem Editor.
	 * 
	 * @author BitCtrl Systems GmbH, Andreas Meissner
	 * @version $Id: EngstellenNavigatorViewPart.java 24859 2010-07-19 15:12:41Z
	 *          meissner $
	 */
	private class VerknuepfeMitEditorAction extends Action {

		/**
		 * Der Konstruktor.
		 */
		public VerknuepfeMitEditorAction() {
			setText("Verknpfe mit Editor");
			setToolTipText("Verknpfe mit Editor");
			setImageDescriptor(BauEditorPlugin.getDefault().getImageDescriptor(
					BildDateiPfade.VERKNUEPFE_MIT_EDITOR));

		}

		@Override
		public int getStyle() {
			return AS_CHECK_BOX;
		}
	}

	/**
	 * Aktion zum Aktivieren bzw. Deaktivieren der Verknpfung dieser Ansicht
	 * mit der Ansicht "Engstellen-Navigator".
	 * 
	 * @author BitCtrl Systems GmbH, Andreas Meissner
	 * @version $Id: EngstellenNavigatorViewPart.java 24859 2010-07-19 15:12:41Z
	 *          meissner $
	 */
	private class VerknuepfeMitNavigatorAction extends Action {

		/**
		 * Der Konstruktor.
		 */
		public VerknuepfeMitNavigatorAction() {
			setText("Verknpfe mit Engstellen-Navigator");
			setToolTipText("Verknpfe mit Engstellen-Navigator");
			setImageDescriptor(BauEditorPlugin.getDefault().getImageDescriptor(
					BildDateiPfade.VERKNUEPFEN));
		}

		@Override
		public int getStyle() {
			return AS_CHECK_BOX;
		}
	}

	/**
	 * Hilfsklasse zur Verwaltung der Spaltensichtbarkeiten.
	 * 
	 * @author BitCtrl Systems GmbH, Andreas Meissner
	 * @version $Id: EngstellenViewPart.java 24906 2010-07-21 12:43:02Z meissner
	 *          $
	 */
	private class ColumnMenuHelper {

		/** Die Sichtbarkeit. */
		private final boolean visibility;

		/** Die Tabellenspalte. */
		private final TableColumn column;

		/**
		 * Der Konstruktor.
		 * 
		 * @param visibility
		 *            die Sichtbarkeit
		 * @param column
		 *            die Tabellenspalte
		 */
		public ColumnMenuHelper(final boolean visibility,
				final TableColumn column) {
			this.visibility = visibility;
			this.column = column;
		}

		/**
		 * Liefert <code>true</code> zurck, wenn Tabellespalte angezeigt werden
		 * soll.
		 * 
		 * @return <code>true</code>, wenn Tabellespalte angezeigt werden soll,
		 *         ansonsten <code>false</code>
		 */
		public boolean getVisibility() {
			return visibility;
		}

		/**
		 * Liefert die Tabellenspalte zurck.
		 * 
		 * @return die Tabellenspalte
		 */
		public TableColumn getColumn() {
			return column;
		}
	}

	@Override
	public void engstellenAdded(final Object quelle,
			final List<EngstellenWrapper> engstellen) {
		if (viewer != null && !viewer.getControl().isDisposed()
				&& realm != null) {
			realm.exec(new Runnable() {
				public void run() {
					for (final EngstellenWrapper wrapper : engstellen) {
						addEngstellenWrapper(wrapper);
					}
				}
			});
		}
	}

	@Override
	public void engstellenRemoved(final Object quelle,
			final List<EngstellenWrapper> engstellen) {
		if (viewer != null && !viewer.getControl().isDisposed()
				&& realm != null) {
			realm.exec(new Runnable() {
				public void run() {
					for (final EngstellenWrapper wrapper : engstellen) {
						removeEngstellenWrapper(wrapper);
					}
				}
			});
		}
	}

	@Override
	public void engstelleChanged(final Object quelle,
			final EngstellenWrapper neuerWert, final EngstellenWrapper alterWert) {
		if (viewer != null && !viewer.getControl().isDisposed()
				&& realm != null) {
			realm.exec(new Runnable() {
				public void run() {

					// Merken, ob die genderte Engstelle zuvor selektiert war
					final ISelection sel = viewer.getSelection();
					final boolean select = sel != null
							&& !sel.isEmpty()
							&& sel instanceof IStructuredSelection
							&& ((IStructuredSelection) sel).getFirstElement() == alterWert;

					// Aktualisierte Engstelle
					removeEngstellenWrapper(alterWert);
					addEngstellenWrapper(neuerWert);

					// Selektiere ggf. die neu hinzugefgte Engstelle
					if (select) {
						selectElement(neuerWert);
					}
				}
			});
		}
	}

	/**
	 * Fgt den gegeben EngstellenWrapper der ObservableList hinzu und
	 * aktualisiert die ContentDescription.
	 * 
	 * @param wrapper
	 *            der neue EngstellenWrapper
	 */
	private void addEngstellenWrapper(final EngstellenWrapper wrapper) {
		if (checkEngstellenWrapper(wrapper)) {
			engstellenWrapper.add(wrapper);
			setContentDescription();
		}
	}

	/**
	 * Entfernt den gegeben EngstellenWrapper aus der ObservableList und
	 * aktualisiert die ContentDescription.
	 * 
	 * @param wrapper
	 *            der zu lschende EngstellenWrapper
	 */
	private void removeEngstellenWrapper(final EngstellenWrapper wrapper) {
		if (engstellenWrapper.contains(wrapper)) {
			engstellenWrapper.remove(wrapper);
			setContentDescription();
		}
	}

	/**
	 * berprft, ob es sich bei dem gegebenen EngstellenWrapper um ein
	 * Engstelle handelt, welche in der aktuellen dargestellt werden soll.
	 * 
	 * @param wrapper
	 *            der EngstellenWrapper
	 * 
	 * @return <code>true</code> wenn der EngstellenWrapper in der Ansicht
	 *         dargestellt werden soll
	 */
	private boolean checkEngstellenWrapper(final EngstellenWrapper wrapper) {
		if (inputZeigeBaustellen != wrapper instanceof BaustellenWrapper
				|| inputZeigeUnfaelle != wrapper instanceof UnfallWrapper
				|| inputZeigeStaus != wrapper instanceof StauWrapper
				|| (inputStrasse != null && !inputStrasse.getPid().equals(
						wrapper.getStrasse().getPid()))
				|| (inputRichtung != null && inputRichtung != wrapper
						.getRichtung())
				|| (inputEngstelle != null && !inputEngstelle.getSituation()
						.getPid().equals(wrapper.getSituation().getPid()))) {
			return false;
		}
		return true;
	}

	@Override
	public PagePrint getDruckAuftrag() {
		final String header = getContentDescription();

		final GridPrint grid = new GridPrint();
		grid.addColumn(new GridColumn(GridColumn.DEFAULT_ALIGN,
				GridColumn.DEFAULT_SIZE, GridColumn.DEFAULT_WEIGHT));
		grid.add(new TextPrint(header, new FontData("Arial", 14, SWT.BOLD)));
		grid.add(new TextPrint("", new FontData("Arial", 10, SWT.NORMAL)));

		final GridPrint tabelle = new GridPrint();
		final DefaultGridLook look = new DefaultGridLook();
		look.setHeaderBackground(new RGB(200, 200, 200));

		TextStyle textStyle = new TextStyle();
		final TextStyle headerStyle = textStyle.font("Arial", 10, SWT.BOLD);
		textStyle = textStyle.font("Arial", 10, SWT.NORMAL);

		look.setCellBorder(new LineBorder(new RGB(0, 0, 0)));
		tabelle.setLook(look);

		int i = 0;
		for (final TableColumn column : viewer.getTable().getColumns()) {
			try {
				if (column.getWidth() == 0) {
					continue;
				}
				int align = SWT.LEFT;
				if (i == 8) {
					align = SWT.CENTER;
				}
				final GridColumn gridColumn = new GridColumn(align,
						SWT.DEFAULT, 1);
				tabelle.addColumn(gridColumn);
				tabelle.addHeader(headerStyle.create(column.getText()));
			} finally {
				i++;
			}
		}

		for (final TableItem item : viewer.getTable().getItems()) {
			for (int colIdx = 0; colIdx < viewer.getTable().getColumns().length; colIdx++) {
				if (viewer.getTable().getColumn(colIdx).getWidth() == 0) {
					continue;
				}
				final Image image = item.getImage(colIdx);
				if (image != null) {
					tabelle.add(new ImagePrint(image.getImageData()));
				} else {
					tabelle.add(textStyle.create(item.getText(colIdx)));
				}
			}
		}
		grid.add(tabelle);

		return new PagePrint(new BigPrint(grid));
	}

	@Override
	public String getTitel() {
		return "Ansicht Engstellen";
	}

	@Override
	protected void ladeEinstellungen() {
		if (BauEditorPlugin.getDefault().isAusfuehrbar()) {
			final JavaModellEinstellungen<EngstellenViewPartEinstellungen> e = new JavaModellEinstellungen<EngstellenViewPartEinstellungen>(
					EngstellenViewPartEinstellungen.class);
			einstellungen = e.getModellEinstellungen(
					EinstellungsArt.benutzerNetzweit, ID);
			if (einstellungen == null) {
				einstellungen = e.getModellEinstellungen(
						EinstellungsArt.benutzerLokal, ID);
			}
		}
		if (einstellungen == null) {
			einstellungen = new EngstellenViewPartEinstellungen();
		}
	}

	@Override
	protected void speicherEinstellungen() {
		if (BauEditorPlugin.getDefault().isAusfuehrbar() && viewer != null
				&& viewer.getControl() != null
				&& !viewer.getControl().isDisposed() && editorAction != null
				&& navigatorAction != null && tableSorter != null) {

			final EngstellenViewPartEinstellungen einstell = new EngstellenViewPartEinstellungen(
					viewer);
			einstell.setEditorActionChecked(editorAction.isChecked());
			einstell.setVerknuepfeActionChecked(navigatorAction.isChecked());
			einstell.setSortierSpaltenIndex(tableSorter.getSpalte());
			einstell.setSortierReihenfolge(tableSorter.getRichtung());

			final JavaModellEinstellungen<EngstellenViewPartEinstellungen> e = new JavaModellEinstellungen<EngstellenViewPartEinstellungen>(
					EngstellenViewPartEinstellungen.class);
			e.setModellEinstellungen(EinstellungsArt.benutzerLokal, ID,
					einstell);
			e.setModellEinstellungen(EinstellungsArt.benutzerNetzweit, ID,
					einstell);
		}
	}

	@Override
	public void preInitInUIThread() {
		setEnablement(false);
	}

	@Override
	public void initInUIThread() {
		if (getViewSite().getActionBars().getMenuManager().isEmpty()) {
			fuelleActionBars();
			erzeugeKontextMenu();
		}
		baustelleBearbeitenAktion = new BaustelleBearbeitenAktion();
		unfallBearbeitenAktion = new UnfallBearbeitenAktion();
		stauAnzeigenAktion = new StauAnzeigenAktion();
		setEnablement(true);
		setContentDescription();
		getCache().addEngstellenListener(this);
	}
}
