/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.parameter.ufd.nsparam;

import org.eclipse.jface.viewers.ArrayContentProvider;
import org.eclipse.jface.viewers.ColumnLabelProvider;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TableViewerColumn;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;

import de.bsvrz.buv.plugin.parameter.ufd.common.AbstractDataContainerComposite;
import de.bsvrz.buv.plugin.parameter.ufd.common.MinMaxColumnEditingSupport;
import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.Data.Array;

/**
 * Darstellung des Fensters fr die Bearbeitung der Parameter "Ursacheneinheit"
 * @author ObertM
 *
 */
public class NSKlassifizierungTrocknungsPhaseComposite extends AbstractDataContainerComposite
{ 
  
  private enum VON_NACH_STUFE {
    ZEILE1("nass4", "nass3"),
    ZEILE2("nass3", "nass2"),
    ZEILE3("nass2", "nass1"),
    ZEILE4("nass1", "trocken");
    
    public final String vonStufe;
    public final String nachStufe;
    
    public static int indexOf(String vonStufe, String nachStufe) {
      VON_NACH_STUFE[] array = values();
      for (int i = 0; i < array.length; i++) {
        if (array[i].vonStufe.equals(vonStufe) && array[i].nachStufe.equals(nachStufe)) {
          return i;
        }
      }
      return -1;
    }
    
    private VON_NACH_STUFE(String vonStufe, String nachStufe) {
      this.vonStufe = vonStufe;
      this.nachStufe = nachStufe;
    }
  }
  
  private final static int COLS = 3;
  
  private String[][] _matrix = new String[VON_NACH_STUFE.values().length][COLS];
   
  private TableViewer _tableViewer;

 
  
  
  public NSKlassifizierungTrocknungsPhaseComposite(Composite parent, int style) {
    super(parent, style);
  }



public void setUpdate(Data data) {
  if (!isInitialized())
    return;
    
  // array initialisieren
  for (int i = 0; i < VON_NACH_STUFE.values().length; i++) {
    _matrix[i][2] = "";
  }

  // Daten aus _data in array schreiben
  Array array = data.getArray("TrocknungsPhasenVerzgerungen");
  for (int i = 0; i < array.getLength(); i++) {
    Data item = array.getItem(i);
    String vonStufe = item.getTextValue("VonNsseStufe").getValueText();
    String nachStufe = item.getTextValue("NachNsseStufe").getValueText();
    int index = VON_NACH_STUFE.indexOf(vonStufe, nachStufe);
    if (index >= 0) {
      _matrix[index][2] = item.getTextValue("Verzgerung").getValueText();
    }
  }
  
  _tableViewer.refresh();
}



public Data getUpdate() {
  if (!isInitialized())
    return null;
  
  Data result = _data.createModifiableCopy();

  VON_NACH_STUFE[] vonNachStufe = VON_NACH_STUFE.values();
  Array array = result.getArray("TrocknungsPhasenVerzgerungen");
  array.setLength(0);
  
  for (int i = 0; i < vonNachStufe.length; i++) {
    if (!"".equals(_matrix[i][2])) {
      
      int index = array.getLength();
      array.setLength(index + 1);
      
      Data item = array.getItem(index);
      
      String vonStufe = vonNachStufe[i].vonStufe;
      item.getTextValue("VonNsseStufe").setText(vonStufe);
      
      String nachStufe = vonNachStufe[i].nachStufe;
      item.getTextValue("NachNsseStufe").setText(nachStufe);
      
      item.getTextValue("Verzgerung").setText(_matrix[i][2]);
    }
  }
    
  return result;
}

  /**
   * This method initializes createGroupDefinition
   * 
   */
  protected void createControls()
  {
    GridData gridData = new GridData();
    gridData.horizontalAlignment = GridData.FILL;
    gridData.verticalAlignment = GridData.FILL;
    gridData.grabExcessHorizontalSpace = true;
    gridData.grabExcessVerticalSpace = true;
  
    Group groupParameter = new Group(this, SWT.NONE);
    groupParameter.setLayout(new GridLayout());
    groupParameter.setLayoutData(gridData);
    groupParameter.setText("Klassifizierung Trocknungsphase");

    createTable(groupParameter);
  }

  private void createTable(Composite parent)
  {
    _tableViewer = new TableViewer(parent, SWT.FULL_SELECTION | SWT.H_SCROLL | SWT.V_SCROLL);
    _tableViewer.setContentProvider(new ArrayContentProvider());
    
    for (int i = 0; i < COLS; i++) {
      TableViewerColumn column = new TableViewerColumn(_tableViewer, SWT.NONE);
      
      final int index = i;
      column.setLabelProvider(new ColumnLabelProvider() {

        @Override
        public String getText(Object element)
        {
          if (element instanceof String[]) {
            return ((String[])element)[index];
          }
          return "";
        }
        
      });
      
      if (i == 2) {
        column.getColumn().setWidth(105);
        column.getColumn().setText("Verzgerung [min]");
        
        column.setEditingSupport(new MinMaxColumnEditingSupport(_tableViewer, 0 , Long.MAX_VALUE) {

          @Override
          protected Object getValue(Object element) {
            if (element instanceof String[]) {
              return ((String[])element)[2];
            }
            return null;
          }

             
          @Override
          protected void setValue(Object element, Object value) {
            if (element instanceof String[]) {
              try {
                ((String[])element)[2] = value == null || "".equals(value ) ? "" : "" + Long.parseLong(value.toString());
                _tableViewer.update(element, null);
              }
              catch (NumberFormatException e) {
                // tue nichts
              }  
            }
          }
        });  
      }
      else {
        switch (i) {
          case 0:
            column.getColumn().setText("Von Stufe");
            break;
          case 1:
            column.getColumn().setText("Nach Stufe");
            break;
        }
        column.getColumn().setWidth(70);
      }
      column.getColumn().setMoveable(false);
      column.getColumn().setResizable(true);
    }
    
    _tableViewer.getTable().setLinesVisible(true);
    _tableViewer.getTable().setHeaderVisible(true);
    
    GridData gridData = new GridData();
    gridData.horizontalAlignment = GridData.FILL;
    gridData.verticalAlignment = GridData.FILL;
    gridData.grabExcessHorizontalSpace = true;
    gridData.grabExcessVerticalSpace = true;
    _tableViewer.getTable().setLayoutData(gridData);
      
    VON_NACH_STUFE[]rows = VON_NACH_STUFE.values();
    for (int row = 0; row < rows.length; row++) {
      for (int col = 0; col < COLS; col++) {
        if (col == 0) {
          _matrix[row][col] = rows[row].vonStufe;
        }
        else if (col == 1) {
          _matrix[row][col] = rows[row].nachStufe; 
        }
        else {
          _matrix[row][col] = "";
        }
      }
    }
    
    _tableViewer.setInput(_matrix);
    
  }

}
