/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.parameter.ufd.nsparam;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;

import de.bsvrz.buv.plugin.parameter.ufd.common.AbstractDataContainerComposite;
import de.bsvrz.dav.daf.main.Data;

/**
 * 
 * @author Sans
 *
 */
public class NSZuBenutzendeEingangsgroessenComposite extends AbstractDataContainerComposite
{ 

	private final static String[] ATTRIBUTES = {
	  "NiederschlagsintensittBenutzen", 
	  "NiederschlagsintensittsstufeBenutzen",
	  "NiederschlagsartBenutzen",
	  "WasserfilmdickenstufeBenutzen",
	  "ZustandDerFahrbahnoberflcheBenutzen"
	};


	private Button[] _buttonArray = new Button[ATTRIBUTES.length];
	  

  /**
   * Mgliche Item-Werte fr die Checkboxen (Unchecked/Checked)
   */
  private static final String [] _checkBoxValues = new String []
  {
    "Nein",
    "Ja"
  };

 
  NSZuBenutzendeEingangsgroessenComposite(Composite parent, int style)
  {
    super(parent, style);
  }
    
   
  @Override
  public Data getUpdate() {
    if (!isInitialized())
      return null;
    
    Data result = _data.createModifiableCopy();
    
    for (int i = 0; i < ATTRIBUTES.length; i++) {
      if (!_buttonArray[i].getGrayed()) {
        if (_buttonArray[i].getSelection()) {
          result.getItem(ATTRIBUTES[i]).asTextValue().setText(_checkBoxValues[1]);
        }
        else {
          result.getItem(ATTRIBUTES[i]).asTextValue().setText(_checkBoxValues[0]);
        }
      }
      
    }
    
    return result;
  }
     
  public void setUpdate(Data data) {
    if (!isInitialized())
      return;
        
    for (int i = 0; i < ATTRIBUTES.length; i++) {
      String value = data.getItem(ATTRIBUTES[i]).asTextValue().getText();
      
      if (_checkBoxValues[0].equals(value)) {
        _buttonArray[i].setSelection(false);
        _buttonArray[i].setGrayed(false);
      }
      else if (_checkBoxValues[1].equals(value)) {
        _buttonArray[i].setSelection(true);
        _buttonArray[i].setGrayed(false);
      }
      else {
        _buttonArray[i].setSelection(true);
        _buttonArray[i].setGrayed(true);
      }
    }
  }
   
  protected void createControls()
  {
    RowLayout rowLayout = new RowLayout();
//    rowLayout.pack = false;
    GridData gridData = new GridData();
    gridData.grabExcessHorizontalSpace = true;
  
    Group groupParameter = new Group(this, SWT.NONE);
    groupParameter.setLayout(rowLayout);
    groupParameter.setLayoutData(gridData);
    groupParameter.setText("Zu benutzende Eingangsgren fr Nssestufen");
    
    createButtons(groupParameter);
  }

  private void createButtons(Composite parent) {
    
    for (int i = 0; i < ATTRIBUTES.length; i++) {
      
      _buttonArray[i] = new Button(parent, SWT.CHECK);
      _buttonArray[i].setText(ATTRIBUTES[i]);
      
      _buttonArray[i].setSelection(true);
      _buttonArray[i].setGrayed(true);
            
    }
  }
  
}
