package de.bsvrz.buv.plugin.pua.a8.projektInfo;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import de.bsvrz.buv.plugin.pua.basis.expose.IPIGanglinienKonvertierung;
import de.bsvrz.buv.plugin.pua.basis.expose.ProjektInfoDefault;

@SuppressWarnings("serial")
public class ProjektInfoUEStatus implements IPIGanglinienKonvertierung
{

  protected final List<String> _ausgabeTabelleSpalten = new ArrayList<String>() 
  {
    {
      add("Status"); // 0
      add("Statusbercksichtigung"); // 1
      add("Info"); // 2
    }
  };
  
  public int getAnzahlAttribute() 
  {
    return _ausgabeTabelleSpalten.size();
  }
   
  public List<String> getAusgabeTabelleSpalten() 
  {
    return Collections.unmodifiableList(_ausgabeTabelleSpalten);
  }
  
  public int getSpaltenIndexRelativ(String pid) 
  {
    return  -1;
  }
  
  public String getBildInhalt(String bildInhalt) 
  {
    return null;
  }
  
  protected final Map<String, Map<String, Integer>> _ueStatus = new HashMap<String, Map<String, Integer>>() {
    { put("HarmoBelastungUnruhe120", new HashMap<String, Integer>() {
      { put("Ja", 120);
        put("Nein", 3);
      }});
      put("HarmoGeschwDiff120", new HashMap<String, Integer>() {
      { put("Ja",   115);
        put("Nein", 3);
      } });
      put("HarmoBelastung100", new HashMap<String, Integer>() {
      { put("Ja", 100);
        put("Nein", 3);
      }});
      put("HarmoGeschwDiff100", new HashMap<String, Integer>() {
      { put("Ja", 95);
        put("Nein", 3);
      }});
      put("HarmoBelastung80", new HashMap<String, Integer>() {
      { put("Ja", 80);
        put("Nein", 3);
      }});
      put("HarmoGeschwDiff80", new HashMap<String, Integer>() {
      { put("Ja", 75);
        put("Nein", 3);
      }});
      put("HarmoBelastung60", new HashMap<String, Integer>() {
      { put("Ja", 60);
        put("Nein", 3);
      }});
      put("Stau", new HashMap<String, Integer>() {
      { put("Ja", 20);
        put("Nein", 3);
      }});
      
      put("LkwberholverbotBelastung", new HashMap<String, Integer>() {
      { put("Ja", 90);
        put("Nein", 3);
      }});
      put("LkwberholverbotNsse", new HashMap<String, Integer>() {
      { put("Ja", 86);
        put("Nein", 3);
      }});
      put("LkwberholverbotSicht", new HashMap<String, Integer>() {
      { put("Ja", 83);
        put("Nein", 3);
      }});
      
      put("Nsse120-Nass1", new HashMap<String, Integer>() {
      { put("Ja", 120);
        put("Nein", 3);
      }});
      put("Nsse100-Nass2", new HashMap<String, Integer>() {
      { put("Ja", 100);
        put("Nein", 3);
      }});
      put("Nsse80-Nass2", new HashMap<String, Integer>() {
      { put("Ja", 85);
        put("Nein", 3);
      }});
      put("Nsse80-Nass3", new HashMap<String, Integer>() {
      { put("Ja", 80);
        put("Nein", 3);
      }});
      put("Nsse60-Nass4-5", new HashMap<String, Integer>() {
      { put("Ja", 60);
        put("Nein", 3);
      }});
      put("Nsse60-Nass2-3", new HashMap<String, Integer>() {
      { put("Ja", 55);
        put("Nein", 3);
      }});
      
      put("Sicht120-Stufe1", new HashMap<String, Integer>() {
      { put("Ja", 120);
        put("Nein", 3);
      }});
      put("Sicht100-Stufe2", new HashMap<String, Integer>() {
      { put("Ja", 100);
        put("Nein", 3);
      }});
      put("Sicht80-Stufe3", new HashMap<String, Integer>() {
      { put("Ja", 80);
        put("Nein", 3);
      }});
      put("Sicht60-Stufe4", new HashMap<String, Integer>() {
      { put("Ja", 60);
        put("Nein", 3);
      }});
      put("Sicht40-Stufe5", new HashMap<String, Integer>() {
      { put("Ja", 40);
        put("Nein", 3);
      }});
    }
  };
     
  public boolean isAttributKonvertierbar(String attribut) {
    return attribut != null && attribut.equals("Status"); 
  }
  
  @Override
  public String getWertKonvertiert(String attribut, String wert, String objekt) {
      
      if (objekt != null) {
        Map<String, Integer> valueMap = null;
      
        for (Map.Entry<String, Map<String, Integer>> entry: _ueStatus.entrySet()) {
          if (objekt.startsWith(entry.getKey())) {
            valueMap = entry.getValue();
          }
        }
        
        if (valueMap != null) {
          Integer value = valueMap.get(wert);
          return value != null ? String.valueOf(value) : null;
        }
      }
      return null;  
       
  }
  
  @Override
  public String getAttributKonvertiert(String attribut)
  {
    String result = attribut;
    if (isAttributKonvertierbar(attribut)) {
      int kla = attribut.indexOf("[");
      int klz = attribut.indexOf("]"); 
      if (kla < 0 || klz < kla)
      {
        result = attribut.trim() + " [km/h]";
      }
    }
    return result ;
  }
  
  @Override
  public long getMilliesTreppenfunktionErgaenzen()
  {
    return 1000;
  }
  
  @Override
  public boolean anfangAuffuellen() {
    return true;
  }
  
  @Override
  public boolean endeAuffuellen() {
    return true;
  }
  
  protected final List<String> _zuIgnorierendeWerte = new ArrayList<String>() {
    {
      add("");
      add("-");
    }
  };
  
  @Override
  public Collection<String> getZuIgnorierendeWerte() {
    return Collections.unmodifiableList(_zuIgnorierendeWerte);
  }

}
