/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.pua.basis.pua;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.Vector;

import org.eclipse.ui.IViewReference;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PlatformUI;

import de.bsvrz.buv.plugin.pua.basis.pua.daten.ProtokollInformationen;
import de.bsvrz.buv.plugin.pua.basis.pua.daten.SkriptInformationen;
import de.bsvrz.buv.plugin.pua.basis.views.ProtokollAusgabeSicht;
import de.bsvrz.dav.daf.main.ClientDavInterface;
import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.DataDescription;
import de.bsvrz.dav.daf.main.ResultData;
import de.bsvrz.dav.daf.main.config.ClientApplication;
import de.bsvrz.dav.daf.main.config.ConfigurationAuthority;
import de.bsvrz.dav.daf.main.config.ConfigurationChangeException;
import de.bsvrz.dav.daf.main.config.ConfigurationException;
import de.bsvrz.dav.daf.main.config.DataModel;
import de.bsvrz.dav.daf.main.config.DynamicObject;
import de.bsvrz.dav.daf.main.config.DynamicObjectType;
import de.bsvrz.dav.daf.main.config.MutableSet;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.dav.daf.main.config.SystemObjectType;
import de.bsvrz.pua.prot.client.ProtocolAnswerReceiver;
import de.bsvrz.pua.prot.client.ProtocolCompletionAnswerReceiver;
import de.bsvrz.pua.prot.client.ProtocolListener;
import de.bsvrz.pua.prot.client.ProtocolResultStream;
import de.bsvrz.pua.prot.client.PuaClient;
import de.bsvrz.pua.prot.client.ScriptAnswerReceiver;
import de.bsvrz.pua.prot.client.dataobject.ProtocolAdministrationData;
import de.bsvrz.pua.prot.client.dataobject.ProtocolAggregationData;
import de.bsvrz.pua.prot.client.dataobject.ProtocolNoChanges;
import de.bsvrz.pua.prot.client.dataobject.ProtocolResult;
import de.bsvrz.pua.prot.client.dataobject.ProtocolResultData;
import de.bsvrz.pua.prot.interpreter.InterpreterErrorMessage;
import de.bsvrz.pua.prot.manager.ProtocolRelatedOperation;
import de.bsvrz.pua.prot.manager.ScriptRelatedOperation;
import de.bsvrz.pua.prot.util.ProcessingParameter;
import de.bsvrz.pua.prot.util.ProtocolRequestResult;
import de.bsvrz.sys.funclib.debug.Debug;
import de.bsvrz.sys.funclib.losb.datk.AtgAnswer;
import de.bsvrz.sys.funclib.losb.datk.AtgProtocolRequest;
import de.bsvrz.sys.funclib.losb.datk.AtgScriptRequest;
import de.bsvrz.sys.funclib.losb.datk.AtlBase;
import de.bsvrz.sys.funclib.losb.datk.AtlExtra;
import de.bsvrz.sys.funclib.losb.datk.AtlMeta;
import de.bsvrz.sys.funclib.losb.datk.PidProtocol;
import de.bsvrz.sys.funclib.losb.datk.PidScript;
import de.bsvrz.sys.funclib.losb.datk.SerializerUtil;
import de.bsvrz.sys.funclib.losb.exceptions.FailureException;
import de.bsvrz.sys.funclib.losb.exceptions.LoggerException;
import de.bsvrz.sys.funclib.losb.exceptions.SenderException;
import de.bsvrz.sys.funclib.losb.kernsoftware.SimpleSender;
import de.bsvrz.sys.funclib.losb.messages.ErrorMessage;
import de.bsvrz.sys.funclib.losb.util.Tuple;
import de.bsvrz.sys.funclib.losb.util.Util;

/**
 * Hauptklasse fr den PuA-Client-Zugriff.<br>
 * <br>
 * 
 * @version $Revision:
 * 
 * @author Dambach-Werke GmbH
 * @author Thomas Drapp
 * 
 */
public class ProtokolleUndAuswertungen
{
  /**
   * DebugLogger fr Debug-Ausgaben.
   */
  private static Debug m_debug;

  /**
   * Datenverteilerverbindung.
   */
  private ClientDavInterface m_connection = null;

  /**
   * Datenmodell.
   */
  private DataModel m_dataModel;

  /**
   * Ergebnis der letzen Operation
   */
  private ProtocolRequestResult m_requestResult = null;

  /**
   * AnfrageId. Streng monoton steigend.
   */
  private long m_requestId_dontUseDirectly;

  /**
   * Id des als letztes angeforderten Protokoll.
   */
  @SuppressWarnings("unused")
  private long m_letzteProtokollId;

  /**
   * Maximale Wartezeit in ms, bis eine Antwort eingetroffen sein muss bzw. wie lange ein Sendevorgang dauern darf.
   * Default: 60s
   */
  private long m_timeout = 60 * 1000;

  /**
   * Wartezeit in Millisekunden bevor erneut gesendet wird.
   */
  private static long WAIT = 500;

  /**
   * Konfigurationsverantwortlicher, an den die Anfrage gesendet wird.
   */
  private ConfigurationAuthority m_configAuth;

  /**
   * Datenbeschreibung der Protokoll-bezogenen Anfrage.
   */
  private DataDescription m_ddProtocol;

  /**
   * Datenbeschreibung der Skript-bezogenen Anfrage.
   */
  private DataDescription m_ddScript;

  /**
   * Objekt an das Pua die Antwort sendet.
   */
  private ClientApplication m_client;

  /**
   * Kopf wird ausgegeben
   */
  private boolean m_printHeader = true;

  /**
   * Format fr Datumseingabe festlegen.
   */
  protected static final SimpleDateFormat m_sdf = new SimpleDateFormat("dd.MM.yyyyHH:mm:ss:SSS"); // yyyyHH OHNE Space
                                                                                                  // ist korrekt!

  /**
   * true: Anzeige der Protokolle in einer Tabelle false: Ausgabe auf der Konsole.
   */
  private boolean m_gui = true;

  /**
   * Liste mit ungelesenen Protokollen.
   */
  private Vector<ProtokollInformationen> m_listeUngeleseneProtokolle = new Vector<ProtokollInformationen>();

  /**
   * Liste mit gespeicherten Protokollen.
   */
  private Vector<ProtokollInformationen> m_listeGespeicherteProtokolle = new Vector<ProtokollInformationen>();

  /**
   * Zuletzt automatisch angelegtes Skriptobjekt. Wird von {@link #createScript(DynamicObject, AtlBase, String)} und
   * {@link #createNewScriptObject(String, String)} gesetzt.
   */
  public DynamicObject m_recentlyCreatedScript = null;

  /**
   * Status der protokollerstellung konnt enicht abgefragt werden.
   */
  public static final byte INVALID_STATUS = -1;

  /**
   * Klasse zum Empfang fuer Protokoll-Fertigstellungen.
   */
  private ProtokollFertigstellungAntwortEmpfaenger m_protokollFertigstellungAntwortEmpfaenger;

  private static final long PROTOCOL_COMPLETION_INTERFACE_ID = -1;

  /**
   * Set zum Merken der Listener fuer Protokoll-Fertigstellungen.
   */
  private final Set<ProtocolListener> m_listeners = new HashSet<ProtocolListener>();
  
  /**
   * Konstruktor mit bergabe von Parametern. Innerhalb eines Programms sollte diese Klasse nur ein mal instanziiert
   * werden, da die Protokoll-Id inkrementiert wird und es sonst zu berschneidungen bei der Protokoll-Id kommen kann.
   * 
   * @param connection
   *          aktuelle Datenverteilerverbindung.
   */
  public ProtokolleUndAuswertungen(ClientDavInterface connection)
  {
    m_debug = Debug.getLogger();

    m_connection = connection;

    m_requestId_dontUseDirectly = System.currentTimeMillis();

    m_dataModel = getConnection().getDataModel();

    m_client = getConnection().getLocalApplicationObject();
    m_configAuth = getConnection().getLocalConfigurationAuthority();
    m_ddProtocol = new DataDescription(getDataModel().getAttributeGroup(PidProtocol.atgProtocolRequest), getDataModel()
        .getAspect(PidProtocol.aspRequest));
    m_ddScript = new DataDescription(getDataModel().getAttributeGroup(PidScript.atgRequest), getDataModel().getAspect(
        PidScript.aspIs));
  }

  /**
   * Liste der ungelesenen Protokolle von PuA holen.
   * 
   * @param benutzer Benutzer, fr den die Anfrage ausgefhrt wird.
   *
   * @return <code>true</code>, wenn Zugriff erfolgreich, sonst <code>false</code>.
   */
  public boolean aktualisiereListeUngeleseneProtokolle(String benutzer)
  {
    String msg = "Aktualisierung der Liste ungelesene Protokolle.";
    m_debug.fine(msg);

    Vector<ProtokollInformationen> liste = new Vector<ProtokollInformationen>();

    m_requestResult = new ProtocolRequestResult();
    Tuple<Long, ProcessingParameter>[] savedProtocolList = getUnreadProtocolList(m_requestResult, benutzer);
    boolean erg = m_requestResult.isRequestSuccessful();
    if (erg)
    {
      for (int i = 0; (i < savedProtocolList.length); i++)
      {
        ProtokollInformationen prot = new ProtokollInformationen(savedProtocolList[i]);

        liste.add(prot);
      }
    }
    else
    {
      msg = "Fehler bei Aktualisierung der Liste ungelesene Protokolle.";
      m_debug.warning(msg);
    }

    synchronized (m_listeUngeleseneProtokolle)
    {
      m_listeUngeleseneProtokolle.clear();
      m_listeUngeleseneProtokolle.addAll(liste);
    }

    return erg;
  }

  /**
   * Liste der gespeicherten Protokolle von PuA holen.
   * 
   * @param benutzer Benutzer, fr den die Anfrage ausgefhrt wird.
   *
   * @return <code>true</code>, wenn Zugriff erfolgreich, sonst <code>false</code>.
   */
  public boolean aktualisiereListeGespeicherteProtokolle(String benutzer)
  {
    String msg = "Aktualisierung der Liste gespeicherte Protokolle.";
    m_debug.fine(msg);

    Vector<ProtokollInformationen> liste = new Vector<ProtokollInformationen>();

    m_requestResult = new ProtocolRequestResult();
    Tuple<Long, ProcessingParameter>[] savedProtocolList = getSavedProtocolList(m_requestResult, benutzer);
    boolean erg = m_requestResult.isRequestSuccessful();
    if (erg)
    {
      for (int i = 0; (i < savedProtocolList.length); i++)
      {
        // savedProtocolList[i].

        ProtokollInformationen prot = new ProtokollInformationen(savedProtocolList[i]);

        liste.add(prot);
      }
    }
    else
    {
      msg = "Fehler bei Aktualisierung der Liste gespeicherte Protokolle.";
      m_debug.warning(msg);
    }

    synchronized (m_listeGespeicherteProtokolle)
    {
      // liste.get(0).getId()

      m_listeGespeicherteProtokolle.clear();
      m_listeGespeicherteProtokolle.addAll(liste);
    }

    return erg;
  }

  /**
   * Skript erstellen
   * 
   * @return Ergebnis
   * 
   * @throws ConfigurationException
   * @throws IllegalArgumentException
   */
  public boolean erstelleSkript(SkriptInformationen skriptInformationen)
  {
    boolean erg = false;
    String retVal = "";
    String createdScript = "";

    try
    {
      AtlBase baseInfo = new AtlBase(skriptInformationen.getName(), skriptInformationen.getBeschreibung(),
          skriptInformationen.getAutor(), skriptInformationen.getStatus(), skriptInformationen.getDatum());

      // Skriptquelltext aus der angebenen Datei lesen
      String source = "";

      BufferedReader sourceFile = new BufferedReader(new FileReader(skriptInformationen.getSkriptDatei()));
      String line;

      while ((line = sourceFile.readLine()) != null)
      {
        source += (line + "\n");
      }

      // Skriptobjekt anlegen
      m_requestResult = createScript(skriptInformationen.getPid(), skriptInformationen.getName(), baseInfo, source);
      createdScript = m_recentlyCreatedScript.getPid();
      erg = m_requestResult.isRequestSuccessful();
      retVal = "\tErfolgreich?\t"
          + (erg ? "Ja." : "Nein.")
          + "\n"
          + ((erg) ? ("\tPID des Skripts:\t\"" + createdScript + "\"") : ("\tFehler:\t\t" + m_requestResult
              .getErrorMsg()));
    }
    catch (NullPointerException npEx)
    {
      retVal = "PARAMETERFEHLER:" + "\n\tBenoetigte Parameter:" + "\n\t\t- Quelltext" + "\n\t\t- Skript (optional)"
          + "\n\t\t- Name (optional)" + "\n\t\t- Beschreibung (optional)" + "\n\t\t- Autor (optional)"
          + "\n\t\t- Status (optional)" + "\n\t\t- Datum (optional)";
      m_requestResult = new ProtocolRequestResult(retVal);
    }
    catch (FileNotFoundException fnfEx)
    {
      retVal = "PARAMETERFEHLER:\n\tQuelltextdatei " + skriptInformationen.getSkriptDatei() + " existiert nicht.";
      m_requestResult = new ProtocolRequestResult(retVal);
    }
    catch (IOException ioEx)
    {
      retVal = "\n\tEin-/Ausgabefehler beim Lesen der Quelltextdatei " + skriptInformationen.getSkriptDatei() + ".";
      m_requestResult = new ProtocolRequestResult(retVal);
    }
    // if (!TEST)
    System.out.println(retVal);

    return erg;
  }

  /**
   * Skript erstellen
   * 
   * @return Ergebnis
   * 
   */
  public boolean erstelleSkript(String pid, String name, AtlBase info, String source) {
	  synchronized (this) {
		  m_requestResult = createScript(pid, name, info, source);
		  return m_requestResult.isRequestSuccessful();  
	  }
  }
  
  /**
   * Zugriff auf ein ungelesenen Protokoll von PuA.
   * 
   * @param protokollId
   *          Id des gewnschten ungelesenen Protokolls.
   * @return Stream fr die Abfrage der Protokolldaten oder <code>null</code>, wenn ein Fehler auftrat.
   */
  public ProtocolResultStream zugriffAufUngelesenesProtokoll(long protokollId)
  {
    String msg = "zugriffAufUngelesenesProtokoll protokollId " + protokollId;
    m_debug.fine(msg);

    try
    {
      ProtocolResultStream stream = getUnreadProtocol(protokollId);

      return stream;
    }
    catch (FailureException fEx)
    {
      msg = "Fehler beim Zugriff auf das ungelesene Protokoll mit protokollId " + protokollId + ".";
      m_debug.warning(msg);

      m_requestResult = new ProtocolRequestResult(msg);

      return null;
    }
  }

  /**
   * Zugriff auf ein gespeichertes Protokoll von PuA.
   * 
   * @param protokollId
   *          Id des gewnschten gespeicherten Protokolls.
   * @return Stream fr die Abfrage der Protokolldaten oder <code>null</code>, wenn ein Fehler auftrat.
   */
  public ProtocolResultStream zugriffAufGespeichertesProtokoll(long protokollId)
  {
    String msg = "zugriffAufGespeichertesProtokoll protokollId " + protokollId;
    m_debug.fine(msg);

    try
    {
      ProtocolResultStream stream = getSavedProtocol(protokollId);

      return stream;
    }
    catch (FailureException fEx)
    {
      msg = "Fehler beim Zugriff auf das gespeicherte Protokoll mit protokollId " + protokollId + ".";
      m_debug.warning(msg);

      m_requestResult = new ProtocolRequestResult(msg);

      return null;
    }
  }

  /**
   * Gibt den Header aus - falls vom User gewnscht.
   * 
   * @param string
   */
  @SuppressWarnings("unused")
  private void printHeaderInfo(String string)
  {
    if (m_printHeader)
      System.out.println(string);
  }

  /**
   * @param periodList
   * @return
   */
  @SuppressWarnings("unused")
  private String periodListToString(List<Tuple<Long, Long>> periodList)
  {
    StringBuffer sb = new StringBuffer();
    if (periodList != null)
    {
      for (int i = 0; i < periodList.size(); i++)
      {
        Tuple<Long, Long> p = periodList.get(i);
        if (i > 0)
          sb.append(", ");
        Util.msToDate(sb, p.first);
        sb.append(" - ");
        Util.msToDate(sb, p.last);
      }
    }
    return sb.toString();
  }

  /**
   * Gibt einen Stream aus.
   * 
   * @param stream
   */
  public void printStream(ProtocolResultStream stream)
  {
    printStream(stream, null, true);
  }

  /**
   * Gibt einen Stream aus.
   * 
   * @param stream
   * @param ausgabeAlsFrame
   *          Ausgabe als Frame (true) oder als InternalFrame (false)
   */
  public void printStream(ProtocolResultStream stream, ProtokollInformationen info, boolean ausgabeAlsFrame)
  {
    boolean first = true;
    // ProtokollAusgabeDialog pv = null;
    // if (false)
    // pv = new ProtokollAusgabeDialog(info, this, stream, ausgabeAlsFrame);
    try
    {
      // display protocol-result
      int numData = 1;

      while (stream.hasNext())
      {
        ProtocolResult res = stream.take();
        // Long mostRecentProtocolId = stream.getProtocolId();
        if (true)
        {
          // System.out.println("res " + res);

          if (res instanceof ProtocolAdministrationData && m_printHeader)
          {
            System.out.println("Protokoll-ID: " + stream.getProtocolId());
            ProtocolAdministrationData adminData = (ProtocolAdministrationData)res;
            System.out.print("\t");
            for (int i = 0; i < adminData.columns.length; i++)
            {
              System.out.print(adminData.columns[i].getCaption() + "\t");
            }
            System.out.print("[NAME]\n");
          }
          if (res instanceof ProtocolAggregationData && m_printHeader)
          {
            ProtocolAggregationData aggregData = (ProtocolAggregationData)res;
            System.out.print("\t");
// TODO anpassen
//            for (int i = 0; i < aggregData.aggregations.length; i++)
//            {
//              System.out.print(aggregData.aggregations[i] + "\t");
//            }
            System.out.print("[AGGREGIERT?]\n");
          }
          if (res instanceof ProtocolNoChanges)
          {
            ProtocolNoChanges noChangeData = (ProtocolNoChanges)res;

            StringBuffer sb = new StringBuffer();

            sb.append("EDS ");
            Util.msToDate(sb, noChangeData.timestamp);

            // System.out.println((c++)+" No Change " + noChangeData.timestamp + " " + sb);
            System.out.println(sb + ":\tNo Change");

          }
          if (res instanceof ProtocolResultData)
          {

            ProtocolResultData prd = (ProtocolResultData)res;
            SimpleDateFormat sdf = new SimpleDateFormat("dd.MM.yyyy HH:mm:ss,SSS");

            long ts = prd.getTimeStamp();
            Date d = new Date();
            d.setTime(ts);

            if (info != null)
            {

              String pid = info.getHauptObjekt().getPid();
              System.out.println("Haupt: " + pid);
              String[] strings = info.getPseudoObjekte().get("mq0");
              for (String string : strings)
              {
                System.out.println("Pseudo: " + string);
              }

            }

            System.out.println("Status: " + prd.status + " %");

            String s = sdf.format(d);
            for (int i = 0; i < prd.values.length; i++)
            {
              s += ("\t" + prd.values[i].toString());
            }

            System.out.println("Value : " + s);
          }
          if (res == null && m_printHeader)
          {
            System.out.println("end of stream.");
          }
        }
        else
        {

          // pv.add(res);
          // //Anzeige in einer Tabelle
          // if (first)
          // {
          // if (stream.getProtocolId()!= null)
          // pv.setProtocolId(stream.getProtocolId());
          // first = false;
          // }
        }
      }
      if (!stream.isComplete()) // ggf Fehler ausgeben:
      {
        if (false)
        {
          // pv.showErrorMessage(stream.getErrorMsg());
        }
        else
          System.out.println("\nEs ist ein Fehler aufgetreten: " + stream.getErrorMsg());
      }

    }
    catch (InterruptedException irEx)
    {
      System.out.println("Fehler beim Lesen des Antwortstreams (" + irEx.getMessage() + ").");
      m_requestResult = new ProtocolRequestResult("Fehler beim Lesen des Antwortstreams (" + irEx.getMessage() + ").");
    }

  }

  /**
   * Liefert eine eindeutige PuA-Anfrage-Id.
   * 
   * @return Eindeutige PuA-Anfrage-Id.
   */
  synchronized private long getRequestId()
  {
    return ++m_requestId_dontUseDirectly;
  }

  /**
   * Stt die Protokollerstellung an, wobei das Ergebnis direkt abgerufen wird. Fngt alle(!) Exceptions ab.
   * 
   * @param pp
   *          Auftragsparameter
   * @return Objekt zum Abfragen der Antwort.
   * @throws FailureException
   *           Fehler beim Absetzen der Anfrage.
   */
  public ProtocolResultStream erstelleProtokollMitSofortigerAusgabe(ProcessingParameter pp) throws FailureException
  {
    long id = m_letzteProtokollId = getRequestId();

    ProtocolAnswerReceiver receiver = null;
    ProtocolResultStream prs = null;

    try
    {
      // schon vorher auf Antwort anmelden
      receiver = new ProtocolAnswerReceiver(getConnection(), m_client, id, true, m_timeout);
      // Daten serialisieren & senden:
      m_requestResult = sendRequest(id, ProtocolRelatedOperation.CREATE, pp.serialize());
      prs = new ProtocolResultStream(receiver, m_requestResult);
    }
    catch (Exception e)
    {
      prs = new ProtocolResultStream(null, new ProtocolRequestResult(e));
    }

    return prs;
  }

  /**
   * Stt die Protokollerstellung an, wobei das Ergebnis spter abgerufen wird. Fngt alle(!) Exceptions ab.
   * 
   * @param pp
   *          Auftragsparameter
   * @return Objekt zum Abfragen der Antwort.
   * @throws FailureException
   *           Fehler beim Absetzen der Anfrage.
   */
  public ProtocolResultStream erstelleProtokollOhneAusgabe(ProcessingParameter pp) throws FailureException
  {
    // Eindeutige Id holen
    long id = m_letzteProtokollId = getRequestId();
    ProtocolResultStream prs = null;

    pp.setSaveProtocol(true); // Protokoll ohne sofortige Ausgabe muss gespeichert werden.

    try
    {
      // Daten serialisieren & senden:
      @SuppressWarnings("unused")
      ProtocolRequestResult result = sendRequest(id, ProtocolRelatedOperation.CREATE, pp.serialize());
    }
    catch (Exception e)
    {
      prs = new ProtocolResultStream(null, new ProtocolRequestResult(e));
    }

    return prs;
  }

  /**
   * Stellt eine Anfrage an Protokolle und Auswertungen. Wartet, bis der Auftrag abgesendet wurde.
   * 
   * @param requestId
   *          AnfrageId
   * @param opCode
   *          Operationscode
   * @param requestData
   *          Auftragsparameter
   * @return Status der Anfrage. Falls Anfrage Fehlschlgt, dann lag ein Fehler beim Senden vor.
   * @throws FailureException
   *           Fehler bei Kommunikation mit der Konfiguration.
   */
  private ProtocolRequestResult sendRequest(long requestId, int opCode, byte requestData[]) throws FailureException
  {
    try
    {
      // Zusammenstellen der Anfrage & senden:
      Data request = AtgProtocolRequest.build(getConnection(), m_client, requestId, opCode, requestData);
      if (SimpleSender.sendWait(getConnection(), m_configAuth, m_ddProtocol, request, m_timeout))
        return new ProtocolRequestResult();
      else
        return new ProtocolRequestResult(ErrorMessage.CAN_NOT_SEND);
    }
    catch (SenderException e)
    {
      return new ProtocolRequestResult(e.getMessage());
    }
  }

  /**
   * Liefert eine Liste der gespeicherten Protokolle und Protokollinformationen.
   *
   * @param resultInfo In diesem Objekt werden Fehlermeldungen abgelegt.
   * @param benutzer Benutzer, fr den die Anfrage ausgefhrt wird.
   *
   * @return Array mit Ids der gespeicherten Protokolle oder <code>null</code> bei Fehler.
   */
  private Tuple<Long, ProcessingParameter>[] getSavedProtocolList(ProtocolRequestResult resultInfo, String benutzer)
  {
    return getProtocolList(resultInfo, benutzer, true);
  }

  /**
   * Liefert eine Liste der noch nicht abgerufenen Protokolle und Protokollinformationen.
   * 
   * @param resultInfo In diesem Objekt werden Fehlermeldungen abgelegt.
   * @param benutzer Benutzer, fr den die Anfrage ausgefhrt wird.
   * 
   * @return Array mit Ids der gespeicherten Protokolle oder <code>null</code> bei Fehler.
   */
  private Tuple<Long, ProcessingParameter>[] getUnreadProtocolList(ProtocolRequestResult resultInfo, String benutzer)
  {
    return getProtocolList(resultInfo, benutzer, false);
  }

  /**
   * Liefert eine Liste der gespeicherten bzw. noch nicht abgerufenen Protokolle und Protokollinformationen.
   * 
   * @param resultInfo
   *          In diesem Objekt werden Fehlermeldungen abgelegt.
   * @param read
   *          <code>true</code> gespeicherte Protokolle abrufen. <code>false</code> noch nicht abgerufene Protokolle
   *          senden.
   * @return Array mit Ids der gespeicherten Protokolle oder <code>null</code> bei Fehler.
   */
  private Tuple<Long, ProcessingParameter>[] getProtocolList(ProtocolRequestResult resultInfo, String benutzer, boolean read)
  {
    if (resultInfo == null)
      resultInfo = new ProtocolRequestResult();

    long requestId = getRequestId();
    ProtocolAnswerReceiver receiver = null;
    AtgProtocolRequest answer = null;
    // Auf Antwort anmelden
    try
    {
      receiver = new ProtocolAnswerReceiver(getConnection(), m_client, requestId, false, m_timeout);

      resultInfo.set(sendRequest(requestId, (read) ? ProtocolRelatedOperation.LIST
          : ProtocolRelatedOperation.UNREAD_PROTOCOL_LIST, SerializerUtil.serializeToByteArray(benutzer == null ? "" : benutzer)));
      if (resultInfo.isRequestSuccessful())
      {
        ResultData rd = receiver.take();
        if (rd == null)
          resultInfo.set(ErrorMessage.TIMEOUT);
        else
        {
          answer = AtgProtocolRequest.getJavaObject(rd.getData());
          if (answer.opCode != ProtocolRelatedOperation.ACK_FLAG)
            resultInfo.set((String)SerializerUtil.deserialize(answer.requestData));
          else
            return deserialize(answer.requestData, resultInfo);
        }
      }
    }
    catch (FailureException e)
    {
      e.printStackTrace();

      resultInfo.set(e.getMessage());
    }
    catch (Exception e)
    {
      e.printStackTrace();

      resultInfo.set(ErrorMessage.UNEXPECTED_DATA_TYPE
          + ((answer != null) ? SerializerUtil.deserialize(answer.requestData).getClass().getName() : ""));
    }
    finally
    {
      if (receiver != null)
        receiver.unsubscribe();
    }
    return null;
  }

  /**
   * Deserialisiert Protokollids und Protokollinformationen.
   * 
   * @param data
   *          Serialisierte Daten.
   * @param resultInfo
   *          Wird mit Ergebnis der Operation belegt.
   * @return Liste mit Protokoll-Ids und Protokollinformationen.
   */
  @SuppressWarnings("unchecked")
  private Tuple<Long, ProcessingParameter>[] deserialize(byte[] data, ProtocolRequestResult resultInfo)
  {
    ObjectInputStream ois = null;
    try
    {
      ByteArrayInputStream bis = new ByteArrayInputStream(data);
      ois = new ObjectInputStream(bis);
      long[] protocolIds = null;
      ProcessingParameter[] pp;

      Object o = ois.readObject();
      if (o instanceof byte[][])
      {
        byte[][] field = (byte[][])o;
        o = SerializerUtil.deserialize(field[0]);
        if (o instanceof long[])
        {
          protocolIds = (long[])o;
          pp = new ProcessingParameter[protocolIds.length];
          for (int i = 1; i < field.length; i++)
            pp[i - 1] = ProcessingParameter.deserialize(getDataModel(), field[i]);
          Tuple<Long, ProcessingParameter>[] result = new Tuple[protocolIds.length];
          for (int i = 0; i < protocolIds.length; i++)
            result[i] = new Tuple<Long, ProcessingParameter>(protocolIds[i], pp[i]);

          resultInfo.setSuccessful();
          return result;
        }
        else
          return setAndLog(resultInfo, ErrorMessage.UNEXPECTED_DATA_TYPE + o.getClass().getName()
              + " <-> long[] in PuaClient.deserialize()");
      }
      else
        return setAndLog(resultInfo, ErrorMessage.UNEXPECTED_DATA_TYPE + o.getClass().getName()
            + " <-> byte[][] in PuaClient.deserialize()");
    }
    catch (ClassNotFoundException e)
    {
      return setAndLog(resultInfo, ErrorMessage.CAN_NOT_DESERIALIZE + e.getMessage());
    }
    catch (IOException e)
    {
      return setAndLog(resultInfo, ErrorMessage.CAN_NOT_ACCESS_FILE + e.getMessage());
    }
    catch (FailureException e)
    {
      return setAndLog(resultInfo, e.getMessage());
    }
    finally
    {
      Util.close(ois);
    }
  }

  /**
   * Fehlerbehandlung
   * 
   * @param resultInfo
   * @param string
   * @return Immer null.
   */
  private Tuple<Long, ProcessingParameter>[] setAndLog(ProtocolRequestResult resultInfo, String string)
  {
    resultInfo.set(string);
    m_debug.warning(string);

    return null;
  }

  /**
   * Fragt ein bereits gespeichertes Protokoll ab.
   * 
   * @param protocolId
   *          Protokoll-Id des gespeicherten Protokolls.
   * @return Objekt zum Abfragen der Antwort.
   * @throws FailureException
   *           Fehler beim Absetzen der Anfrage.
   */
  private ProtocolResultStream getSavedProtocol(long protocolId) throws FailureException
  {
    return getProtocol(protocolId, true);
  }

  /**
   * Fragt ein noch nicht abgerufenes gespeichertes Protokoll ab.
   * 
   * @param protocolId
   *          Protokoll-Id des gespeicherten Protokolls.
   * @return Objekt zum Abfragen der Antwort.
   * @throws FailureException
   *           Fehler beim Absetzen der Anfrage.
   */
  private ProtocolResultStream getUnreadProtocol(long protocolId) throws FailureException
  {
    return getProtocol(protocolId, false);
  }

  /**
   * Fragt ein bereits gespeichertes bzw. noch nicht abgerufenens Protokoll ab.
   * 
   * @param protocolId
   *          Protokoll-Id des gespeicherten Protokolls.
   * @param read
   *          <code>true</code> gespeicherte Protokolle abrufen. <code>false</code> noch nicht abgerufene Protokolle
   *          senden.
   * @return Objekt zum Abfragen der Antwort.
   * @throws FailureException
   *           Fehler beim Absetzen der Anfrage.
   */
  private ProtocolResultStream getProtocol(long protocolId, boolean read) throws FailureException
  {
    // Eindeutige Id holen
    long id = getRequestId();
    ProtocolAnswerReceiver receiver = null;
    ProtocolResultStream prs = null;
    try
    {
      // schon vorher auf die Antwort anmelden
      receiver = new ProtocolAnswerReceiver(getConnection(), m_client, id, true, m_timeout);
      // Daten serialisieren und senden
      ProtocolRequestResult result = sendRequest(id, (read) ? ProtocolRelatedOperation.SEND_SAVED_PROTOCOL
          : ProtocolRelatedOperation.SEND_UNREAD_PROTOCOL, SerializerUtil.serializeId(protocolId));
      prs = new ProtocolResultStream(receiver, result);
    }
    catch (Exception e)
    {
      prs = new ProtocolResultStream(null, new ProtocolRequestResult(e));
    }
    return prs;
  }

  /**
   * Sendet den Auftrag 'Skript anlegen/editieren'. Wartet auf eine Antwort von PuA. Behandelt alle(!) Exceptions.
   * Wertet nur die erste Antwort aus, und beendet danach den Empfang von Daten. Es wird zweimal versucht, die Anfrage
   * an PuA zu senden. Dies hat den Grund, dass, falls von createScript auch das dynamische Skriptobjekt erzeugt wurde,
   * PuA eine gewisse Zeit gegeben werde muss, um sich als Empfnger auf dieses Skriptobjekt anzumelden. Das Skriptobjekt
   * wird zudem in {@link #m_recentlyCreatedScript} abgelegt.
   * 
   * @param pid
   *          Pid des Skriptobjekts, das angelegt / editiert werden soll. Sollte nicht <code>null</code> sein. Existiert
   *          noch kein Skriptobjekt mit der bergebenen pid, so wird eins angelegt.
   * @param name
   *          Name des Skripts.
   * @param baseInfo
   *          Grundinformationen.
   * @param source
   *          Skript Quelltext.
   * @return Ergebnis der Anfrage.
   */
  private ProtocolRequestResult createScript(String pid, String name, AtlBase baseInfo, String source)
  {
    SystemObject script = getDataModel().getObject(pid);
    if (script == null) // ggf Skript anlegen
      script = createNewScriptObject(pid, name);
    else if (!script.getType().equals(getDataModel().getType(PidScript.type))) // falls Objekt existiert: Ist es vom
                                                                               // richtigen Typ?
      return new ProtocolRequestResult(
          "Pid ist schon an ein Objekt vergeben. Dieses Objekt kann nicht verwendet werden, da es kein Skriptobjekt ist.");
    if (script == null) // Anlegen hat nicht funktioniert.
      return new ProtocolRequestResult("Fehler beim Anlegen des Skripts.");
    return createScript((DynamicObject)script, baseInfo, source); // Operation durchfhren.
  }

  /**
   * Sendet den Auftrag 'Skript anlegen/editieren'. Wartet auf eine Antwort von PuA. Behandelt alle(!) Exceptions.
   * Wertet nur die erste Antwort aus, und beendet danach den Empfang von Daten. Es wird zweimal versucht, die Anfrage
   * an PuA zu senden. Dies hat den Grund, dass, falls von createScript auch das dynamische Skriptobjekt erzeugt wurde,
   * PuA eine gewisse Zeit gegeben werde muss, um sich als Empfnger auf dieses Skriptobjekt anzumelden.
   * 
   * @param script
   *          Skriptobjekt das angelegt / editiert werden soll. Kann <code>null</code> sein. Dann wird ein neues
   *          Skriptobjekt erzeugt. Der Name des erzeugten Skriptobjekts ist das aktuelle Datum + Zeit. Auf das
   *          Skriptobjekt kann durch {@link #m_recentlyCreatedScript} zugegriffen werden.
   * @param baseInfo
   *          Grundinformationen.
   * @param source
   *          Skript Quelltext.
   * @return Ergebnis der Anfrage.
   */
  private ProtocolRequestResult createScript(DynamicObject script, AtlBase baseInfo, String source)
  {
    ScriptAnswerReceiver receiver = null;
    try
    {
      if (script == null)
      {
        GregorianCalendar gc = new GregorianCalendar();
        gc.clear();
        gc.setTimeInMillis(System.currentTimeMillis());

        script = createNewScriptObject("pua.testSkript." + System.currentTimeMillis(), "Skript vom "
            + gc.getTime().toString());
        if (script == null)
          return new ProtocolRequestResult(ErrorMessage.CAN_NOT_CREATE_SCRIPT_OBJECT);
      }
      this.m_recentlyCreatedScript = script;

      long requestId = getRequestId();
      // schon vorher auf Antwort anmelden
      receiver = new ScriptAnswerReceiver(getConnection(), script, m_client, requestId, m_timeout);

      // Anfrage zusammenstellen und absenden
      AtlExtra atlExtra = new AtlExtra(m_client, requestId, ScriptRelatedOperation.CREATE, source);
      Data requestData = AtgScriptRequest.build(getConnection(), baseInfo, atlExtra);
      boolean sent = SimpleSender.sendWait(getConnection(), script, m_ddScript, requestData, m_timeout);
      if (!sent)
      {
        sleep();
        sent = SimpleSender.sendWait(getConnection(), script, m_ddScript, requestData, m_timeout);
      }
      if (sent)
      {
        // jetzt auf das Ergebnis warten & vergleichen.
        ResultData rd = receiver.take();
        if (rd == null)
          return new ProtocolRequestResult(ErrorMessage.TIMEOUT);
        else
        {
          AtgAnswer answer = AtgAnswer.getJavaObject(rd.getData());
          if (answer.atlExtra.opCode == ScriptRelatedOperation.ACK_FLAG)
            return new ProtocolRequestResult();
          else
            return new ProtocolRequestResult(answer.message);
        }
      }
      else
        return new ProtocolRequestResult(ErrorMessage.SENDING_NOT_ALLOWED);
    }
    catch (Exception e)
    {
      return new ProtocolRequestResult(e.getMessage());
    }
    finally
    {
      if (receiver != null)
        receiver.unsubscribe();
    }
  }

  /**
   * Wartet {@link #WAIT} Millisekunden lang.
   */
  private void sleep()
  {
    try
    {
      Thread.sleep(WAIT);
    }
    catch (Exception e)
    {
      m_debug.finest(ErrorMessage.INTERRUPTED_EXCEPTION, e);
    }
  }

  /**
   * Erzeugt ein neues dynamischen Skriptobjekt und fgt es in die Menge der dynamischen Skriptobjekte ein. Das Objekt
   * wird im Default-KB des AOE erstellt.
   * 
   * @param pid
   *          Pid die dem Objekt zugewiesen wird. Kann <code>null</code> sein.
   * @param name
   *          Name der dem Objekt zugewiesen wird. Kann <code>null</code> sein.
   * @return Erzeugtes Skriptobjekt oder <code>null</code> im Fehlerfall.
   */
  @SuppressWarnings("deprecation")
  private DynamicObject createNewScriptObject(String pid, String name)
  {
    DynamicObject script = null;

    try
    {
      DynamicObjectType dynamicObjectType = null;
      SystemObjectType sot = getDataModel().getType(PidScript.type);
      if (sot instanceof DynamicObjectType)
        dynamicObjectType = (DynamicObjectType)sot;
      else
        throw new FailureException(InterpreterErrorMessage.INVALID_PID, LoggerException.OTHER);
      script = getDataModel().createDynamicObject(dynamicObjectType, pid, name);
      MutableSet scriptSet = m_configAuth.getMutableSet(PidScript.objectSet);
      scriptSet.add(script);
      m_recentlyCreatedScript = script;
    }
    catch (Exception e)
    {
      m_debug.warning("", e);
      script = null;
    }

    return script;
  }

  /**
   * @return the listeUngeleseneProtokolle
   */
  public Vector<ProtokollInformationen> getListeUngeleseneProtokolle()
  {
    return m_listeUngeleseneProtokolle;
  }

  /**
   * @return the listeGespeicherteProtokolle
   */
  public Vector<ProtokollInformationen> getListeGespeicherteProtokolle()
  {
    return m_listeGespeicherteProtokolle;
  }

  /**
   * @return the requestResult
   */
  public ProtocolRequestResult getRequestResult()
  {
    return m_requestResult;
  }

  /**
   * Lscht das bergebene Skript. Entfernt das bergebene Skriptobjekt aus der Menge der Skripte und lscht das
   * dynamische Objekt.
   * 
   * @param script
   *          Skript-Objekt das gelscht werden soll.
   * @return <code>true</code>, wenn gelscht, sonst <code>false</code>.
   */
  public boolean loescheSkript(DynamicObject skript)
  {
    boolean geloescht = false;
    m_requestResult = new ProtocolRequestResult();

    if (skript != null)
    {
      try
      {
        // Skript-Objekt aus der Menge der Skripte lschen

        MutableSet scriptSet = m_configAuth.getMutableSet(PidScript.objectSet);
        scriptSet.remove(skript);

        // Skript-Objekt ungltig machen

        skript.invalidate();

        geloescht = true;
      }
      catch (ConfigurationChangeException e)
      {
        m_requestResult = new ProtocolRequestResult(e);
      }
      catch (Exception e)
      {
        m_requestResult = new ProtocolRequestResult(e);
      }
    }
    else
    {
      m_requestResult = new ProtocolRequestResult("Kein Skript zum Lschen bergeben");
    }

    return geloescht;
  }

  /**
   * Liefert den Quelltext eines Skripts zurck. Blockiert, bis die Antwort eintrifft. Sendet die Anfrage als einfacher
   * Sender.
   * 
   * @param script
   *          Skriptobjekt dessen Quelltext geliefert werden soll.
   * @param source
   *          Buffer, in den der Skriptquelltext abgelegt wird.
   * @param meta
   *          Metainformationen ber das Skript.
   * @return Ergebnis der Operation.
   */
  public ProtocolRequestResult holeSkriptInformationen(DynamicObject script, StringBuffer source, AtlMeta meta)
  {
    ScriptAnswerReceiver receiver = null;
    try
    {
      long requestId = getRequestId();
      // schon vorher auf Antwort anmelden
      receiver = new ScriptAnswerReceiver(getConnection(), script, m_client, requestId, m_timeout);

      AtlExtra extra = new AtlExtra(m_client, requestId, ScriptRelatedOperation.SOURCE, "");
      Data requestData = AtgScriptRequest.build(getConnection(), new AtlBase(), extra);
      if (SimpleSender.sendWait(getConnection(), script, m_ddScript, requestData, m_timeout))
      {
        // jetzt auf das Ergebnis warten & vergleichen.
        ResultData rd = receiver.take();
        if (rd == null)
          return new ProtocolRequestResult(ErrorMessage.TIMEOUT);
        else
        {
          AtgAnswer answer = AtgAnswer.getJavaObject(rd.getData());
          if (answer.atlExtra.opCode == ScriptRelatedOperation.ACK_FLAG)
          {
            source.append(answer.atlExtra.source);
            meta.set(answer.atlMeta);
            return new ProtocolRequestResult();
          }
          else
            return new ProtocolRequestResult(answer.message);
        }
      }
      else
        return new ProtocolRequestResult(ErrorMessage.CAN_NOT_SEND);
    }
    catch (SenderException e)
    {
      return new ProtocolRequestResult(e.getMessage());
    }
    catch (InterruptedException e)
    {
      return new ProtocolRequestResult(ErrorMessage.INTERRUPTED_EXCEPTION + e.getMessage());
    }
    finally
    {
      if (receiver != null)
        receiver.unsubscribe();
    }
  }

  /**
   * Bricht die Protokollerstellung ab. Wartet, bis die Protokollerstellung eine Quittung sendet.
   * {@link ProtocolResultStream#take()} liefert <code>null</code> und {@link ProtocolResultStream#hasNext()}
   * <code>true</code> zurck.
   * 
   * @param protocolId
   *          Protokoll-Id
   * @returnInformationen ber das Absetzen der Anfrage. Positive Quittung nur dann, wenn die Protokollerstellung
   *                      abgebrochen wurde.
   */
  public ProtocolRequestResult abbruchProtokollerstellung(long protocolId)
  {
    long requestId = getRequestId();
    ProtocolAnswerReceiver receiver = null;

    // Auf Antwort anmelden
    try
    {
      receiver = new ProtocolAnswerReceiver(getConnection(), m_client, requestId, false, m_timeout);
      ProtocolRequestResult result = null;
      result = sendRequest(requestId, ProtocolRelatedOperation.ABORT, SerializerUtil.serializeId(protocolId));

      if (result.isRequestSuccessful())
      {
        ResultData rd = receiver.take();

        if (rd == null)
        {
          result.set(ErrorMessage.TIMEOUT);
        }
        else
        {
          AtgProtocolRequest answer = AtgProtocolRequest.getJavaObject(rd.getData());

          if (answer.opCode != ProtocolRelatedOperation.ACK_FLAG)
          {
            try
            {
              result.set((String)SerializerUtil.deserialize(answer.requestData));
            }
            catch (Exception e)
            {
              result.set(ErrorMessage.UNEXPECTED_DATA_TYPE
                  + SerializerUtil.deserialize(answer.requestData).getClass().getName());
            }
          }
        }
      }

      return result;
    }
    catch (FailureException e)
    {
      return new ProtocolRequestResult(e.getMessage());
    }
    catch (InterruptedException e)
    {
      return new ProtocolRequestResult(ErrorMessage.INTERRUPTED_EXCEPTION + e.getMessage());
    }
    finally
    {
      receiver.unsubscribe();
    }
  }

  /**
   * Hlt die laufende Protokollerstellung an.
   * 
   * @param protocolId
   *          Protokoll-Id.
   * @return Informationen ber das Absetzen der Anfrage.
   * @throws FailureException
   *           Fehler bei der Kommunikation mit der Konfiguration.
   */
  public ProtocolRequestResult anhaltenProtokollerstellung(long protocolId) throws FailureException
  {
    long requestId = getRequestId();

    // Daten serialisieren & senden:
    return sendRequest(requestId, ProtocolRelatedOperation.PAUSE_PROTOCOL, SerializerUtil.serializeId(protocolId));
  }

  /**
   * Setzt die angehaltene Protokollerstellung fort.
   * 
   * @param protocolId
   *          Protokoll-Id.
   * @return Informationen ber das Absetzen der Anfrage.
   * @throws FailureException
   *           Fehler bei der Kommunikation mit der Konfiguration.
   */
  public ProtocolRequestResult fortsetzenProtokollerstellung(long protocolId) throws FailureException
  {
    long requestId = getRequestId();

    // Daten serialisieren & senden:
    return sendRequest(requestId, ProtocolRelatedOperation.RESUME_PROTOCOL, SerializerUtil.serializeId(protocolId));
  }

  /**
   * @return Returns the connection.
   */
  private ClientDavInterface getConnection()
  {
    return m_connection;
  }

  /**
   * @return Returns the dataModel.
   */
  private DataModel getDataModel()
  {
    return m_dataModel;
  }

  /**
   * Lscht ein gespeichertes Protokoll.
   * 
   * @param protocolId
   *          Protokoll das gelscht werden soll.
   * @return Informationen ber den Ausgang des Lschvorgangs.
   */
  public ProtocolRequestResult loescheGespeichertesProtokoll(long protocolId)
  {
    ProtocolRequestResult resultInfo = new ProtocolRequestResult();
    long requestId = getRequestId();
    ProtocolAnswerReceiver receiver = null;

    // Auf Antwort anmelden
    try
    {
      receiver = new ProtocolAnswerReceiver(m_connection, m_client, requestId, false, m_timeout);
      resultInfo = sendRequest(requestId, ProtocolRelatedOperation.DELETE, SerializerUtil.serializeId(protocolId));
      if (resultInfo.isRequestSuccessful())
      {
        ResultData rd = receiver.take();
        if (rd == null)
          resultInfo.set(ErrorMessage.TIMEOUT);
        else
        {
          AtgProtocolRequest answer = AtgProtocolRequest.getJavaObject(rd.getData());
          try
          {
            if (answer.opCode != ProtocolRelatedOperation.ACK_FLAG)
              resultInfo.set((String)SerializerUtil.deserialize(answer.requestData));
          }
          catch (Exception e)
          {
            resultInfo.set(ErrorMessage.UNEXPECTED_DATA_TYPE
                + SerializerUtil.deserialize(answer.requestData).getClass().getName());
          }
        }
      }
    }
    catch (FailureException e)
    {
      resultInfo.set(e.getMessage());
    }
    catch (InterruptedException e)
    {
      return new ProtocolRequestResult(ErrorMessage.INTERRUPTED_EXCEPTION + e.getMessage());
    }
    finally
    {
      receiver.unsubscribe();
    }

    return resultInfo;
  }

  /**
   * Liefert den Status der Protokollerstellung.
   * 
   * @param protocolId
   *          Protokoll-Id.
   * @param resultInfo
   *          Informationen ber den Ablauf der Aktion. Kann <code>null</code> sein.
   * @return Status der Protokollerstellung. -1 bei Fehler.
   */
  public byte statusProtokoll(long protocolId, ProtocolRequestResult resultInfo)
  {
    if (resultInfo == null)
      resultInfo = new ProtocolRequestResult();

    long requestId = getRequestId();
    ProtocolAnswerReceiver receiver = null;

    // Auf Antwort anmelden
    try
    {
      receiver = new ProtocolAnswerReceiver(m_connection, m_client, requestId, false, m_timeout);
      resultInfo.set(sendRequest(requestId, ProtocolRelatedOperation.STATUS, SerializerUtil.serializeId(protocolId)));
      if (resultInfo.isRequestSuccessful())
      {
        ResultData rd = receiver.take();
        if (rd == null)
        {
          resultInfo.set(ErrorMessage.TIMEOUT);

          return INVALID_STATUS;
        }
        else
        {
          AtgProtocolRequest answer = AtgProtocolRequest.getJavaObject(rd.getData());
          if (answer.opCode == ProtocolRelatedOperation.STATUS && answer.requestData.length == 1)
          {
            return answer.requestData[0];
          }
          else
          {
            try
            {
              resultInfo.set((String)SerializerUtil.deserialize(answer.requestData));
            }
            catch (Exception e)
            {
              resultInfo.set(ErrorMessage.UNEXPECTED_DATA_TYPE
                  + SerializerUtil.deserialize(answer.requestData).getClass().getName());
            }

            return INVALID_STATUS;
          }
        }
      }
      else
      {
        return INVALID_STATUS;
      }
    }
    catch (Exception e)
    {
      resultInfo.set(e.getMessage());

      return INVALID_STATUS;
    }
    finally
    {
      receiver.unsubscribe();
    }
  }

  /**
   * Methode liefert die Verbindung zum DaV
   * 
   * @return Verbindung zum DaV
   */
  public ClientDavInterface getClientDaVConnection()
  {
    return m_connection;
  }
  
  /**
   * Empfaengerklasse fuer Protokoll-Fertigstellungen.<br>
   * <br>
   * 
   * @version $Revision:
   * 
   * @author SWARCO TRAFFIC SYSTEMS GmbH
   * @author Ralf Horst
   * 
   */
  private class ProtokollFertigstellungAntwortEmpfaenger extends ProtocolAnswerReceiver
  {
    private final ProtokolleUndAuswertungen m_puaClient;

    public ProtokollFertigstellungAntwortEmpfaenger(ClientDavInterface dav, ClientApplication client, final long requestId, ProtokolleUndAuswertungen puaClient)
    {
      super(dav, client, requestId, false, 0);
      m_puaClient = puaClient;
      incoming = null;
    }

    @Override
    protected void update(final ResultData result)
    {
      if(result != null && result.hasData())
      {
        final Data data = result.getData();
        final long id = data.getUnscaledValue(PidProtocol.protocolId).longValue();
        // hier zusaetzlich zum original Code Filterung nach op-code um die Anzahl der Ereignisse zu verringern
        // es wird anscheinend fr jeden fertiggestellten Zeitpunkt eines Protokolls ein Ereignis versendet,
        // zum Schluss kommt ein Datensatz mit dem op-code ProtocolRelatedOperation.PROTOCOL_COMPLETION_INTERFACE
        final long opCode = data.getUnscaledValue(PidProtocol.opCode).longValue();
        if(opCode == ProtocolRelatedOperation.PROTOCOL_COMPLETION_INTERFACE)
        {
          m_puaClient.protokollFertiggestellt(id);
        }
      }
    }
    
    public void update(ResultData[] results)
    {
      for(ResultData resultData : results)
      {
        if(resultData.getData() != null)
        {
          update(resultData);
        }
      }
    }
  }
  
  /**
   * Fuegt einen ProtocolListener fuer Protokoll-Fertigstellungen hinzu.
   * 
   * @param listener ProtocolListener fuer Protokoll-Fertigstellungen
   *          
   * @return ProtocolRequestResult Ergebnis der Listener-Registrierung
   * @throws FailureException
   *           Ausnahme bei der Anmeldung der Empfaengerklasse.
   */
  public ProtocolRequestResult addProtokollListener(final ProtocolListener listener) throws FailureException
  {
    ProtocolRequestResult result = new ProtocolRequestResult();
    synchronized(m_listeners)
    {
      if(m_listeners.size() == 0)
      {
        m_protokollFertigstellungAntwortEmpfaenger = new ProtokollFertigstellungAntwortEmpfaenger(m_connection, m_client, PROTOCOL_COMPLETION_INTERFACE_ID, this);
        result = startenStoppenProtocolListener((byte)1);
      }
      m_listeners.add(listener);
    }
    
    return result;
  }

  /**
   * Entfernt einen ProtocolListener fuer Protokoll-Fertigstellungen.
   * 
   * @param listener ProtocolListener fuer Protokoll-Fertigstellungen
   *          
   * @return ProtocolRequestResult Ergebnis der Listener-Deregistrierung
   * @throws FailureException
   *           Ausnahme bei der Abmeldung der Empfaengerklasse.
   */
  public ProtocolRequestResult removeProtokollListener(final ProtocolListener listener) throws FailureException
  {
    ProtocolRequestResult result = new ProtocolRequestResult();
    synchronized(m_listeners)
    {
      if(m_listeners.remove(listener))
      {
        if(m_listeners.size() == 0)
        {
          result = startenStoppenProtocolListener((byte)0);
          if(m_protokollFertigstellungAntwortEmpfaenger != null)
          {
            m_protokollFertigstellungAntwortEmpfaenger.unsubscribe();
            m_protokollFertigstellungAntwortEmpfaenger = null;
          }
        }
      }
    }
    
    return result;
  }

  private ProtocolRequestResult startenStoppenProtocolListener(final byte action) throws FailureException 
  {
    return sendRequest(PROTOCOL_COMPLETION_INTERFACE_ID, ProtocolRelatedOperation.PROTOCOL_COMPLETION_INTERFACE, new byte[]{action});
  }

  /**
   * Informiert die Listener ber die Fertigstellung eines Protokolls
   * @param id Protokoll-ID
   */
  void protokollFertiggestellt(final long id) 
  {
    synchronized(m_listeners)
    {
      for(final ProtocolListener listener : m_listeners) 
      {
        listener.protocolFinished(id);
      }
    }
  }
}
