/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.pua.basis.puaDataUpdateListener;

import java.util.EventObject;

import de.bsvrz.buv.plugin.pua.basis.pua.daten.ProtokollInformationen;
import de.bsvrz.pua.prot.client.dataobject.ProtocolResult;

public class PuADataUpdateEvent extends EventObject
{
	private static final long serialVersionUID = 1365256169927819792L;
	
	/**
	 * Liste der PuA-Daten
	 */
	private ProtocolResult _result;
	private ProtokollInformationen _info;
	private Integer _viewId;
	private Long _protokollId;
	

	/**
	 * Konstruktor
	 * @param quelle Quelle des Events.
	 * @param meldungen PuA-Daten.
	 */
	public PuADataUpdateEvent(Object quelle, ProtocolResult result, ProtokollInformationen info, int viewId, Long protokollId)
	{
		super(quelle);
		_result = result;
		_info = info;
		_viewId = viewId;
		_protokollId = protokollId;
	}
	
	/**
	 * Liefert die empfangenen PuA-Daten zurck.
	 * @return Betriebsmeldungen.
	 */
	public ProtocolResult getResult()
	{
		return this._result;
	}

  public Integer getViewId()
  {
    return _viewId;
  }

  public ProtokollInformationen getInfo()
  {
    return _info;
  }

  public Long getProtokollId()
  {
    return _protokollId;
  }


	
	
	
	

}
