/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
/* Segment 13 Bedienung und Visualisierung, Plug-In Streckenprofil 
 * Copyright (C) 2009-2010 BitCtrl Systems GmbH
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * Contact Information: 
 * BitCtrl Systems GmbH 
 * Weienfelser Strae 67 
 * 04229 Leipzig 
 * Phone: +49 341-490670 
 * mailto: info@bitctrl.de
 */

package de.bsvrz.buv.plugin.streckenprofil.sts.a8.editor.pages;

import java.awt.Font;
import java.awt.event.WindowFocusListener;
import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.SortedMap;
import java.util.StringTokenizer;
import java.util.TreeMap;

import javax.swing.JComponent;
import javax.swing.JRootPane;
import javax.swing.SwingUtilities;

import net.sf.paperclips.BigPrint;
import net.sf.paperclips.ImagePrint;
import net.sf.paperclips.PagePrint;
import net.sf.paperclips.ScalePrint;
import net.sf.paperclips.SeriesPrint;

import org.eclipse.birt.chart.model.attribute.LineStyle;
import org.eclipse.birt.chart.model.attribute.MarkerType;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.util.EContentAdapter;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.jface.action.Separator;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.printing.Printer;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.IPartListener2;
import org.eclipse.ui.IWorkbenchPartReference;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.forms.IManagedForm;
import org.eclipse.ui.forms.events.ExpansionAdapter;
import org.eclipse.ui.forms.events.ExpansionEvent;
import org.eclipse.ui.forms.widgets.FormToolkit;
import org.eclipse.ui.forms.widgets.ScrolledForm;
import org.eclipse.ui.forms.widgets.Section;
import org.eclipse.ui.part.WorkbenchPart;

import swingintegration.EmbeddedSwingComposite;

import com.bitctrl.lib.eclipse.birt.chart.ChartCanvas;
import com.bitctrl.util.ITwoDimensionalMap;
import com.swarco.sts.chart.control.TAxis;
import com.swarco.sts.chart.control.TChart;
import com.swarco.sts.chart.control.TSeries;
import com.swarco.sts.chart.control.event.TActionEvent;
import com.swarco.sts.chart.control.event.TActionListener;

import de.bsvrz.buv.plugin.streckenprofil.sts.a8.Activator;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.Modell;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.StreckenprofilCanvas;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.actions.ChartAktionenZiel;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.actions.ExportAktion;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.actions.ExportGridAction;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.actions.GitterlinienAktion;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.chart.StreckenprofilChartBuilder;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.daten.IStreckenProfilUIProvider;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.daten.StreckenProfilDataUpdateListener;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.daten.StreckenProfilDiagrammData;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.daten.StreckenProfilGrafischeEigenschaftenData;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.daten.StreckenProfilKonfigurationData;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.daten.StreckenProfilObjektInformationen;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.daten.StreckenProfilUIProvider;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.daten.StreckenProfilUIProviderEvent;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.daten.StreckenProfilGrafischeEigenschaftenData.KnotenArt;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.daten.StreckenProfilGrafischeEigenschaftenData.LinienArt;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.daten.StreckenProfilGrafischeEigenschaftenData.LinienDicke;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.daten.StreckenProfilGrafischeEigenschaftenData.Typ;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.daten.StreckenProfilKonfigurationData.BezeichnungFahrtRichtung;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.daten.StreckenProfilKonfigurationData.BezeichnungGeschwindigkeitBeschraenkung;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.diagram.StreckenProfilZuDiagrammZwischenschicht2;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.editor.IChartUpdateListener;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.editor.StreckenprofilChartComposite;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.editor.StreckenprofilEditor;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.editor.StreckenprofilLegendeComposite;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.editor.StreckenprofilYAxisLeftChartComposite;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.export.MatrixGrid;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.export.MatrixGridPrint;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.AchsenBeschreibung;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.ActivationState;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.AeussererStreckenAbschnitt;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.AnzeigeQuerschnitt;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.DiagrammEigenschaften;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.LinienEigenschaften;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.MessQuerschnitt;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.RealerStreckenAbschnitt;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.SeriesType;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.Strecke;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenKnoten;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenZug;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenprofilPackage;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.TypAnzeigen;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.TypDatenQuellen;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.TypObjektBezeichnung;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.TypPrognoseTyp;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.TypVerkehrsDaten;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.preferences.PreferenceInit;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.type.StreckenProfilElementTyp;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.type.StreckenProfilInhaltTyp;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.util.ImageFactory;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.util.Tupel;
import de.bsvrz.buv.rw.rw.dav.DaVVerbindung;
import de.bsvrz.dav.daf.main.ClientDavInterface;
import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.DataDescription;
import de.bsvrz.dav.daf.main.Dataset;
import de.bsvrz.dav.daf.main.ResultData;
import de.bsvrz.dav.daf.main.Data.Array;
import de.bsvrz.dav.daf.main.archive.ArchiveData;
import de.bsvrz.dav.daf.main.config.Aspect;
import de.bsvrz.dav.daf.main.config.AttributeGroup;
import de.bsvrz.dav.daf.main.config.ConfigurationObject;
import de.bsvrz.dav.daf.main.config.NonMutableSet;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.dav.daf.main.config.SystemObjectType;
import de.bsvrz.sys.funclib.bitctrl.modell.Aspekt;
import de.bsvrz.sys.funclib.bitctrl.modell.DatensatzUpdateEvent;
import de.bsvrz.sys.funclib.bitctrl.modell.DatensatzUpdateListener;
import de.bsvrz.sys.funclib.bitctrl.modell.Datum;
import de.bsvrz.sys.funclib.bitctrl.modell.OnlineDatum;
import de.bsvrz.sys.funclib.bitctrl.modell.SystemObjekt;
import de.bsvrz.sys.funclib.bitctrl.modell.SystemObjektTyp;
import de.bsvrz.sys.funclib.bitctrl.modell.impl.AbstractOnlineDatensatz;
import de.bsvrz.sys.funclib.bitctrl.modell.tmanzeigenglobal.objekte.Anzeige;
import de.bsvrz.sys.funclib.bitctrl.modell.tmanzeigenglobal.onlinedaten.OdAnzeigeEigenschaftIst;
import de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.attribute.AttTmcRichtung;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.attribute.AttFahrStreifenLage;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.FahrStreifen;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.MessQuerschnittAllgemein;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.onlinedaten.OdVerkehrsDatenKurzZeitFs;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.onlinedaten.OdVerkehrsDatenKurzZeitGeglaettetFs;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.onlinedaten.OdVerkehrsDatenKurzZeitGeglaettetMq;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.onlinedaten.OdVerkehrsDatenKurzZeitMq;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.onlinedaten.OdVerkehrsDatenKurzZeitTrendExtraPolationFs;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.onlinedaten.OdVerkehrsDatenKurzZeitTrendExtraPolationMq;
import de.bsvrz.sys.funclib.bitctrl.modell.tmvewsimulationglobal.objekte.OfflineSimulation;
import de.bsvrz.sys.funclib.debug.Debug;

/**
 * {@link org.eclipse.ui.forms.editor.FormPage} in der das berarbeitete Streckenprofil angezeigt wird.
 * @author Pittner
 *
 */
public class StreckenprofilEditorStreckenProfil2 extends AbstractStreckenProfilEditorFormPage implements
    IChartUpdateListener, ChartAktionenZiel
{


  /**
   * Das {@link Composite}, in dem das erweiterte Streckenprofil gemalt wird.
   */
  private StreckenprofilChartComposite streckenprofilChartComposite;

  /**
   * Tabelle der Verkehrsdaten.
   */
  private MatrixGrid<SystemObjekt, LinienEigenschaften, OnlineDatum> matrix;

  /**
   * Das Streckenprofil.
   */
  // private final Modell modell;

  /**
   * Composite, das nur eine Legende enthlt und die Legende des Rahmenwerks bedient.
   */
  private StreckenprofilLegendeComposite streckenprofilLegendeComposite;

  /**
   * Aktion zum exportieren der aktuellen Verkehrsdaten.
   */
  private ExportGridAction exportDataAction;

  /**
   * Der Prfix fr die ID, die der Rahmenwerkslegende bermittelt wird.
   */
  private String legendeID = "ID_LEGENDE_STRECKENPROFIL";

  /**
   * {@link Section}, in der das BIRT - Chart gemalt wird.
   */
  private Section chartSection;

  /**
   * Das {@link Composite} auf der linken Seite, zum Anzeigen der Y-Achsen.
   */
  private StreckenprofilYAxisLeftChartComposite linkeYAchseComposite;

  /**
   * Container, in den das Chart eingepackt wird.
   */
  private ScrolledComposite streckenprofilChartContainerComposite;

  private ImageFactory imageFactory = ImageFactory.getInstanz();

  private ChartComposite chartComposite = null;

  private ExportAktion exportAktion = null;

  private GitterlinienAktion gitterlinienAktion = null;

//  private Button gitterLinksAussen = null;
//
//  private Button gitterLinks = null;
//
//  private Button gitterRechts = null;
//
//  private Button gitterRechtsAussen = null;

  private BezeichnungFahrtRichtung _richtung;

  private Modell _modell;

  private StreckenprofilEditor _editor;  
  
  private final static Color red = new Color(null, 255, 0, 0);
  private final static Color orange = new Color(null, 255, 165, 0);

  private Action actionGitterAussenLinks;

  private Action actionGitterLinks;

  private Action actionGitterRechts;

  private Action actionGitterRechtsAussen;

  private Composite sectionClient2;

  private FormToolkit toolkit;

  private Composite sectionComposite2;
  
  /**
   * Diagrammoptionen Buttons und Texte
   */
  private Text[] textVon = new Text[4];

  private Text[] textBis = new Text[4];

  private Button[] buttonAnwenden = new Button[4];

  private Button[] buttonAuto = new Button[4];
  

  /**
   * Konstruktor zur Erzeugung einer {@link org.eclipse.ui.forms.editor.FormPage} zur Anzeige des Erweiterten
   * Streckenprofils.
   * 
   * @param editor
   *          der Multipage - Editor, zu dem das {@link StreckenprofilEditorStreckenProfil2} gehrt.
   * @param modell
   *          das Modell des Streckenprofils.
   */
  public StreckenprofilEditorStreckenProfil2(final StreckenprofilEditor editor, BezeichnungFahrtRichtung richtung,
      Modell modell)
  {
    super(editor, StreckenprofilEditorStreckenProfil2.class.getName(), "Streckenprofil");
    legendeID += "_" + System.currentTimeMillis();
    _richtung = richtung;
    _modell = modell;
    _editor = editor;
  }

  /**
   * Liefert das {@link Modell} des Streckenprofils.
   * 
   * @return das {@link Modell} des Streckenprofils.
   */
  public Modell getStreckenEditorModell()
  {
    return _modell;
  }
  
  private void testeWert(Event event)
  {
    boolean valid = true;

    String wert = event.text;
    wert.replace(',', '.');
    try
    {
      Double.parseDouble(wert);
    }
    catch (Exception e)
    {
      valid = false;
    }

    if (!valid)
    {
      if (wert.length() == 0)
      {
        valid = true;
      }
      else if (wert.length() == 1 && wert.charAt(0) == '-')
      {
        valid = true;
      }
      else if (wert.endsWith("."))
      {
        wert = wert + "0";
        try
        {
          Double.parseDouble(wert);
          valid = true;
        }
        catch (Exception e)
        {
        }
      }
    }

    if (!valid)
    {
      event.doit = false;
    }
  }
  
  private void createSectionComposite2()
  {
    RowLayout rowLayout1 = new RowLayout(SWT.VERTICAL);
    rowLayout1.pack = false;
    rowLayout1.fill = true;
    rowLayout1.wrap = false;
    RowLayout rowLayout = new RowLayout(SWT.VERTICAL);
    rowLayout.fill = true;
    rowLayout.wrap = false;
    rowLayout.pack = false;
    GridData gridData25 = new GridData();
    gridData25.horizontalAlignment = GridData.FILL;
    gridData25.grabExcessHorizontalSpace = true;
    gridData25.verticalAlignment = GridData.CENTER;
    GridData gridData24 = new GridData();
    gridData24.horizontalAlignment = GridData.FILL;
    gridData24.grabExcessHorizontalSpace = true;
    gridData24.verticalAlignment = GridData.CENTER;
    GridData gridData23 = new GridData();
    gridData23.horizontalAlignment = GridData.FILL;
    gridData23.grabExcessHorizontalSpace = true;
    gridData23.verticalAlignment = GridData.CENTER;
    GridData gridData22 = new GridData();
    gridData22.horizontalAlignment = GridData.FILL;
    gridData22.grabExcessHorizontalSpace = true;
    gridData22.verticalAlignment = GridData.CENTER;
    GridData gridData21 = new GridData();
    gridData21.horizontalAlignment = GridData.CENTER;
    gridData21.verticalAlignment = GridData.BEGINNING;
    GridData gridData20 = new GridData();
    gridData20.horizontalAlignment = GridData.CENTER;
    gridData20.verticalAlignment = GridData.BEGINNING;
    GridData gridData19 = new GridData();
    gridData19.horizontalAlignment = GridData.FILL;
    gridData19.grabExcessHorizontalSpace = true;
    gridData19.verticalAlignment = GridData.CENTER;
    GridData gridData18 = new GridData();
    gridData18.horizontalAlignment = GridData.FILL;
    gridData18.grabExcessHorizontalSpace = true;
    gridData18.verticalAlignment = GridData.CENTER;
    GridData gridData17 = new GridData();
    gridData17.horizontalAlignment = GridData.CENTER;
    gridData17.verticalAlignment = GridData.BEGINNING;
    GridData gridData16 = new GridData();
    gridData16.horizontalAlignment = GridData.CENTER;
    gridData16.verticalAlignment = GridData.BEGINNING;
    GridData gridData15 = new GridData();
    gridData15.horizontalAlignment = GridData.FILL;
    gridData15.grabExcessHorizontalSpace = true;
    gridData15.verticalAlignment = GridData.CENTER;
    GridData gridData14 = new GridData();
    gridData14.horizontalAlignment = GridData.FILL;
    gridData14.grabExcessHorizontalSpace = true;
    gridData14.verticalAlignment = GridData.CENTER;
    GridData gridData13 = new GridData();
    gridData13.horizontalAlignment = GridData.FILL;
    gridData13.grabExcessHorizontalSpace = true;
    gridData13.verticalAlignment = GridData.CENTER;
    GridData gridData12 = new GridData();
    gridData12.horizontalAlignment = GridData.FILL;
    gridData12.grabExcessHorizontalSpace = true;
    gridData12.verticalAlignment = GridData.CENTER;
    GridData gridData11 = new GridData();
    gridData11.horizontalAlignment = GridData.FILL;
    gridData11.grabExcessHorizontalSpace = true;
    gridData11.verticalAlignment = GridData.CENTER;
    GridData gridData10 = new GridData();
    gridData10.horizontalAlignment = GridData.FILL;
    gridData10.grabExcessHorizontalSpace = true;
    gridData10.verticalAlignment = GridData.CENTER;
    GridData gridData7 = new GridData();
    gridData7.grabExcessHorizontalSpace = true;
    gridData7.verticalAlignment = GridData.CENTER;
    gridData7.grabExcessVerticalSpace = false;
    gridData7.horizontalAlignment = GridData.FILL;

    sectionComposite2 = toolkit.createComposite(sectionClient2, SWT.NONE);
    sectionComposite2.setLayout(new GridLayout(4, true));
    sectionComposite2.setLayoutData(gridData7);

    // y-achse (links aussen)
    GridData gridData30 = new GridData();
    gridData30.grabExcessHorizontalSpace = true;
    gridData30.verticalAlignment = GridData.CENTER;
    gridData30.grabExcessVerticalSpace = false;
    gridData30.horizontalAlignment = GridData.FILL;

    Composite yLinksAussen = toolkit.createComposite(sectionComposite2, SWT.NONE);
    yLinksAussen.setLayout(new GridLayout(2, false));
    yLinksAussen.setLayoutData(gridData30);

    toolkit.createLabel(yLinksAussen, "Y-Achse (links aussen)");
    toolkit.createLabel(yLinksAussen, "");

    Composite comp1 = toolkit.createComposite(yLinksAussen, SWT.NULL);
    comp1.setLayout(new GridLayout(2, false));
    comp1.setLayoutData(gridData10);

    Composite buttonComposite = toolkit.createComposite(yLinksAussen, SWT.NONE);
    buttonComposite.setLayoutData(gridData16);
    buttonComposite.setLayout(rowLayout);
    buttonAnwenden[0] = toolkit.createButton(buttonComposite, "Anwenden", SWT.NONE);
    buttonAnwenden[0].addSelectionListener(new SelectionAdapter() {
      public void widgetSelected(SelectionEvent e)
      {
        final double vonWert = Double.parseDouble(textVon[0].getText());
        final double bisWert = Double.parseDouble(textBis[0].getText());
        
        AchsenBeschreibung achsenBeschreibung = holeAchsenBeschreibungAusDiagrammEigenschaften(getChart().getAxis(TAxis.AC_Y0));        
        achsenBeschreibung.setMinimum(vonWert);
        achsenBeschreibung.setMaximum(bisWert);
        
        SwingUtilities.invokeLater(new Runnable() {
          public void run()
          {
            getChart().getAxis(TAxis.AC_Y0).setClip(vonWert, bisWert, false);
            getChart().repaint(false);
          }
        });
      }
    });

    buttonAuto[0] = toolkit.createButton(buttonComposite, "Auto", SWT.NONE);
    buttonAuto[0].addSelectionListener(new SelectionAdapter() {
      public void widgetSelected(SelectionEvent e)
      {
        SwingUtilities.invokeLater(new Runnable() {
          public void run()
          {
            getChart().getAxis(TAxis.AC_Y0).resetClip();
            getChart().repaint(false);
          }
        });
      }
    });

    toolkit.createLabel(comp1, "Von");
    textVon[0] = new Text(comp1, SWT.BORDER);
    textVon[0].setText("0");
    textVon[0].setLayoutData(gridData12);
    textVon[0].addListener(SWT.Verify, new Listener() {
      public void handleEvent(Event event)
      {
        testeWert(event);
      }
    });

    toolkit.createLabel(comp1, "Bis");
    textBis[0] = new Text(comp1, SWT.BORDER);
    textBis[0].setLayoutData(gridData13);
    textBis[0].addListener(SWT.Verify, new Listener() {
      public void handleEvent(Event event)
      {
        testeWert(event);
      }
    });

    // y-achse (links)
    GridData gridData31 = new GridData();
    gridData31.grabExcessHorizontalSpace = true;
    gridData31.verticalAlignment = GridData.CENTER;
    gridData31.grabExcessVerticalSpace = false;
    gridData31.horizontalAlignment = GridData.FILL;

    Composite yLinks = toolkit.createComposite(sectionComposite2, SWT.NONE);
    yLinks.setLayout(new GridLayout(2, false));
    yLinks.setLayoutData(gridData31);

    toolkit.createLabel(yLinks, "Y-Achse (links)");
    toolkit.createLabel(yLinks, "");

    Composite comp2 = toolkit.createComposite(yLinks, SWT.NULL);
    comp2.setLayout(new GridLayout(2, false));
    comp2.setLayoutData(gridData11);

    Composite buttonComposite2 = toolkit.createComposite(yLinks, SWT.NONE);
    buttonComposite2.setLayoutData(gridData17);
    buttonComposite2.setLayout(rowLayout1);
    buttonAnwenden[1] = toolkit.createButton(buttonComposite2, "Anwenden", SWT.NONE);
    buttonAnwenden[1].addSelectionListener(new SelectionAdapter() {
      public void widgetSelected(SelectionEvent e)
      {
        final double vonWert = Double.parseDouble(textVon[1].getText());
        final double bisWert = Double.parseDouble(textBis[1].getText());
        
        AchsenBeschreibung achsenBeschreibung = holeAchsenBeschreibungAusDiagrammEigenschaften(getChart().getAxis(TAxis.AC_Y1));           
        
//        System.out.println("AB: " + achsenBeschreibung);
        
        achsenBeschreibung.setMinimum(vonWert);
        achsenBeschreibung.setMaximum(bisWert);
        
        SwingUtilities.invokeLater(new Runnable() {
          public void run()
          {
            getChart().getAxis(TAxis.AC_Y1).setClip(vonWert, bisWert, false);
            getChart().repaint(false);
          }
        });
      }
    });

    buttonAuto[1] = toolkit.createButton(buttonComposite2, "Auto", SWT.NONE);
    buttonAuto[1].addSelectionListener(new SelectionAdapter() {
      public void widgetSelected(SelectionEvent e)
      {
        SwingUtilities.invokeLater(new Runnable() {
          public void run()
          {
            getChart().getAxis(TAxis.AC_Y1).resetClip();
            getChart().repaint(false);
          }
        });
      }
    });

    toolkit.createLabel(comp2, "Von");
    textVon[1] = new Text(comp2, SWT.BORDER);
    textVon[1].setText("0");
    textVon[1].setLayoutData(gridData14);
    textVon[1].addListener(SWT.Verify, new Listener() {
      public void handleEvent(Event event)
      {
        testeWert(event);
      }
    });

    toolkit.createLabel(comp2, "Bis");
    textBis[1] = new Text(comp2, SWT.BORDER);
    textBis[1].setLayoutData(gridData15);
    textBis[1].addListener(SWT.Verify, new Listener() {
      public void handleEvent(Event event)
      {
        testeWert(event);
      }
    });

    // y-achse (rechts)
    GridData gridData32 = new GridData();
    gridData32.grabExcessHorizontalSpace = true;
    gridData32.verticalAlignment = GridData.CENTER;
    gridData32.grabExcessVerticalSpace = false;
    gridData32.horizontalAlignment = GridData.FILL;

    Composite yRechts = toolkit.createComposite(sectionComposite2, SWT.NONE);
    yRechts.setLayout(new GridLayout(2, false));
    yRechts.setLayoutData(gridData32);

    toolkit.createLabel(yRechts, "Y-Achse (rechts)");
    toolkit.createLabel(yRechts, "");

    Composite comp3 = toolkit.createComposite(yRechts, SWT.NULL);
    comp3.setLayout(new GridLayout(2, false));
    comp3.setLayoutData(gridData18);

    Composite buttonComposite3 = toolkit.createComposite(yRechts, SWT.NONE);
    buttonComposite3.setLayoutData(gridData20);
    buttonComposite3.setLayout(rowLayout);
    buttonAnwenden[2] = toolkit.createButton(buttonComposite3, "Anwenden", SWT.NONE);
    buttonAnwenden[2].addSelectionListener(new SelectionAdapter() {
      public void widgetSelected(SelectionEvent e)
      {
        final double vonWert = Double.parseDouble(textVon[2].getText());
        final double bisWert = Double.parseDouble(textBis[2].getText());
        
        AchsenBeschreibung achsenBeschreibung = holeAchsenBeschreibungAusDiagrammEigenschaften(getChart().getAxis(TAxis.AC_Y2));   
        
        achsenBeschreibung.setMinimum(vonWert);
        achsenBeschreibung.setMaximum(bisWert);
        
        SwingUtilities.invokeLater(new Runnable() {
          public void run()
          {
            getChart().getAxis(TAxis.AC_Y2).setClip(vonWert, bisWert, false);
            getChart().repaint(false);
          }
        });
      }
    });

    buttonAuto[2] = toolkit.createButton(buttonComposite3, "Auto", SWT.NONE);
    buttonAuto[2].addSelectionListener(new SelectionAdapter() {
      public void widgetSelected(SelectionEvent e)
      {
        SwingUtilities.invokeLater(new Runnable() {
          public void run()
          {
            getChart().getAxis(TAxis.AC_Y2).resetClip();
            getChart().repaint(false);
          }
        });
      }
    });

    toolkit.createLabel(comp3, "Von");
    textVon[2] = new Text(comp3, SWT.BORDER);
    textVon[2].setText("0");
    textVon[2].setLayoutData(gridData22);
    textVon[2].addListener(SWT.Verify, new Listener() {
      public void handleEvent(Event event)
      {
        testeWert(event);
      }
    });

    toolkit.createLabel(comp3, "Bis");
    textBis[2] = new Text(comp3, SWT.BORDER);
    textBis[2].setLayoutData(gridData23);
    textBis[2].addListener(SWT.Verify, new Listener() {
      public void handleEvent(Event event)
      {
        testeWert(event);
      }
    });

    // y-achse (rechts aussen)
    GridData gridData33 = new GridData();
    gridData33.grabExcessHorizontalSpace = true;
    gridData33.verticalAlignment = GridData.CENTER;
    gridData33.grabExcessVerticalSpace = false;
    gridData33.horizontalAlignment = GridData.FILL;

    Composite yRechtsAussen = toolkit.createComposite(sectionComposite2, SWT.NONE);
    yRechtsAussen.setLayout(new GridLayout(2, false));
    yRechtsAussen.setLayoutData(gridData33);

    toolkit.createLabel(yRechtsAussen, "Y-Achse (rechts aussen)");
    toolkit.createLabel(yRechtsAussen, "");

    Composite comp4 = toolkit.createComposite(yRechtsAussen, SWT.NULL);
    comp4.setLayout(new GridLayout(2, false));
    comp4.setLayoutData(gridData19);

    Composite buttonComposite4 = toolkit.createComposite(yRechtsAussen, SWT.NONE);
    buttonComposite4.setLayoutData(gridData21);
    buttonComposite4.setLayout(rowLayout);
    buttonAnwenden[3] = toolkit.createButton(buttonComposite4, "Anwenden", SWT.NONE);
    buttonAnwenden[3].addSelectionListener(new SelectionAdapter() {
      public void widgetSelected(SelectionEvent e)
      {
        final double vonWert = Double.parseDouble(textVon[3].getText());
        final double bisWert = Double.parseDouble(textBis[3].getText());
        
        final TAxis axis = getChart().getAxis(TAxis.AC_Y3);
        
        AchsenBeschreibung achsenBeschreibung = holeAchsenBeschreibungAusDiagrammEigenschaften(axis);        
       
        achsenBeschreibung.setMinimum(vonWert);
        achsenBeschreibung.setMaximum(bisWert);
        
        SwingUtilities.invokeLater(new Runnable() {
          public void run()
          {
            axis.setClip(vonWert, bisWert, false);
            getChart().repaint(false);
          }
        });
      }
    });

    buttonAuto[3] = toolkit.createButton(buttonComposite4, "Auto", SWT.NONE);
    buttonAuto[3].addSelectionListener(new SelectionAdapter() {
      public void widgetSelected(SelectionEvent e)
      {
        SwingUtilities.invokeLater(new Runnable() {
          public void run()
          {
            getChart().getAxis(TAxis.AC_Y3).resetClip();
            getChart().repaint(false);
          }
        });
      }
    });

    toolkit.createLabel(comp4, "Von");
    textVon[3] = new Text(comp4, SWT.BORDER);
    textVon[3].setText("0");
    textVon[3].setLayoutData(gridData24);
    textVon[3].addListener(SWT.Verify, new Listener() {
      public void handleEvent(Event event)
      {
        testeWert(event);
      }
    });

    toolkit.createLabel(comp4, "Bis");
    textBis[3] = new Text(comp4, SWT.BORDER);
    textBis[3].setLayoutData(gridData25);
    textBis[3].addListener(SWT.Verify, new Listener() {
      public void handleEvent(Event event)
      {
        testeWert(event);
      }
    });
  }

  @Override
  protected void createFormContent(final IManagedForm managedForm)
  {
    super.createFormContent(managedForm);

    GridData gridData8 = new GridData();
    gridData8.grabExcessHorizontalSpace = true;
    gridData8.verticalAlignment = GridData.FILL;
    gridData8.grabExcessVerticalSpace = false;
    gridData8.horizontalAlignment = GridData.CENTER;
    
    GridData gridData4 = new GridData();
    gridData4.horizontalAlignment = GridData.FILL;
    gridData4.grabExcessHorizontalSpace = true;
    gridData4.grabExcessVerticalSpace = true;
    gridData4.verticalAlignment = GridData.FILL;
    
    GridData gridData5 = new GridData();
    gridData5.horizontalAlignment = GridData.FILL;
    gridData5.grabExcessHorizontalSpace = true;
    gridData5.grabExcessVerticalSpace = false;
    gridData5.verticalAlignment = GridData.CENTER;    
    
    final ScrolledForm form = managedForm.getForm();
    form.setText(getTitle());
    final Composite formBody = form.getForm().getBody();
         
    formBody.setLayout(new GridLayout());
    toolkit = managedForm.getToolkit();
    
    Section section2 = toolkit.createSection(formBody, Section.TITLE_BAR
        | Section.TWISTIE | Section.COMPACT);
    section2.addExpansionListener(new ExpansionAdapter() {
      public void expansionStateChanged(ExpansionEvent e)
      {
        // System.out.println("expanded2: " + e.getState());
      }
    });
    section2.setText("Diagrammoptionen");         
    section2.setLayoutData(gridData5);
    sectionClient2 = toolkit.createComposite(section2);
    sectionClient2.setLayout(new GridLayout());
    sectionClient2.setLayoutData(gridData8);
    
    section2.setClient(sectionClient2);
  
    createSectionComposite2();

    chartSection = toolkit.createSection(formBody, defaultSectionStyle);   
    chartSection.setLayoutData(gridData4);
    chartSection.setText("Diagramm");

    GridData compositeGridData = new GridData();
    compositeGridData.grabExcessHorizontalSpace = true;
    compositeGridData.verticalAlignment = GridData.CENTER;
    compositeGridData.horizontalAlignment = GridData.BEGINNING;
    GridLayout compositeLayout = new GridLayout();
    compositeLayout.numColumns = 1;
    compositeLayout.makeColumnsEqualWidth = false;
    compositeLayout.verticalSpacing = 0;
    compositeLayout.horizontalSpacing = 0;
    Composite composite = toolkit.createComposite(chartSection, SWT.NONE);
    composite.setLayout(compositeLayout);
    composite.setLayoutData(compositeGridData);
    composite.setBackground(new org.eclipse.swt.graphics.Color(null, 255, 255, 255));
    chartSection.setClient(composite);

    final Composite diagramClient = toolkit.createComposite(composite, SWT.NONE);
    toolkit.paintBordersFor(diagramClient);
    
    diagramClient.setLayout(new FillLayout());

    GridData gridData = new GridData();
    gridData.horizontalAlignment = GridData.FILL;
    gridData.grabExcessHorizontalSpace = true;
    gridData.grabExcessVerticalSpace = true;
    gridData.verticalAlignment = GridData.FILL;
    diagramClient.setLayoutData(gridData);

    chartComposite = new ChartComposite(diagramClient, SWT.EMBEDDED, this);
    chartComposite.create();
    exportAktion = new ExportAktion(this);
    gitterlinienAktion = new GitterlinienAktion(this);
    
    final IToolBarManager toolBarManager = form.getToolBarManager();
    
    Action actionDrucken = new Action(
        "Drucken", Activator.getDefault().getImageDescriptor("icons/printview_tsk.gif")) {

      /*
       * (non-Javadoc)
       * 
       * @see org.eclipse.jface.action.Action#run()
       */
      @Override
      public void run() {
        exportAktion.doExportAktion(ExportAktion.EX_PRINT_VIEW);
      }

    };    
    actionDrucken.setToolTipText("Diagramm-Streckenprofil drucken");
    toolBarManager.add(actionDrucken);
    
    Action actionPdfHochformat = new Action(
        "PDFHochformat", Activator.getDefault().getImageDescriptor("icons/export_pdf_a4_pt.gif")) {
      
      /*
       * (non-Javadoc)
       * 
       * @see org.eclipse.jface.action.Action#run()
       */
      @Override
      public void run() {
        exportAktion.doExportAktion(ExportAktion.EX_PDF_A4_HOCHFORMAT);
      }
      
    };
    actionPdfHochformat.setToolTipText("PDF-Export Hochformat");
    toolBarManager.add(actionPdfHochformat);
    
    Action actionPdfQuerformat = new Action(
        "PDFQuerformat", Activator.getDefault().getImageDescriptor("icons/export_pdf_a4_ls.gif")) {
      
      /*
       * (non-Javadoc)
       * 
       * @see org.eclipse.jface.action.Action#run()
       */
      @Override
      public void run() {
        exportAktion.doExportAktion(ExportAktion.EX_PDF_A4_QUERFORMAT);
      }
      
    };
    actionPdfQuerformat.setToolTipText("PDF-Export Querformat");
    toolBarManager.add(actionPdfQuerformat);
    
    toolBarManager.add(new Separator());   
    
    actionGitterAussenLinks = new Action(
        "GitterLinksAussen", IAction.AS_CHECK_BOX ) {
      
      /*
       * (non-Javadoc)
       * 
       * @see org.eclipse.jface.action.Action#run()
       */
      @Override
      public void run() {
        
        actionGitterLinks.setChecked(false);
        actionGitterRechts.setChecked(false);
        actionGitterRechtsAussen.setChecked(false);
        
        if (actionGitterAussenLinks.isChecked())
        {
          gitterlinienAktion.doGitterlinienAktion(GitterlinienAktion.GA_AU_LINKS);
        }
        else
        {
          gitterlinienAktion.doGitterlinienAktion(GitterlinienAktion.GA_AUS);
        }
      }
      
    };    
    actionGitterAussenLinks.setImageDescriptor(Activator.getDefault().getImageDescriptor("icons/grid_osleft.gif"));
    actionGitterAussenLinks.setToolTipText("Gitter links auen anzeigen");
    actionGitterAussenLinks.setEnabled(false);
    toolBarManager.add(actionGitterAussenLinks);

    actionGitterLinks = new Action(
        "GitterLinks", IAction.AS_CHECK_BOX ) {
      
      /*
       * (non-Javadoc)
       * 
       * @see org.eclipse.jface.action.Action#run()
       */
      @Override
      public void run() {
        
        actionGitterAussenLinks.setChecked(false);
        actionGitterRechts.setChecked(false);
        actionGitterRechtsAussen.setChecked(false);
        
        if (actionGitterLinks.isChecked())
        {
          gitterlinienAktion.doGitterlinienAktion(GitterlinienAktion.GA_LINKS);
        }
        else
        {
          gitterlinienAktion.doGitterlinienAktion(GitterlinienAktion.GA_AUS);
        }
      }
      
    };
    actionGitterLinks.setImageDescriptor(Activator.getDefault().getImageDescriptor("icons/grid_left.gif"));
    actionGitterLinks.setToolTipText("Gitter links anzeigen");
    actionGitterLinks.setEnabled(false);
    toolBarManager.add(actionGitterLinks);
    
    actionGitterRechts = new Action(
        "GitterRechtsAnzeigen", IAction.AS_CHECK_BOX ) {
      
      /*
       * (non-Javadoc)
       * 
       * @see org.eclipse.jface.action.Action#run()
       */
      @Override
      public void run() {
        
        actionGitterAussenLinks.setChecked(false);
        actionGitterLinks.setChecked(false);
        actionGitterRechtsAussen.setChecked(false);
        
        if (actionGitterRechts.isChecked())
        {
          gitterlinienAktion.doGitterlinienAktion(GitterlinienAktion.GA_RECHTS);
        }
        else
        {
          gitterlinienAktion.doGitterlinienAktion(GitterlinienAktion.GA_AUS);
        }
      }
      
    };
    actionGitterRechts.setImageDescriptor(Activator.getDefault().getImageDescriptor("icons/grid_right.gif"));
    actionGitterRechts.setToolTipText("Gitter rechts anzeigen");
    actionGitterRechts.setEnabled(false);
    toolBarManager.add(actionGitterRechts);
    
    actionGitterRechtsAussen = new Action(
        "GitterRechtsAussen", IAction.AS_CHECK_BOX ) {
      
      /*
       * (non-Javadoc)
       * 
       * @see org.eclipse.jface.action.Action#run()
       */
      @Override
      public void run() {
        
        actionGitterAussenLinks.setChecked(false);
        actionGitterLinks.setChecked(false);
        actionGitterRechts.setChecked(false);
        
        if (actionGitterRechtsAussen.isChecked())
        {
          gitterlinienAktion.doGitterlinienAktion(GitterlinienAktion.GA_AU_RECHTS);
        }
        else
        {
          gitterlinienAktion.doGitterlinienAktion(GitterlinienAktion.GA_AUS);
        }
      }
      
    };
    actionGitterRechtsAussen.setImageDescriptor(Activator.getDefault().getImageDescriptor("icons/grid_osright.gif"));
    actionGitterRechtsAussen.setToolTipText("Gitter rechts auen anzeigen");
    actionGitterRechtsAussen.setEnabled(false);
    toolBarManager.add(actionGitterRechtsAussen);
    
//    toolBarManager.add(new Separator());       
//    
//    Action actionLegende = new Action("Legende", IAction.AS_CHECK_BOX)
//    {
//      /*
//       * (non-Javadoc)
//       * 
//       * @see org.eclipse.jface.action.Action#run()
//       */
//      @Override
//      public void run() {
//        StreckenProfilZuDiagrammZwischenschicht2 tmp = chartComposite.getStreckenProfilZuDiagrammZwischenschicht();
//        if(tmp != null)
//        {
//          tmp.setSideLegendVisible(this.isChecked());
//        }
//      }
//    };
//    actionLegende.setChecked(true);
//    actionLegende.setImageDescriptor(Activator.getDefault().getImageDescriptor("icons/outline_co.gif"));
//    actionLegende.setToolTipText("Legende ein-/ausschalten");
//    actionLegende.setEnabled(true);    
//    toolBarManager.add(actionLegende);
    
    toolBarManager.update(true);
    formBody.layout(true);
    
    // Online-Hilfe hinzufgen
    PlatformUI
        .getWorkbench()
        .getHelpSystem()
        .setHelp(
            getManagedForm().getForm(),
            Activator.PLUGIN_ID
                + "."
                + StreckenprofilEditorStreckenProfil2.class
                    .getSimpleName());
    
    
//    getChartComposite().initChart();
  }
  
  /*
   * (non-Javadoc)
   * 
   * @see org.eclipse.ui.forms.editor.FormPage#setFocus()
   */
  @Override
  public void setFocus()
  {
    getManagedForm().getForm().setFocus();
  }

  /*
   * (non-Javadoc)
   * 
   * @see org.eclipse.ui.forms.editor.FormPage#dispose()
   */
  @Override
  public void dispose()
  {     
    if (chartComposite != null && !chartComposite.isDisposed())
      chartComposite.destroy();
    super.dispose();
  }

  @Override
  public void datensatzAktualisiert(final ITwoDimensionalMap<SystemObjekt, LinienEigenschaften, OnlineDatum> valueMap)
  {

//    System.out.println("StreckenprofilEditorStreckenProfil2.datensatzAktualisiert(): " + valueMap.values().size());

    if (matrix != null)
    {
      matrix.setInput(valueMap);
      exportDataAction.setTitleText(streckenprofilChartComposite.getTitle());
    }
    chartSection.setText(streckenprofilChartComposite.getTitle());
    chartSection.layout();
  }

  /**
   * Exportiert die aktuell im Erweiteren Streckenprofil angezeigten Verkehrsdaten.
   */
  public void streckenprofilDatenExportieren()
  {
    if (exportDataAction != null)
    {
      exportDataAction.run();
    }
  }

  /**
   * Neuberechnung des Layouts, damit nur das Chart selbst Scrollbars zeichnet.
   */
  private void layoutModified()
  {
    if (streckenprofilChartComposite != null && !streckenprofilChartComposite.isDisposed())
    {
      streckenprofilChartComposite.setSize(StreckenprofilCanvas.MIN_BREITE, StreckenprofilCanvas.MIN_HOEHE);
      streckenprofilChartContainerComposite.setMinSize(streckenprofilChartComposite.getSize());
      streckenprofilChartContainerComposite.getHorizontalBar().setVisible(true);
      streckenprofilChartContainerComposite.layout(true, true);

      getManagedForm().getForm().setMinSize(getPartControl().getSize());
    }
  }

  @Override
  public void setSimulation(final OfflineSimulation simulation)
  {
    if (streckenprofilChartComposite != null)
    {
      streckenprofilChartComposite.setSimulation(simulation);
    }
  }

  /*
   * (non-Javadoc)
   * 
   * @see org.eclipse.ui.part.WorkbenchPart#getAdapter(java.lang.Class)
   */
  @SuppressWarnings("unchecked")
  @Override
  public Object getAdapter(final Class adapter)
  {   
    {
      return super.getAdapter(adapter);
    }
  }

  @Override
  public PagePrint getDruckAuftrag()
  {
    final SeriesPrint col = new SeriesPrint();

    // Tabelle
    col.add(new BigPrint(new ScalePrint(new MatrixGridPrint<SystemObjekt, LinienEigenschaften, OnlineDatum>(matrix))));

    // // Legende
    // final StreckenprofilLegendeChartBuilder builder = new StreckenprofilLegendeChartBuilder(
    // modell);
    // for (final LinienEigenschaften lp : modell.getLineProperties()) {
    // builder.setLineData(lp, null);
    // }
    // builder.getChart().getBlock().getBounds().setWidth(400);
    //
    // int anzahlLegendenEintraege = modell.getLineProperties().size();
    // if (modell.getChartProperties().isAnzeigeQuerschnitteIcons()) {
    // anzahlLegendenEintraege++;
    // }
    // if (modell.getChartProperties().isGeschwindigkeitsLimitIcons()) {
    // anzahlLegendenEintraege++;
    // }
    // if (modell.getChartProperties().isGeschwindigkeitsLimitLinie()) {
    // anzahlLegendenEintraege++;
    // }

    // builder.getChart().getBlock().getBounds().setHeight(
    // Math.max(anzahlLegendenEintraege * LEGENDEN_EINTRAG_HOEHE, 50));
    //
    // col.add(new BigPrint(new ScalePrint(new BirtChartPrint(builder
    // .getChart()))));

    streckenprofilChartComposite.setAlleAchsenSichtbarkeit(true);
    final ChartCanvas canvas = streckenprofilChartComposite.getChartCanvas();
    canvas.regenerateChart();

    // Chart
    final Printer p = new Printer();
    final Image img = new Image(p, canvas.getBounds());
    final GC gc = new GC(img);
    canvas.print(gc);
    gc.dispose();

    streckenprofilChartComposite.setAlleAchsenSichtbarkeit(false);
    canvas.regenerateChart();

    final ImageData imgData = img.getImageData();
    img.dispose();
    col.add(new BigPrint(new ScalePrint(new ImagePrint(imgData))));
    return new PagePrint(col);

  }

  @Override
  public String getTitel()
  {
//    return streckenprofilChartComposite.getTitle();
    return chartComposite.getTitel();
  }

  @Override
  public TChart getChart()
  {
    TChart ret = null;

    ChartComposite tmp = chartComposite;
    if (tmp != null)
    {
      ret = tmp.getChart();
    }

    return (ret);
  }

  @Override
  public void setGitterlinienAktion(final int type)
  {
    Display.getDefault().asyncExec(new Runnable() {
      public void run()
      {
        if (type == GitterlinienAktion.GA_AU_LINKS && actionGitterAussenLinks.isEnabled())
        {
          actionGitterAussenLinks.setChecked(true);
          actionGitterLinks.setChecked(false);
          actionGitterRechts.setChecked(false);
          actionGitterRechtsAussen.setChecked(false);
        }
        else if (type == GitterlinienAktion.GA_LINKS && actionGitterLinks.isEnabled())
        {
          actionGitterAussenLinks.setChecked(false);
          actionGitterLinks.setChecked(true);
          actionGitterRechts.setChecked(false);
          actionGitterRechtsAussen.setChecked(false);
        }
        else if (type == GitterlinienAktion.GA_RECHTS && actionGitterRechts.isEnabled())
        {
          actionGitterAussenLinks.setChecked(false);
          actionGitterLinks.setChecked(false);
          actionGitterRechts.setChecked(true);
          actionGitterRechtsAussen.setChecked(false);
        }
        else if (type == GitterlinienAktion.GA_AU_RECHTS && actionGitterRechtsAussen.isEnabled())
        {
          actionGitterAussenLinks.setChecked(false);
          actionGitterLinks.setChecked(false);
          actionGitterRechts.setChecked(false);
          actionGitterRechtsAussen.setChecked(true);
        }
        else if (type == GitterlinienAktion.GA_AUS)
        {
          actionGitterAussenLinks.setChecked(false);
          actionGitterLinks.setChecked(false);
          actionGitterRechts.setChecked(false);
          actionGitterRechtsAussen.setChecked(false);
        }
      }
    });
  }

  private class PaintActionListener implements TActionListener
  {
    private boolean destroyed = false;

    private Object destroySync = new Object();

    public void destroy()
    {
      synchronized (destroySync)
      {
        destroyed = true;
      }
    }

    public void actionPerformed(TActionEvent actionEvent)
    {
      synchronized (destroySync)
      {
        if (!destroyed && actionEvent.isAction(TChart.CHART_POST_PAINT))
        {
          final boolean auLinksVisible = getChart().getAxis(TAxis.AC_Y0).isVisible();
          final boolean linksVisible = getChart().getAxis(TAxis.AC_Y1).isVisible();
          final boolean rechtsVisible = getChart().getAxis(TAxis.AC_Y2).isVisible();
          final boolean auRechtsVisible = getChart().getAxis(TAxis.AC_Y3).isVisible();

          Display.getDefault().asyncExec(new Runnable() {
            public void run()
            {
              if (!destroyed)
              {
                
                if (actionGitterAussenLinks.isEnabled() != auLinksVisible)
                {
                  if (actionGitterAussenLinks.isEnabled())
                  {
                    if (actionGitterAussenLinks.isChecked())
                    {
                      gitterlinienAktion.doGitterlinienAktion(GitterlinienAktion.GA_AUS);
                    }
                    actionGitterAussenLinks.setChecked(false);
                    actionGitterAussenLinks.setEnabled(false);
                  }
                  else
                  {
                    actionGitterAussenLinks.setChecked(false);
                    actionGitterAussenLinks.setEnabled(true);
                  }
                }

                if (actionGitterLinks.isEnabled() != linksVisible)
                {
                  if (actionGitterLinks.isEnabled())
                  {
                    if (actionGitterLinks.isChecked())
                    {
                      gitterlinienAktion.doGitterlinienAktion(GitterlinienAktion.GA_AUS);
                    }
                    actionGitterLinks.setChecked(false);
                    actionGitterLinks.setEnabled(false);
                  }
                  else
                  {
                    actionGitterLinks.setChecked(false);
                    actionGitterLinks.setEnabled(true);
                  }
                }
                if (actionGitterRechts.isEnabled() != rechtsVisible)
                {
                  if (actionGitterRechts.isEnabled())
                  {
                    if (actionGitterRechts.isChecked())
                    {
                      gitterlinienAktion.doGitterlinienAktion(GitterlinienAktion.GA_AUS);
                    }
                    actionGitterRechts.setChecked(false);
                    actionGitterRechts.setEnabled(false);
                  }
                  else
                  {
                    actionGitterRechts.setChecked(false);
                    actionGitterRechts.setEnabled(true);
                  }
                }
                if (actionGitterRechtsAussen.isEnabled() != auRechtsVisible)
                {
                  if (actionGitterRechtsAussen.isEnabled())
                  {
                    if (actionGitterRechtsAussen.isChecked())
                    {
                      gitterlinienAktion.doGitterlinienAktion(GitterlinienAktion.GA_AUS);
                    }
                    actionGitterRechtsAussen.setChecked(false);
                    actionGitterRechtsAussen.setEnabled(false);
                  }
                  else
                  {
                    actionGitterRechtsAussen.setChecked(false);
                    actionGitterRechtsAussen.setEnabled(true);
                  }
                }
              }
            }
          });
        }
      }
    }
//    public void actionPerformed(TActionEvent actionEvent)
//    {
//      synchronized (destroySync)
//      {
//        if (!destroyed && actionEvent.isAction(TChart.CHART_POST_PAINT))
//        {
//          final boolean auLinksVisible = getChart().getAxis(TAxis.AC_Y0).isVisible();
//          final boolean linksVisible = getChart().getAxis(TAxis.AC_Y1).isVisible();
//          final boolean rechtsVisible = getChart().getAxis(TAxis.AC_Y2).isVisible();
//          final boolean auRechtsVisible = getChart().getAxis(TAxis.AC_Y3).isVisible();
//          
//          Display.getDefault().asyncExec(new Runnable() {
//            public void run()
//            {
//              if (!destroyed)
//              {
//                
//                if (!gitterLinksAussen.isDisposed() && gitterLinksAussen.isEnabled() != auLinksVisible)
//                {
//                  if (gitterLinksAussen.isEnabled())
//                  {
//                    if (gitterLinksAussen.getSelection())
//                    {
//                      gitterlinienAktion.doGitterlinienAktion(GitterlinienAktion.GA_AUS);
//                    }
//                    gitterLinksAussen.setSelection(false);
//                    gitterLinksAussen.setEnabled(false);
//                  }
//                  else
//                  {
//                    gitterLinksAussen.setSelection(false);
//                    gitterLinksAussen.setEnabled(true);
//                  }
//                }
//                
//                if (!gitterLinks.isDisposed() && gitterLinks.isEnabled() != linksVisible)
//                {
//                  if (gitterLinks.isEnabled())
//                  {
//                    if (gitterLinks.getSelection())
//                    {
//                      gitterlinienAktion.doGitterlinienAktion(GitterlinienAktion.GA_AUS);
//                    }
//                    gitterLinks.setSelection(false);
//                    gitterLinks.setEnabled(false);
//                  }
//                  else
//                  {
//                    gitterLinks.setSelection(false);
//                    gitterLinks.setEnabled(true);
//                  }
//                }
//                if (!gitterRechts.isDisposed() && gitterRechts.isEnabled() != rechtsVisible)
//                {
//                  if (gitterRechts.isEnabled())
//                  {
//                    if (gitterRechts.getSelection())
//                    {
//                      gitterlinienAktion.doGitterlinienAktion(GitterlinienAktion.GA_AUS);
//                    }
//                    gitterRechts.setSelection(false);
//                    gitterRechts.setEnabled(false);
//                  }
//                  else
//                  {
//                    gitterRechts.setSelection(false);
//                    gitterRechts.setEnabled(true);
//                  }
//                }
//                if (!gitterRechtsAussen.isDisposed() && gitterRechtsAussen.isEnabled() != auRechtsVisible)
//                {
//                  if (gitterRechtsAussen.isEnabled())
//                  {
//                    if (gitterRechtsAussen.getSelection())
//                    {
//                      gitterlinienAktion.doGitterlinienAktion(GitterlinienAktion.GA_AUS);
//                    }
//                    gitterRechtsAussen.setSelection(false);
//                    gitterRechtsAussen.setEnabled(false);
//                  }
//                  else
//                  {
//                    gitterRechtsAussen.setSelection(false);
//                    gitterRechtsAussen.setEnabled(true);
//                  }
//                }
//              }
//            }
//          });
//        }
//      }
//    }
  }
  
  private void setSektionEinstellungen(final int sektionIndex, final boolean eingeschaltet, final int vonWert,
      final int bisWert)
  {
//    System.out.println("StreckenprofilEditorStreckenProfil2.setSektionEinstellungen(): " + sektionIndex + " : " + eingeschaltet + " - " + vonWert + " - " + bisWert);
    
    Display.getDefault().asyncExec(new Runnable() {
      public void run()
      {
        _setSektionEinstellungen(sektionIndex, eingeschaltet, vonWert, bisWert);
      }
    });
  }

  private void _setSektionEinstellungen(int sektionIndex, boolean eingeschaltet, int vonWert, int bisWert)
  {
    if (sektionIndex >= 0 && sektionIndex < buttonAnwenden.length)
    {
      if (!buttonAnwenden[sektionIndex].isDisposed() && !buttonAuto[sektionIndex].isDisposed())
      {
        buttonAnwenden[sektionIndex].setEnabled(eingeschaltet);
        buttonAuto[sektionIndex].setEnabled(eingeschaltet);
      }

      if (!textVon[sektionIndex].isDisposed() && !textBis[sektionIndex].isDisposed())
      {
        textVon[sektionIndex].setEnabled(eingeschaltet);
        if (eingeschaltet)
        {
          textVon[sektionIndex].setText("" + vonWert);
        }
        else
        {
          textVon[sektionIndex].setText("0");
        }
        textBis[sektionIndex].setEnabled(eingeschaltet);
        if (eingeschaltet)
        {
          textBis[sektionIndex].setText("" + bisWert);
        }
        else
        {
          textBis[sektionIndex].setText("");
        }
      }
    }
  }
  
  private class AxisRangeListener implements TActionListener
  {
    public void actionPerformed(TActionEvent actionEvent)
    {
//      System.out.println("StreckenprofilEditorStreckenProfil2.AxisRangeListener.actionPerformed()");
      
      if (actionEvent.isAction(TAxis.AXIS_CLIP))
      {
        final double[] clip = (double[])actionEvent.getValue();

        int axisIndex = -1;
        TAxis axis = (TAxis)actionEvent.getSource();
        if (axis.isAxis(TAxis.AC_Y0))
        {
          axisIndex = 0;
        }
        else if (axis.isAxis(TAxis.AC_Y1))
        {
          axisIndex = 1;
        }
        else if (axis.isAxis(TAxis.AC_Y2))
        {
          axisIndex = 2;
        }
        else if (axis.isAxis(TAxis.AC_Y3))
        {
          axisIndex = 3;
        }else{
//          System.out.println("else: " + axis.getAxisFooter());
        }

        if (axisIndex != -1)
        {
          
          AchsenBeschreibung beschreibung = holeAchsenBeschreibungAusDiagrammEigenschaften(axis);
          if (beschreibung != null){            
            
            clip[0] = beschreibung.getMinimum();
            clip[1] = beschreibung.getMaximum();
          }
          
//          System.out.println("---> Beschreibung2: " + axisIndex + " : " + beschreibung);
          
          if (Double.isNaN(clip[0]) || Double.isNaN(clip[1]))
          {
            setSektionEinstellungen(axisIndex, false, 0, 0);
          }
          else
          {
            int vonWert = (int)Math.floor(clip[0]);
            int bisWert = (int)Math.ceil(clip[1]);                                          
            setSektionEinstellungen(axisIndex, true, vonWert, bisWert);
            //axis.setClip(vonWert, bisWert, false);
          }    
          getChart().repaint(false);
        }
      }
    }
  }

  public class ChartComposite extends EmbeddedSwingComposite implements WindowFocusListener, IPartListener2,
      DatensatzUpdateListener, IStreckenProfilUIProvider
  {
    private WorkbenchPart viewPart = null;

    private JRootPane rootPane = null;

    private StreckenProfilZuDiagrammZwischenschicht2 zwischenschicht = null;

    private PaintActionListener paintActionListener = null;

    private Object destroySync = new Object();

    /**
     * Cach mit allen Rckwrtsreferenzen von DAV MQ nach EMF Modell MQ.
     */
    private final Map<MessQuerschnittAllgemein, MessQuerschnitt> mqModelCache = new HashMap<MessQuerschnittAllgemein, MessQuerschnitt>();

    /**
     * Map mit allen {@link MessQuerschnittAllgemein} und deren aktuellen {@link AbstractOnlineDatensatz}en, fr die wir
     * uns am DAV angemeldet haben.
     */
    private final Map<MessQuerschnittAllgemein, AbstractOnlineDatensatz<?>> angemeldeteMQs = new HashMap<MessQuerschnittAllgemein, AbstractOnlineDatensatz<?>>();

    /**
     * Map mit allen {@link FahrStreifen} und deren {@link AbstractOnlineDatensatz}en, fr die wir uns angemeldet haben.
     */
    private final Map<FahrStreifen, AbstractOnlineDatensatz<?>> angemeldeteFSs = new HashMap<FahrStreifen, AbstractOnlineDatensatz<?>>();

    private Map<String, SortedMap<Long, Object>> mapSeriesTmp = new HashMap<String, SortedMap<Long, Object>>();
    
    private Map<String, SortedMap<Long, Object>> mapSeries = Collections.synchronizedMap(mapSeriesTmp);

    private Map<String, Map<String, SortedMap<Long, Object>>> mapObject = new HashMap<String, Map<String, SortedMap<Long, Object>>>() {
      {
        put("Object", mapSeries);
      }
    };

    /**
     * {@link Comparator} fr {@link LinienEigenschaften}. Es wird hierbei zuchst
     * {@link LinienEigenschaften#getTypDatenQuelle()} verglichen. Bei gleichheit wird noch
     * {@link LinienEigenschaften#getTypVerkehrsDaten()} als Vergleichswert bemht.
     * 
     * @author BitCtrl Systems GmbH, hoesel
     * @version $Id: StreckenprofilEditorStreckenProfil2.java,v 1.42 2014/05/13 15:49:10 Pittner Exp $
     */
    protected class LinePropertiesComparator implements Comparator<LinienEigenschaften>
    {

      @Override
      public int compare(final LinienEigenschaften o1, final LinienEigenschaften o2)
      {
        int result = o1.getTypDatenQuelle().compareTo(o2.getTypDatenQuelle());
        if (result == 0)
        {
          result = o1.getTypVerkehrsDaten().compareTo(o2.getTypVerkehrsDaten());
        }
        return result;
      }

    }

    /**
     * Map, in der wir die Onlinedaten cachen. Es wird dabei fr jede {@link LinienEigenschaften} eine Map mit
     * {@link SystemObjekt}en und den momentan fr dieses {@link SystemObjekt} aktuellen {@link OnlineDatum}s
     * gespeichert.
     */
    private final Map<LinienEigenschaften, Map<SystemObjekt, OnlineDatum>> onlineDaten = new TreeMap<LinienEigenschaften, Map<SystemObjekt, OnlineDatum>>(
        new LinePropertiesComparator());

    /**
     * Map mit allen {@link AnzeigeQuerschnitt}en. Und den aktuellen {@link OdAnzeigeEigenschaftIst.Daten} pro
     * {@link Anzeige}.
     */
    private final Map<AnzeigeQuerschnitt, Map<Anzeige, OdAnzeigeEigenschaftIst.Daten>> anzeigeDaten = new HashMap<AnzeigeQuerschnitt, Map<Anzeige, OdAnzeigeEigenschaftIst.Daten>>();

    private HashMap<SystemObject, Data> mapSystemObjectData;

    public ChartComposite(Composite parent, int style, WorkbenchPart viewPart)
    {
      super(parent, style);
      this.viewPart = viewPart;
      populate();
      getFrame().addWindowFocusListener(this);
       
      chartBuilder = new StreckenprofilChartBuilder(_modell);
      

      _modell.getEMFModell().eAdapters().add(updateAdapter);
      _modell.getChartProperties().eAdapters().add(updateAdapter);
      mapSystemObjectData = new HashMap<SystemObject, Data>();
    }
    
    private void anmeldungAnzeigen2()
    {
      List<AnzeigeQuerschnitt> aqs = _modell.getAlleAnzeigequerschnitte();
      for (AnzeigeQuerschnitt aq : aqs)
      {
        
        final Collection<Anzeige> anzeigen = aq.getModellObjekt().getAnzeigen();
        if (anzeigen == null)
        {
          Debug.getLogger().fine(
              "Anzeigequerschnitt " + aq.getModellObjekt().getPid()
                  + " hat keine Anzeigen in der Menge Anzeigen versorgt.");
        }
        else
        {
          for (final Anzeige anz : anzeigen)
          {
            
            final OdAnzeigeEigenschaftIst datenAnzeigeEigenschaftIst = anz.getOdAnzeigeEigenschaftIst();          

            if (!anzeigeDaten.containsKey(aq))
            {
              anzeigeDaten.put(aq, new HashMap<Anzeige, OdAnzeigeEigenschaftIst.Daten>());
            }
            anzeigeDaten.get(aq).put(anz, null);                      
            datenAnzeigeEigenschaftIst.addUpdateListener(OdAnzeigeEigenschaftIst.Aspekte.AqZustand, this);            
          }
        }
      }
    }

    public String getTitel()
    {
      return _modell.getStreckenZug().getName();
    }

    public void initChart()
    {
      
//      System.out.println("StreckenprofilEditorStreckenProfil2.ChartComposite.initChart(!!!)");
      
      mapSeries.clear();
      mapSystemObjectData.clear();
      
      AttTmcRichtung richtung = _modell.getErsteStrecke().getRichtung();      
      BezeichnungFahrtRichtung bezeichnungFahrtRichtung = BezeichnungFahrtRichtung.SW;
      if (richtung.toString().equals("negativ"))
      {
        bezeichnungFahrtRichtung = BezeichnungFahrtRichtung.NO;
      }
      StreckenZug streckenZug = _modell.getStreckenZug();
      EList<Strecke> strecken = streckenZug.getStreckenZugEintraege();      
      Long start = 0l;
      Long ende = 0l;
      
      for (Strecke strecke : strecken)
      {
        ende += strecke.getLaenge().longValue();        
      }     
      
      boolean[] vdQuellen = new boolean[] { false, false, false, false, false, false, false, false };
      boolean[] vdTypen = new boolean[] { false, false, false, false, false, false, false, false, false, false, false,
          false };

      boolean[] anzeigeTypen = new boolean[] { false, false, false, false, false, false, false, false};
//      boolean[] anzeigeTypen = new boolean[] { true, true, true, true, true, true, true, true};
      boolean[] ufdMesswerte = new boolean[] { false, false, false, false, false, false, false, false, false, false,
          false, false };
      
      geschwindigkeitsBeschraenkungen = new boolean[] { false, false, false, false, false, false, false, false, false };
     
      
      EList<LinienEigenschaften> lineProperties = _modell.getLineProperties();

      final List<StreckenProfilGrafischeEigenschaftenData> listGrafikData = new ArrayList<StreckenProfilGrafischeEigenschaftenData>();
      for (LinienEigenschaften lp : lineProperties)
      {

        String bezeichnung = lp.getTypDatenQuelle().getLiteral() + "-" + lp.getTypVerkehrsDaten().getLiteral();

        vdQuellen[lp.getTypDatenQuelle().getValue()] = true;
        vdTypen[lp.getTypVerkehrsDaten().getValue() - 1] = true;
        anzeigeTypen[0] = _modell.getChartProperties().isGeschwindigkeitsLimitIcons();
        anzeigeTypen[1] = _modell.getChartProperties().isGeschwindigkeitsLimitIcons();
//        anzeigeTypen[2] = _modell.getChartProperties().isAnzeigeQuerschnitteIcons();
        
        EList<TypAnzeigen> list = _modell.getAnzeigeEigenschaften().getAnzeigeType();
        for (TypAnzeigen typAnzeigen : list)
        {
          if (typAnzeigen.equals(TypAnzeigen.TYP_A))
            anzeigeTypen[2] = true;
          if (typAnzeigen.equals(TypAnzeigen.TYP_B))
            anzeigeTypen[3] = true;
          if (typAnzeigen.equals(TypAnzeigen.TYP_C))
            anzeigeTypen[4] = true;
        }
        
        
//        int index = _editor.getAlternativeObjektbezeichnung();
//        if (index > -2)
        if (!_modell.getChartProperties().getTypObjektBezeichnung().equals(TypObjektBezeichnung.KEINE))
          anzeigeTypen[7] = true;
                
        SeriesType seriesType = lp.getSeriesType();
        Typ linienTyp = null;
        if (seriesType.equals(SeriesType.LINE))
          linienTyp = Typ.LINIE;
        else if (seriesType.equals(SeriesType.BAR))
          linienTyp = Typ.BALKEN;
        else if (seriesType.equals(SeriesType.BAR_STACKED))
          linienTyp = Typ.GESTAPELTE_BALEN;

        LineStyle lineStyle = lp.getLineStyle();
        LinienArt linienArt = null;
        if (lineStyle.equals(LineStyle.SOLID_LITERAL))
          linienArt = LinienArt.LINIEN;
        else if (lineStyle.equals(LineStyle.DOTTED_LITERAL))
          linienArt = LinienArt.PUNKTE;
        else if (lineStyle.equals(LineStyle.DASHED_LITERAL))
          linienArt = LinienArt.STRICHE;
        else if (lineStyle.equals(LineStyle.DASH_DOTTED_LITERAL))
          linienArt = LinienArt.PUNKT_STRICH;

        de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.LinienDicke lineThickness = lp.getLineThickness();
        LinienDicke linienDicke = null;
        if (lineThickness.equals(de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.LinienDicke.THIN))
          linienDicke = LinienDicke.DUENN;
        else if (lineThickness.equals(de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.LinienDicke.NORMAL))
          linienDicke = LinienDicke.NORMAL;
        else if (lineThickness.equals(de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.LinienDicke.THICK))
          linienDicke = LinienDicke.DICK;
        else if (lineThickness.equals(de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.LinienDicke.THICKER))
          linienDicke = LinienDicke.DICKER;

        MarkerType markerType = lp.getKnotenArt();
        KnotenArt knotenArt = null;
        if (markerType.equals(MarkerType.CIRCLE_LITERAL))
          knotenArt = KnotenArt.KREIS;
        else if (markerType.equals(MarkerType.CROSS_LITERAL))
          knotenArt = KnotenArt.KREUZ;
        else if (markerType.equals(MarkerType.CROSSHAIR_LITERAL))
          knotenArt = KnotenArt.HAARKREUZ;
        else if (markerType.equals(MarkerType.BOX_LITERAL))
          knotenArt = KnotenArt.QUADRAT;
        else if (markerType.equals(MarkerType.ICON_LITERAL))
          knotenArt = KnotenArt.OHNE;

        StreckenProfilGrafischeEigenschaftenData grafikData = new StreckenProfilGrafischeEigenschaftenData(bezeichnung,
            _editor.toString(), true, linienTyp, linienArt, new Color(null, lp.getRgb()), linienDicke, knotenArt, new Color(
                null, lp.getKnotenFarbe()));
        listGrafikData.add(grafikData);
      }
      
      BezeichnungGeschwindigkeitBeschraenkung[] values = BezeichnungGeschwindigkeitBeschraenkung.values();
      boolean gsbStatAnzeigen = _modell.getChartProperties().isGeschwindigkeitsLimitLinieStat();
      boolean gsbDynAnzeigen = _modell.getChartProperties().isGeschwindigkeitsLimitLinieDyn();
      boolean statischAnzeigen = _modell.getChartProperties().isGeschwindigkeitsLimitIcons();
      
      Color color = red;    
      LinienArt linienArt = LinienArt.LINIEN;
      LinienDicke linienDicke = LinienDicke.DICKER;
      int cnt = 0;
      
      for (BezeichnungGeschwindigkeitBeschraenkung gsb : values)
      {
        if (!gsb.equals(BezeichnungGeschwindigkeitBeschraenkung.GSB_STATISCH)){
          geschwindigkeitsBeschraenkungen[cnt] = gsbDynAnzeigen;
        }else{
          // Letzte GSB ist die fr die statischen Anzeigen
          geschwindigkeitsBeschraenkungen[cnt] = gsbStatAnzeigen;          
        }
        if (geschwindigkeitsBeschraenkungen[gsb.ordinal()])
        {          
          StreckenProfilGrafischeEigenschaftenData grafikData = new StreckenProfilGrafischeEigenschaftenData(gsb.name(),
              _editor.toString(), true, Typ.LINIE, linienArt, color, linienDicke, KnotenArt.OHNE, red);
          listGrafikData.add(grafikData);          
        }else{
          loescheMapSeries(gsb.toString());
        }
        cnt++;
      }  
      
      String name = "";
      if (_modell.getStreckenZug().getStreckenzugName() != null){
        name = _modell.getStreckenZug().getStreckenzugName();        
      }
           
      final StreckenProfilKonfigurationData konfigData = new StreckenProfilKonfigurationData(name, _editor.toString(), start, ende, vdQuellen, vdTypen, anzeigeTypen, ufdMesswerte,
          geschwindigkeitsBeschraenkungen);
      this.getDisplay().asyncExec(new Runnable() {

        @Override
        public void run()
        {
          StreckenProfilDataUpdateListener.getInstanz().notifyStreckenProfilDataUpdateListener(konfigData);
          for (final StreckenProfilGrafischeEigenschaftenData grafikData : listGrafikData)
          {
            StreckenProfilDataUpdateListener.getInstanz().notifyStreckenProfilDataUpdateListener(grafikData);
          }
        }
      });
      
      statischeBeschilderungAnzeigen(bezeichnungFahrtRichtung);      
      bezeichnungenObjekteLegendeAnzeigen(bezeichnungFahrtRichtung); 
      
//      System.out.println("StreckenprofilEditorStreckenProfil2.ChartComposite.initChart(): " + _editor.isSimulationAktiv());
      
      if(!_editor.isSimulationAktiv()){
        initialisiereAnzeigen();             
      }
      initialisiereGechwindigkeitsBechraenkungen();
      
      
      
//      List<AnzeigeQuerschnitt> aqs = _modell.getAlleAnzeigequerschnitte();
//      for (AnzeigeQuerschnitt aq : aqs)
//      {
//        System.out.println("---> AQ: " + aq.getModellObjekt().getName() + " : " + aq.getWegBisher());
//      }
//      List<MessQuerschnitt> mqs = _modell.getAlleMessquerschnitte(true);
//      for (MessQuerschnitt mq : mqs)
//      {
//        System.out.println("---> MQ: " + mq.getModellObjekt().getName() + " : " + mq.getWegBisher());
//      }
       
    }

    public void initialisiereAnzeigen()
    {
      List<AnzeigeQuerschnitt> alleAnzeigequerschnitte = _modell.getAlleAnzeigequerschnitte();
      for (AnzeigeQuerschnitt aq : alleAnzeigequerschnitte)
      {
        
        SystemObject soAq = aq.getModellObjekt().getSystemObject();
        
        ArrayList<String> list = new ArrayList<String>();
        if (soAq != null){
          list.add(soAq.getName());
          list.add(soAq.getPid());
        }
        
        String[] toolTip = list.toArray(new String[list.size()]);        

        Double wegBisher = aq.getWegBisher();
        if (wegBisher != null)
        {        
          List<SystemObject> anzeigen = holeAlleAnzeigenVonAq2(aq.getModellObjekt().getSystemObject());
          for (SystemObject anzeige : anzeigen)
          {
            StreckenProfilElementTyp elementTyp = holeStreckenProfilElementTypVonAnzeige(anzeige);

            
            if (elementTyp != null)
            {
              String identifier = elementTyp.getType();
              StreckenProfilInhaltTyp inhalt = StreckenProfilInhaltTyp.BI_INAKTIV;
              
              if (inhalt != null)
              {
                Tupel value = new Tupel(new StreckenProfilObjektInformationen(toolTip), inhalt);              
                if (elementTyp.equals(StreckenProfilElementTyp.WZG_A) || elementTyp.equals(StreckenProfilElementTyp.WZG_B) || elementTyp.equals(StreckenProfilElementTyp.WZG_C))
                {                  
                  value = new Tupel(new StreckenProfilObjektInformationen(toolTip), inhalt);             
                  aktualisiereMapSeries(wegBisher.longValue(), value, identifier);   
                }
              }                            
            }
          }          
        }
      }
    }
    
    public void initialisiereGechwindigkeitsBechraenkungen()
    {
      List<AnzeigeQuerschnitt> alleAnzeigequerschnitte = _modell.getAlleAnzeigequerschnitte();
      for (AnzeigeQuerschnitt aq : alleAnzeigequerschnitte)
      {
        
        SystemObject soAq = aq.getModellObjekt().getSystemObject();
        
        ArrayList<String> list = new ArrayList<String>();
        if (soAq != null){
          list.add(soAq.getName());
//          list.add(soAq.getPid());
        }
        
        String[] toolTip = list.toArray(new String[list.size()]);        
        
        Double wegBisher = aq.getWegBisher();
        if (wegBisher != null)
        {        
          BezeichnungGeschwindigkeitBeschraenkung[] values = BezeichnungGeschwindigkeitBeschraenkung.values();
          for (BezeichnungGeschwindigkeitBeschraenkung gsb : values)
          {
            String identifier = gsb.toString();
            
            Double v = 65535.0;
            
            if (v != null)
            {
//              Tupel value = new Tupel(new StreckenProfilObjektInformationen(toolTip), v.toString());              
//              if (elementTyp.equals(StreckenProfilElementTyp.WZG_A))
              {                  
                Tupel value = new Tupel(new StreckenProfilObjektInformationen(toolTip), v.toString());             
                aktualisiereMapSeries(wegBisher.longValue(), value, identifier);   
              }
            }       
          }
          
//          final StreckenProfilDiagrammData diagrammData = new StreckenProfilDiagrammData(mapObject, _editor.toString(), _editor.isSimulationAktiv(),
//              null);
//          if (!this.isDisposed())
//          {
//            this.getDisplay().asyncExec(new Runnable() {
//
//              @Override
//              public void run()
//              {
//                StreckenProfilDataUpdateListener.getInstanz().notifyStreckenProfilDataUpdateListener(diagrammData);              
//              }
//            });
//          }              
        }
      }
    }
    

    public void statischeBeschilderungAnzeigen(BezeichnungFahrtRichtung bezeichnungFahrtRichtung)
    {
      boolean isStatischeIcons = _modell.getChartProperties().isGeschwindigkeitsLimitIcons();
      boolean isGsbStatAnzeigen = _modell.getChartProperties().isGeschwindigkeitsLimitLinieStat();
      
//      if (isStatischeIcons)
      {
        TreeMap<Double, Double> statischeSchildDaten = chartBuilder.ermittleStatischeSchildDaten3();
        TreeMap<Double, Double> statischeSchildDaten2 = chartBuilder.ermittleStatischeSchildDaten3(true);
        for (Map.Entry<Double, Double> me : statischeSchildDaten.entrySet())
        {
          if (me.getValue() != null){
            
            StreckenProfilInhaltTyp inhaltTyp = null;
            
            switch(me.getValue().intValue()){
              case 10:
                inhaltTyp = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_10;
                break;
              case 20:
                inhaltTyp = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_20;
                break;
              case 30:
                inhaltTyp = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_30;
                break;
              case 40:
                inhaltTyp = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_40;
                break;
              case 50:
                inhaltTyp = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_50;
                break;
              case 60:
                inhaltTyp = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_60;
                break;
              case 70:
                inhaltTyp = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_70;
                break;
              case 80:
                inhaltTyp = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_80;
                break;
              case 100:
                inhaltTyp = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_100;
                break;
              case 120:
                inhaltTyp = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_120;
                break;
              case 130:
                inhaltTyp = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_130;
                break; 
              case 500:
                inhaltTyp = StreckenProfilInhaltTyp.BI_TLS_ENDE_ALLER_STRECKENVERBOTE;
                break;                
              default:
//                inhaltTyp = StreckenProfilInhaltTyp.BI_DUNKEL;
            }
            
            
            Long km = me.getKey().longValue();
            
            if (isStatischeIcons)
            {
              if (inhaltTyp != null){
                Tupel value = new Tupel(new StreckenProfilObjektInformationen(), inhaltTyp);              
                aktualisiereMapSeries(km, value, StreckenProfilElementTyp.WZG_A_STATISCH.getType());
              }
            }
                
                            
            if (isGsbStatAnzeigen)
            {
              Double v = 65535.0;
              if (!inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_ALLER_STRECKENVERBOTE))
              {
                v = me.getValue();
              }
              Tupel value = new Tupel(new StreckenProfilObjektInformationen(), v.toString());
              aktualisiereMapSeries(km, value, BezeichnungGeschwindigkeitBeschraenkung.GSB_STATISCH.toString());                                          
            }else{
              loescheMapSeries(BezeichnungGeschwindigkeitBeschraenkung.GSB_STATISCH.toString());
            }
          }        
        } 
        
        for (Map.Entry<Double, Double> me : statischeSchildDaten2.entrySet())
        {
          if (me.getValue() != null){
            
            StreckenProfilInhaltTyp inhaltTyp = null;
            
            StreckenProfilElementTyp elementTyp = StreckenProfilElementTyp.WZG_A_STATISCH_UV;
            switch(me.getValue().intValue()){    
              case 510:
                inhaltTyp = StreckenProfilInhaltTyp.BI_TLS_ENDE_ALLER_STRECKENVERBOTE;                
                break;
              case 520:
                inhaltTyp = StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_ALLGEMEIN;
                break;
              case 530:
                inhaltTyp = StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_LKW;
                break;
              case 540:
                inhaltTyp = StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_NAESSE;
                break;
              default:
//                inhaltTyp = StreckenProfilInhaltTyp.BI_DUNKEL;
            }
            
            if (inhaltTyp != null){
              Long km = me.getKey().longValue();              
              Tupel value = new Tupel(new StreckenProfilObjektInformationen(), inhaltTyp);
              aktualisiereMapSeries(km, value, elementTyp.getType());                          
            }            
          }        
        }  
        
        final StreckenProfilDiagrammData diagrammData = new StreckenProfilDiagrammData(mapObject, _editor.toString(), _editor.isSimulationAktiv(),
            null);
        if (!this.isDisposed())
        {
          this.getDisplay().asyncExec(new Runnable() {

            @Override
            public void run()
            {
              StreckenProfilDataUpdateListener.getInstanz().notifyStreckenProfilDataUpdateListener(diagrammData);              
            }
          });
        }        
      }
    }
    
    public void bezeichnungenObjekteLegendeAnzeigen(BezeichnungFahrtRichtung bezeichnungFahrtRichtung)
    {
      List<MessQuerschnitt> alleMessquerschnitte = _modell.getAlleMessquerschnitte(true);
      List<AnzeigeQuerschnitt> alleAnzeigequerschnitte = _modell.getAlleAnzeigequerschnitte();
      List<StreckenKnoten> alleStreckenKnoten = _modell.getAlleStreckenKnoten();     

      TreeMap<Long, SystemObjekt> kmMap = new TreeMap<Long, SystemObjekt>();

      for (MessQuerschnitt mq : alleMessquerschnitte)
      {
        Double wegBisher = mq.getWegBisher();
        if (wegBisher != null)
        {
          kmMap.put(wegBisher.longValue(), mq.getModellObjekt());
        }
      }
      
      for (AnzeigeQuerschnitt aq : alleAnzeigequerschnitte)
      {
        Double wegBisher = aq.getWegBisher();
        if (wegBisher != null)
        {
          kmMap.put(wegBisher.longValue(), aq.getModellObjekt());          
        }
      }
      
      for (StreckenKnoten as : alleStreckenKnoten)
      {
        Double wegBisher = as.getWegBisher();
        if (wegBisher != null)
        {
          kmMap.put(wegBisher.longValue(), as.getModellObjekt());
        }
      }
      
      for (Map.Entry<Long, SystemObjekt> me : kmMap.entrySet())
      {
        Long km = me.getKey();
        SystemObjekt value = me.getValue();
        
        String s1 = "";
        String s2 = "";        
        String name = "";
        String pid = "";
        SystemObjektTyp typ = value.getTyp();        
        SystemObject so = value.getSystemObject();
        
        java.awt.Color color = null;
        
        name = value.getName();
        pid = value.getPid();
        if (typ.getPid().equals("typ.messQuerschnitt"))
        {        
          s1 = name;
          s2 = pid.toLowerCase();
          color = java.awt.Color.BLUE;
        }
        else if (typ.getPid().equals("typ.anzeigeQuerschnitt"))       
        {         
          s1 = name;
          s2 = pid.toLowerCase();
          color = java.awt.Color.GREEN;
        }
        else if (typ.getPid().equals("typ.straenKnoten"))       
        {
          s1 = name;
          s2 = pid.toLowerCase();
          color = java.awt.Color.MAGENTA;
        }
        else{
//          System.out.println("else typ: " + typ.getPid());         
        }
        
        
        ArrayList<String> list = new ArrayList<String>();        
        list.add("Name: " + s1);
        
//        int index = _editor.getAlternativeObjektbezeichnung();
        
        TypObjektBezeichnung typObjektBezeichnung = _modell.getChartProperties().getTypObjektBezeichnung();
        
        if (typObjektBezeichnung.equals(TypObjektBezeichnung.KEINE)){
          
        }else{
          int index = typObjektBezeichnung.getValue();
          
          AttributeGroup atg = so.getDataModel().getAttributeGroup("atg.alternativeObjektbezeichnung");
          Data cd = so.getConfigurationData(atg);
          if (cd != null){
            Array array = cd.getItem("Bezeichnung").asArray();
//          System.out.println("indexAlternatveObjektbezeichnung: " + index + " -> " + array.getLength());
            if (array != null && array.getLength() > index){
              String tmp = array.getItem(index).asTextValue().getValueText();
              if (tmp != null && tmp.length() > 0){
                s1 = tmp;
                list.add("Alternative Bezeichnung: "  + s1);
              }
            }
          }
          
//          if (index > -2)
//          {
            StreckenProfilObjektInformationen spoi = new StreckenProfilObjektInformationen(new String[] { s1, s2 });
            StreckenProfilKonfigurationData.TextKonfiguration tk = new StreckenProfilKonfigurationData.TextKonfiguration(
                name, color, "Arial", Font.BOLD, 9.0, 45.0, list.toArray(new String[list.size()]));
            Tupel tupel = new Tupel(spoi, tk);
            aktualisiereMapSeries(km, tupel, StreckenProfilElementTyp.STANDORT_QUERSCHNITT.getType());          
//          }          
        }
//        else
//        {
//          loescheMapSeries(StreckenProfilElementTyp.STANDORT_QUERSCHNITT.getType());
//        }
      }

      final StreckenProfilDiagrammData diagrammData = new StreckenProfilDiagrammData(new HashMap<String, Map<String, SortedMap<Long, Object>>>(mapObject),
          _editor.toString(), _editor.isSimulationAktiv(), null);
      if (!this.isDisposed())
      {
        this.getDisplay().asyncExec(new Runnable() {

          @Override
          public void run()
          {
            StreckenProfilDataUpdateListener.getInstanz().notifyStreckenProfilDataUpdateListener(diagrammData);
          }
        });
      }
    }

    /**
     * Meldet MQs und FS fr die im Modell vereinbarten Attributgruppen und Aspekte an.
     * 
     * @param mq
     *          Der Messquerschnitt, fr dessen Onlinedaten (auch die Onlinedaten der Fahrstreifen) sich angemeldet
     *          wird.
     */
    protected void mQundFsAnmelden(final MessQuerschnitt mq)
    {
      if (ActivationState.ACTIVE.equals(mq.getState()))
      {
        mqModelCache.put(mq.getMessQuerschnitt(), mq);
      }

      final TypPrognoseTyp aktuellerPrognoseTyp = getStreckenEditorModell().getChartProperties().getTypPrognoseTyp();
      final MessQuerschnittAllgemein mqallgemein = mq.getMessQuerschnitt();
      if (ActivationState.ACTIVE.equals(mq.getState()))
      {
        if (mqallgemein instanceof de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.MessQuerschnitt)
        {
          for (final FahrStreifen fs : ((de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.MessQuerschnitt)mq
              .getMessQuerschnitt()).getFahrStreifen())
          {
            final AttFahrStreifenLage fsLage = fs.getKdFahrStreifen().getDatum().getLage();
            for (final LinienEigenschaften lp : getStreckenEditorModell().getLineProperties())
            {
              if ((AttFahrStreifenLage.ZUSTAND_0_HFS.equals(fsLage) && TypDatenQuellen.HFS.equals(lp
                  .getTypDatenQuelle()))
                  || (AttFahrStreifenLage.ZUSTAND_1__1UEFS.equals(fsLage) && TypDatenQuellen.UEFS1.equals(lp
                      .getTypDatenQuelle()))
                  || (AttFahrStreifenLage.ZUSTAND_2__2UEFS.equals(fsLage) && TypDatenQuellen.UEFS2.equals(lp
                      .getTypDatenQuelle()))
                  || (AttFahrStreifenLage.ZUSTAND_3__3UEFS.equals(fsLage) && TypDatenQuellen.UEFS3.equals(lp
                      .getTypDatenQuelle()))
                  || (AttFahrStreifenLage.ZUSTAND_4__4UEFS.equals(fsLage) && TypDatenQuellen.UEFS4.equals(lp
                      .getTypDatenQuelle()))
                  || (AttFahrStreifenLage.ZUSTAND_5__5UEFS.equals(fsLage) && TypDatenQuellen.UEFS5.equals(lp
                      .getTypDatenQuelle()))
                  || (AttFahrStreifenLage.ZUSTAND_6__6UEFS.equals(fsLage) && TypDatenQuellen.UEFS6.equals(lp
                      .getTypDatenQuelle())))
              {

                AbstractOnlineDatensatz<?> fsDatensatz = null;
                Aspekt fsaspekt = null;
                switch (aktuellerPrognoseTyp)
                {
                  case ANALYSE:
                    fsDatensatz = fs.getOdVerkehrsDatenKurzZeitFs();
                    fsaspekt = OdVerkehrsDatenKurzZeitFs.Aspekte.Analyse;
                    break;
                  case FLINK_EXTRA_POLATION:
                    fsDatensatz = fs.getOdVerkehrsDatenKurzZeitTrendExtraPolationFs();
                    fsaspekt = OdVerkehrsDatenKurzZeitTrendExtraPolationFs.Aspekte.PrognoseFlink;
                    break;
                  case FLINK_GEGLAETTET:
                    fsDatensatz = fs.getOdVerkehrsDatenKurzZeitGeglaettetFs();
                    fsaspekt = OdVerkehrsDatenKurzZeitGeglaettetFs.Aspekte.PrognoseFlink;
                    break;
                  case NORMAL_EXTRA_POLATION:
                    fsDatensatz = fs.getOdVerkehrsDatenKurzZeitTrendExtraPolationFs();
                    fsaspekt = OdVerkehrsDatenKurzZeitTrendExtraPolationFs.Aspekte.PrognoseNormal;
                    break;
                  case NORMAL_GEGLAETTET:
                    fsDatensatz = fs.getOdVerkehrsDatenKurzZeitGeglaettetFs();
                    fsaspekt = OdVerkehrsDatenKurzZeitGeglaettetFs.Aspekte.PrognoseNormal;
                    break;
                  case TRAEGE_EXTRA_POLATION:
                    fsDatensatz = fs.getOdVerkehrsDatenKurzZeitTrendExtraPolationFs();
                    fsaspekt = OdVerkehrsDatenKurzZeitTrendExtraPolationFs.Aspekte.PrognoseTraege;
                    break;
                  case TRAEGE_GEGLAETTET:
                    fsDatensatz = fs.getOdVerkehrsDatenKurzZeitGeglaettetFs();
                    fsaspekt = OdVerkehrsDatenKurzZeitGeglaettetFs.Aspekte.PrognoseTraege;
                    break;
                  default:
                    throw new IllegalArgumentException(
                        "Es wurde ein unbekannter Typ fr das erweiterte Streckenprofil bergeben.");
                }

                if (fsDatensatz != null && fsaspekt != null && !angemeldeteFSs.containsKey(fs))
                {
                  fsDatensatz.addUpdateListener(fsaspekt, this);
                  angemeldeteFSs.put(fs, fsDatensatz);
                }
                break;
              }
            }
          }
        }
        AbstractOnlineDatensatz<?> mqDatensatz = null;
        Aspekt mqaspekt = null;
        switch (aktuellerPrognoseTyp)
        {
          case ANALYSE:
            mqDatensatz = mqallgemein.getOdVerkehrsDatenKurzZeitMq();
            mqaspekt = OdVerkehrsDatenKurzZeitMq.Aspekte.Analyse;
            break;
          case FLINK_EXTRA_POLATION:
            mqDatensatz = mqallgemein.getOdVerkehrsDatenKurzZeitTrendExtraPolationMq();
            mqaspekt = OdVerkehrsDatenKurzZeitTrendExtraPolationMq.Aspekte.PrognoseFlink;
            break;
          case FLINK_GEGLAETTET:
            mqDatensatz = mqallgemein.getOdVerkehrsDatenKurzZeitGeglaettetMq();
            mqaspekt = OdVerkehrsDatenKurzZeitGeglaettetMq.Aspekte.PrognoseFlink;
            break;
          case NORMAL_EXTRA_POLATION:
            mqDatensatz = mqallgemein.getOdVerkehrsDatenKurzZeitTrendExtraPolationMq();
            mqaspekt = OdVerkehrsDatenKurzZeitTrendExtraPolationMq.Aspekte.PrognoseNormal;
            break;
          case NORMAL_GEGLAETTET:
            mqDatensatz = mqallgemein.getOdVerkehrsDatenKurzZeitGeglaettetMq();
            mqaspekt = OdVerkehrsDatenKurzZeitGeglaettetMq.Aspekte.PrognoseNormal;
            break;
          case TRAEGE_EXTRA_POLATION:
            mqDatensatz = mqallgemein.getOdVerkehrsDatenKurzZeitTrendExtraPolationMq();
            mqaspekt = OdVerkehrsDatenKurzZeitTrendExtraPolationMq.Aspekte.PrognoseTraege;
            break;
          case TRAEGE_GEGLAETTET:
            mqDatensatz = mqallgemein.getOdVerkehrsDatenKurzZeitGeglaettetMq();
            mqaspekt = OdVerkehrsDatenKurzZeitGeglaettetMq.Aspekte.PrognoseTraege;
            break;
          default:
            throw new IllegalArgumentException(
                "Es wurde ein unbekannter Typ fr das erweiterte Streckenprofil bergeben.");
        }
        if (mqaspekt != null && mqDatensatz != null && !angemeldeteMQs.containsKey(mq))
        {
          mqDatensatz.addUpdateListener(mqaspekt, this);
          angemeldeteMQs.put(mqallgemein, mqDatensatz);
        }
        else
        {
          Activator.getDefault().getLogger().info(mq.getName() + " ist schon fr Onlinedaten angemeldet.");
        }
      }
    }

    /**
     * Anmeldung fr {@link OdAnzeigeEigenschaftIst} aller Anzeigen, die innerhalb des Streckenprofils existieren.
     */
    private void anmeldungAnzeigen()
    {
      StreckenKnoten knoten = _modell.getErsterStreckenKnoten();
      while (knoten != null && knoten.getNachStrecke() != null)
      {
        RealerStreckenAbschnitt<?> abschnitt = knoten.getAktiverStreckenAbschnitt();

        abschnitt = knoten.getNachStrecke().getAktiverStreckenAbschnitt();
        if (abschnitt instanceof AeussererStreckenAbschnitt)
        {
          for (final AnzeigeQuerschnitt emfAq : abschnitt.getAnzeigeQuerschnitt())
          {
            final de.bsvrz.sys.funclib.bitctrl.modell.tmanzeigenglobal.objekte.AnzeigeQuerschnitt aquerschnitt = emfAq
                .getModellObjekt();
            if (aquerschnitt != null)
            {
              final Collection<Anzeige> anzeigen = aquerschnitt.getAnzeigen();
              if (anzeigen == null)
              {
                Debug.getLogger().fine(
                    "Anzeigequerschnitt " + aquerschnitt.getPid()
                        + " hat keine Anzeigen in der Menge Anzeigen versorgt.");
              }
              else
              {
                for (final Anzeige anz : anzeigen)
                {
                  // for (final FahrStreifen f : anz.getFahrStreifen())
                  {
                    // final KdFahrStreifen.Daten lage = f.getKdFahrStreifen().getDatum();
                    // if (lage != null && AttFahrStreifenLage.ZUSTAND_0_HFS.equals(lage.getLage()))
                    {
                      final OdAnzeigeEigenschaftIst datenAnzeigeEigenschaftIst = anz.getOdAnzeigeEigenschaftIst();

                      if (!anzeigeDaten.containsKey(emfAq))
                      {
                        anzeigeDaten.put(emfAq, new HashMap<Anzeige, OdAnzeigeEigenschaftIst.Daten>());
                      }
                      anzeigeDaten.get(emfAq).put(anz, null);                      
                      datenAnzeigeEigenschaftIst.addUpdateListener(OdAnzeigeEigenschaftIst.Aspekte.AqZustand, this);
                      // es kann pro AQ nur eine HFB
                      // geben
                      // break;
                    }
                  }
                }
              }
            }
          }
          knoten = knoten.getNachStrecke().getNachKnoten();
        }
      }
    }

    protected JComponent createSwingComponent()
    {
      rootPane = new JRootPane();

      return (rootPane);
    }

    public void create()
    {
      String info = "unknown view part";
      synchronized (destroySync)
      {
        if (viewPart != null)
        {
          String streckenBezeichnung = "";
          StreckenZug streckenZug = _modell.getStreckenZug();
          EList<Strecke> streckenZugEintraege = streckenZug.getStreckenZugEintraege();
          for (Strecke strecke : streckenZugEintraege)
          {
            streckenBezeichnung = strecke.getName();
            break;
          }
          zwischenschicht = new StreckenProfilZuDiagrammZwischenschicht2("", _editor.toString(), streckenBezeichnung);
          
          viewPart.getSite().getPage().addPartListener(this);
          paintActionListener = new PaintActionListener();
          zwischenschicht.getChart().addPaintListener(paintActionListener);
          rootPane.setContentPane(zwischenschicht.getStreckenProfilAnzeige());
          info = viewPart.getPartName();
          StreckenProfilDataUpdateListener.getInstanz().addDaVDataUpdateListener(zwischenschicht);
          StreckenProfilUIProvider.getInstanz().addStreckenProfilUIProvider(this);
          
          
          TAxis axis = null;
                    
          for (int i = 0; i < TAxis.AC_YA.length; i++)
          {
            switch(i){
              case 0:
                axis = zwischenschicht.getChart().getAxis(TAxis.AC_Y0);
                break;
              case 1:
                axis = zwischenschicht.getChart().getAxis(TAxis.AC_Y1);
                break;
              case 2:
                axis = zwischenschicht.getChart().getAxis(TAxis.AC_Y2);
                break;
              case 3:
                axis = zwischenschicht.getChart().getAxis(TAxis.AC_Y3);
                break;
              default:                
            }
//            System.out.println("i: " + i + " -> " + axis);
                        
            if (axis != null){
              axis.addActionListener(new AxisRangeListener());                  
            }
          }
        }
      }
    }

    public void destroy()
    {
      String info = "unknown view part";
      synchronized (destroySync)
      {
        if (viewPart != null)
        {
          info = viewPart.getPartName();
          // getFrame().removeWindowFocusListener(this);
          viewPart = null;
          if (zwischenschicht != null)
          {
            paintActionListener.destroy();
            zwischenschicht.getChart().removePaintListener(paintActionListener);
            StreckenProfilDataUpdateListener.getInstanz().removeDaVDataUpdateListener(zwischenschicht);
            zwischenschicht.destroy();
            zwischenschicht = null;
            StreckenProfilUIProvider.getInstanz().removeStreckenProfilUIProvider(this);
          }
          dispose();

          rootPane = null;
          paintActionListener = null;
        }
      }
      // System.out.println("composite destroyed: " + info);
    }

    public TChart getChart()
    {
      TChart ret = null;

      StreckenProfilZuDiagrammZwischenschicht2 tmp = zwischenschicht;
      if (tmp != null)
      {
        ret = tmp.getChart();
      }

      return (ret);
    }

    public StreckenProfilZuDiagrammZwischenschicht2 getStreckenProfilZuDiagrammZwischenschicht()
    {
      return (zwischenschicht);
    }
    
    public void windowGainedFocus(java.awt.event.WindowEvent arg0)
    {
      synchronized (destroySync)
      {
        if (viewPart != null && !this.isDisposed())
        {
          if (chartComposite != null && !chartComposite.isDisposed()){                  
            Display display = chartComposite.getDisplay();
            if (display != null && !display.isDisposed()){
              display.asyncExec(new Runnable() {
                public void run()
                {
                  if (chartComposite != null && !chartComposite.isDisposed()){   
                    forceFocus();                                    
                  }
                }
              });            
            }
          }
        }
      }
    }

    public void windowLostFocus(java.awt.event.WindowEvent arg0)
    {
    }

    public void partActivated(IWorkbenchPartReference partRef)
    {
      synchronized (destroySync)
      {
        if (viewPart != null && partRef.getPart(false) == viewPart)
        {
          if (chartComposite != null && !chartComposite.isDisposed()){                  
            Display display = chartComposite.getDisplay();
            if (display != null && !display.isDisposed()){
              display.asyncExec(new Runnable() {
                public void run()
                {
                  if (chartComposite != null && !chartComposite.isDisposed()){   
                    forceFocus();                                    
                  }
                }
              });            
            }
          }
        }
      }
    }

    public void partBroughtToTop(IWorkbenchPartReference partRef)
    {
    }

    public void partClosed(IWorkbenchPartReference partRef)
    {
    }

    public void partDeactivated(IWorkbenchPartReference partRef)
    {
    }

    public void partHidden(IWorkbenchPartReference partRef)
    {
    }

    public void partInputChanged(IWorkbenchPartReference partRef)
    {
    }

    public void partOpened(IWorkbenchPartReference partRef)
    {
    }

    public void partVisible(IWorkbenchPartReference partRef)
    {
    }

    @Override
    public void datensatzAktualisiert(final DatensatzUpdateEvent event)
    {       
      OnlineDatum datum = event.getDatum();
      
      if (datum != null && datum.dContainsDaten())
      {       
        ResultData result = erzeugeDaVData(datum);
        if (result != null)
        {
          List<Dataset> list = new ArrayList<Dataset>();
          list.add(result);
          verarbeiteDaten(new StreckenProfilUIProviderEvent(_editor, list));
        }
      }                    
    }

    /**
     * @param datum
     * @return
     */
    private ResultData erzeugeDaVData(Datum datum)
    {
      ResultData re = null;

      ClientDavInterface connection = DaVVerbindung.getInstanz().getDaVVerbindung();

      Data daVData = null;
      String pidAtg = null;
      String pidAsp = null;
      long zeitStempel = 0l;        
      
      if (datum instanceof OdAnzeigeEigenschaftIst.Daten)
      {
        pidAtg = OdAnzeigeEigenschaftIst.PID;
        pidAsp = OdAnzeigeEigenschaftIst.Aspekte.AqZustand.getPid();
        
      }else{
        TypPrognoseTyp typPrognoseTyp = _modell.getChartProperties().getTypPrognoseTyp();
                
        switch (typPrognoseTyp)
        {
          case ANALYSE:            
            if (datum instanceof OdVerkehrsDatenKurzZeitFs.Daten)
            {
              zeitStempel = ((OdVerkehrsDatenKurzZeitFs.Daten)datum).dGetZeitstempel().getTime();
              pidAtg = OdVerkehrsDatenKurzZeitFs.PID;            
              pidAsp = OdVerkehrsDatenKurzZeitFs.Aspekte.Analyse.getPid();
              
            }
            else if (datum instanceof OdVerkehrsDatenKurzZeitMq.Daten)
            {
              zeitStempel = ((OdVerkehrsDatenKurzZeitMq.Daten)datum).dGetZeitstempel().getTime();
              pidAtg = OdVerkehrsDatenKurzZeitMq.PID;            
              pidAsp = OdVerkehrsDatenKurzZeitMq.Aspekte.Analyse.getPid();              
            }
            break;
          case FLINK_EXTRA_POLATION:
            if (datum instanceof OdVerkehrsDatenKurzZeitTrendExtraPolationFs.Daten)
            {
              zeitStempel = ((OdVerkehrsDatenKurzZeitTrendExtraPolationFs.Daten)datum).dGetZeitstempel().getTime();
              pidAtg = OdVerkehrsDatenKurzZeitTrendExtraPolationFs.PID;
              pidAsp = OdVerkehrsDatenKurzZeitTrendExtraPolationFs.Aspekte.PrognoseFlink.getPid();
              
            }
            else if (datum instanceof OdVerkehrsDatenKurzZeitTrendExtraPolationMq.Daten)
            {
              zeitStempel = ((OdVerkehrsDatenKurzZeitTrendExtraPolationMq.Daten)datum).dGetZeitstempel().getTime();
              pidAtg = OdVerkehrsDatenKurzZeitTrendExtraPolationMq.PID;
              pidAsp = OdVerkehrsDatenKurzZeitTrendExtraPolationMq.Aspekte.PrognoseFlink.getPid();              
            }
            break;
          case FLINK_GEGLAETTET:
            if (datum instanceof OdVerkehrsDatenKurzZeitGeglaettetFs.Daten)
            {
              zeitStempel = ((OdVerkehrsDatenKurzZeitGeglaettetFs.Daten)datum).dGetZeitstempel().getTime();
              pidAtg = OdVerkehrsDatenKurzZeitGeglaettetFs.PID;
              pidAsp = OdVerkehrsDatenKurzZeitGeglaettetFs.Aspekte.PrognoseFlink.getPid();              
            }
            else if (datum instanceof OdVerkehrsDatenKurzZeitGeglaettetMq.Daten)
            {
              zeitStempel = ((OdVerkehrsDatenKurzZeitGeglaettetMq.Daten)datum).dGetZeitstempel().getTime();
              pidAtg = OdVerkehrsDatenKurzZeitGeglaettetMq.PID;
              pidAsp = OdVerkehrsDatenKurzZeitGeglaettetMq.Aspekte.PrognoseFlink.getPid();              
            }
            break;
          case NORMAL_EXTRA_POLATION:
            if (datum instanceof OdVerkehrsDatenKurzZeitTrendExtraPolationFs.Daten)
            {
              zeitStempel = ((OdVerkehrsDatenKurzZeitTrendExtraPolationFs.Daten)datum).dGetZeitstempel().getTime();
              pidAtg = OdVerkehrsDatenKurzZeitTrendExtraPolationFs.PID;            
              pidAsp = OdVerkehrsDatenKurzZeitTrendExtraPolationFs.Aspekte.PrognoseNormal.getPid();              
            }
            else if (datum instanceof OdVerkehrsDatenKurzZeitTrendExtraPolationMq.Daten)
            {
              zeitStempel = ((OdVerkehrsDatenKurzZeitTrendExtraPolationMq.Daten)datum).dGetZeitstempel().getTime();
              pidAtg = OdVerkehrsDatenKurzZeitTrendExtraPolationMq.PID;            
              pidAsp = OdVerkehrsDatenKurzZeitTrendExtraPolationMq.Aspekte.PrognoseNormal.getPid();              
            }
            break;
          case NORMAL_GEGLAETTET:
            if (datum instanceof OdVerkehrsDatenKurzZeitGeglaettetFs.Daten)
            {
              zeitStempel = ((OdVerkehrsDatenKurzZeitGeglaettetFs.Daten)datum).dGetZeitstempel().getTime();
              pidAtg = OdVerkehrsDatenKurzZeitGeglaettetFs.PID;            
              pidAsp = OdVerkehrsDatenKurzZeitGeglaettetFs.Aspekte.PrognoseNormal.getPid();              
            }
            else if (datum instanceof OdVerkehrsDatenKurzZeitGeglaettetMq.Daten)
            {
              zeitStempel = ((OdVerkehrsDatenKurzZeitGeglaettetMq.Daten)datum).dGetZeitstempel().getTime();
              pidAtg = OdVerkehrsDatenKurzZeitGeglaettetMq.PID;            
              pidAsp = OdVerkehrsDatenKurzZeitGeglaettetMq.Aspekte.PrognoseNormal.getPid();              
            }
            break;
          case TRAEGE_EXTRA_POLATION:
            if (datum instanceof OdVerkehrsDatenKurzZeitTrendExtraPolationFs.Daten)
            {
              zeitStempel = ((OdVerkehrsDatenKurzZeitTrendExtraPolationFs.Daten)datum).dGetZeitstempel().getTime();
              pidAtg = OdVerkehrsDatenKurzZeitTrendExtraPolationFs.PID;                       
              pidAsp = OdVerkehrsDatenKurzZeitTrendExtraPolationFs.Aspekte.PrognoseTraege.getPid();              
            }
            else if (datum instanceof OdVerkehrsDatenKurzZeitTrendExtraPolationMq.Daten)
            {
              zeitStempel = ((OdVerkehrsDatenKurzZeitTrendExtraPolationMq.Daten)datum).dGetZeitstempel().getTime();
              pidAtg = OdVerkehrsDatenKurzZeitTrendExtraPolationMq.PID;                       
              pidAsp = OdVerkehrsDatenKurzZeitTrendExtraPolationMq.Aspekte.PrognoseTraege.getPid();              
            }
            break;
          case TRAEGE_GEGLAETTET:
            if (datum instanceof OdVerkehrsDatenKurzZeitGeglaettetFs.Daten)
            {
              zeitStempel = ((OdVerkehrsDatenKurzZeitGeglaettetFs.Daten)datum).dGetZeitstempel().getTime();
              pidAtg = OdVerkehrsDatenKurzZeitGeglaettetFs.PID;                       
              pidAsp = OdVerkehrsDatenKurzZeitGeglaettetFs.Aspekte.PrognoseTraege.getPid();              
            }
            else if (datum instanceof OdVerkehrsDatenKurzZeitGeglaettetMq.Daten)
            {
              zeitStempel = ((OdVerkehrsDatenKurzZeitGeglaettetMq.Daten)datum).dGetZeitstempel().getTime();
              pidAtg = OdVerkehrsDatenKurzZeitGeglaettetMq.PID;                       
              pidAsp = OdVerkehrsDatenKurzZeitGeglaettetMq.Aspekte.PrognoseTraege.getPid();              
            }
            break;
          default:
            throw new IllegalArgumentException(
            "Es wurde ein unbekannter Typ fr das erweiterte Streckenprofil bergeben.");
        }
        
      }
      
      if (pidAsp != null && pidAsp != null){
        AttributeGroup atg = connection.getDataModel().getAttributeGroup(pidAtg);
        Aspect asp = connection.getDataModel().getAspect(pidAsp);
        daVData = connection.createData(atg);
        datum.bean2Atl(daVData, Activator.getDefault().getObjektFactory());
        if (daVData != null && atg != null && asp != null)
          re = new ResultData(datum.dGetDatensatz().getSystemObjekt().getSystemObject(),
              new DataDescription(atg, asp), zeitStempel, daVData);        
      }
      
      return re;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.swt.widgets.Widget#dispose()
     */
    @Override
    public void dispose()
    {
      if (_modell != null && updateAdapter != null)
      {
        _modell.getEMFModell().eAdapters().remove(updateAdapter);
        _modell.getChartProperties().eAdapters().remove(updateAdapter);
      }
      super.dispose();
    }

    /**
     * Interner {@link EContentAdapter}, der sich auf alle mglichen nderungen innerhalb des EMF Modells anmeldet.
     */
    private final EContentAdapter updateAdapter = new EContentAdapter() {

      /*
       * (non-Javadoc)
       * 
       * @see org.eclipse.emf.ecore.util.EContentAdapter#notifyChanged (org.eclipse.emf.common.notify.Notification)
       */
      @Override
      public void notifyChanged(final Notification notification)
      {
        super.notifyChanged(notification);
        final Object feature = notification.getFeature();

        if ((StreckenprofilPackage.Literals.LINIEN_EIGENSCHAFTEN__LINE_STYLE.equals(feature))
            || (StreckenprofilPackage.Literals.LINIEN_EIGENSCHAFTEN__LINE_THICKNESS.equals(feature))
            || (StreckenprofilPackage.Literals.LINIEN_EIGENSCHAFTEN__RGB.equals(feature))
            || (StreckenprofilPackage.Literals.LINIEN_EIGENSCHAFTEN__LINE_STYLE.equals(feature))
            || (StreckenprofilPackage.Literals.LINIEN_EIGENSCHAFTEN__VISIBLE.equals(feature)))
        {
           
        }
        else if (StreckenprofilPackage.Literals.ACTIVATEABLE__STATE.equals(feature)
            || StreckenprofilPackage.Literals.ACHSEN_BESCHREIBUNG__ACHSENPOSITION.equals(feature)
            || StreckenprofilPackage.Literals.ACHSEN_BESCHREIBUNG__HILFSLINIEN.equals(feature)
            || StreckenprofilPackage.Literals.ACHSEN_BESCHREIBUNG__MAXIMUM.equals(feature)
            || StreckenprofilPackage.Literals.ACHSEN_BESCHREIBUNG__MINIMUM.equals(feature)
            || StreckenprofilPackage.Literals.ACHSEN_BESCHREIBUNG__SCHRITTE.equals(feature)
            || (StreckenprofilPackage.Literals.LINIEN_EIGENSCHAFTEN__KNOTEN_ART.equals(feature))
            || (StreckenprofilPackage.Literals.LINIEN_EIGENSCHAFTEN__KNOTEN_FARBE.equals(feature))
            || (StreckenprofilPackage.Literals.LINIEN_EIGENSCHAFTEN__SERIES_TYPE.equals(feature))
            || (StreckenprofilPackage.Literals.STRECKEN_ZUG_EINTRAG.equals(feature))
            || (StreckenprofilPackage.Literals.DIAGRAMM_EIGENSCHAFTEN__ANZEIGE_QUERSCHNITTE_ICONS.equals(feature))
            || (StreckenprofilPackage.Literals.DIAGRAMM_EIGENSCHAFTEN__GESCHWINDIGKEITS_LIMIT_ICONS.equals(feature))
            || (StreckenprofilPackage.Literals.DIAGRAMM_EIGENSCHAFTEN__GESCHWINDIGKEITS_LIMIT_LINIE_STAT.equals(feature))
            || (StreckenprofilPackage.Literals.DIAGRAMM_EIGENSCHAFTEN__GESCHWINDIGKEITS_LIMIT_LINIE_DYN.equals(feature))
            || (StreckenprofilPackage.Literals.DIAGRAMM_EIGENSCHAFTEN__TYP_PROGNOSE_TYP.equals(feature)))
        {
          
        }
        else if (StreckenprofilPackage.Literals.STRECKENPROFIL_EDITOR_MODEL__LINE_PROPERTIES.equals(feature))
        {
           
        }
        else if (StreckenprofilPackage.Literals.DIAGRAMM_EIGENSCHAFTEN__SKALIERUNG_XACHSE.equals(feature))
        {
          
        }
        else if (StreckenprofilPackage.Literals.STRECKEN_ABSCHNITT__VON_KNOTEN.equals(feature)
            || StreckenprofilPackage.Literals.STRECKEN_ABSCHNITT__NACH_KNOTEN.equals(feature))
        {
           
        }
      }
    };

    private StreckenprofilChartBuilder chartBuilder;

    private boolean[] geschwindigkeitsBeschraenkungen;

    /**
     * @param km
     * @param value
     * @param identifier
     */
    private boolean aktualisiereMapSeries(Long km, Object value, String identifier)
    {
      boolean update = false;
      if (identifier != null && value != null && km != null)
      {
        update = true;
        SortedMap<Long, Object> map = null;
        if (!mapSeries.containsKey(identifier))
        {
          map = new TreeMap<Long, Object>();
        }
        else
        {
          map = mapSeries.get(identifier);
        }
        map.put(km, value);
        mapSeries.put(identifier, map);          
      }
      return update;
    }
    
    /**
     * @param km
     * @param value
     * @param identifier
     */
    private boolean loescheKmAusMapSeries(Long km, String identifier)
    {
      boolean update = false;
      if (identifier != null && km != null)
      {
        update = true;
        SortedMap<Long, Object> map = null;
        if (mapSeries.containsKey(identifier))
        {
          map = mapSeries.get(identifier);
          if (map.containsKey(km)){
            map.remove(km);
          }
//          mapSeries.put(identifier, map);
        }
      }
      return update;
    }
    
    /**
     * @param km
     * @param value
     * @param identifier
     */
    private boolean loescheKmGsbAusMapSeries(Long km, Object value)
    {
      boolean update = false;
      
      BezeichnungGeschwindigkeitBeschraenkung[] values = BezeichnungGeschwindigkeitBeschraenkung.values();
      for (BezeichnungGeschwindigkeitBeschraenkung bGsb : values)
      {
        String identifier = bGsb.toString();
        if (identifier != null && km != null)
        {
          update = true;
          SortedMap<Long, Object> map = null;
          if (mapSeries.containsKey(identifier))
          {
            map = mapSeries.get(identifier);
//            if (map.containsKey(km))
//            {
//              map.remove(km);
//            }
              map.put(km, value);
              mapSeries.put(identifier, map);
          }
        }
        
      }
       
      
      return update;
    }
    
    /**
     * @param km
     * @param value
     * @param identifier
     */
    private void loescheMapSeries(String identifier)
    {
      if (identifier != null)
      {       
        if (mapSeries.containsKey(identifier))
        {
          SortedMap<Long,Object> sortedMap = mapSeries.get(identifier);          
          sortedMap = new TreeMap<Long, Object>();
          mapSeries.put(identifier, sortedMap);
        }        
      }
    }

    /**
     * Ermittelt die A-Typen aus der Konfiguration
     * @param object
     * @return
     */
    private StreckenProfilElementTyp holeStreckenProfilElementTypVonAnzeige2(SystemObject object)
    {
      StreckenProfilElementTyp re = null;
      AttributeGroup atg = object.getDataModel().getAttributeGroup("atg.anzeige");
      Data cd = object.getConfigurationData(atg);
      String pidTyp = cd.getItem("AnzeigeTyp").asReferenceValue().getSystemObjectPid();
      
//      if (pidTyp.equals("anzeigeTyp.uz.A81.sba_stgt.TypA.1") || pidTyp.equals("anzeigeTyp.uz.A81.sba_stgt.TypA.1.links")
//          || pidTyp.equals("anzeigeTyp.uz.A81.sba_stgt.TypA.1.rechts"))
      if (pidTyp.equals("anzeigeTyp.uz.A8.sba_stgt.TypA.1") || pidTyp.equals("anzeigeTyp.uz.A8.sba_stgt.TypA.1.links")
            || pidTyp.equals("anzeigeTyp.uz.A8.sba_stgt.TypA.1.rechts"))
      {
        re = StreckenProfilElementTyp.WZG_A;
      }
      else if (pidTyp.equals("anzeigeTyp.uz.A8.sba_stgt.TypB.1"))
      {
        re = StreckenProfilElementTyp.WZG_B;
      }
      else if (pidTyp.equals("anzeigeTyp.uz.A8.sba_stgt.TypC.1"))
      {
        re = StreckenProfilElementTyp.WZG_C;
      }       

      return re;
    }
    
    /* (non-Javadoc)
     * Method declared on ListEditor.
     */
    protected String[] parseString(String stringList) {
        StringTokenizer st = new StringTokenizer(stringList, File.pathSeparator
                + "\n\r");//$NON-NLS-1$
        ArrayList v = new ArrayList();
        while (st.hasMoreElements()) {
            v.add(st.nextElement());
        }
        return (String[]) v.toArray(new String[v.size()]);
    }
    
    /**
     * Ermittelt die A-Typen aus der Konfiguration
     * @param object
     * @return
     */
    private StreckenProfilElementTyp holeStreckenProfilElementTypVonAnzeige(SystemObject object)
    {
      
      IPreferenceStore store = Activator.getDefault().getPreferenceStore();
      String stringA = store.getString(PreferenceInit.PROP_ANZEIGE_TYP_A);      
      List<String> listTypA = new ArrayList<String>();
      if (stringA != null && stringA.length() > 0){
        String[] ss = parseString(stringA);
        if (ss != null){
          listTypA.addAll(Arrays.asList(ss));
        }        
      }
      String stringB = store.getString(PreferenceInit.PROP_ANZEIGE_TYP_B);      
      List<String> listTypB = new ArrayList<String>();
      if (stringB != null && stringB.length() > 0){
        String[] ss = parseString(stringB);
        if (ss != null){
          listTypB.addAll(Arrays.asList(ss));
        }        
      }
      String stringC = store.getString(PreferenceInit.PROP_ANZEIGE_TYP_C);      
      List<String> listTypC = new ArrayList<String>();
      if (stringC != null && stringC.length() > 0){
        String[] ss = parseString(stringC);
        if (ss != null){
          listTypC.addAll(Arrays.asList(ss));
        }        
      }
      
      StreckenProfilElementTyp re = null;
      AttributeGroup atg = object.getDataModel().getAttributeGroup("atg.anzeige");
      Data cd = object.getConfigurationData(atg);
      String pidTyp = cd.getItem("AnzeigeTyp").asReferenceValue().getSystemObjectPid();
            
      if (listTypA.contains(pidTyp))
      {
        re = StreckenProfilElementTyp.WZG_A;
      }      
      else if (listTypB.contains(pidTyp))
      {
        re = StreckenProfilElementTyp.WZG_B;
      }
      else if (listTypC.contains(pidTyp))
      {
        re = StreckenProfilElementTyp.WZG_C;
      }       
      
      return re;
    }

    /**
     * Ersetzt den logischen Inhalt einer Anzeige bei Temposplit
     * @param object
     * @param inhalt
     * @param tooltip
     * @return
     */
    private StreckenProfilInhaltTyp ersetzeInhaltBeiTemposplit(SystemObject aq, SystemObject object, StreckenProfilInhaltTyp inhalt,
        List<String> tooltips)
    {

      ClientDavInterface connection = DaVVerbindung.getInstanz().getDaVVerbindung();
      AttributeGroup atg = connection.getDataModel().getAttributeGroup("atg.anzeigeEigenschaftIst");
      Aspect asp = connection.getDataModel().getAspect("asp.aqZustand");
      AttributeGroup atg1 = connection.getDataModel().getAttributeGroup("atg.wvzInhalt");

      if (atg != null && atg1 != null && object != null)
      {
        List<SystemObject> anzeigen = holeAlleAnzeigenVonAq2(aq);
        
        Map<StreckenProfilInhaltTyp, SystemObject> map = new HashMap<StreckenProfilInhaltTyp, SystemObject>();

        StreckenProfilElementTyp elementTypAnzeige = holeStreckenProfilElementTypVonAnzeige(object);        
        
        List<String> listTmp = new ArrayList<String>();
        for (SystemObject so : anzeigen)
        {          
          StreckenProfilElementTyp elementTyp = holeStreckenProfilElementTypVonAnzeige(so);
          if (elementTyp != null){           
            if (elementTyp.equals(elementTypAnzeige))
            {              
              Data data = null;
              
              if (mapSystemObjectData.containsKey(so))
              {
                data = mapSystemObjectData.get(so);                
              }else{
                
//              System.out.println("-> Else kein Key: " + so);              
//              ResultData result = DaVVerbindung.getInstanz().getDaVVerbindung().getData(so, new DataDescription(atg, asp), 1000);
//              if (result.hasData())
//              {
//                data = result.getData();
//              }
              }
              
              if (data != null)
              {
                String bi = StreckenProfilInhaltTyp.BI_GESTOERT.getType();
                // if (result.hasData())
                {
                  SystemObject ai = data.getItem("Eigenschaft").getItem("AnzeigeInhalt").asReferenceValue()
                  .getSystemObject();
                  if (ai != null){
                    Data cd = ai.getConfigurationData(atg1);
                    bi = cd.getItem("Bildinhalt").asTextValue().getValueText();                    
                  }
                }
                
                if (StreckenProfilInhaltTyp.hasType(bi))
                {
                  StreckenProfilInhaltTyp neu = StreckenProfilInhaltTyp.getType(bi);                  
                  // Nur hinzufuegen, wenn noch nicht in Liste vorhanden und StreckenProfilInhaltTyp ist eine GSB
                  if (!map.containsKey(neu)  
                      && neu.getValue() < 1000){
                    map.put(neu, so);
                    listTmp.add(" - " + neu.getType());
                  }
                }
              }              
            }
          }
        }

        if (map.size() == 1)
        {
          StreckenProfilInhaltTyp inhaltTmp = map.keySet().toArray(new StreckenProfilInhaltTyp[map.keySet().size()])[0];
          return inhaltTmp;
        }

        // Temposplit!!!
        if (map.size() > 1)
        {
          StreckenProfilInhaltTyp inhaltTmp = (StreckenProfilInhaltTyp)Collections.min(map.keySet());
          boolean unterschiedlicheInhalte = false;

          
          for (Map.Entry<StreckenProfilInhaltTyp, SystemObject> me : map.entrySet())
          {
            if (!inhalt.getType().equals(me.getKey().getType())){              
              unterschiedlicheInhalte = true;
//              System.out.println(_editor.getTitel() + " -> unterschiedlich: "  + inhalt.getType() + " -> " + me.getKey().getType() + " : " + me.getValue()); 
            }
          }

          if (unterschiedlicheInhalte)
          {            
            tooltips.addAll(listTmp);
            
            StreckenProfilInhaltTyp re = null;
            
//            if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_FAHRSTREIFEN_GESPERRT))
//            {
//              Set<StreckenProfilInhaltTyp> tmpSet = new HashSet<StreckenProfilInhaltTyp>(map.keySet());
//              List<StreckenProfilInhaltTyp> delList = new ArrayList<StreckenProfilInhaltTyp>();
//              for (StreckenProfilInhaltTyp typ : tmpSet)
//              {
//                if (typ.equals(StreckenProfilInhaltTyp.BI_TLS_FAHRSTREIFEN_GESPERRT))
//                    delList.add(typ);
//              }              
//              tmpSet.removeAll(delList);              
//              inhaltTmp = (StreckenProfilInhaltTyp)Collections.min(tmpSet);
//            }
            
            // AnzeigeTyp-A
            if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_FAHRSTREIFEN_GESPERRT))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_FAHRSTREIFEN_GESPERRT_MARKIERT.createNewInstance();
            }
            if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_100))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_100_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_120))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_120_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_130))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_130_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_40))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_40_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_50))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_50_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_60))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_60_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_80))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_80_MARKIERT.createNewInstance();
            }
            // AnzeigeTyp-B
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_GEFAHRENSTELLE))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_GEFAHRENSTELLE_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_STAU))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_STAU_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_GLAETTEGEFAHR))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_GLAETTEGEFAHR_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_SCHLEUDERGEFAHR))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_SCHLEUDERGEFAHR_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_ALLGEMEIN))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_ALLGEMEIN_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_LKW))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_LKW_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_NAESSE))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_NAESSE_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_BAUSTELLE))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_BAUSTELLE_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_ALLER_STRECKENVERBOTE))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_ENDE_ALLER_STRECKENVERBOTE_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_UEBERHOLVERBOT_ALLGEMEIN))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_ENDE_UEBERHOLVERBOT_ALLGEMEIN_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_UEBERHOLVERBOT_LKW))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_ENDE_UEBERHOLVERBOT_LKW_MARKIERT.createNewInstance();
            }
            // AnzeigeTyp-C
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_500M))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_500M_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_1000M))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_1000M_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_1500M))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_1500M_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_2000M))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_2000M_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_2500M))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_2500M_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_AUF_500M))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_AUF_500M_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_AUF_1000M))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_AUF_1000M_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_AUF_1500M))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_AUF_1500M_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_AUF_2000M))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_AUF_2000M_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_AUF_2500M))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_AUF_2500M_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_NEBEL))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_NEBEL_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_NAESSE))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_NAESSE_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_UNFALL))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_UNFALL_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_SMOG))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_SMOG_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_AS_GLAETTE))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_AS_GLAETTE_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_AS_GLAETTE))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_AS_GLAETTE_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_AS_OELSPUR))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_AS_OELSPUR_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_7KOMMA5TONNEN))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_7KOMMA5TONNEN_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_STAU_GEFAHR))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_STAU_GEFAHR_MARKIERT.createNewInstance();
            }
            else if (inhaltTmp.equals(StreckenProfilInhaltTyp.BI_TLS_SICHT))
            {
              re = StreckenProfilInhaltTyp.BI_TLS_SICHT_MARKIERT.createNewInstance();
            }            
//            else
//            {              
//              re = inhaltTmp.createNewInstance();
//            }
            
            if (re != null)
              tooltips.add(1, re.getType());
            
            return re;
            
          }
        }
      }
      return inhalt;
    }

//    /**
//     * @param anzeige
//     * @return
//     */
//    public List<SystemObject> holeAlleAnzeigenVonAq(SystemObject anzeige)
//    {
//      List<SystemObject> re = null;
//
//      SystemObjectType type = anzeige.getDataModel().getType("typ.anzeigeQuerschnitt");
//      List<SystemObject> elements = type.getElements();
//
//      for (SystemObject so : elements)
//      {
//        NonMutableSet set = ((ConfigurationObject)so).getNonMutableSet("Anzeigen");
//        if (set != null)
//        {
//          List<SystemObject> elements2 = set.getElements();
//          for (SystemObject so2 : elements2)
//          {
//            if (so2.getPid().equals(anzeige.getPid()))
//            {
//              re = elements2;
//              break;
//            }
//          }
//        }
//        if (re != null)
//          break;
//      }
//
//      return re;
//    }
    
    /**
     * @param anzeige
     * @return
     */
    public List<SystemObject> holeAlleAnzeigenVonAq2(SystemObject aq)
    {
      List<SystemObject> re = null;
      NonMutableSet set = ((ConfigurationObject)aq).getNonMutableSet("Anzeigen");
      if (set != null)
      {
        List<SystemObject> elements2 = set.getElements();
        re = elements2;
      }
      return re;
    }

    /**
     * @param object
     * @return
     */
    private String holeLageFs(SystemObject object)
    {
      String re = null;
      AttributeGroup atg = object.getDataModel().getAttributeGroup("atg.fahrStreifen");
      Data cd = object.getConfigurationData(atg);
      if (cd != null)
        re = cd.getItem("Lage").asTextValue().getValueText();
      return re;
    }

    /**
     * @param object
     * @return
     */
    private String holeIdentifierAusLage(String lage)
    {
      String identifier = "";
      if (lage.equals("HFS"))
      {
        identifier = BezeichnungGeschwindigkeitBeschraenkung.GSB_HFS.toString();
      }
      else if (lage.equals("1FS"))
      {
        identifier = BezeichnungGeschwindigkeitBeschraenkung.GSB_UEFS1.toString();
      }
      else if (lage.equals("2FS"))
      {
        identifier = BezeichnungGeschwindigkeitBeschraenkung.GSB_UEFS2.toString();
      }
      else if (lage.equals("3FS"))
      {
        identifier = BezeichnungGeschwindigkeitBeschraenkung.GSB_UEFS3.toString();
      }
      else if (lage.equals("4FS"))
      {
        identifier = BezeichnungGeschwindigkeitBeschraenkung.GSB_UEFS4.toString();
      }
      else if (lage.equals("5FS"))
      {
        identifier = BezeichnungGeschwindigkeitBeschraenkung.GSB_UEFS5.toString();
      }
      else if (lage.equals("6FS"))
      {
        identifier = BezeichnungGeschwindigkeitBeschraenkung.GSB_UEFS6.toString();
      }
      else if (lage.equals("STNDS"))
      {
        identifier = BezeichnungGeschwindigkeitBeschraenkung.GSB_STNDS.toString();
      }
      else{
        System.out.println("else Lagen: " + lage);
      }
      
      return identifier;
    }
    /**
     * @param object
     * @return
     */
    private String[] holeLageAnzeige(SystemObject object)
    {
      String[] re = null;

//      SystemObjectType type = object.getDataModel().getType("typ.sswSbaAnzeige");
//      List<SystemObject> elements = type.getElements();
//      AttributeGroup atg = object.getDataModel().getAttributeGroup("atg.sswSbaAnzeige");
//      for (SystemObject so : elements)
//      {
//        Data cd = so.getConfigurationData(atg);
//        SystemObject soAnzeige = cd.getItem("Anzeige").asReferenceValue().getSystemObject();
//        if (object.getPid().equals(soAnzeige.getPid()))
//        {
//
//          Array array = cd.getItem("Lage").asArray();
//
//          List<String> list = new ArrayList<String>();
//          for (int i = 0; i < array.getLength(); i++)
//          {
//            String s = array.getItem(i).asTextValue().getValueText();
//            list.add(s);
//          }
//
//          return list.toArray(new String[list.size()]);
//        }
//      }
      
      SystemObjectType type = object.getDataModel().getType("typ.sswSbaAnzeige"); // SSW SBA


      if (type != null)
      {
        List<SystemObject> elements = type.getElements();
        
        
        AttributeGroup atg = object.getDataModel().getAttributeGroup("atg.sswSbaAnzeige");
        for (SystemObject so : elements)
        {
          Data cd = so.getConfigurationData(atg);
          SystemObject soAnzeige = cd.getItem("Anzeige").asReferenceValue().getSystemObject();
          if (object.getPid().equals(soAnzeige.getPid()))
          {
            Array array = cd.getItem("Lage").asArray();
  
            List<String> list = new ArrayList<String>();
            for (int i = 0; i < array.getLength(); i++)
            {
              String s = array.getItem(i).asTextValue().getValueText();
              list.add(s);
            }
  
            return list.toArray(new String[list.size()]);
          }
        }
      }
      
      type = object.getDataModel().getType("typ.sbaAnzeige"); // UZ NW
      
      
      if (type != null)
      {
        List<SystemObject> elements = type.getElements();

        AttributeGroup atg = object.getDataModel().getAttributeGroup("atg.sbaAnzeige");
        for (SystemObject so : elements)
        {
          Data cd = so.getConfigurationData(atg);
          SystemObject soAnzeige = cd.getItem("Anzeige").asReferenceValue().getSystemObject();
          if (object.getPid().equals(soAnzeige.getPid()))
          {
            String text = cd.getScaledValue("Zuordnung").getValueText();
            
            if (text.equals("HFS"))
            {
              return new String[] {"HFS"};
            }
            else if (text.equals("1. FS"))
            {
              return new String[] {"1FS"};
            }
            else if (text.equals("2. FS"))
            {
              return new String[] {"2FS"};
            }
            else if (text.equals("3. FS"))
            {
              return new String[] {"3FS"};
            }
            else if (text.equals("4. FS"))
            {
              return new String[] {"4FS"};
            }
            else if (text.equals("Stiel rechts"))
            {
              return new String[] {"HFS"};
            }
            else if (text.equals("Stiel links"))
            {
              return new String[] {"1FS"};
            }
            else
            {
              return re;
            }
          }
        }
      }
      
      return re;
    }

//    /**
//     * @param treeset
//     * @param search
//     * @return
//     */
//    private Long findNearest(TreeSet<Long> treeset, Long search)
//    {
//      if (treeset.isEmpty())
//        return 0l;
//
//      if (treeset.contains(search))
//        return search;
//
//      Long higher = treeset.higher(search);
//
//      if (higher == null || higher == 0L)
//        return treeset.last();
//
//      long higherDiff = absoluteDifference(higher, search);
//
//      Long lower = treeset.lower(search);
//
//      if (lower == null || lower == 0L)
//        return treeset.first();
//
//      long lowerDiff = absoluteDifference(lower, search);
//
//      if (lowerDiff > higherDiff)
//        return higher;
//
//      return lower;
//    }
//
//    private long absoluteDifference(Long a, Long b)
//    {
//      return Math.abs(a - b);
//    }

    /**
     * Abmeldung am Dav und aufrumen der verschiedenen Caches.
     */
    public void abmeldung()
    {

      for (final Map<SystemObjekt, OnlineDatum> m : onlineDaten.values())
      {
        m.clear();
      }

      for (final AnzeigeQuerschnitt aq : anzeigeDaten.keySet())
      {
        for (final Anzeige anz : anzeigeDaten.get(aq).keySet())
        {
          anz.getOdAnzeigeEigenschaftIst().removeUpdateListener(OdAnzeigeEigenschaftIst.Aspekte.AqZustand,
              ChartComposite.this);
        }
      }

      anzeigeDaten.clear();
      mqModelCache.clear();
    }

    /**
     * Meldet sich als {@link DatensatzUpdateListener} auf alle MQ's und Fahrstreifen des Streckenprofils an.
     */
    public void anmeldung()
    {
      // vorher abmelden, zur sicherheit!!!
      abmeldung();

      List<MessQuerschnitt> alleMessquerschnitte = _modell.getAlleMessquerschnitte(true);
      for (final MessQuerschnitt mq : alleMessquerschnitte)
      {
        mQundFsAnmelden(mq);
      }
      //anmeldungAnzeigen();
      
      anmeldungAnzeigen2();
    
    }

    @Override
    public void streckenProfilUIProviderUpdate(StreckenProfilUIProviderEvent e)
    {      
      verarbeiteDaten(e);      
    }

    private void verarbeiteDaten(StreckenProfilUIProviderEvent e)
    {
      Long zeitStempel = null;

      Object source = e.getSource();
      if (source instanceof StreckenprofilEditor)
      {
        StreckenprofilEditor editor = (StreckenprofilEditor)source;
        
//        System.out.println("editor: " + editor.toString() + "" + _editor.toString() + " > " + editor.isSimulationAktiv());
        
        if (editor.toString().equals(_editor.toString()))
        {                    
          List<Dataset> daten = e.getStreckenProfilUIProviderDaten();      
          if (e.getStreckenProfilUIProviderDaten() != null){
            for (Dataset dataset : daten)
            {
              DataDescription dd = dataset.getDataDescription();
              SystemObject object = dataset.getObject();
//              boolean update = false;
              if (editor.isSimulationAktiv())
              {
                if (dataset instanceof ArchiveData)
                {
                  ArchiveData archiveData = (ArchiveData)dataset;
                  zeitStempel = new Long(archiveData.getArchiveTime());
//                  update = true;
                }
              }
              else
              {
                if (dataset instanceof ResultData)
                {
                  ResultData resultData = (ResultData)dataset;
                  zeitStempel = new Long(resultData.getDataTime());
//                  update = true;
                }
              }
              
//              if (update)
              {
                if (dataset.getData() != null && zeitStempel != null)
                {            
                  mapSystemObjectData.put(object, dataset.getData());
                  
                  if (dd.getAttributeGroup().getPid().equals("atg.anzeigeEigenschaftIst"))
                  {
                    verarbeiteAnzeigeDaten(zeitStempel, object, dd, dataset.getData());
                  }else{
//                    if (dd.getAttributeGroup().getPid().equals("atg.verkehrsDatenKurzZeitMq")
//                        || dd.getAttributeGroup().getPid().equals("atg.verkehrsDatenKurzZeitFs"))
                    {
                      verarbeiteVerkehrsDaten(zeitStempel, object, dd, dataset.getData());                    
                    }
                  }
                  
//                if (update)
                  {  
                    final StreckenProfilDiagrammData diagrammData = new StreckenProfilDiagrammData(mapObject, editor.toString(), editor.isSimulationAktiv(), zeitStempel);
                    if (!this.isDisposed())
                    {
                      this.getDisplay().asyncExec(new Runnable() {
                        
                        @Override
                        public void run()
                        {                          
                          StreckenProfilDataUpdateListener.getInstanz().notifyStreckenProfilDataUpdateListener(diagrammData);
                        }
                      });
                    }
                  }
                }                
              }              
            }              
          }                  
        }
      }
    }

    private boolean verarbeiteAnzeigeDaten(Long zeitStempel, SystemObject object, DataDescription dd, Data data)
    {
      boolean update = false;
      if (dd.getAttributeGroup().getPid().equals("atg.anzeigeEigenschaftIst"))
      {
        Long km = null;
        List<AnzeigeQuerschnitt> aqs = _modell.getAlleAnzeigequerschnitte();
        
//        System.out.println("verarbeiteAnzeigeDaten(): " + _editor.getTitel() + " -> " + object + " -> " + data);
        
        SystemObject soAq  = null;
        for (AnzeigeQuerschnitt aq : aqs)
        {     
          SystemObject so = aq.getModellObjekt().getSystemObject();
          if (so != null){
            List<SystemObject> anzeigen = holeAlleAnzeigenVonAq2(so);
            if (anzeigen != null){
              for (SystemObject so2 : anzeigen)
              {
                if (so2.equals(object)){
                  soAq = so;
                  Double wegBisher = aq.getWegBisher();
                  
                  if (wegBisher != null){
                    km = wegBisher.longValue();
//                    if (soAq.getPid().equals("aq.A81.5124.HFB.N"))
//                       km -= 3080;
                    break;
                  }
                }              
              }              
            }else{
              System.out.println("keine Anzeigen fr: " + so);
            }
          }          
        }   
        ArrayList<String> list = new ArrayList<String>();
        if (soAq != null){
          list.add(soAq.getName());
//          list.add(soAq.getPid());
        }
        
        String[] toolTip = list.toArray(new String[list.size()]);

        AttributeGroup atg1 = object.getDataModel().getAttributeGroup("atg.wvzInhalt");

        SystemObject so = data.getItem("Eigenschaft").getItem("AnzeigeInhalt").asReferenceValue().getSystemObject();
        if (so != null)
        {          
          Data cd = so.getConfigurationData(atg1);
          String bildInhalt = cd.getItem("Bildinhalt").asTextValue().getValueText();

          StreckenProfilElementTyp elementTyp = holeStreckenProfilElementTypVonAnzeige(object);

          if (StreckenProfilInhaltTyp.hasType(bildInhalt) && elementTyp != null)
          {

            String identifier = elementTyp.getType();
            StreckenProfilInhaltTyp inhalt = StreckenProfilInhaltTyp.getType(bildInhalt);
            
            if (inhalt != null)
            {
              Tupel value = new Tupel(new StreckenProfilObjektInformationen(toolTip), inhalt);   
               
              if (elementTyp.equals(StreckenProfilElementTyp.WZG_A) || elementTyp.equals(StreckenProfilElementTyp.WZG_B) || elementTyp.equals(StreckenProfilElementTyp.WZG_C))
              {
                
                StreckenProfilInhaltTyp inhaltNeu = null;
                //if(elementTyp.equals(StreckenProfilElementTyp.WZG_A) )
                
                 
                List<String> list2 = new ArrayList<String>();
                list2.add(soAq.getName());
                inhaltNeu = ersetzeInhaltBeiTemposplit(soAq, object, inhalt, list2);
                                                
                if (inhaltNeu == null){
                  value = new Tupel(new StreckenProfilObjektInformationen(toolTip), inhalt);
                }
                else if (!inhaltNeu.getType().equals(inhalt.getType()))
                {
                  value = new Tupel(new StreckenProfilObjektInformationen(list2.toArray(new String[list2.size()])), inhaltNeu);
                }
                update = aktualisiereMapSeries(km, value, identifier);               
//                BezeichnungGeschwindigkeitBeschraenkung[] values = BezeichnungGeschwindigkeitBeschraenkung.values();
//
//                for (BezeichnungGeschwindigkeitBeschraenkung gsb : values)
                {
                  
//                  if (geschwindigkeitsBeschraenkungen[gsb.ordinal()] 
//                    && gsb.equals(BezeichnungGeschwindigkeitBeschraenkung.GSB_HFS)
//                    )
                  {
                    
                    if (elementTyp.equals(StreckenProfilElementTyp.WZG_A))
                    {
                      String[] lagen = holeLageAnzeige(object);
                      
//                      System.out.println("object " + object + " lagen " + Arrays.toString(lagen));
                      
                      if (lagen != null && lagen.length > 0)
                      {
                        
                        String lage = lagen[0];
                        if (lagen.length > 1)
                          lage = lagen[1];
                        identifier = holeIdentifierAusLage(lage);
                        
//                      identifier = BezeichnungGeschwindigkeitBeschraenkung.GSB_HFS.toString();
//                      if (lagen[0].equals("HFS"))
//                      {
//                        identifier = BezeichnungGeschwindigkeitBeschraenkung.GSB_HFS.toString();
//                      }
//                      else if (lagen[0].equals("1FS"))
//                      {
//                        identifier = BezeichnungGeschwindigkeitBeschraenkung.GSB_UEFS1.toString();
//                      }
//                      else if (lagen[0].equals("2FS"))
//                      {
//                        identifier = BezeichnungGeschwindigkeitBeschraenkung.GSB_UEFS2.toString();
//                      }
//                      else if (lagen[0].equals("3FS"))
//                      {
//                        identifier = BezeichnungGeschwindigkeitBeschraenkung.GSB_UEFS3.toString();
//                      }
//                      else if (lagen[0].equals("4FS"))
//                      {
//                        identifier = BezeichnungGeschwindigkeitBeschraenkung.GSB_UEFS4.toString();
//                      }
//                      else if (lagen[0].equals("5FS"))
//                      {
//                        identifier = BezeichnungGeschwindigkeitBeschraenkung.GSB_UEFS5.toString();
//                      }
//                      else if (lagen[0].equals("6FS"))
//                      {
//                        identifier = BezeichnungGeschwindigkeitBeschraenkung.GSB_UEFS6.toString();
//                      }
//                      else if (lagen[0].equals("STNDS"))
//                      {
//                        identifier = BezeichnungGeschwindigkeitBeschraenkung.GSB_STNDS.toString();
//                      }
//                      else{
//                        System.out.println("else Lagen: " + lagen[0]);
//                      }
                        
                        inhaltNeu = StreckenProfilInhaltTyp.BI_INAKTIV;
                        
                        if (inhalt != null && inhaltNeu != null){                        
                          Double v = 65535.0;
                          
                          if (inhalt.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_40)
                              || inhaltNeu.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_40_MARKIERT))
                          {
                            v = 40.0;
                          }
                          else if (inhalt.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_50)
                              || inhaltNeu.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_50_MARKIERT))
                          {
                            v = 50.0;
                          }
                          else if (inhalt.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_60)
                              || inhaltNeu.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_60_MARKIERT))
                          {
                            v = 60.0;
                          }
                          else if (inhalt.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_80)
                              || inhaltNeu.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_80_MARKIERT))
                          {
                            v = 80.0;
                          }
                          else if (inhalt.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_100)
                              || inhaltNeu.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_100_MARKIERT))
                          {
                            v = 100.0;
                          }
                          else if (inhalt.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_120)
                              || inhaltNeu.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_120_MARKIERT))
                          {
                            v = 120.0;
                          }
                          else if (inhalt.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_130)
                              || inhaltNeu.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_130_MARKIERT))
                          {
                            v = 130.0;
                          }
                          
                          
//                          if (soAq.getPid().equals("aq.A8.6049.HFB.O")){
//                            if (soAq.getPid().equals("aq.A8.6006.HFB.O")){
//                            System.out.println("AQ-M22: " + km + " : " + v + " -> "  + identifier + " : " + inhalt.getType() + " : " + inhaltNeu) ;
//                          }
                          
//                       loescheKmAusMapSeries(km, identifier);                        
                          if(identifier != null 
//                              && identifier.equals(BezeichnungGeschwindigkeitBeschraenkung.GSB_HFS.toString())
                              )
                          {
                            value = new Tupel(new StreckenProfilObjektInformationen(toolTip), v.toString());
                            update = aktualisiereMapSeries(km, value, identifier);
                          }
                        }
                      }                      
                    }                    
                  }
                }
              }
            }
          }
        }
      }
      return update;      
    }

    private void verarbeiteVerkehrsDaten(Long zeitStempel, SystemObject object, DataDescription dd, Data data)
    {
      Integer i = null;
      // String quelle = BezeichnungVerkehrsDatenQuellen.MQ.toString();

//      if (dd.getAttributeGroup().getPid().equals("atg.verkehrsDatenKurzZeitMq")
//          || dd.getAttributeGroup().getPid().equals("atg.verkehrsDatenKurzZeitFs"))
      {

        String ext = "";
        
        TypPrognoseTyp typPrognoseTyp = _modell.getChartProperties().getTypPrognoseTyp();
        if (typPrognoseTyp.equals(TypPrognoseTyp.FLINK_EXTRA_POLATION) 
            || typPrognoseTyp.equals(TypPrognoseTyp.NORMAL_EXTRA_POLATION) 
            || typPrognoseTyp.equals(TypPrognoseTyp.TRAEGE_EXTRA_POLATION)
          ){
          ext = "P";
        }
        else if (typPrognoseTyp.equals(TypPrognoseTyp.FLINK_GEGLAETTET) 
            || typPrognoseTyp.equals(TypPrognoseTyp.NORMAL_GEGLAETTET) 
            || typPrognoseTyp.equals(TypPrognoseTyp.TRAEGE_GEGLAETTET)
        ){
          ext = "G";
        }
        
        List<MessQuerschnitt> mqs = _modell.getAlleMessquerschnitte(false);
        
        EList<LinienEigenschaften> lps = _modell.getLineProperties();
        for (LinienEigenschaften lp : lps)
        {
          TypDatenQuellen typQuelle = lp.getTypDatenQuelle();
          TypVerkehrsDaten typVd = lp.getTypVerkehrsDaten();
          String typ = typVd.getLiteral();
//          Long km = holeBetriebsKilometerMq(object);
          Long km = null;        
          
          String[] toolTip = new String[]{object.getName()};

          
          if (dd.getAttributeGroup().getPid().equals("atg.verkehrsDatenKurzZeitFs") 
              || dd.getAttributeGroup().getPid().equals("atg.verkehrsDatenKurzZeitTrendExtraPolationFs")
              || dd.getAttributeGroup().getPid().equals("atg.verkehrsDatenKurzZeitGeglttetFs")
              )
          {
            SystemObject object2 = holeMqVonFs(object);
            for (MessQuerschnitt mq2 : mqs)
            {
              if (mq2.getModellObjekt().getSystemObject().equals(object2)){             
                Double wegBisher = mq2.getWegBisher();
                if (wegBisher != null){
                  km = wegBisher.longValue();
                  break;
                }
              }
            }
//            km = holeBetriebsKilometerFs(object);
            typ = firstCharLowerCase(typVd.getLiteral());
            String lage = holeLageFs(object);

            if (lage != null && !lage.equals(typQuelle.getLiteral())){
              continue;
            }
          }
          else
          {
//            System.out.println("else: " + dd.getAttributeGroup().getPid() + " -> " + object);
            for (MessQuerschnitt mq : mqs)
            {
              if (mq.getModellObjekt().getSystemObject().equals(object)){             
                Double wegBisher = mq.getWegBisher();
                if (wegBisher != null){
                  km = wegBisher.longValue();
                  break;
                }
              }
            }            
            if (!typQuelle.equals(TypDatenQuellen.MQ))
              continue;            
          }

          String quelle = typQuelle.getLiteral();
          i = data.getItem(typ + ext).getItem("Wert").asUnscaledValue().intValue();
          if (i < 0)
          {
            i = 65535;
          }

          if (i != null)
          {
            Tupel value = new Tupel(new StreckenProfilObjektInformationen(toolTip), i.toString());
            String identifier = null;
            if (quelle != null && typVd.getLiteral() != null)
            {
              identifier = quelle + "-" + typVd.getLiteral();
//              System.out.println(typ + ext + " ::: " + dd.getAttributeGroup().getPid() + " : " + identifier + " -> " + i);
            }
            
            aktualisiereMapSeries(km, value, identifier);
          }
        }
      }
    }

    private String firstCharLowerCase(String str)
    {
      return str.substring(0, 1).toLowerCase() + str.substring(1);
    }
  }
  
  /**
  * @param object
  * @param richtung
  * @return
  */
  public SystemObject holeMqVonFs(SystemObject object)
  {
   SystemObject re = null;
     
   SystemObjectType type = object.getDataModel().getType("typ.messQuerschnittAllgemein");
   List<SystemObject> elements = type.getElements();
  
   for (SystemObject so : elements)
   {
     NonMutableSet set = ((ConfigurationObject)so).getNonMutableSet("FahrStreifen");
     if (set != null)
     {
       List<SystemObject> elements2 = set.getElements();
       for (SystemObject so2 : elements2)
       {
         if (so2.getPid().equals(object.getPid()))
         {
           re = so;
           break;
         }
       }
     }
     if (re != null)
       break;
   }
  
   return re;
  }
  

  public ChartComposite getChartComposite()
  {
    return chartComposite;
  }

  public void setChartComposite(ChartComposite chartComposite)
  {
    this.chartComposite = chartComposite;
  }

  private AchsenBeschreibung holeAchsenBeschreibungAusDiagrammEigenschaften(TAxis axis)
  {    
    TSeries[] seriesList = axis.getSeriesList();
    
    
    AchsenBeschreibung achsenBeschreibung = null;                
    DiagrammEigenschaften chartProperties = _modell.getChartProperties();
//    System.out.println("holeAchsenBeschreibungAusDiagrammEigenschaften(): " + chartProperties.getYAxisTypeGeschwindigkeit());
    for (TSeries tSeries : seriesList)
    {
      String unitSymbol = tSeries.getUnitSymbol();  
      
//      System.out.println("---> unitSymbol: " + unitSymbol + " -> " + tSeries.getQuantitySymbol() + " ->  " + tSeries.getFooter());
      
      if (unitSymbol.equals("PkwE/km")){
        achsenBeschreibung = chartProperties.getYAxisBemessungsverkehrsdichte();
      }
      else if (unitSymbol.equals("PkwE/h")){
        achsenBeschreibung = chartProperties.getYAxisBemessungsverkehrsstaerke();
      }
      else if (unitSymbol.equals("km/h")){
        achsenBeschreibung = chartProperties.getYAxisTypeGeschwindigkeit();
      }
      else if (unitSymbol.equals("Fz/h")){
        achsenBeschreibung = chartProperties.getYAxisTypAnzahl();        
      }
      else if (unitSymbol.equals("Fz/km")){
        achsenBeschreibung = chartProperties.getYAxisFahrezeugdichte();
      }
      else if (unitSymbol.equals("%")){
        achsenBeschreibung = chartProperties.getYAxisLKWAnteil();
      }else{
//        System.out.println("else: " + unitSymbol);
//        achsenBeschreibung = chartProperties.getYAxisTypeGeschwindigkeit();
      }
      
      if (achsenBeschreibung != null)
        return achsenBeschreibung;       
    }
      
    return null;
  }
}
