/**
 * <copyright>
 * </copyright>
 *
 * $Id: SeriesType.java,v 1.2 2014/04/17 15:51:12 Pittner Exp $
 */
package de.bsvrz.buv.plugin.streckenprofil.sts.a8.model;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc --> A representation of the literals of the enumeration '
 * <em><b>Series Type</b></em>', and utility methods for working with them. <!--
 * end-user-doc -->
 * @see de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenprofilPackage#getSeriesType()
 * @model
 * @generated
 */
public enum SeriesType implements Enumerator {
	/**
   * The '<em><b>Line</b></em>' literal object.
   * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
   * @see #LINE_VALUE
   * @generated
   * @ordered
   */
	LINE(0, "Line", "Line"), /**
	 * The '<em><b>Bar</b></em>' literal object. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #BAR_VALUE
	 * @generated
	 * @ordered
	 */
	BAR(1, "Bar", "Bar"), /**
   * The '<em><b>Bar Stacked</b></em>' literal object.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @see #BAR_STACKED_VALUE
   * @generated
   * @ordered
   */
	BAR_STACKED(2, "BarStacked", "BarStacked");

	/**
   * The '<em><b>Line</b></em>' literal value.
   * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Line</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
   * @see #LINE
   * @model name="Line"
   * @generated
   * @ordered
   */
	public static final int LINE_VALUE = 0;

	/**
   * The '<em><b>Bar</b></em>' literal value.
   * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Bar</b></em>' literal object isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
   * @see #BAR
   * @model name="Bar"
   * @generated
   * @ordered
   */
	public static final int BAR_VALUE = 1;

	/**
   * The '<em><b>Bar Stacked</b></em>' literal value.
   * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Bar Stacked</b></em>' literal object isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
   * @see #BAR_STACKED
   * @model name="BarStacked"
   * @generated
   * @ordered
   */
	public static final int BAR_STACKED_VALUE = 2;

	/**
	 * An array of all the '<em><b>Series Type</b></em>' enumerators. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private static final SeriesType[] VALUES_ARRAY = new SeriesType[]
    {
      LINE,
      BAR,
      BAR_STACKED,
    };

	/**
   * A public read-only list of all the '<em><b>Series Type</b></em>' enumerators.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public static final List<SeriesType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
   * Returns the '<em><b>Series Type</b></em>' literal with the specified literal value.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public static SeriesType get(String literal) {
    for (int i = 0; i < VALUES_ARRAY.length; ++i)
    {
      SeriesType result = VALUES_ARRAY[i];
      if (result.toString().equals(literal))
      {
        return result;
      }
    }
    return null;
  }

	/**
   * Returns the '<em><b>Series Type</b></em>' literal with the specified name.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public static SeriesType getByName(String name) {
    for (int i = 0; i < VALUES_ARRAY.length; ++i)
    {
      SeriesType result = VALUES_ARRAY[i];
      if (result.getName().equals(name))
      {
        return result;
      }
    }
    return null;
  }

	/**
   * Returns the '<em><b>Series Type</b></em>' literal with the specified integer value.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public static SeriesType get(int value) {
    switch (value)
    {
      case LINE_VALUE: return LINE;
      case BAR_VALUE: return BAR;
      case BAR_STACKED_VALUE: return BAR_STACKED;
    }
    return null;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	private final int value;

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	private final String name;

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	private final String literal;

	/**
   * Only this class can construct instances.
   * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
   * @generated
   */
	private SeriesType(int value, String name, String literal) {
    this.value = value;
    this.name = name;
    this.literal = literal;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public int getValue() {
    return value;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public String getName() {
    return name;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public String getLiteral() {
    return literal;
  }

	/**
   * Returns the literal value of the enumerator, which is its string representation.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public String toString() {
    return literal;
  }

} // SeriesType
