/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.bsvrz.buv.plugin.streckenprofil.sts.a8.preferences;

import org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer;

import de.bsvrz.buv.plugin.streckenprofil.sts.a8.Activator;

/**
 * Initialisiert die Prferenzen dieses Plug-Ins.
 * 
 * @author Pittner
 * 
 */
public class PreferenceInit extends AbstractPreferenceInitializer
{
	public static final String PROP_ANZEIGE_TYP_A = "PROP_ANZEIGE_TYP_A";
	public static final String PROP_ANZEIGE_TYP_B = "PROP_ANZEIGE_TYP_B";
	public static final String PROP_ANZEIGE_TYP_C = "PROP_ANZEIGE_TYP_C";

	public PreferenceInit()
	{
		super();
	}

	@Override
	public void initializeDefaultPreferences()
	{
		Activator.getDefault().getPreferenceStore().setDefault(
		    PROP_ANZEIGE_TYP_A, "");
		Activator.getDefault().getPreferenceStore().setDefault(
		    PROP_ANZEIGE_TYP_C, "");
		Activator.getDefault().getPreferenceStore().setDefault(
		    PROP_ANZEIGE_TYP_C, "");
	}
	
	public static String getAnzeigeTypA()
	{
	  return Activator.getDefault().getPreferenceStore().getString(
	      PROP_ANZEIGE_TYP_A);
	}
	public static String getAnzeigeTypB()
	{
	  return Activator.getDefault().getPreferenceStore().getString(
	      PROP_ANZEIGE_TYP_B);
	}
	public static String getAnzeigeTypC()
	{
	  return Activator.getDefault().getPreferenceStore().getString(
	      PROP_ANZEIGE_TYP_C);
	}

}
