/*
 * Created on Jul 13, 2004
 */
package de.bsvrz.buv.plugin.streckenprofil.sts.a8.type;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.Iterator;
import java.util.List;

/**
 * Represents our allowable data types - a small subset of those available in a real database!
 * 
 * @author Pittner
 * 
 */
public class StreckenProfilInhaltTyp implements Cloneable, Comparable<StreckenProfilInhaltTyp>
{

  private static List typen = new ArrayList();
 
  // Allgemeine Inhalte fuer alle WZG-Typen
  public static StreckenProfilInhaltTyp BI_DUNKEL = new StreckenProfilInhaltTyp("Dunkel", 20);
  public static StreckenProfilInhaltTyp BI_BELIEBIG = new StreckenProfilInhaltTyp("Beliebig");
  public static StreckenProfilInhaltTyp BI_GESTOERT = new StreckenProfilInhaltTyp("Gestrt");
  public static StreckenProfilInhaltTyp BI_INAKTIV = new StreckenProfilInhaltTyp("Inaktiv");
  public static StreckenProfilInhaltTyp BI_UNDEFINIERT = new StreckenProfilInhaltTyp("Undefiniert");  

  // WZG-A   
  public static StreckenProfilInhaltTyp BI_TLS_FAHRSTREIFEN_GESPERRT = new StreckenProfilInhaltTyp("TLS.FahrstreifenGesperrt", 8);
  public static StreckenProfilInhaltTyp BI_TLS_FAHRSTREIFEN_GESPERRT_MARKIERT = new StreckenProfilInhaltTyp("TLS.FahrstreifenGesperrt / andere Inhalte");
//  public static StreckenProfilInhaltTyp BI_TLS_FAHRSTREIFEN_GESPERRT = new StreckenProfilInhaltTyp("TLS.FahrstreifenGesperrt", 0);
  public static StreckenProfilInhaltTyp BI_TLS_FAHRSTREIFEN_WECHSELN_NACH_LINKS = new StreckenProfilInhaltTyp("TLS.FahrstreifenWechselnNachLinks", 9);
  public static StreckenProfilInhaltTyp BI_TLS_FAHRSTREIFEN_WECHSELN_NACH_RECHTS = new StreckenProfilInhaltTyp("TLS.FahrstreifenWechselnNachRechts", 9);
  public static StreckenProfilInhaltTyp BI_TLS_ZULAESSIGE_HOECHST_10 = new StreckenProfilInhaltTyp("TLS.ZulaessigeHoechst10");
  public static StreckenProfilInhaltTyp BI_TLS_ZULAESSIGE_HOECHST_20 = new StreckenProfilInhaltTyp("TLS.ZulaessigeHoechst20");
  public static StreckenProfilInhaltTyp BI_TLS_ZULAESSIGE_HOECHST_30 = new StreckenProfilInhaltTyp("TLS.ZulaessigeHoechst30");
  public static StreckenProfilInhaltTyp BI_TLS_ZULAESSIGE_HOECHST_40 = new StreckenProfilInhaltTyp("TLS.ZulaessigeHoechst40", 1);
  public static StreckenProfilInhaltTyp BI_TLS_ZULAESSIGE_HOECHST_40_MARKIERT = new StreckenProfilInhaltTyp("TLS.ZulaessigeHoechst40 / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_ZULAESSIGE_HOECHST_50 = new StreckenProfilInhaltTyp("TLS.ZulaessigeHoechst50", 2);
  public static StreckenProfilInhaltTyp BI_TLS_ZULAESSIGE_HOECHST_50_MARKIERT = new StreckenProfilInhaltTyp("TLS.ZulaessigeHoechst50 / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_ZULAESSIGE_HOECHST_60 = new StreckenProfilInhaltTyp("TLS.ZulaessigeHoechst60", 3);
  public static StreckenProfilInhaltTyp BI_TLS_ZULAESSIGE_HOECHST_60_MARKIERT = new StreckenProfilInhaltTyp("TLS.ZulaessigeHoechst60 / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_ZULAESSIGE_HOECHST_70 = new StreckenProfilInhaltTyp("TLS.ZulaessigeHoechst70");
  public static StreckenProfilInhaltTyp BI_TLS_ZULAESSIGE_HOECHST_80 = new StreckenProfilInhaltTyp("TLS.ZulaessigeHoechst80", 4);
  public static StreckenProfilInhaltTyp BI_TLS_ZULAESSIGE_HOECHST_80_MARKIERT = new StreckenProfilInhaltTyp("TLS.ZulaessigeHoechst80 / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_ZULAESSIGE_HOECHST_100 = new StreckenProfilInhaltTyp("TLS.ZulaessigeHoechst100", 5);
  public static StreckenProfilInhaltTyp BI_TLS_ZULAESSIGE_HOECHST_100_MARKIERT = new StreckenProfilInhaltTyp("TLS.ZulaessigeHoechst100 / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_ZULAESSIGE_HOECHST_120 = new StreckenProfilInhaltTyp("TLS.ZulaessigeHoechst120", 6);
  public static StreckenProfilInhaltTyp BI_TLS_ZULAESSIGE_HOECHST_120_MARKIERT = new StreckenProfilInhaltTyp("TLS.ZulaessigeHoechst120 / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_ZULAESSIGE_HOECHST_130 = new StreckenProfilInhaltTyp("TLS.ZulaessigeHoechst130", 7);
  public static StreckenProfilInhaltTyp BI_TLS_ZULAESSIGE_HOECHST_130_MARKIERT = new StreckenProfilInhaltTyp("TLS.ZulaessigeHoechst130 / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_ENDE_ZULAESSIGE_HOECHST_10 = new StreckenProfilInhaltTyp("TLS.EndeZulaessigeHoechst10");
  public static StreckenProfilInhaltTyp BI_TLS_ENDE_ZULAESSIGE_HOECHST_20 = new StreckenProfilInhaltTyp("TLS.EndeZulaessigeHoechst20");
  public static StreckenProfilInhaltTyp BI_TLS_ENDE_ZULAESSIGE_HOECHST_30 = new StreckenProfilInhaltTyp("TLS.EndeZulaessigeHoechst30");
  public static StreckenProfilInhaltTyp BI_TLS_ENDE_ZULAESSIGE_HOECHST_40 = new StreckenProfilInhaltTyp("TLS.EndeZulaessigeHoechst40", 10);
  public static StreckenProfilInhaltTyp BI_TLS_ENDE_ZULAESSIGE_HOECHST_50 = new StreckenProfilInhaltTyp("TLS.EndeZulaessigeHoechst50", 11);
  public static StreckenProfilInhaltTyp BI_TLS_ENDE_ZULAESSIGE_HOECHST_60 = new StreckenProfilInhaltTyp("TLS.EndeZulaessigeHoechst60", 12);
  public static StreckenProfilInhaltTyp BI_TLS_ENDE_ZULAESSIGE_HOECHST_70 = new StreckenProfilInhaltTyp("TLS.EndeZulaessigeHoechst70");
  public static StreckenProfilInhaltTyp BI_TLS_ENDE_ZULAESSIGE_HOECHST_80 = new StreckenProfilInhaltTyp("TLS.EndeZulaessigeHoechst80", 13);
  public static StreckenProfilInhaltTyp BI_TLS_ENDE_ZULAESSIGE_HOECHST_100 = new StreckenProfilInhaltTyp("TLS.EndeZulaessigeHoechst100", 14);
  public static StreckenProfilInhaltTyp BI_TLS_ENDE_ZULAESSIGE_HOECHST_120 = new StreckenProfilInhaltTyp("TLS.EndeZulaessigeHoechst120", 15);
  public static StreckenProfilInhaltTyp BI_TLS_ENDE_ZULAESSIGE_HOECHST_130 = new StreckenProfilInhaltTyp("TLS.EndeZulaessigeHoechst130", 16);
  public static StreckenProfilInhaltTyp BI_TLS_FAHRSTREIFEN_HALTEN = new StreckenProfilInhaltTyp("TLS.FahrstreifenHalten");

  // WZG-B
  public static StreckenProfilInhaltTyp BI_TLS_GEFAHRENSTELLE = new StreckenProfilInhaltTyp("TLS.Gefahrenstelle", 3);
  public static StreckenProfilInhaltTyp BI_TLS_GEFAHRENSTELLE_MARKIERT = new StreckenProfilInhaltTyp("TLS.Gefahrenstelle / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_STAU = new StreckenProfilInhaltTyp("TLS.Stau", 2);
  public static StreckenProfilInhaltTyp BI_TLS_STAU_MARKIERT = new StreckenProfilInhaltTyp("TLS.Stau / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_GLAETTEGEFAHR = new StreckenProfilInhaltTyp("TLS.Glaettegefahr", 1);
  public static StreckenProfilInhaltTyp BI_TLS_GLAETTEGEFAHR_MARKIERT = new StreckenProfilInhaltTyp("TLS.Glaettegefahr / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_SCHLEUDERGEFAHR = new StreckenProfilInhaltTyp("TLS.Schleudergefahr", 7);
  public static StreckenProfilInhaltTyp BI_TLS_SCHLEUDERGEFAHR_MARKIERT = new StreckenProfilInhaltTyp("TLS.Schleudergefahr / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_UEBERHOLVERBOT_ALLGEMEIN = new StreckenProfilInhaltTyp("TLS.UeberholverbotAllgemein", 4);
  public static StreckenProfilInhaltTyp BI_TLS_UEBERHOLVERBOT_ALLGEMEIN_MARKIERT = new StreckenProfilInhaltTyp("TLS.UeberholverbotAllgemein / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_UEBERHOLVERBOT_LKW = new StreckenProfilInhaltTyp("TLS.UeberholverbotLkw", 5);
  public static StreckenProfilInhaltTyp BI_TLS_UEBERHOLVERBOT_LKW_MARKIERT = new StreckenProfilInhaltTyp("TLS.UeberholverbotLkw / andere Inhalte");
  // TODO staBes: #6 Erweiterung um den Inhaltstyp 'BI_TLS_UEBERHOLVERBOT_NAESSE'.
  public static StreckenProfilInhaltTyp BI_TLS_UEBERHOLVERBOT_NAESSE = new StreckenProfilInhaltTyp("TLS.UeberholverbotNaesse");
  public static StreckenProfilInhaltTyp BI_TLS_UEBERHOLVERBOT_NAESSE_MARKIERT = new StreckenProfilInhaltTyp("TLS.UeberholverbotNaesse / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_BAUSTELLE = new StreckenProfilInhaltTyp("TLS.Baustelle", 6);
  public static StreckenProfilInhaltTyp BI_TLS_BAUSTELLE_MARKIERT = new StreckenProfilInhaltTyp("TLS.Baustelle / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_ENDE_ALLER_STRECKENVERBOTE = new StreckenProfilInhaltTyp("TLS.EndeAllerStreckenverbote", 8);                                                                                       
  public static StreckenProfilInhaltTyp BI_TLS_ENDE_ALLER_STRECKENVERBOTE_MARKIERT = new StreckenProfilInhaltTyp("TLS.EndeAllerStreckenverbote / andere Inhalte");                                                                                       
  public static StreckenProfilInhaltTyp BI_TLS_ENDE_UEBERHOLVERBOT_ALLGEMEIN = new StreckenProfilInhaltTyp("TLS.EndeUeberholverbotAllgemein", 9);
  public static StreckenProfilInhaltTyp BI_TLS_ENDE_UEBERHOLVERBOT_ALLGEMEIN_MARKIERT = new StreckenProfilInhaltTyp("TLS.EndeUeberholverbotAllgemein / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_ENDE_UEBERHOLVERBOT_LKW = new StreckenProfilInhaltTyp("TLS.EndeUeberholverbotLkw", 10);
  public static StreckenProfilInhaltTyp BI_TLS_ENDE_UEBERHOLVERBOT_LKW_MARKIERT = new StreckenProfilInhaltTyp("TLS.EndeUeberholverbotLkw / andere Inhalte");

  // WZG-C
//  public static StreckenProfilInhaltTyp BI_TLS_1KM = new StreckenProfilInhaltTyp("TLS.1Kilometer", 16);
//  public static StreckenProfilInhaltTyp BI_TLS_1KM_MARKIERT = new StreckenProfilInhaltTyp("TLS.1Kilometer / andere Inhalte");
//  public static StreckenProfilInhaltTyp BI_TLS_1_KOMMA_5_KM = new StreckenProfilInhaltTyp("TLS.1Komma5Kilometer", 18);
//  public static StreckenProfilInhaltTyp BI_TLS_1_KOMMA_5_KM_MARKIERT = new StreckenProfilInhaltTyp("TLS.1Komma5Kilometer / andere Inhalte");
//  public static StreckenProfilInhaltTyp BI_TLS_2KM = new StreckenProfilInhaltTyp("TLS.2Kilometer", 20);
//  public static StreckenProfilInhaltTyp BI_TLS_2KM_MARKIERT = new StreckenProfilInhaltTyp("TLS.2Kilometer / andere Inhalte");
//  public static StreckenProfilInhaltTyp BI_TLS_2_KOMMA_5_KM = new StreckenProfilInhaltTyp("TLS.2Komma5Kilometer", 22);
//  public static StreckenProfilInhaltTyp BI_TLS_2_KOMMA_5_KM_MARKIERT = new StreckenProfilInhaltTyp("TLS.2Komma5Kilometer / andere Inhalte");
//  public static StreckenProfilInhaltTyp BI_TLS_3KM = new StreckenProfilInhaltTyp("TLS.3Kilometer", 24);
//  public static StreckenProfilInhaltTyp BI_TLS_3KM_MARKIERT = new StreckenProfilInhaltTyp("TLS.3Kilometer / andere Inhalte");
  
  public static StreckenProfilInhaltTyp BI_TLS_500M = new StreckenProfilInhaltTyp("TLS.500Meter", 14);
  public static StreckenProfilInhaltTyp BI_TLS_500M_MARKIERT = new StreckenProfilInhaltTyp("TLS.500Meter / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_1000M = new StreckenProfilInhaltTyp("TLS.1000Meter", 15);
  public static StreckenProfilInhaltTyp BI_TLS_1000M_MARKIERT = new StreckenProfilInhaltTyp("TLS.1000Meter / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_1500M = new StreckenProfilInhaltTyp("TLS.1500Meter", 17);
  public static StreckenProfilInhaltTyp BI_TLS_1500M_MARKIERT = new StreckenProfilInhaltTyp("TLS.1500Meter / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_2000M = new StreckenProfilInhaltTyp("TLS.2000Meter", 19);
  public static StreckenProfilInhaltTyp BI_TLS_2000M_MARKIERT = new StreckenProfilInhaltTyp("TLS.2000Meter / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_2500M = new StreckenProfilInhaltTyp("TLS.2500Meter", 21);
  public static StreckenProfilInhaltTyp BI_TLS_2500M_MARKIERT = new StreckenProfilInhaltTyp("TLS.2500Meter / andere Inhalte");
//  public static StreckenProfilInhaltTyp BI_TLS_3000M = new StreckenProfilInhaltTyp("TLS.3000Meter", 23);
//  public static StreckenProfilInhaltTyp BI_TLS_3000M_MARKIERT = new StreckenProfilInhaltTyp("TLS.3000Meter / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_AUF_500M = new StreckenProfilInhaltTyp("TLS.Auf500Meter", 13);
  public static StreckenProfilInhaltTyp BI_TLS_AUF_500M_MARKIERT = new StreckenProfilInhaltTyp("TLS.Auf500Meter / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_AUF_1000M = new StreckenProfilInhaltTyp("TLS.Auf1000Meter", 12);
  public static StreckenProfilInhaltTyp BI_TLS_AUF_1000M_MARKIERT = new StreckenProfilInhaltTyp("TLS.Auf1000Meter / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_AUF_1500M = new StreckenProfilInhaltTyp("TLS.Auf1500Meter", 11);
  public static StreckenProfilInhaltTyp BI_TLS_AUF_1500M_MARKIERT = new StreckenProfilInhaltTyp("TLS.Auf1500Meter / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_AUF_2000M = new StreckenProfilInhaltTyp("TLS.Auf2000Meter", 10); 
  public static StreckenProfilInhaltTyp BI_TLS_AUF_2000M_MARKIERT = new StreckenProfilInhaltTyp("TLS.Auf2000Meter / andere Inhalte"); 
  public static StreckenProfilInhaltTyp BI_TLS_AUF_2500M = new StreckenProfilInhaltTyp("TLS.Auf2500Meter", 9); 
  public static StreckenProfilInhaltTyp BI_TLS_AUF_2500M_MARKIERT = new StreckenProfilInhaltTyp("TLS.Auf2500Meter / andere Inhalte"); 
  public static StreckenProfilInhaltTyp BI_TLS_NEBEL = new StreckenProfilInhaltTyp("TLS.Nebel");
  public static StreckenProfilInhaltTyp BI_TLS_NEBEL_MARKIERT = new StreckenProfilInhaltTyp("TLS.Nebel / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_NAESSE = new StreckenProfilInhaltTyp("TLS.Naesse");
  public static StreckenProfilInhaltTyp BI_TLS_NAESSE_MARKIERT = new StreckenProfilInhaltTyp("TLS.Naesse / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_UNFALL = new StreckenProfilInhaltTyp("TLS.Unfall", 1);
  public static StreckenProfilInhaltTyp BI_TLS_UNFALL_MARKIERT = new StreckenProfilInhaltTyp("TLS.Unfall / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_SMOG = new StreckenProfilInhaltTyp("TLS.Smog");
  public static StreckenProfilInhaltTyp BI_TLS_SMOG_MARKIERT = new StreckenProfilInhaltTyp("TLS.Smog / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_AS_GLAETTE = new StreckenProfilInhaltTyp("TLS-AS.Gltte");
  public static StreckenProfilInhaltTyp BI_TLS_AS_GLAETTE_MARKIERT = new StreckenProfilInhaltTyp("TLS-AS.Gltte / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_AS_OELSPUR = new StreckenProfilInhaltTyp("TLS-AS.lspur", 2);
  public static StreckenProfilInhaltTyp BI_TLS_AS_OELSPUR_MARKIERT = new StreckenProfilInhaltTyp("TLS-AS.lspur / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_7KOMMA5TONNEN = new StreckenProfilInhaltTyp("TLS.7Komma5Tonnen", 8);
  public static StreckenProfilInhaltTyp BI_TLS_7KOMMA5TONNEN_MARKIERT = new StreckenProfilInhaltTyp("TLS.7Komma5Tonnen / andere Inhalte");
  public static StreckenProfilInhaltTyp BI_TLS_STAU_GEFAHR = new StreckenProfilInhaltTyp("TLS.Staugefahr", 6);
  public static StreckenProfilInhaltTyp BI_TLS_STAU_GEFAHR_MARKIERT = new StreckenProfilInhaltTyp("TLS.Staugefahr / andere Inhalte");
  //public static StreckenProfilInhaltTyp BI_TLS_STAU = new StreckenProfilInhaltTyp("TLS.Stau");
  public static StreckenProfilInhaltTyp BI_TLS_SICHT = new StreckenProfilInhaltTyp("TLS.Sicht", 7);
  public static StreckenProfilInhaltTyp BI_TLS_SICHT_MARKIERT = new StreckenProfilInhaltTyp("TLS.Sicht / andere Inhalte");
//  public static StreckenProfilInhaltTyp BI_TLS_TIERE = new StreckenProfilInhaltTyp("TLS.Tiere", 3);
//  public static StreckenProfilInhaltTyp BI_TLS_TIERE_MARKIERT = new StreckenProfilInhaltTyp("TLS.Tiere / andere Inhalte");
//  public static StreckenProfilInhaltTyp BI_TLS_KONTROLLE = new StreckenProfilInhaltTyp("TLS.Kontrolle", 4);
//  public static StreckenProfilInhaltTyp BI_TLS_KONTROLLE_MARKIERT = new StreckenProfilInhaltTyp("TLS.Kontrolle / andere Inhalte");

  // Blinker
  public static StreckenProfilInhaltTyp BI_TLS_GELBES_BLINKLICHT = new StreckenProfilInhaltTyp("TLS.GelbesBlinklicht");
  public static StreckenProfilInhaltTyp UFD_GESTOERT = new StreckenProfilInhaltTyp("UFD.Gestrt");
  public static StreckenProfilInhaltTyp UFD_INAKTIV = new StreckenProfilInhaltTyp("UFD.Inaktiv");
  public static StreckenProfilInhaltTyp UFD_UNDEFINIERT = new StreckenProfilInhaltTyp("Undefiniert");  

  // UFD OberflaechenZustand
  public static StreckenProfilInhaltTyp UFD_OBERFLAECHE_SCHNEE = new StreckenProfilInhaltTyp("OFSchnee/Schneematsch");
  public static StreckenProfilInhaltTyp UFD_OBERFLAECHE_NASS_3 = new StreckenProfilInhaltTyp("OFnass3");
  public static StreckenProfilInhaltTyp UFD_OBERFLAECHE_NASS_2 = new StreckenProfilInhaltTyp("OFnass");
  public static StreckenProfilInhaltTyp UFD_OBERFLAECHE_NASS_1 = new StreckenProfilInhaltTyp("OFfeucht");
  public static StreckenProfilInhaltTyp UFD_OBERFLAECHE_TROCKEN = new StreckenProfilInhaltTyp("OFtrocken");
  public static StreckenProfilInhaltTyp UFD_OBERFLAECHE_GESTOERT = new StreckenProfilInhaltTyp("OFGestrt");
  public static StreckenProfilInhaltTyp UFD_OBERFLAECHE_UNDEFINIERT = new StreckenProfilInhaltTyp("OFUndefiniert");

  // UFD Niederschlag
  public static StreckenProfilInhaltTyp UFD_NIEDERSCHLAG_NASS_5 = new StreckenProfilInhaltTyp("NSnass5");
  public static StreckenProfilInhaltTyp UFD_NIEDERSCHLAG_NASS_4 = new StreckenProfilInhaltTyp("NSnass4");
  public static StreckenProfilInhaltTyp UFD_NIEDERSCHLAG_NASS_3 = new StreckenProfilInhaltTyp("NSnass3");
  public static StreckenProfilInhaltTyp UFD_NIEDERSCHLAG_NASS_2 = new StreckenProfilInhaltTyp("NSnass2");
  public static StreckenProfilInhaltTyp UFD_NIEDERSCHLAG_NASS_1 = new StreckenProfilInhaltTyp("NSnass1");
  public static StreckenProfilInhaltTyp UFD_NIEDERSCHLAG_TROCKEN = new StreckenProfilInhaltTyp("NStrocken");
  public static StreckenProfilInhaltTyp UFD_NIEDERSCHLAG_GESTOERT = new StreckenProfilInhaltTyp("NSGestrt");
  public static StreckenProfilInhaltTyp UFD_NIEDERSCHLAG_NICHT_ERMITTELBAR = new StreckenProfilInhaltTyp("NSNichtErmittelbar");
  public static StreckenProfilInhaltTyp UFD_NIEDERSCHLAG_UNDEFINIERT = new StreckenProfilInhaltTyp("NSUndefiniert");

  // UFD Sichtweite
  public static StreckenProfilInhaltTyp UFD_SICHTWEITE_STUFE_6 = new StreckenProfilInhaltTyp("SWStufe6");
  public static StreckenProfilInhaltTyp UFD_SICHTWEITE_STUFE_5 = new StreckenProfilInhaltTyp("SWStufe5");
  public static StreckenProfilInhaltTyp UFD_SICHTWEITE_STUFE_4 = new StreckenProfilInhaltTyp("SWStufe4");
  public static StreckenProfilInhaltTyp UFD_SICHTWEITE_STUFE_3 = new StreckenProfilInhaltTyp("SWStufe3");
  public static StreckenProfilInhaltTyp UFD_SICHTWEITE_STUFE_2 = new StreckenProfilInhaltTyp("SWStufe2");
  public static StreckenProfilInhaltTyp UFD_SICHTWEITE_STUFE_1 = new StreckenProfilInhaltTyp("SWStufe1");
  public static StreckenProfilInhaltTyp UFD_SICHTWEITE_GESTOERT = new StreckenProfilInhaltTyp("SWgestrt");
  public static StreckenProfilInhaltTyp UFD_SICHTWEITE_NICHT_ERMITTELBAR = new StreckenProfilInhaltTyp("SWNichtErmittelbar");
  public static StreckenProfilInhaltTyp UFD_SICHTWEITE_UNDEFINIERT = new StreckenProfilInhaltTyp("SWUndefiniert");
  
  // UFD Helligkeit
  public static StreckenProfilInhaltTyp UFD_HELLIGKEIT_STUFE_10 = new StreckenProfilInhaltTyp("HKStufe10");
  public static StreckenProfilInhaltTyp UFD_HELLIGKEIT_STUFE_9 = new StreckenProfilInhaltTyp("HKStufe9");
  public static StreckenProfilInhaltTyp UFD_HELLIGKEIT_STUFE_8 = new StreckenProfilInhaltTyp("HKStufe8");
  public static StreckenProfilInhaltTyp UFD_HELLIGKEIT_STUFE_7 = new StreckenProfilInhaltTyp("HKStufe7");
  public static StreckenProfilInhaltTyp UFD_HELLIGKEIT_STUFE_6 = new StreckenProfilInhaltTyp("HKStufe6");
  public static StreckenProfilInhaltTyp UFD_HELLIGKEIT_STUFE_5 = new StreckenProfilInhaltTyp("HKStufe5");
  public static StreckenProfilInhaltTyp UFD_HELLIGKEIT_STUFE_4 = new StreckenProfilInhaltTyp("HKStufe4");
  public static StreckenProfilInhaltTyp UFD_HELLIGKEIT_STUFE_3 = new StreckenProfilInhaltTyp("HKStufe3");
  public static StreckenProfilInhaltTyp UFD_HELLIGKEIT_STUFE_2 = new StreckenProfilInhaltTyp("HKStufe2");
  public static StreckenProfilInhaltTyp UFD_HELLIGKEIT_STUFE_1 = new StreckenProfilInhaltTyp("HKStufe1");
  public static StreckenProfilInhaltTyp UFD_HELLIGKEIT_GESTOERT = new StreckenProfilInhaltTyp("HKgestrt");
  public static StreckenProfilInhaltTyp UFD_HELLIGKEIT_UNDEFINIERT = new StreckenProfilInhaltTyp("HKUndefiniert");

  private String typ;

  private Integer value;

  public int getValue()
  {
    return value;
  }

  private StreckenProfilInhaltTyp(String type)
  {
    this(type, 1000);    
  }
  
  private StreckenProfilInhaltTyp(String type, int value)
  {
    this.typ = type;
    this.value = value;
    String typeToAdd = this.getType();
    typen.add(typeToAdd);
  }

  /**
   * @return Returns the type.
   */
  public String getType()
  {
    return typ;
  }

  /**
   * @param type
   * @return
   */
  public static boolean hasType(String type)
  {
//    return typen.contains(type.toUpperCase());
    return typen.contains(type);
  }

  /**
   * @return
   */
  public static String getTypes()
  {
    StringBuffer typeBuffer = new StringBuffer();
    for (Iterator iter = typen.iterator(); iter.hasNext();)
    {
      String element = (String)iter.next();
      typeBuffer.append(element).append(", ");
    }
    if (typen.size() >= 1)
    {
      typeBuffer.delete(typeBuffer.length() - 2, typeBuffer.length());
    }
    return typeBuffer.toString();
  }
  
  
//  /**
//   * Liefer die Instanz des {@link StreckenProfilInhaltTyp} 
//   * anhand der uebergebenen Bezeichnung
//   * 
//   * @param type
//   * @return
//   */
//  public static StreckenProfilInhaltTyp getType(String type){
//    StreckenProfilInhaltTyp re = null;    
//    if (typen.contains(type)){
//      re = new StreckenProfilInhaltTyp(type);    
//    }
//    return re;     
//  }
  
  /**
   * Liefert die Instanz des {@link StreckenProfilInhaltTyp} 
   * anhand der uebergebenen Bezeichnung
   * 
   * @param type
   * @return
   */
  public static StreckenProfilInhaltTyp getType(String type){
    StreckenProfilInhaltTyp re = null;    
    if (typen.contains(type)){
      
      if (type.equals(StreckenProfilInhaltTyp.BI_DUNKEL.getType())){
        re = StreckenProfilInhaltTyp.BI_DUNKEL.createNewInstance();             
      }     
//      else if (type.equals(StreckenProfilInhaltTyp.BI_GESTOERT.getType())){
//        re = StreckenProfilInhaltTyp.BI_GESTOERT.createNewInstance();                     
//      }     
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_FAHRSTREIFEN_GESPERRT.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_FAHRSTREIFEN_GESPERRT.createNewInstance();
      }
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_FAHRSTREIFEN_WECHSELN_NACH_LINKS.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_FAHRSTREIFEN_WECHSELN_NACH_LINKS.createNewInstance();
      }
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_FAHRSTREIFEN_WECHSELN_NACH_RECHTS.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_FAHRSTREIFEN_WECHSELN_NACH_RECHTS.createNewInstance();
      }
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_130.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_130.createNewInstance();
      }
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_120.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_120.createNewInstance();
      }
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_100.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_100.createNewInstance();        
      }
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_80.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_80.createNewInstance();        
      }
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_70.getType())){
          re = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_70.createNewInstance();        
        }
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_60.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_60.createNewInstance();        
      }
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_50.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_50.createNewInstance();        
      }
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_40.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_40.createNewInstance();        
      }
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_30.getType())){
          re = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_30.createNewInstance();        
        }
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_20.getType())){
          re = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_20.createNewInstance();        
        }
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_10.getType())){
          re = StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_10.createNewInstance();        
        }
      
//      public static StreckenProfilInhaltTyp BI_TLS_GEFAHRENSTELLE = new StreckenProfilInhaltTyp("TLS.Gefahrenstelle", 3);
//      public static StreckenProfilInhaltTyp BI_TLS_GEFAHRENSTELLE_MARKIERT = new StreckenProfilInhaltTyp("TLS.Gefahrenstelle / andere Inhalte");
//      public static StreckenProfilInhaltTyp BI_TLS_STAU = new StreckenProfilInhaltTyp("TLS.Stau", 2);
//      public static StreckenProfilInhaltTyp BI_TLS_STAU_MARKIERT = new StreckenProfilInhaltTyp("TLS.Stau / andere Inhalte");
//      public static StreckenProfilInhaltTyp BI_TLS_GLAETTEGEFAHR = new StreckenProfilInhaltTyp("TLS.Glaettegefahr", 1);
//      public static StreckenProfilInhaltTyp BI_TLS_GLAETTEGEFAHR_MARKIERT = new StreckenProfilInhaltTyp("TLS.Glaettegefahr / andere Inhalte");
//      public static StreckenProfilInhaltTyp BI_TLS_SCHLEUDERGEFAHR = new StreckenProfilInhaltTyp("TLS.Schleudergefahr", 7);
//      public static StreckenProfilInhaltTyp BI_TLS_SCHLEUDERGEFAHR_MARKIERT = new StreckenProfilInhaltTyp("TLS.Schleudergefahr / andere Inhalte");
//      public static StreckenProfilInhaltTyp BI_TLS_UEBERHOLVERBOT_ALLGEMEIN = new StreckenProfilInhaltTyp("TLS.UeberholverbotAllgemein", 4);
//      public static StreckenProfilInhaltTyp BI_TLS_UEBERHOLVERBOT_ALLGEMEIN_MARKIERT = new StreckenProfilInhaltTyp("TLS.UeberholverbotAllgemein / andere Inhalte");
//      public static StreckenProfilInhaltTyp BI_TLS_UEBERHOLVERBOT_LKW = new StreckenProfilInhaltTyp("TLS.UeberholverbotLkw", 5);
//      public static StreckenProfilInhaltTyp BI_TLS_UEBERHOLVERBOT_LKW_MARKIERT = new StreckenProfilInhaltTyp("TLS.UeberholverbotLkw / andere Inhalte");
//      // TODO staBes: #6 Erweiterung um den Inhaltstyp 'BI_TLS_UEBERHOLVERBOT_NAESSE'.
//      public static StreckenProfilInhaltTyp BI_TLS_UEBERHOLVERBOT_NAESSE = new StreckenProfilInhaltTyp("TLS.UeberholverbotNaesse");
//      public static StreckenProfilInhaltTyp BI_TLS_UEBERHOLVERBOT_NAESSE_MARKIERT = new StreckenProfilInhaltTyp("TLS.UeberholverbotNaesse / andere Inhalte");
//      public static StreckenProfilInhaltTyp BI_TLS_BAUSTELLE = new StreckenProfilInhaltTyp("TLS.Baustelle", 6);
//      public static StreckenProfilInhaltTyp BI_TLS_BAUSTELLE_MARKIERT = new StreckenProfilInhaltTyp("TLS.Baustelle / andere Inhalte");
//      public static StreckenProfilInhaltTyp BI_TLS_ENDE_ALLER_STRECKENVERBOTE = new StreckenProfilInhaltTyp("TLS.EndeAllerStreckenverbote", 8);                                                                                       
//      public static StreckenProfilInhaltTyp BI_TLS_ENDE_ALLER_STRECKENVERBOTE_MARKIERT = new StreckenProfilInhaltTyp("TLS.EndeAllerStreckenverbote / andere Inhalte");                                                                                       
//      public static StreckenProfilInhaltTyp BI_TLS_ENDE_UEBERHOLVERBOT_ALLGEMEIN = new StreckenProfilInhaltTyp("TLS.EndeUeberholverbotAllgemein", 9);
//      public static StreckenProfilInhaltTyp BI_TLS_ENDE_UEBERHOLVERBOT_ALLGEMEIN_MARKIERT = new StreckenProfilInhaltTyp("TLS.EndeUeberholverbotAllgemein / andere Inhalte");
//      public static StreckenProfilInhaltTyp BI_TLS_ENDE_UEBERHOLVERBOT_LKW = new StreckenProfilInhaltTyp("TLS.EndeUeberholverbotLkw", 10);
//      public static StreckenProfilInhaltTyp BI_TLS_ENDE_UEBERHOLVERBOT_LKW_MARKIERT = new StreckenProfilInhaltTyp("TLS.EndeUeberholverbotLkw / andere Inhalte");
      
      
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_GEFAHRENSTELLE.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_GEFAHRENSTELLE.createNewInstance();        
      }
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_STAU.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_STAU.createNewInstance();        
      }
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_GLAETTEGEFAHR.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_GLAETTEGEFAHR.createNewInstance();        
      }
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_SCHLEUDERGEFAHR.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_SCHLEUDERGEFAHR.createNewInstance();        
      }
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_ALLGEMEIN.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_ALLGEMEIN.createNewInstance();        
      }
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_LKW.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_LKW.createNewInstance();        
      }
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_NAESSE.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_NAESSE.createNewInstance();        
      }
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_BAUSTELLE.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_BAUSTELLE.createNewInstance();        
      }
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_ALLER_STRECKENVERBOTE.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_ENDE_ALLER_STRECKENVERBOTE.createNewInstance();        
      }
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_UEBERHOLVERBOT_ALLGEMEIN.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_ENDE_UEBERHOLVERBOT_ALLGEMEIN.createNewInstance();        
      }
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_UEBERHOLVERBOT_LKW.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_ENDE_UEBERHOLVERBOT_LKW.createNewInstance();        
      }    
      
//      public static StreckenProfilInhaltTyp BI_TLS_500M = new StreckenProfilInhaltTyp("TLS.500Meter", 14);
//      public static StreckenProfilInhaltTyp BI_TLS_500M_MARKIERT = new StreckenProfilInhaltTyp("TLS.500Meter / andere Inhalte");
//      public static StreckenProfilInhaltTyp BI_TLS_1000M = new StreckenProfilInhaltTyp("TLS.1000Meter", 15);
//      public static StreckenProfilInhaltTyp BI_TLS_1000M_MARKIERT = new StreckenProfilInhaltTyp("TLS.1000Meter / andere Inhalte");
//      public static StreckenProfilInhaltTyp BI_TLS_1500M = new StreckenProfilInhaltTyp("TLS.1500Meter", 17);
//      public static StreckenProfilInhaltTyp BI_TLS_1500M_MARKIERT = new StreckenProfilInhaltTyp("TLS.1500Meter / andere Inhalte");
//      public static StreckenProfilInhaltTyp BI_TLS_2000M = new StreckenProfilInhaltTyp("TLS.2000Meter", 19);
//      public static StreckenProfilInhaltTyp BI_TLS_2000M_MARKIERT = new StreckenProfilInhaltTyp("TLS.2000Meter / andere Inhalte");
//      public static StreckenProfilInhaltTyp BI_TLS_2500M = new StreckenProfilInhaltTyp("TLS.2500Meter", 21);
//      public static StreckenProfilInhaltTyp BI_TLS_2500M_MARKIERT = new StreckenProfilInhaltTyp("TLS.2500Meter / andere Inhalte");
////      public static StreckenProfilInhaltTyp BI_TLS_3000M = new StreckenProfilInhaltTyp("TLS.3000Meter", 23);
////      public static StreckenProfilInhaltTyp BI_TLS_3000M_MARKIERT = new StreckenProfilInhaltTyp("TLS.3000Meter / andere Inhalte");
//      public static StreckenProfilInhaltTyp BI_TLS_AUF_500M = new StreckenProfilInhaltTyp("TLS.Auf500Meter", 13);
//      public static StreckenProfilInhaltTyp BI_TLS_AUF_500M_MARKIERT = new StreckenProfilInhaltTyp("TLS.Auf500Meter / andere Inhalte");
//      public static StreckenProfilInhaltTyp BI_TLS_AUF_1000M = new StreckenProfilInhaltTyp("TLS.Auf1000Meter", 12);
//      public static StreckenProfilInhaltTyp BI_TLS_AUF_1000M_MARKIERT = new StreckenProfilInhaltTyp("TLS.Auf1000Meter / andere Inhalte");
//      public static StreckenProfilInhaltTyp BI_TLS_AUF_1500M = new StreckenProfilInhaltTyp("TLS.Auf1500Meter", 11);
//      public static StreckenProfilInhaltTyp BI_TLS_AUF_1500M_MARKIERT = new StreckenProfilInhaltTyp("TLS.Auf1500Meter / andere Inhalte");
//      public static StreckenProfilInhaltTyp BI_TLS_AUF_2000M = new StreckenProfilInhaltTyp("TLS.Auf2000Meter", 10); 
//      public static StreckenProfilInhaltTyp BI_TLS_AUF_2000M_MARKIERT = new StreckenProfilInhaltTyp("TLS.Auf2000Meter / andere Inhalte"); 
//      public static StreckenProfilInhaltTyp BI_TLS_AUF_2500M = new StreckenProfilInhaltTyp("TLS.Auf2500Meter", 9); 
//      public static StreckenProfilInhaltTyp BI_TLS_AUF_2500M_MARKIERT = new StreckenProfilInhaltTyp("TLS.Auf2500Meter / andere Inhalte"); 
//      public static StreckenProfilInhaltTyp BI_TLS_NEBEL = new StreckenProfilInhaltTyp("TLS.Nebel");
//      public static StreckenProfilInhaltTyp BI_TLS_NEBEL_MARKIERT = new StreckenProfilInhaltTyp("TLS.Nebel / andere Inhalte");
//      public static StreckenProfilInhaltTyp BI_TLS_NAESSE = new StreckenProfilInhaltTyp("TLS.Naesse");
//      public static StreckenProfilInhaltTyp BI_TLS_NAESSE_MARKIERT = new StreckenProfilInhaltTyp("TLS.Naesse / andere Inhalte");
//      public static StreckenProfilInhaltTyp BI_TLS_UNFALL = new StreckenProfilInhaltTyp("TLS.Unfall", 1);
//      public static StreckenProfilInhaltTyp BI_TLS_UNFALL_MARKIERT = new StreckenProfilInhaltTyp("TLS.Unfall / andere Inhalte");
//      public static StreckenProfilInhaltTyp BI_TLS_SMOG = new StreckenProfilInhaltTyp("TLS.Smog");
//      public static StreckenProfilInhaltTyp BI_TLS_SMOG_MARKIERT = new StreckenProfilInhaltTyp("TLS.Smog / andere Inhalte");
//      public static StreckenProfilInhaltTyp BI_TLS_AS_GLAETTE = new StreckenProfilInhaltTyp("TLS-AS.Gltte");
//      public static StreckenProfilInhaltTyp BI_TLS_AS_GLAETTE_MARKIERT = new StreckenProfilInhaltTyp("TLS-AS.Gltte / andere Inhalte");
//      public static StreckenProfilInhaltTyp BI_TLS_AS_OELSPUR = new StreckenProfilInhaltTyp("TLS-AS.lspur", 2);
//      public static StreckenProfilInhaltTyp BI_TLS_AS_OELSPUR_MARKIERT = new StreckenProfilInhaltTyp("TLS-AS.lspur / andere Inhalte");
//      public static StreckenProfilInhaltTyp BI_TLS_7KOMMA5TONNEN = new StreckenProfilInhaltTyp("TLS.7Komma5Tonnen", 8);
//      public static StreckenProfilInhaltTyp BI_TLS_7KOMMA5TONNEN_MARKIERT = new StreckenProfilInhaltTyp("TLS.7Komma5Tonnen / andere Inhalte");
//      public static StreckenProfilInhaltTyp BI_TLS_STAU_GEFAHR = new StreckenProfilInhaltTyp("TLS.Staugefahr", 6);
//      public static StreckenProfilInhaltTyp BI_TLS_STAU_GEFAHR_MARKIERT = new StreckenProfilInhaltTyp("TLS.Staugefahr / andere Inhalte");
//      //public static StreckenProfilInhaltTyp BI_TLS_STAU = new StreckenProfilInhaltTyp("TLS.Stau");
//      public static StreckenProfilInhaltTyp BI_TLS_SICHT = new StreckenProfilInhaltTyp("TLS.Sicht", 7);
//      public static StreckenProfilInhaltTyp BI_TLS_SICHT_MARKIERT = new StreckenProfilInhaltTyp("TLS.Sicht / andere Inhalte");
////      public static StreckenProfilInhaltTyp BI_TLS_TIERE = new StreckenProfilInhaltTyp("TLS.Tiere", 3);
////      public static StreckenProfilInhaltTyp BI_TLS_TIERE_MARKIERT = new StreckenProfilInhaltTyp("TLS.Tiere / andere Inhalte");
////      public static StreckenProfilInhaltTyp BI_TLS_KONTROLLE = new StreckenProfilInhaltTyp("TLS.Kontrolle", 4);
////      public static StreckenProfilInhaltTyp BI_TLS_KONTROLLE_MARKIERT = new StreckenProfilInhaltTyp("TLS.Kontrolle / andere Inhalte");      
      
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_500M.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_500M.createNewInstance();        
      }  
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_1000M.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_1000M.createNewInstance();        
      }  
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_1500M.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_1500M.createNewInstance();        
      }  
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_2000M.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_2000M.createNewInstance();        
      }  
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_2500M.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_2500M.createNewInstance();        
      }  
//      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_3000M.getType())){
//        re = StreckenProfilInhaltTyp.BI_TLS_3000M.createNewInstance();        
//      } 
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_AUF_500M.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_AUF_500M.createNewInstance();        
      }  
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_AUF_1000M.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_AUF_1000M.createNewInstance();        
      }  
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_AUF_1500M.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_AUF_1500M.createNewInstance();        
      }  
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_AUF_2000M.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_AUF_2000M.createNewInstance();        
      }  
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_AUF_2500M.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_AUF_2500M.createNewInstance();        
      }  
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_NEBEL.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_NEBEL.createNewInstance();        
      }  
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_NEBEL.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_NEBEL.createNewInstance();        
      }  
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_NEBEL.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_NEBEL.createNewInstance();        
      }  
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_NAESSE.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_NAESSE.createNewInstance();        
      }  
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_UNFALL.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_UNFALL.createNewInstance();        
      }  
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_SMOG.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_SMOG.createNewInstance();        
      }  
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_AS_GLAETTE.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_AS_GLAETTE.createNewInstance();        
      }  
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_AS_OELSPUR.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_AS_OELSPUR.createNewInstance();        
      }  
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_7KOMMA5TONNEN.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_7KOMMA5TONNEN.createNewInstance();        
      }  
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_STAU_GEFAHR.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_STAU_GEFAHR.createNewInstance();        
      }  
      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_SICHT.getType())){
        re = StreckenProfilInhaltTyp.BI_TLS_SICHT.createNewInstance();        
      }  
//      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_TIERE.getType())){
//        re = StreckenProfilInhaltTyp.BI_TLS_TIERE.createNewInstance();        
//      }  
//      else if (type.equals(StreckenProfilInhaltTyp.BI_TLS_KONTROLLE.getType())){
//        re = StreckenProfilInhaltTyp.BI_TLS_TIERE.createNewInstance();        
//      }              
      else
      {
        re = new StreckenProfilInhaltTyp(type);
      }
    }
    return re;     
  }
  
  /**
   * @param type
   * @return
   */
  public static List<StreckenProfilInhaltTyp> getInhalteAusElementTyp(StreckenProfilElementTyp elementTyp){

    
    List<StreckenProfilInhaltTyp> list = new ArrayList<StreckenProfilInhaltTyp>();
    
    if (elementTyp.equals(StreckenProfilElementTyp.UFD_HELLIGKEIT)){
      list.add(StreckenProfilInhaltTyp.UFD_HELLIGKEIT_STUFE_10);
      list.add(StreckenProfilInhaltTyp.UFD_HELLIGKEIT_STUFE_9);
      list.add(StreckenProfilInhaltTyp.UFD_HELLIGKEIT_STUFE_8);
      list.add(StreckenProfilInhaltTyp.UFD_HELLIGKEIT_STUFE_7);
      list.add(StreckenProfilInhaltTyp.UFD_HELLIGKEIT_STUFE_6);
      list.add(StreckenProfilInhaltTyp.UFD_HELLIGKEIT_STUFE_5);
      list.add(StreckenProfilInhaltTyp.UFD_HELLIGKEIT_STUFE_4);
      list.add(StreckenProfilInhaltTyp.UFD_HELLIGKEIT_STUFE_3);
      list.add(StreckenProfilInhaltTyp.UFD_HELLIGKEIT_STUFE_2);
      list.add(StreckenProfilInhaltTyp.UFD_HELLIGKEIT_STUFE_1);
      list.add(StreckenProfilInhaltTyp.UFD_HELLIGKEIT_GESTOERT);
      list.add(StreckenProfilInhaltTyp.UFD_HELLIGKEIT_UNDEFINIERT);
    }
    else if (elementTyp.equals(StreckenProfilElementTyp.UFD_SICHTWEITE)){     
      list.add(StreckenProfilInhaltTyp.UFD_SICHTWEITE_STUFE_6);
      list.add(StreckenProfilInhaltTyp.UFD_SICHTWEITE_STUFE_5);
      list.add(StreckenProfilInhaltTyp.UFD_SICHTWEITE_STUFE_4);
      list.add(StreckenProfilInhaltTyp.UFD_SICHTWEITE_STUFE_3);
      list.add(StreckenProfilInhaltTyp.UFD_SICHTWEITE_STUFE_2);
      list.add(StreckenProfilInhaltTyp.UFD_SICHTWEITE_STUFE_1);
      list.add(StreckenProfilInhaltTyp.UFD_SICHTWEITE_GESTOERT);
      list.add(StreckenProfilInhaltTyp.UFD_SICHTWEITE_UNDEFINIERT);
    }
    else if (elementTyp.equals(StreckenProfilElementTyp.UFD_NIEDERSCHLAG)){     
      list.add(StreckenProfilInhaltTyp.UFD_NIEDERSCHLAG_NASS_5);
      list.add(StreckenProfilInhaltTyp.UFD_NIEDERSCHLAG_NASS_4);
      list.add(StreckenProfilInhaltTyp.UFD_NIEDERSCHLAG_NASS_3);
      list.add(StreckenProfilInhaltTyp.UFD_NIEDERSCHLAG_NASS_2);
      list.add(StreckenProfilInhaltTyp.UFD_NIEDERSCHLAG_NASS_1);
      list.add(StreckenProfilInhaltTyp.UFD_NIEDERSCHLAG_GESTOERT);
      list.add(StreckenProfilInhaltTyp.UFD_NIEDERSCHLAG_UNDEFINIERT);
    }
    else if (elementTyp.equals(StreckenProfilElementTyp.UFD_OBERFLAECHE)){     
      list.add(StreckenProfilInhaltTyp.UFD_OBERFLAECHE_SCHNEE);
      list.add(StreckenProfilInhaltTyp.UFD_OBERFLAECHE_NASS_3);
      list.add(StreckenProfilInhaltTyp.UFD_OBERFLAECHE_NASS_2);
      list.add(StreckenProfilInhaltTyp.UFD_OBERFLAECHE_NASS_1);
      list.add(StreckenProfilInhaltTyp.UFD_OBERFLAECHE_TROCKEN);
      list.add(StreckenProfilInhaltTyp.UFD_OBERFLAECHE_GESTOERT);
      list.add(StreckenProfilInhaltTyp.UFD_OBERFLAECHE_UNDEFINIERT);
    }
    // TODO staBes: #7 Generiere Liste fr alle moeglichen Inhaltstypen der statischen Beschilderung WZG-A-Statisch.
    else if (elementTyp.equals(StreckenProfilElementTyp.WZG_A_STATISCH)){     
      list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_10);
      list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_20);
      list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_30);
      list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_40);
      list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_50);
      list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_60);
      list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_70);
      list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_80);
      list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_100);
      list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_120);
      list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_130);
      list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_10);
      list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_20);
      list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_30);
      list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_40);
      list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_50);
      list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_60);
      list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_70);
      list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_80);
      list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_100);
      list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_120);
      list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_130);
      list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_130);
      list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_ALLER_STRECKENVERBOTE);
    }
    // TODO staBes: #8 Generiere Liste fr alle moeglichen Inhaltstypen der statischen Beschilderung WZG-A-Statisch-UV.
    else if (elementTyp.equals(StreckenProfilElementTyp.WZG_A_STATISCH_UV)){     
      list.add(StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_ALLGEMEIN);
      list.add(StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_NAESSE);
      list.add(StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_LKW);
    }
    else if (elementTyp.equals(StreckenProfilElementTyp.WZG_A) 
             || elementTyp.equals(StreckenProfilElementTyp.WZG_B)
             || elementTyp.equals(StreckenProfilElementTyp.WZG_C)
             || elementTyp.equals(StreckenProfilElementTyp.WZG_BLINKER_B)){
      
      list.add(StreckenProfilInhaltTyp.BI_DUNKEL);
      list.add(StreckenProfilInhaltTyp.BI_GESTOERT);
      
      if (elementTyp.equals(StreckenProfilElementTyp.WZG_A)){
        list.add(StreckenProfilInhaltTyp.BI_TLS_FAHRSTREIFEN_GESPERRT);
        list.add(StreckenProfilInhaltTyp.BI_TLS_FAHRSTREIFEN_WECHSELN_NACH_LINKS);
        list.add(StreckenProfilInhaltTyp.BI_TLS_FAHRSTREIFEN_WECHSELN_NACH_RECHTS);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_10);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_20);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_30);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_40);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_40_MARKIERT);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_50);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_50_MARKIERT);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_60);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_60_MARKIERT);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_70);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_80);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_80_MARKIERT);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_100);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_100_MARKIERT);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_120);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_120_MARKIERT);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_130);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_130_MARKIERT);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_10);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_20);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_30);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_40);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_50);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_60);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_70);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_80);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_100);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_120);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_130);
        list.add(StreckenProfilInhaltTyp.BI_TLS_FAHRSTREIFEN_HALTEN);
      }
      else if (elementTyp.equals(StreckenProfilElementTyp.WZG_B)){               
        list.add(StreckenProfilInhaltTyp.BI_TLS_GEFAHRENSTELLE);
        list.add(StreckenProfilInhaltTyp.BI_TLS_STAU);
        list.add(StreckenProfilInhaltTyp.BI_TLS_GLAETTEGEFAHR);
        list.add(StreckenProfilInhaltTyp.BI_TLS_SCHLEUDERGEFAHR);
        list.add(StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_ALLGEMEIN);
        list.add(StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_LKW);
        list.add(StreckenProfilInhaltTyp.BI_TLS_BAUSTELLE);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_ALLER_STRECKENVERBOTE);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_UEBERHOLVERBOT_ALLGEMEIN);
        list.add(StreckenProfilInhaltTyp.BI_TLS_ENDE_UEBERHOLVERBOT_LKW);         
      }
      else if (elementTyp.equals(StreckenProfilElementTyp.WZG_C)){           
        list.add(StreckenProfilInhaltTyp.BI_TLS_500M);
        list.add(StreckenProfilInhaltTyp.BI_TLS_1000M);
        list.add(StreckenProfilInhaltTyp.BI_TLS_1500M);
        list.add(StreckenProfilInhaltTyp.BI_TLS_2000M);
        list.add(StreckenProfilInhaltTyp.BI_TLS_2500M);
        list.add(StreckenProfilInhaltTyp.BI_TLS_AUF_500M);
        list.add(StreckenProfilInhaltTyp.BI_TLS_AUF_1000M);
        list.add(StreckenProfilInhaltTyp.BI_TLS_AUF_1500M);
        list.add(StreckenProfilInhaltTyp.BI_TLS_AUF_2000M);
        list.add(StreckenProfilInhaltTyp.BI_TLS_AUF_2500M);
        list.add(StreckenProfilInhaltTyp.BI_TLS_NEBEL);
        list.add(StreckenProfilInhaltTyp.BI_TLS_NAESSE);
        list.add(StreckenProfilInhaltTyp.BI_TLS_UNFALL);
        list.add(StreckenProfilInhaltTyp.BI_TLS_SMOG);
        list.add(StreckenProfilInhaltTyp.BI_TLS_AS_GLAETTE);
        list.add(StreckenProfilInhaltTyp.BI_TLS_AS_OELSPUR);
        list.add(StreckenProfilInhaltTyp.BI_TLS_7KOMMA5TONNEN);
        list.add(StreckenProfilInhaltTyp.BI_TLS_STAU_GEFAHR);
        list.add(StreckenProfilInhaltTyp.BI_TLS_SICHT);
      }
      else if (elementTyp.equals(StreckenProfilElementTyp.WZG_BLINKER_B)){           
        list.add(StreckenProfilInhaltTyp.BI_TLS_GELBES_BLINKLICHT);
      }
    }
    
    return list;     
  }
  
  
  @Override
  public boolean equals(Object obj)
  {
    if (obj instanceof StreckenProfilInhaltTyp)
    {
      StreckenProfilInhaltTyp that = (StreckenProfilInhaltTyp)obj;
      if (this.getType().equals(that.getType()))
        return true;
    }
    return false;
  }
  
  
//  public class StreckenProfilInhaltTypComparator implements Comparator<StreckenProfilInhaltTyp>{
//
//    @Override
//    public int compare(StreckenProfilInhaltTyp o1, StreckenProfilInhaltTyp o2)
//    {
//      // TODO Auto-generated method stub
//      int i1 = o1.getValue();
//      int i2 = o2.getValue();
//      if (i1 < i2)
//        return -1;
//      else if (i2 > i1)
//        return 1;
//      return 0;
//    }
//    
//  }


//  @Override
//  public int compare(StreckenProfilInhaltTyp o1, StreckenProfilInhaltTyp o2)
//  {
//    // TODO Auto-generated method stub
//    int i1 = o1.getValue();
//    int i2 = o2.getValue();
//    if (i1 < i2)
//      return -1;
//    else if (i2 > i1)
//      return 1;
//    return 0;
//  }

  @Override
  public int compareTo(StreckenProfilInhaltTyp o)
  {
    // TODO Auto-generated method stub
    int i2 = o.getValue();
    int i1 = getValue();
    
//    if (i1 > i2)
//      return 1;
//    else if (i2 > i1)
//      return -1;
    
    return i1 - i2;
     
  }
  
  
  @Override
  public StreckenProfilInhaltTyp clone() throws CloneNotSupportedException
  {
    // TODO Auto-generated method stub
    return new StreckenProfilInhaltTyp(getType(), getValue());
  }

  public StreckenProfilInhaltTyp createNewInstance()
  {
    // TODO Auto-generated method stub
    return new StreckenProfilInhaltTyp(this.getType(), this.getValue());
  }
 
//  @Override
//  public int compareTo(Integer o)
//  {
//    if (value < o)
//      return -1;
//    else if (o > value)
//      return 1;
//    return 0;  
//  }
}