/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.bsvrz.buv.plugin.streckenprofil.sts.a8.wizardpages;

import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.PlatformUI;

import de.bsvrz.buv.plugin.streckenprofil.sts.a8.Activator;

public class StreckenprofilDateImportWizardPage extends WizardPage {
	private Text textFileName;

	/**
	 * Create the wizard.
	 */
	public StreckenprofilDateImportWizardPage() {
		super("StreckenprofilDateImportWizardPage");
		setTitle("Streckenprofil importieren");
		setDescription("Whlen Sie die zu importierende Datei aus!");
		setImageDescriptor(Activator.getDefault().getImageDescriptor(
				"/icons/import_wiz.png"));
	}

	/**
	 * Create contents of the wizard.
	 * 
	 * @param parent
	 */
	public void createControl(final Composite parent) {
		final Composite container = new Composite(parent, SWT.NULL);

		setControl(container);
		container.setLayout(new GridLayout(2, false));

		final Label lblDatei = new Label(container, SWT.NONE);
		lblDatei.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false,
				false, 1, 1));
		lblDatei.setText("Datei:");

		textFileName = new Text(container, SWT.BORDER);
		textFileName.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true,
				false, 1, 1));

		final Button btnAuswahl = new Button(container, SWT.NONE);
		btnAuswahl.setText("Auswahl");
		btnAuswahl.addSelectionListener(new SelectionAdapter() {

			@Override
			public void widgetSelected(final SelectionEvent e) {
				final FileDialog dialog = new FileDialog(PlatformUI
						.getWorkbench().getActiveWorkbenchWindow().getShell(),
						SWT.OPEN);
				dialog.setFilterExtensions(new String[] { "*."
						+ Activator.FILE_EXTENSION });
				final String name = dialog.open();
				if (name != null) {
					textFileName.setText(name);
					updatePageCompletion();
				}
			}

		});
		updatePageCompletion();
	}

	public String getFilesource() {
		return textFileName.getText();
	}

	private void updatePageCompletion() {
		boolean state = false;
		final String destination = getFilesource();
		if ((destination != null) && (!destination.isEmpty())) {
			state = true;
		}
		setPageComplete(state);

	}

}
