package de.bsvrz.sba.plugin.actions.parameter;

/**
 * Default-Implementierung von {@link IParameter}
 * 
 * @author HofmannJ
 * 
 */
public class DefaultParameter implements IParameter
{
	/**
	 * ID des {@link IParameter}
	 */
	private String _id = null;

	/**
	 * Wert des {@link IParameter}
	 */
	private Object _value = null;

	/**
	 * Information zum {@link IParameter}
	 */
	private String _info = null;

	/**
	 * Konstruktor, bernimmt ID, Wert und Informationen des {@link IParameter}.
	 * 
	 * @param id
	 *          ID des {@link IParameter}
	 * @param value
	 *          Wert des {@link IParameter}
	 * @param info
	 *          Informationen zum {@link IParameter}
	 */
	public DefaultParameter(String id, Object value, String info)
	{
		this._id = id;
		this._value = value;
		this._info = info;
	}

	@Override
	public String getId()
	{
		return _id;
	}

	@Override
	public String getParameterInfo()
	{
		return _info;
	}

	@Override
	public Object getValue()
	{
		return _value;
	}

	@Override
	public void setValue(Object value)
	{
		this._value = value;
	}

}