package de.bsvrz.sba.plugin.parameter.steuerungskern.dialog;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.PlatformUI;

import de.bsvrz.sba.plugin.parameter.steuerungskern.Activator;

/**
 * Dialog zum Definieren einer neuen Treppenfunktion
 * @author MO
 * 
 */
public class DialogNeueTreppenFunktion extends Dialog
{
	private Group     _groupOben = null;
	private Composite _compositeUnten = null;
	private Shell _shell = null;
	
	private Text _textBezeichnung = null;

	private Button _buttonOk = null;

	private String _returnWert = null;
	
	/**
	 * Konstruktor
	 * 
	 * @param parent
	 *          Eltern-Shell
	 * @param style
	 *          SWT-Stil
	 */
	public DialogNeueTreppenFunktion(Shell parent, int style)
	{
		super(parent, style);
	}

	/**
	 * Konstruktor
	 * 
	 * @param parent
	 *          Eltern-Shell
	 */
	public DialogNeueTreppenFunktion(Shell parent)
	{
		this(parent, 0);
	}

	/**
	 * ffnet den Dialog zum Anlegen einer neuen Instanz des Steuerungskerns
	 * @return Name der neuen Instnz oder null wenn keine neue Instanz angelegt werden soll
	 */
	public String open()
	{
		Shell parent = getParent();
		_shell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL | SWT.RESIZE);
		_shell.setSize(500, 250);
		_shell.setText("Neue Treppenfunktion anlegen");
		
//		try
//		{
//		  _shell.setImage(de.bsvrz.wwa.plugin.strategiemanager.Activator.getImage("icons/modify_16x16.png"));
//		}
//		catch (Exception e) 
//		{
//    }
		
		/*
		 * Fllen
		 */
		createOben(_shell);
		createUnten(_shell);

		/*
		 * Layout
		 */
		GridLayout glShell = new GridLayout(1, false);
		_shell.setLayout(glShell);

		GridData gdOben = new GridData();
		gdOben.grabExcessHorizontalSpace = true;
		gdOben.horizontalAlignment = GridData.FILL;
		gdOben.grabExcessVerticalSpace = true;
		gdOben.verticalAlignment = GridData.FILL;
		_groupOben.setLayoutData(gdOben);

		GridData gdUnten = new GridData();
		gdUnten.grabExcessHorizontalSpace = true;
		gdUnten.horizontalAlignment = GridData.END;
		_compositeUnten.setLayoutData(gdUnten);

		/*
		 * ffnen
		 */
		_shell.open();
		Display display = parent.getDisplay();
		while (!_shell.isDisposed())
		{
			if (!display.readAndDispatch())
				display.sleep();
		}

		return _returnWert;
	}

	/**
	 * Erzeugt die obere {@link Group}.
	 * 
	 * @param parent
	 *          Eltern-{@link Composite}.
	 * @return Obere {@link Group}
	 */
	private Group createOben(Composite parent)
	{
		if (_groupOben == null)
		{
			_groupOben = new Group(parent, SWT.NONE);
			_groupOben.setText("Strategie:");

			// Bezeichnung
			
			Label labelBezeichnung = new Label(_groupOben, SWT.NONE);
			labelBezeichnung.setText("Bezeichnung:");
			_textBezeichnung = new Text(_groupOben, SWT.BORDER);

			/*
			 * Layout
			 */
			_groupOben.setLayout(new GridLayout(2, false));

			GridData gdTextBezeichnung = new GridData();
			gdTextBezeichnung.grabExcessHorizontalSpace = true;
			gdTextBezeichnung.horizontalAlignment = GridData.FILL;
			_textBezeichnung.setLayoutData(gdTextBezeichnung);
		}
		
		return _groupOben;
	}

	/**
	 * Erzeugt das untere {@link Composite}.
	 * 
	 * @param parent
	 *          Eltern {@link Composite}
	 * @return Unteres {@link Composite}
	 */
	private Composite createUnten(Composite parent)
	{
		if (_compositeUnten == null)
		{
			_compositeUnten = new Composite(parent, SWT.NONE);

			_buttonOk = new Button(_compositeUnten, SWT.PUSH);
			_buttonOk.setText("OK");
			_buttonOk.setEnabled(true);
			_buttonOk.addSelectionListener(new SelectionAdapter()
			{
				public void widgetSelected(SelectionEvent e)
				{
					actionOk();
				}
			});

			Button buttonAbbrechen = new Button(_compositeUnten, SWT.PUSH);
			buttonAbbrechen.setText("Abbrechen");
			buttonAbbrechen.addSelectionListener(new SelectionAdapter()
			{
				public void widgetSelected(SelectionEvent e)
				{
					actionAbbrechen();
				}
			});

			Button buttonHilfe = new Button(_compositeUnten, SWT.PUSH);
			buttonHilfe.setText("Hilfe");
			buttonHilfe.addSelectionListener(new SelectionAdapter()
			{
				public void widgetSelected(SelectionEvent e)
				{
					actionHilfe();
				}
			});

			/*
			 * Layout
			 */
			RowLayout rlUnten = new RowLayout();
			rlUnten.pack = false;
			_compositeUnten.setLayout(rlUnten);
		}

		return _compositeUnten;
	}

	/**
	 * Fhrt die Aktion hinter der Schaltflche OK aus. Der Benutzer wird
	 * angelegt.
	 */
	private void actionOk()
	{
		// Bezeichnung
		
		String name = _textBezeichnung.getText();

		if (name.length() == 0)
		{
      message("Neue Treppenfunktion anlegen", "Bezeichnung definieren");
      return;
		}

		// Prfen ob diese Bezeichnung bereits verwendet wird
		
//		boolean pruefen = true;
//		
//		if (_parameterDaten != null)
//			if (name.equals(_parameterDaten.getName()))
//				pruefen = false;
//		
//		if (pruefen)
//		{
//			Ausloeser tmp = VerwaltungAusloeser.getInstance().getAusloeser(AusloeserTyp.MANUELL, name);
//			if (tmp != null)
//			{
//	      message("Auslser Strategien", "Es ist bereits ein Auslser mit diesem Namen definiert !");
//	      return;
//			}
//		}
//		
//		AusloeserManuell am = new AusloeserManuell(name); 
    
    _returnWert = name;
		_shell.dispose();
	}

	/**
	 * Gibt eine Informationsmeldung auf dem Bildschirm aus.
	 * 
	 * @param title
	 *          Titel der Meldung
	 * @param message
	 *          Anzuzeigender Meldungstext
	 */
	private void message(String title, String message)
	{
		MessageBox mb = new MessageBox(PlatformUI.getWorkbench().getDisplay()
				.getActiveShell(), SWT.ICON_INFORMATION | SWT.OK);
		mb.setText(title);
		mb.setMessage(message);
		mb.open();
	}

	private void actionAbbrechen()
	{
		_shell.dispose();
	}

	private void actionHilfe()
	{
		String hilfeKontextId = Activator.PLUGIN_ID + ".dialog.neueTreppenFunktion";
		PlatformUI.getWorkbench().getHelpSystem().displayHelp(hilfeKontextId);
	}
}