package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.bedienung;

import java.util.Vector;

import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.ListViewer;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerSorter;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.List;

public class CompositeZuordnung extends Composite
{
  /**
   * Liste mit den moeglichen WVZ-Inhalten
   */
  private Vector<Object> _moeglicheObjekte = new Vector<Object>();  

  /**
   * Liste mit den angewaehlten WVZ-Inhalten
   */
  private Vector<Object> _zugewieseneObjekte = new Vector<Object>();  

  /**
   * Moegliche Objekte
   */
  private List _listeMoeglicherObjekte;

  /**
   * Zugewiesene Objekte
   */
  private List _listeZugewiesenerObjekte;

  /**
   * Button nach rechts
   */
  private Button _buttonNachRechts;

  /**
   * Button nach links
   */
  private Button _buttonNachLinks;

  /**
   * Viewer mgliche Objekte
   */
	private ListViewer _lvMoeglicheObjekte;

	/**
	 * Viewer zugewiesene Objekte
	 */
	public ListViewer _lvZugewieseneObjekte;

	/**
	 * Text links
	 */
	private String _textLinks;
	
	/**
	 * Text rechts
	 */
	private String _textRechts;
	
	/**
	 * Konstruktor der Klasse
	 * @param parent Parent Composite
	 * @param style Stil
	 */
	public CompositeZuordnung(Composite parent, int style)
  {
	  super (parent, style);
	  
    setLayout(new GridLayout (3, false));
	  
	  initGUI ();
  }

	/**
	 * Konstruktor der Klasse
	 * @param parent Parent Composite
	 * @param style Stil
	 * @param textLinks Text ber der linken Auswahl
	 * @param textRechts Text ber der rechten Auswahl
	 */
	public CompositeZuordnung(Composite parent, int style, String textLinks, String textRechts)
  {
	  super (parent, style);
	  
	  _textLinks = textLinks;
	  
	  _textRechts = textRechts;
	  
    setLayout(new GridLayout (3, false));
	  
	  initGUI ();
  }

  /**
   * Methode erzeugt das Composite mit der Zuordnung der WVZ-Inhalte
   */
  private void initGUI ()
  {
    // Spalte 1
    
    GridData gdSpalte1 = new GridData ();
    gdSpalte1.horizontalAlignment = GridData.FILL;
    gdSpalte1.verticalAlignment = GridData.FILL;
    gdSpalte1.grabExcessHorizontalSpace = true;
    gdSpalte1.grabExcessVerticalSpace = true;
    gdSpalte1.minimumWidth = 200;

    Composite spalte1 = new Composite (this, SWT.BORDER);
    spalte1.setLayout(new FillLayout ());
    spalte1.setLayoutData(gdSpalte1);

    // Spalte 2

    GridData gdSpalte2 = new GridData ();
    gdSpalte2.horizontalAlignment = GridData.CENTER;
    gdSpalte2.grabExcessHorizontalSpace = false;
    gdSpalte2.minimumWidth = 80;

    Composite spalte2 = new Composite (this, SWT.BORDER);
    spalte2.setLayout(new GridLayout (1, true));
    spalte2.setLayoutData(gdSpalte2);

    // Spalte 3

    GridData gdSpalte3 = new GridData ();
    gdSpalte3.horizontalAlignment = GridData.FILL;
    gdSpalte3.verticalAlignment = GridData.FILL;
    gdSpalte3.grabExcessHorizontalSpace = true;
    gdSpalte3.grabExcessVerticalSpace = true;
    gdSpalte3.minimumWidth = 200;
    
    Composite spalte3 = new Composite (this, SWT.BORDER);
    spalte3.setLayout(new GridLayout(1, false));
    spalte3.setLayoutData(gdSpalte3);

    createCompositeMoeglicheObjekte   (spalte1);
    
    createCompositeKopierenButtons    (spalte2);
    
    createCompositeZugewieseneObjekte (spalte3);
  }

  /**
   * Fgt die Liste mit den mglichen Funktionen hinzu
   * @param parent Composite in das die Liste eingefgt werden sollen
   */
  private void createCompositeMoeglicheObjekte (Composite parent)
  {
    Group group = new Group (parent, SWT.BORDER);
    
    if (_textLinks != null)
      group.setText(_textLinks);
    
    group.setLayout(new FillLayout(SWT.VERTICAL));

    _listeMoeglicherObjekte = new List (group, SWT.BORDER | SWT.MULTI | SWT.V_SCROLL | SWT.H_SCROLL);
    _listeMoeglicherObjekte.addSelectionListener(new SelectionListener () 
    {
      public void widgetDefaultSelected(SelectionEvent e)
      {
      }

      public void widgetSelected(SelectionEvent e)
      {
      	boolean anwahlMoeglich = true;
      	
     		anwahlMoeglich = _listeMoeglicherObjekte.getSelectionCount() != 0;
      	
        _buttonNachRechts.setEnabled(anwahlMoeglich);
      }
    });
    
    _listeMoeglicherObjekte.addMouseListener(new MouseListener()
		{
			
			@Override
			public void mouseUp(MouseEvent e)
			{
			}
			
			@Override
			public void mouseDown(MouseEvent e)
			{
			}
			
			@Override
			public void mouseDoubleClick(MouseEvent e)
			{
        actionNachRechts();		
			}
		});
    
    _lvMoeglicheObjekte = new ListViewer(_listeMoeglicherObjekte);
    _lvMoeglicheObjekte.setContentProvider(new IStructuredContentProvider()
		{
			@Override
			public void dispose()
			{
			}
			
			@Override
			public Object[] getElements(Object inputElement)
			{
        Vector v = (Vector)inputElement;
        return v.toArray();
			}

			@Override
      public void inputChanged(Viewer viewer, Object oldInput, Object newInput)
      {
      }
		});
    
    _lvMoeglicheObjekte.setInput(_moeglicheObjekte);
    
    _lvMoeglicheObjekte.setLabelProvider(new LabelProvider() 
    {
      public Image getImage(Object element) 
      {
        return null;
      }

      public String getText(Object element) 
      {
        return (getBezeichnung ((Object) element));
      }
    });
    
    _lvMoeglicheObjekte.setSorter(new ViewerSorter()
    {
      public int compare(Viewer viewer, Object e1, Object e2) 
      {
        return getBezeichnung ((Object)e1).compareTo(getBezeichnung((Object)e2));
      }
    });
  }

  /**
   * Fgt die Liste mit den zugewiesenden Funktionen hinzu
   * @param parent Composite in das die Liste eingefgt werden sollen
   */
  protected void createCompositeZugewieseneObjekte (Composite parent)
  {
    Group group = new Group (parent, SWT.BORDER);
    
    if (_textRechts != null)
      group.setText(_textRechts);
    
    group.setLayout(new FillLayout(SWT.VERTICAL));
    
    GridData gd = new GridData();
    gd.horizontalAlignment = GridData.FILL;
    gd.verticalAlignment = GridData.FILL;
    gd.grabExcessHorizontalSpace = true;
    gd.grabExcessVerticalSpace = true;

    group.setLayoutData(gd);
   
    _listeZugewiesenerObjekte = new List (group, SWT.BORDER | SWT.MULTI | SWT.V_SCROLL | SWT.H_SCROLL);
    _listeZugewiesenerObjekte.addSelectionListener(new SelectionListener () 
    {
      public void widgetDefaultSelected(SelectionEvent e)
      {
      }

      public void widgetSelected(SelectionEvent e)
      {
      	selektionRechts ();
      }
    });

    _listeZugewiesenerObjekte.addMouseListener(new MouseListener()
		{
			@Override
			public void mouseUp(MouseEvent e)
			{
			}
			
			@Override
			public void mouseDown(MouseEvent e)
			{
			}
			
			@Override
			public void mouseDoubleClick(MouseEvent e)
			{
				actionNachLinks();
			}
		});
		
    _lvZugewieseneObjekte = new ListViewer(_listeZugewiesenerObjekte);
    _lvZugewieseneObjekte.setContentProvider(new IStructuredContentProvider()
		{
			@Override
			public void inputChanged (Viewer viewer, Object oldInput, Object newInput)
			{
			}
			
			@Override
			public void dispose()
			{
			}
			
			@Override
			public Object[] getElements(Object inputElement)
			{
        Vector v = (Vector)inputElement;
        return v.toArray();
			}
		});
    
    _lvZugewieseneObjekte.setInput(_zugewieseneObjekte);
    
    _lvZugewieseneObjekte.setLabelProvider(new LabelProvider() 
    {
      public Image getImage(Object element) 
      {
        return null;
      }

      public String getText(Object element) 
      {
        return (getBezeichnung ((Object) element));
      }
    });
    
    _lvZugewieseneObjekte.setSorter(new ViewerSorter()
    {
      public int compare(Viewer viewer, Object e1, Object e2) 
      {
        return getBezeichnung ((Object)e1).compareTo(getBezeichnung((Object)e2));
      }
    });

    if (_zugewieseneObjekte != null)
	    for (Object inhalt : _zugewieseneObjekte)
	    	if (_moeglicheObjekte.contains(inhalt))
	        _moeglicheObjekte.remove(inhalt);
    
    _lvMoeglicheObjekte.refresh();
    _lvZugewieseneObjekte.refresh();
  }

  /**
   * Methode wird aufgerufen, wenn im rechten Feld eine Selektion vorgenommen wurde
   */
	protected void selektionRechts()
  {
  	int anzahl = _listeZugewiesenerObjekte.getSelectionCount();
  	
  	boolean enabled = anzahl != 0;
  	
    _buttonNachLinks.setEnabled(enabled);
  }

	/**
   * Fgt die Kopierbuttons hinzu
   * @param parent Composite in das die Buttons eingefgt werden sollen
   */
  private void createCompositeKopierenButtons (Composite parent)
  {
    Composite composite = new Composite (parent, SWT.NONE);

    _buttonNachRechts = new Button(composite, SWT.PUSH);
    _buttonNachRechts.setText(" Hinzufgen >>");
    _buttonNachRechts.setEnabled(false);
    _buttonNachRechts.addSelectionListener(new SelectionAdapter()
    {
      public void widgetSelected(SelectionEvent e)
      {
        actionNachRechts();
      }
    });

    _buttonNachLinks = new Button(composite, SWT.PUSH);
    _buttonNachLinks.setText(" << Entfernen ");
    _buttonNachLinks.setEnabled(false);
    _buttonNachLinks.addSelectionListener(new SelectionAdapter()
    {
      public void widgetSelected(SelectionEvent e)
      {
        actionNachLinks();
      }
    });

    /*
     * Layout
     */
    RowLayout rlUnten = new RowLayout(SWT.VERTICAL);
    rlUnten.pack = false;
    composite.setLayout(rlUnten);
  }

  /**
   * Kopiert die selektierten Eintrge von links nach rechts
   */
  private void actionNachRechts()
  {
    IStructuredSelection selection = (IStructuredSelection) _lvMoeglicheObjekte.getSelection();
    StructuredSelection ss = (StructuredSelection) selection;

  	for (int x = 0; x < ss.size(); ++x)
    {
      Object obj1 = ss.toArray()[x];

      if (obj1 instanceof Object)
      {
      	Object as = (Object) obj1;
      	
      	if (!_zugewieseneObjekte.contains(as))
      		_zugewieseneObjekte.add(as);
      	
      	_moeglicheObjekte.remove(as);
      }
    }

  	_lvMoeglicheObjekte.refresh();
  	_lvZugewieseneObjekte.refresh();
  	
    _buttonNachRechts.setEnabled(false);
  }

  /**
   * Kopiert die selektierten Eintrge von rechts nach links
   */
  private void actionNachLinks()
  {
    IStructuredSelection selection = (IStructuredSelection) _lvZugewieseneObjekte.getSelection();
    StructuredSelection ss = (StructuredSelection) selection;

  	for (int x = 0; x < ss.size(); ++x)
    {
      Object obj1 = ss.toArray()[x];

      if (obj1 instanceof Object)
      {
      	Object as = (Object) obj1;
      	
      	if (!_moeglicheObjekte.contains(as))
          _moeglicheObjekte.add(as);
        
        _zugewieseneObjekte.remove(as);
      }
    }

    _lvMoeglicheObjekte.refresh();  
    _lvZugewieseneObjekte.refresh();
    	
    _buttonNachLinks.setEnabled(false);
  }
  
	/**
	 * Methode liefert eine Bezeichnung fr einen Aspekt. Die Bezeichnung setzt sich
	 * zusammen aus Name + Pid
	 * @param objekt Systemobjekt des Aspekts
	 * @return Bezeichnung 
	 */
	private String getBezeichnung (Object objekt)
	{
		return objekt.toString();
	}

	/**
   * Methode liefert moeglicheObjekte zurck
   * @return moeglicheObjekte
   */
  public Vector<Object> getMoeglicheObjekte()
  {
  	return _moeglicheObjekte;
  }

	/**
   * Methode setzt die Variable moeglicheObjekte
   * @param moeglicheObjekte zu bernehmender Wert fr moeglicheObjekte
   */
  public void setMoeglicheObjekte(Vector<Object> moeglicheObjekte)
  {
  	_moeglicheObjekte = moeglicheObjekte;
  }

	/**
   * Methode liefert zugewieseneObjekte zurck
   * @return zugewieseneObjekte
   */
  public Vector<Object> getZugewieseneObjekte()
  {
  	return _zugewieseneObjekte;
  }

	/**
   * Methode setzt die Variable zugewieseneObjekte
   * @param zugewieseneObjekte zu bernehmender Wert fr zugewieseneObjekte
   */
  public void setZugewieseneObjekte(Vector<Object> zugewieseneObjekte)
  {
  	_zugewieseneObjekte = zugewieseneObjekte;
  }

  /**
   * Methode aktualisiert die Darstellung
   */
	public void refresh()
  {
  	_lvZugewieseneObjekte.refresh();
    _lvMoeglicheObjekte.refresh();
  }
	
	public Vector<Object> getSelectedObjekteRechts ()
	{
    IStructuredSelection selection = (IStructuredSelection) _lvZugewieseneObjekte.getSelection();
    StructuredSelection ss = (StructuredSelection) selection;

    Vector<Object> v = new Vector<Object>();
    
  	for (int x = 0; x < ss.size(); ++x)
    {
      Object obj1 = ss.toArray()[x];
      v.add(obj1);
    }

  	return v;
	}
}
