package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.bedienung;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;
import java.util.Map.Entry;

import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.ListViewer;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerSorter;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.List;

import de.bsvrz.buv.rw.rw.dav.DaVVerbindung;
import de.bsvrz.dav.daf.main.ClientDavInterface;
import de.bsvrz.dav.daf.main.config.DataModel;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.sba.plugin.parameter.steuerungskern.konfig.AnzeigeQuerschnittMitTyp;
import de.bsvrz.sba.plugin.parameter.steuerungskern.projektspezifischeEinstellungen.DefaultEinstellungen;
import de.bsvrz.sba.plugin.parameter.steuerungskern.projektspezifischeEinstellungen.EAnzeigeQuerschnittTyp;
import de.bsvrz.sba.plugin.parameter.steuerungskern.tools.Tools;

/**
 * Composite zum Versorgen der Parameter Bedienung
 * @author ObertM
 *
 */
public class CopyOfCompositeMoeglicheAnzeigeQuerschnitte extends Composite
{
  /**
   * Liste mit den moeglichen Anzeigequerschnitten
   */
  private Vector<AnzeigeQuerschnittMitTyp> _moeglicheObjekte = new Vector<AnzeigeQuerschnittMitTyp>();  

  /**
   * Liste mit den angewaehlten Anzeuigequerschnitten
   */
  private Vector<AnzeigeQuerschnittMitTyp> _zugewieseneObjekte = new Vector<AnzeigeQuerschnittMitTyp>();  

  /**
   * Moegliche Anzeigequerschnitte
   */
  private List _listeMoeglicherObjekte;

  /**
   * Zugewiesene Anzeigequerschnitte
   */
  private List _listeZugewiesenerObjekte;

  /**
   * Button nach rechts
   */
  private Button _buttonNachRechts;

  /**
   * Button nach links
   */
  private Button _buttonNachLinks;

  /**
   * Viewer mgliche Objekte
   */
	private ListViewer _lvMoeglicheObjekte;

	/**
	 * Viewer zugewiesene Objekte
	 */
	private ListViewer _lvZugewieseneObjekte;

	/**
	 * Hashmap mit den mglichen Objekten
	 */
	private HashMap<SystemObject, AnzeigeQuerschnittMitTyp> _objekte = new HashMap<SystemObject, AnzeigeQuerschnittMitTyp>();

	/**
	 * Parameter Anzeigequerschnitte
	 */
	private java.util.List<AnzeigeQuerschnittMitTyp> _parameter;

	private Combo _combo;

	private Button _buttonTypUebernehmen;

  /**
   * Konstruktor der Klasse
   * @param parent Parent Composite
   * @param style Stil
   * @param parameter aktuelle Parameter
   */
	CopyOfCompositeMoeglicheAnzeigeQuerschnitte(Composite parent, int style, ParameterBedienung parameter) 
  {
    super(parent, style);
    
    /*
     * Kopie der Parameter anlegen
     */
    _parameter = new ArrayList<AnzeigeQuerschnittMitTyp>();
    for (AnzeigeQuerschnittMitTyp aqmt : parameter.getMoeglicheAnzeigeQuerschnitte())
    	_parameter.add(aqmt.getCopy());
   
    initialize();
  }

	/**
   * Fhrt die Basis-Initialisierung des Composites durch
   */
  private void initialize()
  {
    GridData gridData1 = new GridData();
    gridData1.horizontalAlignment = GridData.FILL;
    gridData1.grabExcessHorizontalSpace = true;
    gridData1.grabExcessVerticalSpace = true;
    gridData1.horizontalIndent = 0;
    gridData1.verticalAlignment = GridData.FILL;

    setLayout(new GridLayout(1, false));
    setLayoutData(gridData1);
    
    bestimmeMoeglicheObjekte ();
    
    if (_parameter != null)
    {
    	for (AnzeigeQuerschnittMitTyp aqmt : _parameter)
    		_objekte.put(aqmt.getAnzeigeQuerschnitt(), aqmt);
    	
    	for (AnzeigeQuerschnittMitTyp aqmt : _objekte.values())
    		_moeglicheObjekte.add(aqmt);
    	
    	for (AnzeigeQuerschnittMitTyp aqmt : _parameter)
    	{
    		_moeglicheObjekte.remove(aqmt);
    		_zugewieseneObjekte.add(aqmt);
    	}
    }
    
    createCompositeObjekte(this);

    createCompositeButtons (this);
  }

  /**
   * Methode bestimmt die im Datenverteiler definierten Objekte
   */
	private void bestimmeMoeglicheObjekte()
  {
		java.util.List<SystemObject> objekte = Tools.getSystemObjekte("typ.anzeigeQuerschnitt");
    for (SystemObject so : objekte)
    	_objekte.put(so, new AnzeigeQuerschnittMitTyp (so, EAnzeigeQuerschnittTyp.UNDEFINIERT));
  }

	/**
   * Methode fgt die Anzeigequerschnitte hinzu
   */
  private void initialisiereObjekte ()
  {
    for (AnzeigeQuerschnittMitTyp a : _objekte.values())
    {
    	if (!_moeglicheObjekte.contains(a) && !_zugewieseneObjekte.contains(a))
  		  _moeglicheObjekte.add(a);
    }
  	
    _lvMoeglicheObjekte.refresh();
  }  

  /**
   * Methode legt ein Composite an in dem die Anzeigequerschnitte versorgt werden knnen
   * @param parent Parent Composite
   */
  private void createCompositeObjekte (Composite parent)
  {
    FillLayout fillLayout1 = new FillLayout();
    fillLayout1.marginHeight = 5;
    fillLayout1.marginWidth = 5;
    fillLayout1.type = org.eclipse.swt.SWT.HORIZONTAL;
    
    GridData gridData2 = new GridData();
    gridData2.horizontalAlignment = GridData.FILL;
    gridData2.grabExcessHorizontalSpace = true;
    gridData2.grabExcessVerticalSpace = true;
    gridData2.verticalAlignment = GridData.FILL;
    
    Composite eingang = new Composite(parent, SWT.BORDER);
  	eingang.setLayout(fillLayout1);
  	eingang.setLayoutData(gridData2);
    // Zeile 0
    
    GridData gdZeile0 = new GridData ();
    gdZeile0.horizontalAlignment = GridData.FILL;
    gdZeile0.verticalAlignment = GridData.FILL;
    gdZeile0.grabExcessHorizontalSpace = true;
    gdZeile0.grabExcessVerticalSpace = false;

    Group zeile0 = new Group (eingang, SWT.NONE);
    zeile0.setLayout(new GridLayout (3, false));
  	
    // Zeile 0 Spalte 1
    
    GridData gdZeile0Spalte1 = new GridData ();
    gdZeile0Spalte1.horizontalAlignment = GridData.FILL;
    gdZeile0Spalte1.verticalAlignment = GridData.FILL;
    gdZeile0Spalte1.grabExcessHorizontalSpace = true;
    gdZeile0Spalte1.grabExcessVerticalSpace = true;
    gdZeile0Spalte1.minimumWidth = 200;

    Composite zeile0Spalte1 = new Composite (zeile0, SWT.BORDER);
    zeile0Spalte1.setLayout(new FillLayout ());
    zeile0Spalte1.setLayoutData(gdZeile0Spalte1);

    // Zeile 0 Spalte 2

    GridData gdZeile0Spalte2 = new GridData ();
    gdZeile0Spalte2.horizontalAlignment = GridData.CENTER;
    gdZeile0Spalte2.grabExcessHorizontalSpace = false;
    gdZeile0Spalte2.minimumWidth = 80;

    Composite zeile0Spalte2 = new Composite (zeile0, SWT.BORDER);
    zeile0Spalte2.setLayout(new GridLayout (1, true));
    zeile0Spalte2.setLayoutData(gdZeile0Spalte2);

    // Zeile 0 Spalte 3

    GridData gdZeile0Spalte3 = new GridData ();
    gdZeile0Spalte3.horizontalAlignment = GridData.FILL;
    gdZeile0Spalte3.verticalAlignment = GridData.FILL;
    gdZeile0Spalte3.grabExcessHorizontalSpace = true;
    gdZeile0Spalte3.grabExcessVerticalSpace = true;
    gdZeile0Spalte3.minimumWidth = 200;
    
    Composite zeile0Spalte3 = new Composite (zeile0, SWT.BORDER);
    zeile0Spalte3.setLayout(new GridLayout(1, false));
    zeile0Spalte3.setLayoutData(gdZeile0Spalte3);

    createCompositeMoeglicheObjekte(zeile0Spalte1);
    
    createCompositeKopierenButtons(zeile0Spalte2);
    
    createCompositeZugewieseneObjekte(zeile0Spalte3);
    
    createCompositeTyp(zeile0Spalte3);
    
  }

	/**
	 * Methode erzeugt das Composite mit den Buttons
	 */
	private void createCompositeButtons(Composite parent)
	{
		GridData gridData1 = new GridData();
		gridData1.horizontalAlignment = GridData.FILL;
		gridData1.grabExcessHorizontalSpace = true;
		
		Composite composite = new Composite(parent, SWT.BORDER);
		composite.setLayout(new GridLayout(1, false));
		composite.setLayoutData(gridData1);

		GridData gdComboItem = new GridData();
		gdComboItem.horizontalAlignment = GridData.END;

		Button buttonDefault = new Button(composite, SWT.NONE);
		
		buttonDefault.setText("Defaultwerte");
		buttonDefault.addMouseListener(new MouseAdapter()
		{
			@Override
			public void mouseDown(MouseEvent e)
			{
				super.mouseDown(e);
				
				defaultWerte();
			}
		});
	}

	/**
	 * Methode definiert die Defaultwerte
	 */
	private void defaultWerte ()
	{
		ArrayList<AnzeigeQuerschnittMitTyp> aqs = new ArrayList<AnzeigeQuerschnittMitTyp>();
		
		ClientDavInterface connection = DaVVerbindung.getInstanz().getDaVVerbindung();
		DataModel model = connection.getDataModel();
		
    HashMap<String, EAnzeigeQuerschnittTyp> querschnitte = DefaultEinstellungen.getDefaultAnzeigeQuerschnitte();
    
    Iterator<Entry<String, EAnzeigeQuerschnittTyp>> it = querschnitte.entrySet().iterator();
    while (it.hasNext())
    {
      Entry<String, EAnzeigeQuerschnittTyp> entry = it.next();	
    	SystemObject so = model.getObject(entry.getKey());
    	
    	if (so != null)
    	{
    		if (_objekte.containsKey(so))
    		{
    			_objekte.get(so).setTyp(entry.getValue());
       		aqs.add(_objekte.get(so));
    		}
    	}
    }
    
    _moeglicheObjekte.clear();
    _zugewieseneObjekte.clear();
    
    _moeglicheObjekte.addAll(_objekte.values());
    
    for (AnzeigeQuerschnittMitTyp aqmt : aqs)
    {
      _moeglicheObjekte.remove(aqmt);
      _zugewieseneObjekte.add(aqmt);
    }
    
    _lvMoeglicheObjekte.refresh();
    _lvZugewieseneObjekte.refresh();
	}

  /**
   * Fgt die Liste mit den mglichen Funktionen hinzu
   * @param parent Composite in das die Liste eingefgt werden sollen
   */
  private void createCompositeMoeglicheObjekte (Composite parent)
  {
    Group group = new Group (parent, SWT.BORDER);
    group.setText("Mgliche Anzeigequerschnitte");
    group.setLayout(new FillLayout(SWT.VERTICAL));

    _listeMoeglicherObjekte = new List (group, SWT.BORDER | SWT.MULTI | SWT.V_SCROLL);
    _listeMoeglicherObjekte.addSelectionListener(new SelectionListener () 
    {
      public void widgetDefaultSelected(SelectionEvent e)
      {
      }

      public void widgetSelected(SelectionEvent e)
      {
      	boolean anwahlMoeglich = true;
      	
     		anwahlMoeglich = _listeMoeglicherObjekte.getSelectionCount() != 0;
      	
        _buttonNachRechts.setEnabled(anwahlMoeglich);
      }
    });
    
    _listeMoeglicherObjekte.addMouseListener(new MouseListener()
		{
			
			@Override
			public void mouseUp(MouseEvent e)
			{
			}
			
			@Override
			public void mouseDown(MouseEvent e)
			{
			}
			
			@Override
			public void mouseDoubleClick(MouseEvent e)
			{
        actionNachRechts();		
			}
		});
    
    _lvMoeglicheObjekte = new ListViewer(_listeMoeglicherObjekte);
    _lvMoeglicheObjekte.setContentProvider(new IStructuredContentProvider()
		{
			@Override
			public void dispose()
			{
			}
			
			@Override
			public Object[] getElements(Object inputElement)
			{
        Vector v = (Vector)inputElement;
        return v.toArray();
			}

			@Override
      public void inputChanged(Viewer viewer, Object oldInput, Object newInput)
      {
      }
		});
    
    _lvMoeglicheObjekte.setInput(_moeglicheObjekte);
    
    _lvMoeglicheObjekte.setLabelProvider(new LabelProvider() 
    {
      public Image getImage(Object element) 
      {
        return null;
      }

      public String getText(Object element) 
      {
        return (getBezeichnung ((AnzeigeQuerschnittMitTyp) element));
      }
    });
    
    _lvMoeglicheObjekte.setSorter(new ViewerSorter()
    {
      public int compare(Viewer viewer, Object e1, Object e2) 
      {
        return getBezeichnung ((AnzeigeQuerschnittMitTyp)e1).compareTo(getBezeichnung((AnzeigeQuerschnittMitTyp)e2));
      }
    });
  }

  /**
   * Fgt die Liste mit den zugewiesenden Funktionen hinzu
   * @param parent Composite in das die Liste eingefgt werden sollen
   */
  private void createCompositeZugewieseneObjekte (Composite parent)
  {
    Group group = new Group (parent, SWT.BORDER);
    group.setText("Zugeordnete Anzeigequerschnitte");
    group.setLayout(new FillLayout(SWT.VERTICAL));
    
    GridData gd = new GridData();
    gd.horizontalAlignment = GridData.FILL;
    gd.verticalAlignment = GridData.FILL;
    gd.grabExcessHorizontalSpace = true;
    gd.grabExcessVerticalSpace = true;

    group.setLayoutData(gd);
   
    _listeZugewiesenerObjekte = new List (group, SWT.BORDER | SWT.MULTI | SWT.V_SCROLL);
    _listeZugewiesenerObjekte.addSelectionListener(new SelectionListener () 
    {
      public void widgetDefaultSelected(SelectionEvent e)
      {
      }

      public void widgetSelected(SelectionEvent e)
      {
      	int anzahl = _listeZugewiesenerObjekte.getSelectionCount();
      	
      	boolean enabled = anzahl != 0;
      	
        _buttonNachLinks.setEnabled(enabled);
        _buttonTypUebernehmen.setEnabled(enabled);
        _combo.setEnabled(enabled);
        
        if (enabled)
        {
          IStructuredSelection selection = (IStructuredSelection) _lvZugewieseneObjekte.getSelection();
          StructuredSelection ss = (StructuredSelection) selection;

          Object obj1 = ss.toArray()[0]; // 1. selektiertes Objekt

          if (obj1 instanceof AnzeigeQuerschnittMitTyp)
          {
          	AnzeigeQuerschnittMitTyp aqmt = (AnzeigeQuerschnittMitTyp) obj1;
          	
          	EAnzeigeQuerschnittTyp typ = aqmt.getTyp();
          	
          	selektiereTyp (typ);
          }
        }
      }
    });

    _listeZugewiesenerObjekte.addMouseListener(new MouseListener()
		{
			@Override
			public void mouseUp(MouseEvent e)
			{
			}
			
			@Override
			public void mouseDown(MouseEvent e)
			{
			}
			
			@Override
			public void mouseDoubleClick(MouseEvent e)
			{
				actionNachLinks();
			}
		});
		
    _lvZugewieseneObjekte = new ListViewer(_listeZugewiesenerObjekte);
    _lvZugewieseneObjekte.setContentProvider(new IStructuredContentProvider()
		{
			@Override
			public void inputChanged (Viewer viewer, Object oldInput, Object newInput)
			{
			}
			
			@Override
			public void dispose()
			{
			}
			
			@Override
			public Object[] getElements(Object inputElement)
			{
        Vector v = (Vector)inputElement;
        return v.toArray();
			}
		});
    
    _lvZugewieseneObjekte.setInput(_zugewieseneObjekte);
    
    _lvZugewieseneObjekte.setLabelProvider(new LabelProvider() 
    {
      public Image getImage(Object element) 
      {
        return null;
      }

      public String getText(Object element) 
      {
        return (getBezeichnung ((AnzeigeQuerschnittMitTyp) element));
      }
    });
    
    _lvZugewieseneObjekte.setSorter(new ViewerSorter()
    {
      public int compare(Viewer viewer, Object e1, Object e2) 
      {
        return getBezeichnung ((AnzeigeQuerschnittMitTyp)e1).compareTo(getBezeichnung((AnzeigeQuerschnittMitTyp)e2));
      }
    });

    if (_zugewieseneObjekte != null)
	    for (AnzeigeQuerschnittMitTyp inhalt : _zugewieseneObjekte)
	    	if (_moeglicheObjekte.contains(inhalt))
	        _moeglicheObjekte.remove(inhalt);
    
    _lvMoeglicheObjekte.refresh();
    _lvZugewieseneObjekte.refresh();
  }

  protected void selektiereTyp(EAnzeigeQuerschnittTyp typ)
  {
  	int index = -1;
  	
  	for (int i=0; i<EAnzeigeQuerschnittTyp.values().length; ++i)
  		if (EAnzeigeQuerschnittTyp.values()[i] == typ)
  			index = i;
  	
  	_combo.select(index);
  }

	/**
   * Fgt die Kopierbuttons hinzu
   * @param parent Composite in das die Buttons eingefgt werden sollen
   */
  private void createCompositeKopierenButtons (Composite parent)
  {
    Composite composite = new Composite (parent, SWT.NONE);

    _buttonNachRechts = new Button(composite, SWT.PUSH);
    _buttonNachRechts.setText(" Hinzufgen >>");
    _buttonNachRechts.setEnabled(false);
    _buttonNachRechts.addSelectionListener(new SelectionAdapter()
    {
      public void widgetSelected(SelectionEvent e)
      {
        actionNachRechts();
      }
    });

    _buttonNachLinks = new Button(composite, SWT.PUSH);
    _buttonNachLinks.setText(" << Entfernen ");
    _buttonNachLinks.setEnabled(false);
    _buttonNachLinks.addSelectionListener(new SelectionAdapter()
    {
      public void widgetSelected(SelectionEvent e)
      {
        actionNachLinks();
      }
    });

    /*
     * Layout
     */
    RowLayout rlUnten = new RowLayout(SWT.VERTICAL);
    rlUnten.pack = false;
    composite.setLayout(rlUnten);
  }

  /**
   * Kopiert die selektierten Eintrge von links nach rechts
   */
  private void actionNachRechts()
  {
    IStructuredSelection selection = (IStructuredSelection) _lvMoeglicheObjekte.getSelection();
    StructuredSelection ss = (StructuredSelection) selection;

  	for (int x = 0; x < ss.size(); ++x)
    {
      Object obj1 = ss.toArray()[x];

      if (obj1 instanceof AnzeigeQuerschnittMitTyp)
      {
      	AnzeigeQuerschnittMitTyp as = (AnzeigeQuerschnittMitTyp) obj1;
      	
      	if (!_zugewieseneObjekte.contains(as))
      		_zugewieseneObjekte.add(as);
      	
      	_moeglicheObjekte.remove(as);
      }
    }

  	_lvMoeglicheObjekte.refresh();
  	_lvZugewieseneObjekte.refresh();
  	
    _buttonNachRechts.setEnabled(false);
  }

  /**
   * Kopiert die selektierten Eintrge von rechts nach links
   */
  private void actionNachLinks()
  {
    IStructuredSelection selection = (IStructuredSelection) _lvZugewieseneObjekte.getSelection();
    StructuredSelection ss = (StructuredSelection) selection;

  	for (int x = 0; x < ss.size(); ++x)
    {
      Object obj1 = ss.toArray()[x];

      if (obj1 instanceof AnzeigeQuerschnittMitTyp)
      {
      	AnzeigeQuerschnittMitTyp as = (AnzeigeQuerschnittMitTyp) obj1;
      	
      	if (!_moeglicheObjekte.contains(as))
          _moeglicheObjekte.add(as);
        
        _zugewieseneObjekte.remove(as);
      }
    }

    _lvMoeglicheObjekte.refresh();  
    _lvZugewieseneObjekte.refresh();
    	
    _buttonNachLinks.setEnabled(false);
  }

  /**
   * Methode liefert die aktuell eingestellten Parameter
   * @return aktuell eingestellten Parameter
   */
	public Vector<AnzeigeQuerschnittMitTyp>  getParameter()
  {
	  return leseAktuelleEinstellungen();
  }
 
	private Vector<AnzeigeQuerschnittMitTyp>  leseAktuelleEinstellungen ()
	{
    Vector<AnzeigeQuerschnittMitTyp> objekte = new Vector<AnzeigeQuerschnittMitTyp>();
    
    for (AnzeigeQuerschnittMitTyp so : _zugewieseneObjekte)
    	objekte.add(so);
    
  	return objekte;
  }

	/**
	 * Methode aktualisiert die View
	 */
	public void refresh()
  {
  }
	
	/**
	 * Methode liefert eine Bezeichnung fr einen Aspekt. Die Bezeichnung setzt sich
	 * zusammen aus Name + Pid
	 * @param objekt Systemobjekt des Aspekts
	 * @return Bezeichnung 
	 */
	private String getBezeichnung (AnzeigeQuerschnittMitTyp objekt)
	{
		return objekt.toString();
	}
	
	private void createCompositeTyp (Composite parent)
	{
    /*
     * Combobox mit der Auswahlmglichkeit der Anzeigetypen
     */
    
		GridData gdTextItem = new GridData();
		gdTextItem.horizontalAlignment = GridData.FILL;
		gdTextItem.grabExcessHorizontalSpace = true;
		gdTextItem.verticalAlignment = GridData.BEGINNING;

		GridData gdComboItem = new GridData();
		gdComboItem.horizontalAlignment = GridData.FILL;

		Label dummy = new Label(parent, SWT.LEFT);
		dummy.setText("Anzeigetyp");
		dummy.setLayoutData(gdTextItem);

		_combo = new Combo(parent, SWT.BORDER);
		_combo.setLayoutData(gdComboItem);

		int anzahl = EAnzeigeQuerschnittTyp.values().length;
		
		String[] sa = new String[anzahl];
		for (int j = 0; j < anzahl; ++j)
			sa[j] = EAnzeigeQuerschnittTyp.values()[j].getName();

		_combo.setItems(sa);
		_combo.select(0);
		
		_buttonTypUebernehmen = new Button(parent, SWT.NONE);
		
		_buttonTypUebernehmen.setText("Anzeigetyp bernehmen");
		_buttonTypUebernehmen.addMouseListener(new MouseAdapter()
		{
			@Override
			public void mouseDown(MouseEvent e)
			{
				super.mouseDown(e);

				aendereTyp ();
			}
		});
		
		_combo.setEnabled(false);
		_buttonTypUebernehmen.setEnabled(false);
	}

	protected void aendereTyp()
  {
		/*
		 * Ausgewhlten Anzeigetyp bestimmen
		 */
		int index = _combo.getSelectionIndex();
		if (index == -1)
			return;
		
		EAnzeigeQuerschnittTyp typ = EAnzeigeQuerschnittTyp.values()[index];
		
		/*
		 * Bestimmen welche Anzeigequerschnitte selektiert sind
		 */
    IStructuredSelection selection = (IStructuredSelection) _lvZugewieseneObjekte.getSelection();
    StructuredSelection ss = (StructuredSelection) selection;

  	for (int x = 0; x < ss.size(); ++x)
    {
      Object obj1 = ss.toArray()[x];

      if (obj1 instanceof AnzeigeQuerschnittMitTyp)
      {
      	AnzeigeQuerschnittMitTyp as = (AnzeigeQuerschnittMitTyp) obj1;
      	as.setTyp(typ);
      }
    }

  	/*
  	 * Aktualisieren
  	 */
    _lvZugewieseneObjekte.refresh();  
  }
}
