package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.laengsquerabgleich.universal;

import java.util.ArrayList;
import java.util.List;
import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CTabFolder;
import org.eclipse.swt.custom.CTabItem;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Spinner;

import de.bsvrz.sba.plugin.parameter.steuerungskern.daten.WVZInhalt;
import de.bsvrz.sba.plugin.parameter.steuerungskern.dialog.AnzeigeInhaltTyp;
import de.bsvrz.sba.plugin.parameter.steuerungskern.konfig.VerwaltungWvzInhalte;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.laengsquerabgleich.universal.eigenschaften.UniversalEigenschaften;

/**
 * Darstellung des Fensters zur Versorgung der Parameter
 */
public class CompositeParameterUniversal extends Composite
{
	/**
	 * Aktuelles Composite
	 */
  private Composite _composite;

  /**
   * Liste mit den unterschiedlichen Parametergruppen
   */
	private ArrayList<String> _list;

	private RegelUniversal _aktuelleRegel;

	private CTabFolder _tabFolder;

	private CompositeParameterAllgemein _compositeParaAllgemein;

	private CompositeParameterEigenschaft1 _compositeParaEigenschaft1;

	private CompositeParameterEigenschaft2 _compositeParaEigenschaft2;

	private CompositeParameterEigenschaft3 _compositeParaEigenschaft3;

	private CompositeParameterEigenschaft4 _compositeParaEigenschaft4;

	private CompositeParameterEigenschaft5 _compositeParaEigenschaft5;

	private CompositeParameterEigenschaft6 _compositeParaEigenschaft6;

	private CompositeParameterEigenschaft7 _compositeParaEigenschaft7;

	private CompositeParameterEigenschaft8 _compositeParaEigenschaft8;

	private CompositeParameterEigenschaft9 _compositeParaEigenschaft9;

	private CompositeParameterEigenschaft10 _compositeParaEigenschaft10;

	private CompositeParameterEigenschaft11 _compositeParaEigenschaft11;

	private CompositeParameterAlternativerInhalt _compositeParaAlternativerInhalt;
	
	private CompositeParameterAngeforderterInhalt _compositeParaAngeforderterInhalt;

	private String _angeforderterInhalt;

	private String _alternativerInhalt;

	private int _indexAngeforderterInhalt;

	private int _indexAlternativerInhalt;

	private Spinner _spinnerAnzahl;

  /**
   * Konstruktor der Klasse
   * @param parent Parent Composite
   * @param style Stil des Fenstern
   * @param aktuell Aktuelle Parameter
   * @param pidAnzeigeTyp Pid des Anzeigetyps
   */
  CompositeParameterUniversal (Composite parent, int style, RegelUniversal aktuell)
  {
    super (parent, style);
    
    _aktuelleRegel = aktuell; // erzeugeKopie(aktuell);

    /*
     * Prfen ob mindestens eine Anzeige versorgt ist
     */
    if (_aktuelleRegel.getEigenschaften().size() == 0)
    	erweitereReduziereDatenstruktur(1);

    initialize();
  }

  /**
   * Fhrt die Basis-Initialisierung des Composites durch
   */
  private void initialize()
  {
    GridData gridData1 = new GridData();
    gridData1.horizontalAlignment = GridData.FILL;
    gridData1.grabExcessHorizontalSpace = true;
    gridData1.grabExcessVerticalSpace = true;
    gridData1.heightHint = -1;
    gridData1.widthHint = -1;
    gridData1.horizontalIndent = 0;
    gridData1.verticalAlignment = GridData.FILL;
    setLayout(new GridLayout(1, false));
    setLayoutData(gridData1);
    GridLayout gridLayout = new GridLayout();
    gridLayout.makeColumnsEqualWidth = false;
    gridLayout.numColumns = 1;
    GridData gridData2 = new GridData();
    gridData2.horizontalAlignment = GridData.FILL;
    gridData2.grabExcessHorizontalSpace = true;
    gridData2.grabExcessVerticalSpace = true;
    gridData2.heightHint = -1;
    gridData2.widthHint = -1;
    gridData2.horizontalIndent = 0;
    gridData2.verticalAlignment = GridData.FILL;

    _composite = new Composite(this, SWT.NONE);
    _composite.setLayoutData(gridData2);
    _composite.setLayout(gridLayout);

    createCompositeTab();
    
    /*
     * Reiter anlegen fr die unterschiedlichen Parameter
     */
    
    _angeforderterInhalt = "Schaltbild";
    _alternativerInhalt  = "Alternatives Schaltbild";
    
    _list = new ArrayList<String>();
    
    _list.add ("Allgemein");
    _list.add ("E1");
    _list.add ("E2");
    _list.add ("E3");
    _list.add ("E4");
    _list.add ("E5");
    _list.add ("E6");
    _list.add ("E7");
    _list.add ("E8");
    _list.add ("E9");
    _list.add ("E10");
    _list.add ("E11");
    
    _list.add (_angeforderterInhalt);
    _indexAngeforderterInhalt = _list.size() - 1;
    
    _list.add (_alternativerInhalt);
    _indexAlternativerInhalt = _list.size() - 1;
   
    erzeugeTabItems (_list);

    updateData ();
  }

  /**
   * Methode zum Anlegen des Composite fr die Tabelle
   */
  private void createCompositeTab()
  {
    GridData gridDataGroup = new GridData();
    gridDataGroup.horizontalAlignment = GridData.FILL;
    gridDataGroup.grabExcessHorizontalSpace = true;
    gridDataGroup.grabExcessVerticalSpace = true;
    gridDataGroup.verticalAlignment = GridData.FILL;

  	GridData gridDataTabFolder = new GridData();
    gridDataTabFolder.horizontalAlignment = GridData.FILL;
    gridDataTabFolder.grabExcessHorizontalSpace = true;
    gridDataTabFolder.grabExcessVerticalSpace = true;
    gridDataTabFolder.verticalAlignment = GridData.FILL;

    Group _groupParameter = new Group(_composite, SWT.NONE);
    _groupParameter.setText("Parameter");
    _groupParameter.setLayout(new GridLayout(1, false));
    _groupParameter.setLayoutData(gridDataGroup);
  
    _tabFolder = new CTabFolder(_groupParameter, SWT.NONE);
    _tabFolder.setLayout(new GridLayout());
    _tabFolder.setLayoutData(gridDataTabFolder);
    _tabFolder.addSelectionListener(new SelectionListener() {

			@Override
      public void widgetDefaultSelected(SelectionEvent e)
      {
      }

      @Override
      public void widgetSelected(SelectionEvent e)
      {
        CTabFolder folder = (CTabFolder)e.getSource();        
        CTabItem itemSel = folder.getSelection();
        
        Composite cSel = (Composite)itemSel.getControl();
        
        /*
         * Damit die Tabellen in den einzelnen Parameterdialogen richtig dargestellt werden 
         * (in der richtigen Hhe der Zeilen) muss beim Anwhlen eines Reiters mit so einer Tabelle
         * die Tabelle aktualisiert werden.
         */
        if (((Composite)cSel).getChildren().length > 0)
        {
          if (itemSel.getText().equals(_list.get(0)))
          {
          	if (_compositeParaAllgemein != null)
          	  _compositeParaAllgemein.refresh();
          }
          
          if (itemSel.getText().equals(_list.get(1)))
          {
          	if (_compositeParaEigenschaft1 != null)
          	  _compositeParaEigenschaft1.refresh();
          }

          if (itemSel.getText().equals(_list.get(2)))
          {
          	if (_compositeParaEigenschaft2 != null)
          	  _compositeParaEigenschaft2.refresh();
          }

          if (itemSel.getText().equals(_list.get(3)))
          {
          	if (_compositeParaEigenschaft3 != null)
          	  _compositeParaEigenschaft3.refresh();
          }

          if (itemSel.getText().equals(_list.get(4)))
          {
          	if (_compositeParaEigenschaft4 != null)
          	  _compositeParaEigenschaft4.refresh();
          }

          if (itemSel.getText().equals(_list.get(5)))
          {
          	if (_compositeParaEigenschaft5 != null)
          	  _compositeParaEigenschaft5.refresh();
          }

          if (itemSel.getText().equals(_list.get(6)))
          {
          	if (_compositeParaEigenschaft6 != null)
          	  _compositeParaEigenschaft6.refresh();
          }

          if (itemSel.getText().equals(_list.get(7)))
          {
          	if (_compositeParaEigenschaft7 != null)
          	  _compositeParaEigenschaft7.refresh();
          }

          if (itemSel.getText().equals(_list.get(8)))
          {
          	if (_compositeParaEigenschaft8 != null)
          	  _compositeParaEigenschaft8.refresh();
          }

          if (itemSel.getText().equals(_list.get(9)))
          {
          	if (_compositeParaEigenschaft9 != null)
          	  _compositeParaEigenschaft9.refresh();
          }

          if (itemSel.getText().equals(_list.get(10)))
          {
          	if (_compositeParaEigenschaft10 != null)
          	  _compositeParaEigenschaft10.refresh();
          }

          if (itemSel.getText().equals(_list.get(11)))
          {
          	if (_compositeParaEigenschaft11 != null)
          	  _compositeParaEigenschaft11.refresh();
          }

          if (itemSel.getText().equals(_angeforderterInhalt))
          {
          	if (_compositeParaAngeforderterInhalt != null)
          	  _compositeParaAngeforderterInhalt.refresh();
          }

          if (itemSel.getText().equals(_alternativerInhalt))
          {
          	if (_compositeParaAlternativerInhalt != null)
          	  _compositeParaAlternativerInhalt.refresh();
          }
        }
      }
    });
  }

  /**
   * Reiter fr die Liste der Objekte erstellen
   * 
   * @param list
   */
  public void erzeugeTabItems( List<String> list )
  {
  	for (int i=0; i<list.size(); ++i)
  	{
      String s = list.get(i);
     
      CTabItem tabItem = new CTabItem( _tabFolder, SWT.NONE );

      String tabName = s;
      tabItem.setText( tabName );
      tabItem.setData( tabName, s );

      GridData gridData2 = new GridData();
      gridData2.horizontalAlignment = GridData.FILL;
      gridData2.grabExcessHorizontalSpace = true;
      gridData2.grabExcessVerticalSpace = true;
      gridData2.verticalAlignment = GridData.FILL;

      Composite c1 = new Composite( _tabFolder, SWT.NONE );
      c1.setLayout( new GridLayout() );
      c1.setLayoutData( gridData2 );

      tabItem.setControl( c1 );

    }
    _tabFolder.setSelection( 0 );
    
  }

  /**
   * Updatefunktion zum Aktualisieren der Daten
   */
  private void updateData ()
  {
  	updateDataAllgemein ();

  	updateEigenschaften ();
  }
  
  public void updateEigenschaften()
  {
		updateDataEigenschaft1 ();

  	updateDataEigenschaft2 ();

  	updateDataEigenschaft3 ();

  	updateDataEigenschaft4 ();

  	updateDataEigenschaft5 ();

  	updateDataEigenschaft6 ();

  	updateDataEigenschaft7 ();

  	updateDataEigenschaft8 ();

  	updateDataEigenschaft9 ();

  	updateDataEigenschaft10 ();

  	updateDataEigenschaft11 ();

  	updateDataAngeforderterInhalt();

  	updateDataAlternativerInhalt();
  }

  /**
   * Methode zum Aktualisieren des Composite mit den allgemeinen Eigenschaften 
   */

	private void updateDataAllgemein ()
  {
		CTabItem[] items = _tabFolder.getItems();
    CTabItem item = items [0];
    
    if (item != null )
    {
      Composite c = (Composite) item.getControl();
      Control[] children = c.getChildren();
      CompositeParameterAllgemein compPar = null;

      if ( children.length == 0 )
      {
        compPar = new CompositeParameterAllgemein( c, SWT.None, _aktuelleRegel, this );
        _compositeParaAllgemein = compPar;
        
        /*
         * Spinner mit der Anzahl der zu betrachtenden Anzeigen auslesen. Bei nderung der Anzahl muss
         * die Datenstruktur erweitert/reduziert werden und die einzelnen Eingabecomposites aktualisiert
         * werden
         */
        _spinnerAnzahl = _compositeParaAllgemein.getSpinnerAnzahlAnzeigen();
        if (_spinnerAnzahl != null)
        {
        	_spinnerAnzahl.addModifyListener(new ModifyListener()
					{
						@Override
						public void modifyText(ModifyEvent e)
						{
							aktualisiereEingabeFelder ();
						}
					});
        }
        
        compPar.layout( true );
        c.layout( true );
        
        compPar.refresh();
      }
      else
      {
        compPar = (CompositeParameterAllgemein) children[0];
        compPar.update ( _aktuelleRegel );
        
        compPar.layout( true );
        c.layout( true );

        compPar.getTvParameter().refresh();
      }
    }
  }

	/**
	 * Methode aktualisiert die einzelnen Composites mit den Eingabefeldern
	 */
	protected void aktualisiereEingabeFelder()
  {
  	int anzahl = _spinnerAnzahl.getSelection();
  	
  	/*
  	 * Im Moment eingestellte Werte einlesen
  	 */
  	
  	_aktuelleRegel = getParameter();
  	
  	/*
  	 * Datenstruktur erweitern/reduzieren
  	 */

  	erweitereReduziereDatenstruktur (anzahl);
  	
  	/*
  	 * Composites aktualisieren
  	 */
  	
  	updateEigenschaften();
  }

  /**
   * Methode zum Aktualisieren des Composite mit den Eingenschaften 1 
   */
  private void updateDataEigenschaft1()
  {
		CTabItem[] items = _tabFolder.getItems();
    CTabItem item = items [1];
    
    if (item != null )
    {
      Composite c = (Composite) item.getControl();
      Control[] children = c.getChildren();
      CompositeParameterEigenschaft1 compPar = null;

     if ( children.length == 0 )
      {
        compPar = new CompositeParameterEigenschaft1( c, SWT.None, _aktuelleRegel );
        _compositeParaEigenschaft1 = compPar;
        
        compPar.layout( true );
        c.layout( true );
        
        compPar.refresh();
        
        item.setToolTipText("Anzeigeinhalt");
      }
      else
      {
        compPar = (CompositeParameterEigenschaft1) children[0];
        compPar.update ( _aktuelleRegel );
        
        compPar.layout( true );
        c.layout( true );

        compPar.getTvParameter().refresh();
      }
    }
  }

  /**
   * Methode zum Aktualisieren des Composite mit den Eingenschaften 2 
   */
  private void updateDataEigenschaft2()
  {
		CTabItem[] items = _tabFolder.getItems();
    CTabItem item = items [2];
    
    if (item != null )
    {
      Composite c = (Composite) item.getControl();
      Control[] children = c.getChildren();
      CompositeParameterEigenschaft2 compPar = null;

     if ( children.length == 0 )
      {
        compPar = new CompositeParameterEigenschaft2( c, SWT.None, _aktuelleRegel );
        _compositeParaEigenschaft2 = compPar;
        
        compPar.layout( true );
        c.layout( true );
        
        compPar.refresh();
        
        item.setToolTipText("Anzeigeinhalt Vorintervall");
      }
      else
      {
        compPar = (CompositeParameterEigenschaft2) children[0];
        compPar.update ( _aktuelleRegel );
        
        compPar.layout( true );
        c.layout( true );

        compPar.getTvParameter().refresh();
      }
    }
  }

  /**
   * Methode zum Aktualisieren des Composite mit den Eingenschaften 3 
   */
  private void updateDataEigenschaft3()
  {
		CTabItem[] items = _tabFolder.getItems();
    CTabItem item = items [3];
    
    if (item != null )
    {
      Composite c = (Composite) item.getControl();
      Control[] children = c.getChildren();
      CompositeParameterEigenschaft3 compPar = null;

     if ( children.length == 0 )
      {
        compPar = new CompositeParameterEigenschaft3( c, SWT.None, _aktuelleRegel );
        _compositeParaEigenschaft3 = compPar;
        
        compPar.layout( true );
        c.layout( true );
        
        compPar.refresh();
        
        item.setToolTipText("Vorgnger");
      }
      else
      {
        compPar = (CompositeParameterEigenschaft3) children[0];
        compPar.update ( _aktuelleRegel );
        
        compPar.layout( true );
        c.layout( true );

        compPar.getTvParameter().refresh();
      }
    }
  }

  /**
   * Methode zum Aktualisieren des Composite mit den Eingenschaften 4 
   */
  private void updateDataEigenschaft4()
  {
		CTabItem[] items = _tabFolder.getItems();
    CTabItem item = items [4];
    
    if (item != null )
    {
      Composite c = (Composite) item.getControl();
      Control[] children = c.getChildren();
      CompositeParameterEigenschaft4 compPar = null;

     if ( children.length == 0 )
      {
        compPar = new CompositeParameterEigenschaft4( c, SWT.None, _aktuelleRegel );
        _compositeParaEigenschaft4 = compPar;
        
        compPar.layout( true );
        c.layout( true );
        
        compPar.refresh();
        
        item.setToolTipText("Nachfolger");
      }
      else
      {
        compPar = (CompositeParameterEigenschaft4) children[0];
        compPar.update ( _aktuelleRegel );
        
        compPar.layout( true );
        c.layout( true );

        compPar.getTvParameter().refresh();
      }
    }
  }

  /**
   * Methode zum Aktualisieren des Composite mit den Eingenschaften 5 
   */
  private void updateDataEigenschaft5()
  {
		CTabItem[] items = _tabFolder.getItems();
    CTabItem item = items [5];
    
    if (item != null )
    {
      Composite c = (Composite) item.getControl();
      Control[] children = c.getChildren();
      CompositeParameterEigenschaft5 compPar = null;

     if ( children.length == 0 )
      {
        compPar = new CompositeParameterEigenschaft5( c, SWT.None, _aktuelleRegel );
        _compositeParaEigenschaft5 = compPar;
        
        compPar.layout( true );
        c.layout( true );
        
        compPar.refresh();

        item.setToolTipText("WZG Typ");
      }
      else
      {
        compPar = (CompositeParameterEigenschaft5) children[0];
        compPar.update ( _aktuelleRegel );
        
        compPar.layout( true );
        c.layout( true );

        compPar.getTvParameter().refresh();
      }
    }
  }

  /**
   * Methode zum Aktualisieren des Composite mit den Eingenschaften 6 
   */
  private void updateDataEigenschaft6()
  {
		CTabItem[] items = _tabFolder.getItems();
    CTabItem item = items [6];
    
    if (item != null )
    {
      Composite c = (Composite) item.getControl();
      Control[] children = c.getChildren();
      CompositeParameterEigenschaft6 compPar = null;

     if ( children.length == 0 )
      {
        compPar = new CompositeParameterEigenschaft6( c, SWT.None, _aktuelleRegel );
        _compositeParaEigenschaft6 = compPar;
        
        compPar.layout( true );
        c.layout( true );
        
        compPar.refresh();
        
        item.setToolTipText("Anzeige");
      }
      else
      {
        compPar = (CompositeParameterEigenschaft6) children[0];
        compPar.update ( _aktuelleRegel );
        
        compPar.layout( true );
        c.layout( true );

        compPar.getTvParameter().refresh();
      }
    }
  }

  /**
   * Methode zum Aktualisieren des Composite mit den Eingenschaften 7 
   */
  private void updateDataEigenschaft7()
  {
		CTabItem[] items = _tabFolder.getItems();
    CTabItem item = items [7];
    
    if (item != null )
    {
      Composite c = (Composite) item.getControl();
      Control[] children = c.getChildren();
      CompositeParameterEigenschaft7 compPar = null;

     if ( children.length == 0 )
      {
        compPar = new CompositeParameterEigenschaft7( c, SWT.None, _aktuelleRegel );
        _compositeParaEigenschaft7 = compPar;
        
        compPar.layout( true );
        c.layout( true );
        
        compPar.refresh();
        
        item.setToolTipText("Fahrstreifentyp");
      }
      else
      {
        compPar = (CompositeParameterEigenschaft7) children[0];
        compPar.update ( _aktuelleRegel );
        
        compPar.layout( true );
        c.layout( true );

        compPar.getTvParameter().refresh();
      }
    }
  }

  /**
   * Methode zum Aktualisieren des Composite mit den Eingenschaften 8 
   */
  private void updateDataEigenschaft8()
  {
		CTabItem[] items = _tabFolder.getItems();
    CTabItem item = items [8];
    
    if (item != null )
    {
      Composite c = (Composite) item.getControl();
      Control[] children = c.getChildren();
      CompositeParameterEigenschaft8 compPar = null;

     if ( children.length == 0 )
      {
        compPar = new CompositeParameterEigenschaft8( c, SWT.None, _aktuelleRegel );
        _compositeParaEigenschaft8 = compPar;
        
        compPar.layout( true );
        c.layout( true );
        
        item.setToolTipText("Fahrstreifen");

        compPar.refresh();
      }
      else
      {
        compPar = (CompositeParameterEigenschaft8) children[0];
        compPar.update ( _aktuelleRegel );
        
        compPar.layout( true );
        c.layout( true );

        compPar.getTvParameter().refresh();
      }
    }
  }

  /**
   * Methode zum Aktualisieren des Composite mit den Eingenschaften 9 
   */
  private void updateDataEigenschaft9()
  {
		CTabItem[] items = _tabFolder.getItems();
    CTabItem item = items [9];
    
    if (item != null )
    {
      Composite c = (Composite) item.getControl();
      Control[] children = c.getChildren();
      CompositeParameterEigenschaft9 compPar = null;

     if ( children.length == 0 )
      {
        compPar = new CompositeParameterEigenschaft9( c, SWT.None, _aktuelleRegel );
        _compositeParaEigenschaft9 = compPar;
        
        compPar.layout( true );
        c.layout( true );
        
        item.setToolTipText("Anzeige ausgefallen");

        compPar.refresh();
      }
      else
      {
        compPar = (CompositeParameterEigenschaft9) children[0];
        compPar.update ( _aktuelleRegel );
        
        compPar.layout( true );
        c.layout( true );

        compPar.getTvParameter().refresh();
      }
    }
  }

  /**
   * Methode zum Aktualisieren des Composite mit den Eingenschaften 10 
   */
  private void updateDataEigenschaft10()
  {
		CTabItem[] items = _tabFolder.getItems();
    CTabItem item = items [10];
    
    if (item != null )
    {
      Composite c = (Composite) item.getControl();
      Control[] children = c.getChildren();
      CompositeParameterEigenschaft10 compPar = null;

     if ( children.length == 0 )
      {
        compPar = new CompositeParameterEigenschaft10( c, SWT.None, _aktuelleRegel );
        _compositeParaEigenschaft10 = compPar;
        
        compPar.layout( true );
        c.layout( true );
        
        item.setToolTipText("WVZ Inhalt ausgefallen");

        compPar.refresh();
      }
      else
      {
        compPar = (CompositeParameterEigenschaft10) children[0];
        compPar.update ( _aktuelleRegel );
        
        compPar.layout( true );
        c.layout( true );

        compPar.getTvParameter().refresh();
      }
    }
  }

  /**
   * Methode zum Aktualisieren des Composite mit den Eingenschaften 11 
   */
  private void updateDataEigenschaft11()
  {
		CTabItem[] items = _tabFolder.getItems();
    CTabItem item = items [11];
    
    if (item != null )
    {
      Composite c = (Composite) item.getControl();
      Control[] children = c.getChildren();
      CompositeParameterEigenschaft11 compPar = null;

     if ( children.length == 0 )
      {
        compPar = new CompositeParameterEigenschaft11( c, SWT.None, _aktuelleRegel );
        _compositeParaEigenschaft11 = compPar;
        
        compPar.layout( true );
        c.layout( true );
        
        item.setToolTipText("Anzahl Fahrstreifen");

        compPar.refresh();
      }
      else
      {
        compPar = (CompositeParameterEigenschaft11) children[0];
        compPar.update ( _aktuelleRegel );
        
        compPar.layout( true );
        c.layout( true );

        compPar.getTvParameter().refresh();
      }
    }
  }

  /**
   * Methode zum Aktualisieren des Composite mit dem angeforderten Inhalt
   */
  private void updateDataAngeforderterInhalt()
  {
		CTabItem[] items = _tabFolder.getItems();
    CTabItem item = items [_indexAngeforderterInhalt];
    
    if (item != null )
    {
      Composite c = (Composite) item.getControl();
      Control[] children = c.getChildren();
      CompositeParameterAngeforderterInhalt compPar = null;

     if ( children.length == 0 )
      {
        compPar = new CompositeParameterAngeforderterInhalt( c, SWT.None, _aktuelleRegel );
        _compositeParaAngeforderterInhalt = compPar;
        
        compPar.layout( true );
        c.layout( true );
        
        compPar.refresh();
      }
      else
      {
        compPar = (CompositeParameterAngeforderterInhalt) children[0];
        compPar.update ( _aktuelleRegel );
        
        compPar.layout( true );
        c.layout( true );

        compPar.getTvParameter().refresh();
      }
    }
  }

  /**
   * Methode zum Aktualisieren des Composite mit dem alternativen Inhalt
   */
  private void updateDataAlternativerInhalt()
  {
		CTabItem[] items = _tabFolder.getItems();
    CTabItem item = items [_indexAlternativerInhalt];
    
    if (item != null )
    {
      Composite c = (Composite) item.getControl();
      Control[] children = c.getChildren();
      CompositeParameterAlternativerInhalt compPar = null;

     if ( children.length == 0 )
      {
        compPar = new CompositeParameterAlternativerInhalt( c, SWT.None, _aktuelleRegel );
        _compositeParaAlternativerInhalt = compPar;
        
        compPar.layout( true );
        c.layout( true );
        
        compPar.refresh();
      }
      else
      {
        compPar = (CompositeParameterAlternativerInhalt) children[0];
        compPar.update ( _aktuelleRegel );
        
        compPar.layout( true );
        c.layout( true );

        compPar.getTvParameter().refresh();
      }
    }
  }

	/**
	 * Methode aktualisiert die einzelnen Composite
	 */
	public void refresh()
  {
		if (_compositeParaAllgemein != null)
	    _compositeParaAllgemein.refresh();

		if (_compositeParaEigenschaft1 != null)
	    _compositeParaEigenschaft1.refresh();

		if (_compositeParaEigenschaft2 != null)
	    _compositeParaEigenschaft2.refresh();

		if (_compositeParaEigenschaft3 != null)
	    _compositeParaEigenschaft3.refresh();

		if (_compositeParaEigenschaft4 != null)
	    _compositeParaEigenschaft4.refresh();

		if (_compositeParaEigenschaft5 != null)
	    _compositeParaEigenschaft5.refresh();

		if (_compositeParaEigenschaft6 != null)
	    _compositeParaEigenschaft6.refresh();

		if (_compositeParaEigenschaft7 != null)
	    _compositeParaEigenschaft7.refresh();

		if (_compositeParaEigenschaft8 != null)
	    _compositeParaEigenschaft8.refresh();

		if (_compositeParaEigenschaft9 != null)
	    _compositeParaEigenschaft9.refresh();

		if (_compositeParaEigenschaft10 != null)
	    _compositeParaEigenschaft10.refresh();

		if (_compositeParaEigenschaft11 != null)
	    _compositeParaEigenschaft11.refresh();

		if (_compositeParaAngeforderterInhalt != null)
	    _compositeParaAngeforderterInhalt.refresh();

		if (_compositeParaAlternativerInhalt != null)
	    _compositeParaAlternativerInhalt.refresh();

  }

	/**
	 * Methode benimmt neue Werte vom DaV
	 * @param regel
	 */
	public void update(RegelUniversal regel)
  {
	  _aktuelleRegel = regel;
	  
	  updateData();
  }

	/**
	 * Methode liest die Werte der einzelnen Composites ein
	 * @return eine Universalregel
	 */
	public RegelUniversal getParameter()
  {
		if (_compositeParaAllgemein != null)
		  _compositeParaAllgemein.uebernehmeDaten();
		
		if (_compositeParaEigenschaft1 != null)
		  _compositeParaEigenschaft1.uebernehmeDaten();

		if (_compositeParaEigenschaft2 != null)
		  _compositeParaEigenschaft2.uebernehmeDaten();

		if (_compositeParaEigenschaft3 != null)
		  _compositeParaEigenschaft3.uebernehmeDaten();

		if (_compositeParaEigenschaft4 != null)
		  _compositeParaEigenschaft4.uebernehmeDaten();

		if (_compositeParaEigenschaft5 != null)
		  _compositeParaEigenschaft5.uebernehmeDaten();

		if (_compositeParaEigenschaft6 != null)
		  _compositeParaEigenschaft6.uebernehmeDaten();

		if (_compositeParaEigenschaft7 != null)
		  _compositeParaEigenschaft7.uebernehmeDaten();

		if (_compositeParaEigenschaft8 != null)
		  _compositeParaEigenschaft8.uebernehmeDaten();

		if (_compositeParaEigenschaft9 != null)
		  _compositeParaEigenschaft9.uebernehmeDaten();

		if (_compositeParaEigenschaft10 != null)
		  _compositeParaEigenschaft10.uebernehmeDaten();

		if (_compositeParaEigenschaft11 != null)
		  _compositeParaEigenschaft11.uebernehmeDaten();

		if (_compositeParaAngeforderterInhalt != null)
		  _compositeParaAngeforderterInhalt.uebernehmeDaten();

		if (_compositeParaAlternativerInhalt != null)
		  _compositeParaAlternativerInhalt.uebernehmeDaten();

	  return _aktuelleRegel;
  }

	/**
	 * Methode erweitert/reduziert die aktuellen Parameter auf die aktuell eingestellte Anzahl Anzeigen
	 * @param anzahl Anzahl Anzeigen
	 */
	private void erweitereReduziereDatenstruktur(int anzahl)
  {
		/*
		 * Eigenschaften erweitern
		 */
		Vector<UniversalEigenschaften> eigenschaften = _aktuelleRegel.getEigenschaften();
		Vector<UniversalEigenschaften> neu = new Vector<UniversalEigenschaften>();
		
		for (int i=0; i<anzahl; ++i)
		{
			if (i < eigenschaften.size())
				neu.add(eigenschaften.get(i));
			else
				neu.add(new UniversalEigenschaften());
		}
		
		_aktuelleRegel.setEigenschaften(neu);
		
		/*
		 * WVZ-Inhalte
		 */
		Vector<WVZInhalt> inhalte = _aktuelleRegel.getAngeforderteInhalte();
		Vector<WVZInhalt> neueInhalte = new Vector<WVZInhalt>();
		
		for (int i=0; i<anzahl; ++i)
		{
			if (i < inhalte.size())
				neueInhalte.add(inhalte.get(i));
			else
				neueInhalte.add(VerwaltungWvzInhalte.getInstance().getWvzInhaltBeibehalten());
		}
		
		_aktuelleRegel.setAngeforderteInhalte(neueInhalte);
	}

//	/**
//	 * Methode zum Auslsen der Aktualisierung bei nderung des Spinners
//	 */
//	public void loeseAktualisierungAus ()
//	{
//		Runnable r = new Runnable()
//		{
//			@Override
//			public void run()
//			{
//				updateEigenschaften();
//			}
//		};
//		
//		PlatformUI.getWorkbench().getDisplay().asyncExec(r);
//	}
}
