package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.verriegelung.allgemein;

import java.util.HashMap;


/**
 * Klasse definiert den Aufau einer Schilderbcke. Die Schilderbrcke wird dabei in Spalten
 * einer JTable dargestellt.
 * @author ObertM
 *
 */
public class Design
{
	/**
	 * Definition der Spalten
	 */
  private Spalte [] _spalten;

  /**
   * Konstruktor der Klasse
   * @param spalten Definition der Spalten
   */
  public Design (Spalte [] spalten)
  {
  	_spalten = spalten;
  	
  	HashMap<EVA, Integer> counter = new HashMap<EVA, Integer>();
  	
  	int indexAnzeigeInQuerBeziehung = 0;
  	
  	// Index der einzelnen AnzeigenTypen bestimmen
  	
  	for (Spalte s : spalten)
  	{
  		EVA eva = s.getEva();
  		
  		// Index des Anzeigeelements
  		
  		if (!counter.containsKey(eva))
  			counter.put(eva, 0);
  		
  		int index = counter.get(eva);
  		
  		s.setIndex(index);
  		
  		index++;
  		
  		counter.put(eva, index);
  		
  		// Dazugehrende Anzeigen innerhalb der Querbeziehung
  		
  		int [] indexAnzeige = new int [eva.getAnzahlAnzeigen()];
  		
  		for (int i=0; i<eva.getAnzahlAnzeigen(); ++i)
  			indexAnzeige [i] = indexAnzeigeInQuerBeziehung++;
  		
  		s.setIndexAnzeige(indexAnzeige);
  	}
  }
  
	/**
   * Methode liefert zeilen zurck
   * @return zeilen
   */
  public Spalte[] getSpalten()
  {
  	return _spalten;
  }
}


