package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.verriegelung.allgemeineVerriegelungsMatrix;


import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;

import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.widgets.Composite;

import de.bsvrz.sba.plugin.parameter.steuerungskern.projektspezifischeEinstellungen.EAnzeigeQuerschnittTyp;

/**
 * Darstellung des Fensters zur Versorgung der Parameter
 */
public class CompositeParameterAllgemeineVerriegelungsMatrix extends Composite
{
	/**
	 * Aktuelles Composite
	 */
  private Composite _composite;
  
  /**
   * Konstruktor der Klasse
   * @param parent Parent Composite
   * @param style Stil des Fenstern
   * @param aktuell Aktuelle Parameter
   * @param typ Typ des Anzeigequerschnitts
   */
  CompositeParameterAllgemeineVerriegelungsMatrix (Composite parent, int style, ListeMitRegeln aktuell, EAnzeigeQuerschnittTyp typ)
  {
    super (parent, style);
    
    _composite = new CompositeAVM(parent, style, aktuell, typ.getDesignVM());

//    /*
//     * Definition des bentigten Konstruktors
//     */
//    Class[] REPLICATE_CONSTRUCTOR_PARAMS = new Class[]{Composite.class, int.class, ListeMitRegeln.class};
//
//    /*
//     * Klasse anlegen und Konstruktor laden
//     */
//    Class klasse = typ.getKlasseAllgemeineVerriegelung();
//    Constructor ctor = null;
//    
//    try
//    {
//	    ctor = klasse.getDeclaredConstructor(REPLICATE_CONSTRUCTOR_PARAMS);
//    } 
//    catch (SecurityException e)
//    {
//	    e.printStackTrace();
//    } 
//    catch (NoSuchMethodException e)
//    {
//	    e.printStackTrace();
//    }
//    
//    Object replicate = null;
//    
//    if (ctor != null)
//    {
//	    try
//	    {
//		    replicate = ctor.newInstance(parent, style, aktuell);
//	    } 
//	    catch (IllegalArgumentException e)
//	    {
//		    e.printStackTrace();
//	    } 
//	    catch (InstantiationException e)
//	    {
//		    e.printStackTrace();
//	    } 
//	    catch (IllegalAccessException e)
//	    {
//		    e.printStackTrace();
//	    } 
//	    catch (InvocationTargetException e)
//	    {
//		    e.printStackTrace();
//	    }
//    }
//    
//    if (replicate != null)
//    {
//    	_composite = (Composite) replicate;
//    }
  }
  
  /**
   * Methode liefert die Anzahl der Parameter
   * @return Anzahl der Parameter
   */
  public int getAnzahlParameter()
  {
  	return ((ICompositeParameterAllgemeineVerriegelungsMatrix) _composite).getAnzahlParameter();
  }
  
  /**
   * Methode liefert den Tabelviewer
   * @return
   */
  public TableViewer getTvAnzeige()
  {
    return ((ICompositeParameterAllgemeineVerriegelungsMatrix) _composite).getTvAnzeige();
  }

  /**
   * Methode liefert die eingestellten Parameter
   * @return eingestellte Parameter
   */
	public ListeMitRegeln getParameter()
  {
		ICompositeParameterAllgemeineVerriegelungsMatrix c = ((ICompositeParameterAllgemeineVerriegelungsMatrix) _composite);

    ListeMitRegeln para = null;

		if (c != null)
		{
		  para = c.getParameter();
		  c.aktualisiereFolder();
		}
		
		return para;
  }

	/**
	 * Methode bernimmt die Daten eines anderen Folders
	 * @param tvAnzeige Tableviewer der zu bernhmenden Tabelle
	 */
	public void setTvAnzeige (TableViewer tvAnzeige)
	{
    ((ICompositeParameterAllgemeineVerriegelungsMatrix) _composite).setTvAnzeige(tvAnzeige);
	}
	
  /**
   * Methode zum Aktualisieren des Folders
   */
  public void aktualisiereFolder ()
  {
  	((ICompositeParameterAllgemeineVerriegelungsMatrix) _composite).aktualisiereFolder();
  }
}
