package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.vorgaengerNachfolger;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.ArrayList;
import java.util.List;
import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;

import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.sba.plugin.parameter.steuerungskern.daten.VorgaengerNachfolgerArt;
import de.bsvrz.sba.plugin.parameter.steuerungskern.konfig.Konfig;
import de.bsvrz.sba.plugin.parameter.steuerungskern.projektspezifischeEinstellungen.DefaultEinstellungen;

/**
 * Darstellung des Fensters zur Versorgung der Parameter
 */
public class CompositeParameterQuer extends Composite
{
	/**
	 * Aktuelles Composite
	 */
  private Composite _composite;

  /**
   * Composite fr die Buttons
   */
	private Composite _compositeButtons;

	/**
	 * Defaultbutton
	 */
	private Button _buttonDefault;

	/**
	 * Liste mglicher Anzeigequerschnitte
	 */
	private List<SystemObject> _listeMoeglicherAQs;

	/**
	 * Auswahl AQ
	 */
	private AuswahlObjekt _aq;

	/**
	 * Auswahl Anzeige
	 */
	private AuswahlObjekt _anzeige;

	/**
	 * Auswahl direkter Vorgnger
	 */
	private AuswahlObjekt _direkterVorgaenger;

	/**
	 * Auswahl Vorgnger gleichen Typs
	 */
	private AuswahlObjekt _vorgngerGleichenTyps;

	/**
	 * Auswahl direkter Nachfolger
	 */
	private AuswahlObjekte _direkteNachfolger;

	/**
	 * Auswahl Nachfolger gleichen Typs
	 */
	private AuswahlObjekte _nachfolgerGleichenTyps;

	/**
	 * Liste mgicher Anzeigen
	 */
	private List<SystemObject> _listeMoeglicherAnzeigen = new ArrayList<SystemObject>();

	/**
	 * Aktuell angewhlte Anzeige
	 */
	private SystemObject _aktuelleAnzeige;

	/**
	 * Aktuell angewhlter Anzeigequerschnitt
	 */
	private SystemObject _aktuellerAnzeigeQuerschnitt;

	/**
	 * Mgliche Objekte Vorgnger gleicher Typ
	 */
	private List<String> _objekteVGT;

	/**
	 * Mgliche Objekte Nachfolger gleicher Typ
	 */
	private List<String> _objekteNGT;

	/**
	 * Mgliche Objekte direkte Vorgnger
	 */

	private List<String> _objekteDV;

	/**
	 * Mgliche Objekte direkte Nachfolger
	 */

	private List<String> _objekteDN;

	/**
	 * Button "fr alle"
	 */
	private Button _buttonAlle;

	private ParameterVorgaengerNachfolger _parameter;

	private AuswahlQuerAbgleich _auswahl;

	protected boolean _alleQuerschnitte;

	private AuswahlObjekt _filterVorgaenger;

	private AuswahlObjekt _filterNachfolger;

  /**
   * Konstruktor der Klasse
   * @param parent Parent Composite
   * @param style Stil des Fenstern
   * @param parameter 
   * @param aktuell Aktuelle Parameter
   * @param fahrtrichtung Fahrtrichtung
   */
  CompositeParameterQuer (Composite parent, int style, ParameterVorgaengerNachfolger parameter)
  {
    super (parent, style);
   
    _parameter = parameter;
    
    initialize();
  }

  /**
   * Fhrt die Basis-Initialisierung des Composites durch
   */
  private void initialize()
  {
    if ( _listeMoeglicherAQs == null )
    	_listeMoeglicherAQs = Konfig.getInstance().getAnzeigeQuerschnitte(); 
    		
    /*
     * Composite anlegen
     */
    GridData gridData1 = new GridData();
    gridData1.horizontalAlignment = GridData.FILL;
    gridData1.grabExcessHorizontalSpace = true;
    gridData1.grabExcessVerticalSpace = true;
    gridData1.heightHint = -1;
    gridData1.widthHint = -1;
    gridData1.horizontalIndent = 0;
    gridData1.verticalAlignment = GridData.FILL;
    
    setLayout(new GridLayout(1, false));
    setLayoutData(gridData1);
    
    _composite = new Composite(this, SWT.NONE);
    _composite.setLayout(new GridLayout(1, false));
    _composite.setLayoutData(gridData1);
 
    /*
     * Auswahl Anzeigequerschnitt
     */
    _aq = new AuswahlObjekt(_composite, "Anzeigequerschnitt");
    _aq.setMoeglicheObjekte(ToolsVN.bestimmeObjektNamen(_listeMoeglicherAQs, false));

    /*
     * Auswahl Anzeige
     */
    _anzeige = new AuswahlObjekt(_composite, "zu betrachtende Anzeige");
    
    /*
     * Auswahl alle Anzeigequerschnitte
     */
    _auswahl =  new AuswahlQuerAbgleich(_composite);

    /*
     * Vorgnger
     */
    erzeugeVorgaengerElemente(_composite);
    
    /*
     * Nachfolger
     */
    erzeugeNachfolgerElemente(_composite);

    /*
     * Buttons
     */
    createButtons(_composite);
    
    /*
     * Auswahlelemente initialisieren
     */
    bestimmeMoeglicheVorgaenger();
    bestimmeMoeglicheNachfolger();
    
    /*
     * Filter initialisieren
     */
    initialisiereFilter();

    /*
     * nderung bei den Anzeigen
     */
    _anzeige.addPropertyChangeListener(new PropertyChangeListener()
		{
			@Override
			public void propertyChange(PropertyChangeEvent evt)
			{
				leseAktuelleEinstellungen();
				
				bestimmeMoeglicheWerte ();
				updateData();
			}
		});
    
    /*
     * nderungen bei den Anzeigequerschnitten
     */
    _aq.addPropertyChangeListener(new PropertyChangeListener()
		{
			@Override
			public void propertyChange(PropertyChangeEvent arg0)
			{
				String name = _aq.getAusgewaehltesObjekt();
				
				if (name != null)
				{
					leseAktuelleEinstellungen();
					
					SystemObject aq = ToolsVN.bestimmeObjekt (name, _listeMoeglicherAQs);
					
					_aktuellerAnzeigeQuerschnitt = aq;
					initialisiereFilter();
					
					if (aq != null)
					{
					  _anzeige.setMoeglicheObjekte(ToolsVN.bestimmeObjektNamen(ToolsVN.bestimmeAnzeigenZuAq(aq), false));

						bestimmeAnzeigen (aq);
						bestimmeMoeglicheWerte();
						updateData();
					}
				}
			}
		});

    /*
     * nderung bei der Auswahl
     */
    _auswahl.addPropertyChangeListener(new PropertyChangeListener()
		{
			@Override
			public void propertyChange(PropertyChangeEvent arg0)
			{
				_alleQuerschnitte = _auswahl.isAlleQuerschnitte();
				
				_filterVorgaenger.setEnable(_alleQuerschnitte);
				_filterNachfolger.setEnable(_alleQuerschnitte);
				
				initialisiereFilter();
				
				bestimmeAnzeigen(_aktuellerAnzeigeQuerschnitt);
				bestimmeMoeglicheWerte();
				
				leseAktuelleEinstellungen();
				updateData();
			}
		});
  }

  /**
   * Methode erzeugt die Eingabeelemente fr die Vorgngerbeziehung
   * @param parent Parentcomposite
   */
  private void erzeugeVorgaengerElemente (Composite parent)
  {
    GridData gridDataGroup = new GridData();
    gridDataGroup.horizontalAlignment = GridData.FILL;
    gridDataGroup.grabExcessHorizontalSpace = true;

    Group gruppeVorgaenger = new Group(parent, SWT.NONE);
    gruppeVorgaenger.setText("Vorgnger in Querrichtung");
    gruppeVorgaenger.setLayout(new GridLayout(1, false));
    gruppeVorgaenger.setLayoutData(gridDataGroup);

    erzeugeFilterVorgaenger(gruppeVorgaenger);
    
    _direkterVorgaenger = new AuswahlObjekt(gruppeVorgaenger, "direkter Vorgnger");

    _vorgngerGleichenTyps = new AuswahlObjekt(gruppeVorgaenger, "Vorgnger gleichen Typs");
  }

  /**
   * Methode erzeugt die Eingabeelemente fr die Nachfolgerbeziehung
   * @param parent Parentcomposite
   */
  private void erzeugeNachfolgerElemente (Composite parent)
  {
    GridData gridDataGroup = new GridData();
    gridDataGroup.horizontalAlignment = GridData.FILL;
    gridDataGroup.grabExcessHorizontalSpace = true;

    Group gruppe = new Group(parent, SWT.NONE);
    gruppe.setText("Nachfolger in Querrichtung");
    gruppe.setLayout(new GridLayout(1, false));
    gruppe.setLayoutData(gridDataGroup);

    erzeugeFilterNachfolger(gruppe);
    
    _direkteNachfolger = new AuswahlObjekte(gruppe, "direkte Nachfolger");

    _nachfolgerGleichenTyps = new AuswahlObjekte(gruppe, "Nachfolger gleichen Typs");
  }

  /**
   * Methode initialisiert die beiden Filter fr Vorgnger und Nachfolger
   */
  private void initialisiereFilter ()
  {
		if (!_alleQuerschnitte)
		{
			if (_aktuellerAnzeigeQuerschnitt != null)
			{
			  _filterVorgaenger.setAngewaehltesObjekt(_aktuellerAnzeigeQuerschnitt.getName());
			  _filterNachfolger.setAngewaehltesObjekt(_aktuellerAnzeigeQuerschnitt.getName());
			}
		}
		else
		{
		  _filterVorgaenger.setAngewaehltesObjekt(ToolsVN._undefiniert);
		  _filterNachfolger.setAngewaehltesObjekt(ToolsVN._undefiniert);
		}
  }
  
  /**
   * Methode erzeugt den Filter "Vorgnger"
   */
  private void erzeugeFilterVorgaenger (Composite parent)
  {
    _filterVorgaenger = new AuswahlObjekt(parent, "Filter");
    _filterVorgaenger.addPropertyChangeListener(new PropertyChangeListener()
		{
			@Override
			public void propertyChange(PropertyChangeEvent arg0)
			{
				String name = _filterVorgaenger.getAusgewaehltesObjekt();
				
				if (name != null)
				{
					bestimmeMoeglicheWerte();
					
					leseAktuelleEinstellungen();
					updateData();
			  }
			}
		});
    _filterVorgaenger.setEnable (false);
  }

	/**
	 * Methode bestimmt die mglichen Anzeigequerschnitte in Querrrichtung
	 */
	private void bestimmeMoeglicheVorgaenger()
  {
		List<SystemObject> moeglicheNachfolger = new ArrayList<SystemObject>();
		
		if (_listeMoeglicherAQs != null)
		{
			for (SystemObject so : _listeMoeglicherAQs)
				moeglicheNachfolger.add(so);
			
		  _filterVorgaenger.setMoeglicheObjekte(ToolsVN.bestimmeObjektNamen(moeglicheNachfolger, true));
		}
  }

 /**
   * Methode erzeugt den Filter "Nachfolger"
   */
  private void erzeugeFilterNachfolger (Composite parent)
  {
    _filterNachfolger = new AuswahlObjekt(parent, "Filter");
    _filterNachfolger.addPropertyChangeListener(new PropertyChangeListener()
		{
			@Override
			public void propertyChange(PropertyChangeEvent arg0)
			{
				String name = _filterNachfolger.getAusgewaehltesObjekt();
				
				if (name != null)
				{
					bestimmeMoeglicheWerte();
					
					leseAktuelleEinstellungen();
					updateData();
			  }
			}
		});
    
    _filterNachfolger.setEnable (false);
  }

	/**
	 * Methode bestimmt die mglichen Anzeigequerschnitte in Querrrichtung
	 */
	private void bestimmeMoeglicheNachfolger()
  {
		List<SystemObject> moeglicheNachfolger = new ArrayList<SystemObject>();
		
		if (_listeMoeglicherAQs != null)
		{
			for (SystemObject so : _listeMoeglicherAQs)
			  moeglicheNachfolger.add(so);
			
		  _filterNachfolger.setMoeglicheObjekte(ToolsVN.bestimmeObjektNamen(moeglicheNachfolger, true));
		}
  }

	/**
	 * Methode bestimmt die mglichen Anzeigen fr den Querabgleich
	 * @param aq Querschnitt
	 */
	private void bestimmeAnzeigen (SystemObject aq)
  {
		_listeMoeglicherAnzeigen.clear();

//		if (!_alleQuerschnitte)
//		{
//			List<SystemObject> anzeigen = Tools.bestimmeAnzeigenZuAq(aq);
//			if (anzeigen != null)
//			{
//				for (SystemObject so : anzeigen)
//					_listeMoeglicherAnzeigen.add(so);
//			}
//		}
//		else
		{
    	for (SystemObject so : Konfig.getInstance().getAnzeigen())
    		_listeMoeglicherAnzeigen.add(so);
		}
  }

	/**
	 * Methode bestimmt die mglichen Auswahlwerte die abhngig von einer Anzeige sind
	 */
	private void bestimmeMoeglicheWerte()
  {
		/*
		 * Aktuelle Anzeige bestimmen
		 */
		String name = _anzeige.getAusgewaehltesObjekt();
		if (name == null)
		{
			_aktuelleAnzeige = null;
			return;
		}
		
		SystemObject anzeige = ToolsVN.bestimmeObjekt (name, _listeMoeglicherAnzeigen);
		_aktuelleAnzeige = anzeige;

		if (anzeige != null)
		{
		  SystemObject typ = Konfig.getInstance().getWzgTypVonAnzeige(anzeige.getPid());
		  
		  /*
		   * Bestimmen der mglichen Vorgngerobjekte (= alle Anzeigen ausseer der eigenen)
		   */
		  List<SystemObject> listeMoeglicherVorgaenger            = new ArrayList<SystemObject>();
		  List<SystemObject> listeMoeglicherVorgaengerGleicherTyp = new ArrayList<SystemObject>();
		  
			/*
			 * Vorgnger bestimmen
			 */
			name = _filterVorgaenger.getAusgewaehltesObjekt();
			if (name != null && !name.equals(ToolsVN._undefiniert))
			{
				SystemObject vorgaenger = ToolsVN.bestimmeObjekt (name, _listeMoeglicherAQs);
				listeMoeglicherVorgaenger = ToolsVN.bestimmeAnzeigenZuAq(vorgaenger);
			}
			else
			{
			  for (SystemObject so : _listeMoeglicherAnzeigen)
			  {
			  	if (so != anzeige)
			  		listeMoeglicherVorgaenger.add(so);
			  }
			}

		  for (SystemObject so : listeMoeglicherVorgaenger)
		  {
	  	  SystemObject typSo = Konfig.getInstance().getWzgTypVonAnzeige(so.getPid());
	  	  
	  	  if (typSo == null)
	  	  	listeMoeglicherVorgaengerGleicherTyp.add(so);
	  	  else
	  	  {
			  	if (typ == typSo)
			  		listeMoeglicherVorgaengerGleicherTyp.add(so);
	  	  }
		  }

		  _objekteVGT = ToolsVN.bestimmeObjektNamen(listeMoeglicherVorgaengerGleicherTyp, true);
		  _objekteDV  = ToolsVN.bestimmeObjektNamen(listeMoeglicherVorgaenger, true);
		  
		  /*
		   * Bestimmen der mglichen Nachfolgerobjekte (abhngig ob NachfolgerAQ ausgewhlt wurde)
		   */

		  List<SystemObject> listeMoeglicherNachfolger            = new ArrayList<SystemObject>();
		  List<SystemObject> listeMoeglicherNachfolgerGleicherTyp = new ArrayList<SystemObject>();

			/*
			 * Nachfolger bestimmen
			 */
			name = _filterNachfolger.getAusgewaehltesObjekt();
			if (name != null && !name.equals(ToolsVN._undefiniert))
			{
				SystemObject nachfolger = ToolsVN.bestimmeObjekt (name, _listeMoeglicherAQs);
				listeMoeglicherNachfolger = ToolsVN.bestimmeAnzeigenZuAq(nachfolger);
			}
			else
			{
			  for (SystemObject so : _listeMoeglicherAnzeigen)
			  {
			  	if (so != anzeige)
			  		listeMoeglicherNachfolger.add(so);
			  }
			}

		  for (SystemObject so : listeMoeglicherNachfolger)
		  {
	  	  SystemObject typSo = Konfig.getInstance().getWzgTypVonAnzeige(so.getPid());
	  	  
	  	  if (typSo == null)
	  	  	listeMoeglicherNachfolgerGleicherTyp.add(so);
	  	  else
	  	  {
			  	if (typ == typSo)
			  		listeMoeglicherNachfolgerGleicherTyp.add(so);
	  	  }
		  }

		  /*
		   * Bisher angewhlte Objekte bleiben auch nach Filternderung erhalten+
		   */
		  _objekteNGT = ToolsVN.bestimmeObjektNamen(listeMoeglicherNachfolgerGleicherTyp, false);
		  _objekteDN  = ToolsVN.bestimmeObjektNamen(listeMoeglicherNachfolger, false);
		}		
  }

  /**
   * Methode bernimmt die Daten und zeigt diese in der Tabelle an
   */
  private void updateData ()
  {
  	if (_aktuelleAnzeige == null)
  		return;
  	
  	/*
  	 * Direkter Vorgnger
  	 */
  	SystemObject dv  =_parameter.getVorgaengerInQuerRichtung(_aktuelleAnzeige, VorgaengerNachfolgerArt.DIREKT );
    if (dv == null)
    	_direkterVorgaenger.setAngewaehltesObjekt(_objekteDV, ToolsVN._undefiniert);
    else
    	_direkterVorgaenger.setAngewaehltesObjekt(_objekteDV, ToolsVN.bestimmeBezeichnung(dv));

  	/*
  	 * Vorgnger gleichen Typs
  	 */
  	SystemObject vgt = _parameter.getVorgaengerInQuerRichtung(_aktuelleAnzeige, VorgaengerNachfolgerArt.GLEICHERTYP );
    if (vgt == null)
    	_vorgngerGleichenTyps.setAngewaehltesObjekt(_objekteVGT, ToolsVN._undefiniert);
    else
    	_vorgngerGleichenTyps.setAngewaehltesObjekt(_objekteVGT, ToolsVN.bestimmeBezeichnung(vgt));

  	/*
  	 * Direkter Nachfolger
  	 */
  	SystemObject[] dn  = _parameter.getNachfolgerInQuerRichtung(_aktuelleAnzeige, VorgaengerNachfolgerArt.DIREKT );
    _direkteNachfolger.setAngewaehlteObjekte (_objekteDN, ToolsVN.bestimmeObjektNamen (dn, false));

  	/*
  	 * Nachfolger gleichen Typs
  	 */
  	SystemObject[] ngt = _parameter.getNachfolgerInQuerRichtung(_aktuelleAnzeige, VorgaengerNachfolgerArt.GLEICHERTYP );
    _nachfolgerGleichenTyps.setAngewaehlteObjekte (_objekteNGT, ToolsVN.bestimmeObjektNamen (ngt, false));
  }

  /**
   * Methode erzeugt das Composite mit den Buttons
   */
  private void createButtons(Composite parent)
  {
    RowLayout rowLayout = new RowLayout();
    rowLayout.pack = false;
    GridData gridData3 = new GridData();
    gridData3.horizontalAlignment = GridData.END;
    gridData3.grabExcessHorizontalSpace = true;
    gridData3.verticalAlignment = GridData.CENTER;
    
    _compositeButtons = new Composite( parent, SWT.NONE );
    _compositeButtons.setLayoutData( gridData3 );
    _compositeButtons.setLayout( rowLayout );
    
    _buttonDefault = new Button( _compositeButtons, SWT.NONE );
    _buttonDefault.setText( "Defaultwerte" );
    _buttonDefault.addMouseListener( new MouseAdapter()
    {
      @Override
      public void mouseDown( MouseEvent e )
      {
        aktionDefault ();
      }
    } );
    
    _buttonAlle = new Button( _compositeButtons, SWT.NONE );
    _buttonAlle.setText( "Alle Anzeigequerschnitte auf Defaultwerte setzen" );
    _buttonAlle.addMouseListener( new MouseAdapter()
    {
      @Override
      public void mouseDown( MouseEvent e )
      {
        aktionAlle ();
      }
    } );

  }
  
  /**
   * Methode definiert die Querbeziehungen fr alle Anzeigequerschnitte
   */
  protected void aktionAlle()
  {
  	for (SystemObject so : _listeMoeglicherAQs)
  	  setzeQuerBeziehung(so);
  }
  
  /**
   * Methode generiert automatisch alle B/C Kombinationen
   */
  protected void aktionDefault()
  {
  	setzeQuerBeziehung(_aktuellerAnzeigeQuerschnitt);
  }

	public void leseAktuelleEinstellungen()
  {
  	if (_aktuelleAnzeige != null)
  	{
  		SystemObject so = null;
  		
  		/*
  		 * Direkter Vorgnger
  		 */
  		String name = _direkterVorgaenger.getAusgewaehltesObjekt();
  		if (name.equals(ToolsVN._undefiniert))
  		  so = null;
  		else
  			so = ToolsVN.bestimmeObjekt(name, _listeMoeglicherAnzeigen);
  		
  		_parameter.setDirektenVorgaengerQuerrichtung(_aktuelleAnzeige, so);

  		/*
  		 * Vorgnger gleichen Typs
  		 */
  		name = _vorgngerGleichenTyps.getAusgewaehltesObjekt();
  		if (name.equals(ToolsVN._undefiniert))
  		  so = null;
  		else
  			so = ToolsVN.bestimmeObjekt(name, _listeMoeglicherAnzeigen);
  		
  		_parameter.setVorgaengerGleichenTypsQuerrichtung(_aktuelleAnzeige, so);
  		
  		/*
  		 * Direkte Nachfolger
  		 */
  		SystemObject[] nachfolger = ToolsVN.bestimmeSystemObjekteAusListe(_direkteNachfolger.getZugeordneteObjekte(), _listeMoeglicherAnzeigen);
  		_parameter.setDirekteNachfolgerQuerrichtung(_aktuelleAnzeige, nachfolger);
  		
  		/*
  		 * Nachfolger gleichen typs
  		 */
  		nachfolger = ToolsVN.bestimmeSystemObjekteAusListe(_nachfolgerGleichenTyps.getZugeordneteObjekte(), _listeMoeglicherAnzeigen);
  		_parameter.setNachfolgerGleichenTypsQuerrichtung(_aktuelleAnzeige, nachfolger);
  	}
  }

	/**
	 * Methode setzt die Querbeziehungen innerhalb eines Anzeigequerschnitts vom Typ<br>
	 * @param anzeigeQuerschnitt Anzeigequerschnitt
	 */
  public void setzeQuerBeziehung (SystemObject anzeigeQuerschnitt)
  {
  	erzeugeRegeln(DefaultEinstellungen.getDefaultQuerBeziehung (anzeigeQuerschnitt));
  	
//  	IAnzeigeQuerschnittTyp iaqt = VerwaltungAnzeigeQuerschnitte.getInstance().getAnzeigeQuerschnitt (anzeigeQuerschnitt);
//  	if (iaqt != null)
//  	  erzeugeRegeln (iaqt.getDefaultQuerBeziehung());
  	
    updateData();
  }

  /**
   * Methode erzeugt die Vorgnger/Nachfolger Beziehung fr einen Anzeigequerschnitt
   * @param reihenfolge Reihenfolge der Anzeigen innerhalb des Anzeigequerschnitts in
   * der Reihenfolge von links nach rechts und von oben nach unten. 
   */
  private void erzeugeRegeln(SystemObject[] reihenfolge)
  {
  	for (SystemObject so : reihenfolge)
  		System.out.println("CompositeParameterQuer.erzeugeRegeln() " + so.getPid());
  	
  	ParameterVorgaengerNachfolger v = _parameter;
  	
  	int anzahl = reihenfolge.length;
  	
  	/*
  	 * Direkte Nachfolger
  	 */
  	for (int i=0; i<anzahl; ++i)
  	{
      if (i != anzahl - 1)  		
        v.setDirekteNachfolgerQuerrichtung( reihenfolge [i], new SystemObject [] { reihenfolge [i + 1]} );
      else
        v.setDirekteNachfolgerQuerrichtung( reihenfolge [i], new SystemObject [] {});
  	}

  	/*
  	 * Direkte Vorgnger
  	 */
  	for (int i=anzahl - 1; i>=0; i--)
  	{
      if (i > 0)  		
        v.setDirektenVorgaengerQuerrichtung ( reihenfolge [i], reihenfolge [i - 1] );
      else
        v.setDirektenVorgaengerQuerrichtung ( reihenfolge [i], null );
  	}
  	
  	/*
  	 * Nachfolger gleichen Typs
  	 */
  	for (int i=0; i<anzahl; ++i)
  	{
		  SystemObject typ = Konfig.getInstance().getWzgTypVonAnzeige (reihenfolge [i].getPid());
  		Vector<SystemObject> ngt = new Vector<SystemObject>();
  		
  		for (int j=i+1; j<anzahl; ++j)
  		{
  		  SystemObject so = reihenfolge [j];	
  		  SystemObject typSO = Konfig.getInstance().getWzgTypVonAnzeige (so.getPid());
  		  if (typ == typSO)
  		  {
  		  	ngt.add(so);
  		  	break;
  		  }
  		}

      v.setNachfolgerGleichenTypsQuerrichtung( reihenfolge [i], ngt.toArray( new SystemObject [ngt.size()]));
  	}

  	/*
  	 * Vorgnger gleichen Typs
  	 */
  	for (int i=anzahl - 1; i>=0; i--)
  	{
  		v.setVorgaengerGleichenTypsQuerrichtung( reihenfolge [i], null );
  		
  		if (i > 0)
  		{
		    SystemObject typ = Konfig.getInstance().getWzgTypVonAnzeige (reihenfolge [i].getPid());
  		  for (int j=i-1; j>=0; j--)
  		  {
  		    SystemObject so = reihenfolge [j];	
  		    SystemObject typSO = Konfig.getInstance().getWzgTypVonAnzeige (so.getPid());
  		    if (typ == typSO)
  		    {
  		      v.setVorgaengerGleichenTypsQuerrichtung( reihenfolge [i],  so );
  		      break;
  		    }
  		  }
  		}
  		else
	      v.setVorgaengerGleichenTypsQuerrichtung( reihenfolge [i], null );
  	}
  }
}
