package de.bsvrz.sba.plugin.parameter.steuerungskern.view.allgemein;

import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.aufhebungen.aufhebung.OpenViewParameterAufhebung;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.aufhebungen.aufhebung.VerwaltungParaAufhebung;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.ausfallbehandlung.ausfallandereszeichen.OpenViewParameterAusfallAnderesZeichen;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.ausfallbehandlung.ausfallandereszeichen.VerwaltungParaAusfallAnderesZeichen;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.ausfallbehandlung.ausfallgleicheszeichen.OpenViewParameterAusfallGleichesZeichen;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.ausfallbehandlung.ausfallgleicheszeichen.VerwaltungParaAusfallGleichesZeichen;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.ausfallbehandlung.ausschaltregel.OpenViewParameterAusschaltRegel;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.ausfallbehandlung.ausschaltregel.VerwaltungParaAusschaltRegel;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.laengsquerabgleich.lueckenfuellen.OpenViewParameterLueckenFuellen;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.laengsquerabgleich.lueckenfuellen.VerwaltungParaLueckenFuellen;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.laengsquerabgleich.monotonie.OpenViewParameterMonotonie;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.laengsquerabgleich.monotonie.VerwaltungParaMonotonie;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.laengsquerabgleich.monotonieKreuzPfeil.OpenViewParameterMonotonieKreuzPfeil;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.laengsquerabgleich.monotonieKreuzPfeil.VerwaltungParaMonotonieKreuzPfeil;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.laengsquerabgleich.trichterung.OpenViewParameterTrichterung;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.laengsquerabgleich.trichterung.VerwaltungParaTrichterung;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.laengsquerabgleich.universal.OpenViewParameterUniversal;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.laengsquerabgleich.verdopplung.OpenViewParameterVerdopplung;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.laengsquerabgleich.verdopplung.VerwaltungParaVerdopplung;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.laengsquerabgleich.zusammenfassen.OpenViewParameterZusammenfassen;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.laengsquerabgleich.zusammenfassen.VerwaltungParaZusammenfassen;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.laengsquerabgleich.zusammenfassungEnde.OpenViewParameterZusammenfassungEnde;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.notwendigeschaltungen.absolutnotwendigeschaltung.OpenViewParameterAbsolutNotwendigeSchaltung;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.notwendigeschaltungen.absolutnotwendigeschaltung.VerwaltungParaAbsolutNotwendigeSchaltung;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.notwendigeschaltungen.notwendigeschaltung.OpenViewParameterNotwendigeSchaltung;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.notwendigeschaltungen.notwendigeschaltung.VerwaltungParaNotwendigeSchaltung;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.prio.OpenViewParameterPriorisierung;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.prio.VerwaltungParaPriorisierung;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.verriegelung.allgemeineVerriegelungsMatrix.OpenViewParameterAllgemeineVerriegelungsMatrix;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.verriegelung.allgemeineVerriegelungsMatrix.VerwaltungParaAllgemeineVerriegelungsMatrix;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.verriegelung.spezielleVerriegelungsMatrix.OpenViewParameterSpezielleVerriegelungsMatrix;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.verriegelung.spezielleVerriegelungsMatrix.VerwaltungParaSpezielleVerriegelungsMatrix;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.verschiebungen.verschieben.OpenViewParameterVerschieben;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.verschiebungen.verschieben.VerwaltungParaVerschieben;

public class OpenVersorgungsViews
{
	/**
	 * Kennung Parameter "Trichterung"
	 */
	public static final String _trichterung = "Trichterung";

	/**
	 * Kennung Parameter "Universal"
	 */
	public static final String _universal = "Universal";

	/**
	 * Kennung Parameter "Verdopplung"
	 */
	public static final String _verdopplung = "Verdopplung";

	/**
	 * Kennung Parameter "Monotonie"
	 */
	public static final String _monotonie = "Monotonie";

	/**
	 * Kennung Parameter "Zusammenfassen"
	 */
	public static final String _zusammenfassen = "Zusammenfassen";

	/**
	 * Kennung Parameter "Prio"
	 */
	public static final String _prio = "Priorisierung";

	/**
	 * Kennung Parameter "Ausfall gleiches Zeichen"
	 */
	public static final String _ausfallGleichesZeichen = "Ausfall gleiches Zeichen";

	/**
	 * Kennung Parameter "Ausfall anderes Zeichen"
	 */
	public static final String _ausfallAnderesZeichen = "Ausfall anderes Zeichen";

	/**
	 * Kennung Parameter "Ausschalttregel"
	 */
	public static final String _ausschaltRegel = "Ausschaltregel";

	/**
	 * Kennung Parameter "Allgemeine Verriegelungsmatrix"
	 */
	public static final String _allgemeineVerriegelungsMatrix = "Allgemeine Verriegelungsmatrix";

	/**
	 * Kennung Parameter "Spezielle Verriegelungsmatrix"
	 */
	public static final String _spezielleVerriegelungsMatrix = "Spezielle Verriegelungsmatrix";

	/**
	 * Kennung Parameter "Aufhebung"
	 */
	public static final String _aufhebung = "Aufhebung";

	/**
	 * Kennung Parameter "Lcken fllen"
	 */
	public static final String _lueckenFuellen = "Lcken fllen";

	/**
	 * Kennung Parameter "Verschieben"
	 */
	public static final String _verschieben = "Verschieben";

	/**
	 * Kennung Parameter "Notwendige Schaltung"
	 */
	public static final String _notwendigeSchaltung = "notwendige Schaltung";

	/**
	 * Kennung Parameter "Absolut notwendige Schaltung"
	 */
	public static final String _absolutNotwendigeSchaltung = "absolut notwendige Schaltung";

	/**
	 * Kennung Parameter "Monotonie Kreuz/Pfeil"
	 */
	public static final String _monotonieKreuzPfeil = "Monotonie Kreuz/Pfeil";

	/**
	 * Kennung Parameter "Zusammenfassung Ende"
	 */
	public static final String _zusammenfassungEnde = "Zusammenfassung Ende";

	/**
	 * Methode ffnet die Views mit den Versorgungsdialogen der einzelnen Parameter
	 * @param kennung Kennung der Parameterart
	 * @param pidObjekte Pid(s) der zu versorgenden Objekte
	 */
  public static void openView (String kennung, String pidObjekte)
  {
    StringBuffer sb = new StringBuffer();
    sb.append(pidObjekte);
      
    if (kennung.equals(_trichterung))
    {
      OpenViewParameterTrichterung.openView(sb.toString());
    }
    else if (kennung.equals(_verdopplung))
    {
      OpenViewParameterVerdopplung.openView(sb.toString());
    }
    else if (kennung.equals(_monotonie))
    {
      OpenViewParameterMonotonie.openView(sb.toString());
    }
    else if (kennung.equals(_zusammenfassen))
    {
      OpenViewParameterZusammenfassen.openView(sb.toString());
    }
    else if (kennung.equals(_prio))
    {
      OpenViewParameterPriorisierung.openView(sb.toString());
    }
    else if (kennung.equals(_ausfallGleichesZeichen))
    {
      OpenViewParameterAusfallGleichesZeichen.openView(sb.toString());
    }
    else if (kennung.equals(_ausfallAnderesZeichen))
    {
      OpenViewParameterAusfallAnderesZeichen.openView(sb.toString());
    }
    else if (kennung.equals(_ausschaltRegel))
    {
      OpenViewParameterAusschaltRegel.openView(sb.toString());
    }
    else if (kennung.equals(_allgemeineVerriegelungsMatrix))
    {
      OpenViewParameterAllgemeineVerriegelungsMatrix.openView(sb.toString());
    }
    else if (kennung.equals(_spezielleVerriegelungsMatrix))
    {
      OpenViewParameterSpezielleVerriegelungsMatrix.openView(sb.toString());
    }
    else if (kennung.equals(_aufhebung))
    {
      OpenViewParameterAufhebung.openView(sb.toString());
    }
    else if (kennung.equals(_lueckenFuellen))
    {
      OpenViewParameterLueckenFuellen.openView(sb.toString());
    }
    else if (kennung.equals(_verschieben))
    {
      OpenViewParameterVerschieben.openView(sb.toString());
    }
    else if (kennung.equals(_notwendigeSchaltung))
    {
      OpenViewParameterNotwendigeSchaltung.openView(sb.toString());
    }
    else if (kennung.equals(_absolutNotwendigeSchaltung))
    {
      OpenViewParameterAbsolutNotwendigeSchaltung.openView(sb.toString());
    }
    else if (kennung.equals(_universal))
    {
      OpenViewParameterUniversal.openView(sb.toString());
    }
    else if (kennung.equals(_monotonieKreuzPfeil))
    {
      OpenViewParameterMonotonieKreuzPfeil.openView(sb.toString());
    }
    else if (kennung.equals(_zusammenfassungEnde))
    {
      OpenViewParameterZusammenfassungEnde.openView(sb.toString());
    }
  }
  
  /**
   * Methode prft ob fr einen Anzeigequerschnitt spezielle Parameter versorgt sind
   * @param kennung Kennung der Parameterart
   * @param anzeigeQuerschnitt Anzeigequerschnitt
   * @return Information ob spezielle Parameter versorgt sind
   */
	public static boolean isParameterFuerAnzeigeQuerschnittVersorgt (String kennung, SystemObject anzeigeQuerschnitt)
	{
		if (kennung.equals(_trichterung))
			return VerwaltungParaTrichterung.getInstance().getParameterProAnzeigeQuerschnitt().containsKey(anzeigeQuerschnitt);

		else if (kennung.equals(_verdopplung))
			return VerwaltungParaVerdopplung.getInstance().getParameterProAnzeigeQuerschnitt().containsKey(anzeigeQuerschnitt);

		else if (kennung.equals(_monotonie))
			return VerwaltungParaMonotonie.getInstance().getParameterProAnzeigeQuerschnitt().containsKey(anzeigeQuerschnitt);

		else if (kennung.equals(_zusammenfassen))
			return VerwaltungParaZusammenfassen.getInstance().getParameterProAnzeigeQuerschnitt().containsKey(anzeigeQuerschnitt);

		else if (kennung.equals(_prio))
			return VerwaltungParaPriorisierung.getInstance().getParameterProAnzeigeQuerschnitt().containsKey(anzeigeQuerschnitt);

		else if (kennung.equals(_ausfallGleichesZeichen))
			return VerwaltungParaAusfallGleichesZeichen.getInstance().getParameterProAnzeigeQuerschnitt().containsKey(anzeigeQuerschnitt);

		else if (kennung.equals(_ausfallAnderesZeichen))
			return VerwaltungParaAusfallAnderesZeichen.getInstance().getParameterProAnzeigeQuerschnitt().containsKey(anzeigeQuerschnitt);

		else if (kennung.equals(_ausschaltRegel))
			return VerwaltungParaAusschaltRegel.getInstance().getParameterProAnzeigeQuerschnitt().containsKey(anzeigeQuerschnitt);

		else if (kennung.equals(_allgemeineVerriegelungsMatrix))
			return VerwaltungParaAllgemeineVerriegelungsMatrix.getInstance().getParameterProAnzeigeQuerschnitt().containsKey(anzeigeQuerschnitt);

		else if (kennung.equals(_aufhebung))
			return VerwaltungParaAufhebung.getInstance().getParameterProAnzeigeQuerschnitt().containsKey(anzeigeQuerschnitt);

		else if (kennung.equals(_lueckenFuellen))
			return VerwaltungParaLueckenFuellen.getInstance().getParameterProAnzeigeQuerschnitt().containsKey(anzeigeQuerschnitt);

		else if (kennung.equals(_verschieben))
			return VerwaltungParaVerschieben.getInstance().getParameterProAnzeigeQuerschnitt().containsKey(anzeigeQuerschnitt);

		else if (kennung.equals(_notwendigeSchaltung))
			return VerwaltungParaNotwendigeSchaltung.getInstance().getParameterProAnzeigeQuerschnitt().containsKey(anzeigeQuerschnitt);

		else if (kennung.equals(_absolutNotwendigeSchaltung))
			return VerwaltungParaAbsolutNotwendigeSchaltung.getInstance().getParameterProAnzeigeQuerschnitt().containsKey(anzeigeQuerschnitt);

		else if (kennung.equals(_spezielleVerriegelungsMatrix))
			return VerwaltungParaSpezielleVerriegelungsMatrix.getInstance().getParameterProAnzeigeQuerschnitt().containsKey(anzeigeQuerschnitt);

		else if (kennung.equals(_monotonieKreuzPfeil))
			return VerwaltungParaMonotonieKreuzPfeil.getInstance().getParameterProAnzeigeQuerschnitt().containsKey(anzeigeQuerschnitt);

    return false;		
	}

  /**
   * Methode prft ob fr eine Anzeige spezielle Parameter versorgt sind
   * @param kennung Kennung der Parameterart
   * @param anzeigeQuerschnitt Anzeige
   * @return Information ob spezielle Parameter versorgt sind
   */
	public static boolean isParameterFuerAnzeigeVersorgt (String kennung, SystemObject anzeige)
	{
		if (kennung.equals(_trichterung))
			return VerwaltungParaTrichterung.getInstance().getParameterProAnzeige().containsKey(anzeige);

		else if (kennung.equals(_verdopplung))
			return VerwaltungParaVerdopplung.getInstance().getParameterProAnzeige().containsKey(anzeige);

		else if (kennung.equals(_monotonie))
			return VerwaltungParaMonotonie.getInstance().getParameterProAnzeige().containsKey(anzeige);

		else if (kennung.equals(_zusammenfassen))
			return VerwaltungParaZusammenfassen.getInstance().getParameterProAnzeige().containsKey(anzeige);

		else if (kennung.equals(_prio))
			return VerwaltungParaPriorisierung.getInstance().getParameterProAnzeige().containsKey(anzeige);

		else if (kennung.equals(_ausfallGleichesZeichen))
			return VerwaltungParaAusfallGleichesZeichen.getInstance().getParameterProAnzeige().containsKey(anzeige);

		else if (kennung.equals(_ausfallAnderesZeichen))
			return VerwaltungParaAusfallAnderesZeichen.getInstance().getParameterProAnzeige().containsKey(anzeige);

		else if (kennung.equals(_ausschaltRegel))
			return VerwaltungParaAusschaltRegel.getInstance().getParameterProAnzeige().containsKey(anzeige);

		else if (kennung.equals(_allgemeineVerriegelungsMatrix))
			return VerwaltungParaAllgemeineVerriegelungsMatrix.getInstance().getParameterProAnzeige().containsKey(anzeige);

		else if (kennung.equals(_aufhebung))
			return VerwaltungParaAufhebung.getInstance().getParameterProAnzeige().containsKey(anzeige);

		else if (kennung.equals(_lueckenFuellen))
			return VerwaltungParaLueckenFuellen.getInstance().getParameterProAnzeige().containsKey(anzeige);

		else if (kennung.equals(_verschieben))
			return VerwaltungParaVerschieben.getInstance().getParameterProAnzeige().containsKey(anzeige);

		else if (kennung.equals(_notwendigeSchaltung))
			return VerwaltungParaNotwendigeSchaltung.getInstance().getParameterProAnzeige().containsKey(anzeige);

		else if (kennung.equals(_notwendigeSchaltung))
			return VerwaltungParaAbsolutNotwendigeSchaltung.getInstance().getParameterProAnzeige().containsKey(anzeige);

    return false;		
	}
}
