/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.sba.plugin.parametereditor.editor;

import de.bsvrz.dav.daf.main.ClientDavConnection;
import de.bsvrz.dav.daf.main.CommunicationError;
import de.bsvrz.dav.daf.main.ConnectionException;
import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.InconsistentLoginException;
import de.bsvrz.dav.daf.main.MissingParameterException;

public class DaVKommunikationTest
{
	 private static final String _ip = "192.0.1.116";
	 private static final int _port = 8085;
//	private static final String _ip = "127.0.0.1";
//	private static final int _port = 8083;
	private static final String _benutzer = "Tester";
	private static final String _passwort = "geheim";
	private ClientDavConnection _connection = null;

	// private static final String _pidSysObj = "mq.a10.0000";
	// private static final String _pidAtg = "atg.anteilLkwFuzzy";
	// private static final String _pidAsp = "asp.parameterSoll";
	private static final String _pidSysObj = "ske.Fussballspiel";
	private static final String _pidAtg = "atg.systemKalenderEintrag";
	private static final String _pidAspEmpfang = "asp.parameterSoll";
	private static final String _pidAspSenden = "asp.parameterVorgabe";

	private static final short _simVar = 0;

	public static void main(String[] params)
	{
		DaVKommunikationTest test = new DaVKommunikationTest();
	}

	public DaVKommunikationTest()
	{
		davVerbinden();
		testA();
		davTrennen();
	}

	protected void testA()
	{
		DaVKommunikation davKommunikation = new DaVKommunikation(_connection);
		short simvar = 0;
		Data empfangeDaten = davKommunikation.empfangeDaten(_pidSysObj, _pidAtg,
				_pidAspEmpfang, _simVar);

		System.out.println("=> Empfangen: " + empfangeDaten);
		
		
		Data copyData = empfangeDaten.createModifiableCopy();
		
		
		davKommunikation.sendeDaten(_pidSysObj, _pidAtg, _pidAspSenden, _simVar, copyData);
		
		System.out.println("Gesendet!");
	}

	private void davVerbinden()
	{
		try
		{
			_connection = new ClientDavConnection();
			// IP setzen
			_connection.getClientDavParameters().setDavCommunicationAddress(_ip);

			// Port setzen
			_connection.getClientDavParameters().setDavCommunicationSubAddress(_port);

			try
			{
				_connection.connect();

				try
				{
					_connection.login(_benutzer, _passwort);
				} catch (InconsistentLoginException e)
				{
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

			} catch (CommunicationError e)
			{
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (ConnectionException e)
			{
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		} catch (MissingParameterException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private void davTrennen()
	{
		if (_connection != null)
		{
			_connection.disconnect(false, "Kein Fehler");
		}
	}
}
