/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.sts.buv.plugin.workflow.tsf;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.graphics.Image;

/**
 * Liefert die Bilder des Plug-Ins und fhrt fr diese eine
 * {@link ImageRegistry}.
 * 
 * @author HofmannJ
 * 
 */
public class ImageGetter
{
	private static ImageRegistry _ir = new ImageRegistry();

	public static Image getImage(String path)
	{
		Image re = null;

		if (path != null)
		{
			if (_ir.get(path) == null)
			{
				ImageDescriptor id = Activator.getImageDescriptor(path);
				if (id != null)
				{
					_ir.put(path, id);
				}
			}

			re = _ir.get(path);
		}

		return re;
	}

	public static ImageDescriptor getImageDescriptor(String path)
	{
		ImageDescriptor re = null;

		if (path != null)
		{
			if (_ir.get(path) == null)
			{
				ImageDescriptor id = Activator.getImageDescriptor(path);
				if (id != null)
				{
					_ir.put(path, id);
				}
			}

			re = _ir.getDescriptor(path);
		}

		return re;
	}
}
