/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.sts.buv.plugin.workflow.tsf.dav;

import de.bsvrz.dav.daf.main.config.SystemObject;

/**
 * Antwort auf die Aufforderung zum Weiterschalten.
 * <ul>
 * <li>TYP: <code>typ.tsfAbschnitt</code></li>,
 * <li>ATG: <code>atg.tsfWeiterSchaltenAntwort</code></li>,
 * <li>ASP: <code>asp.tsfVorgabe</code>.</li>
 * </ul>
 * 
 * @author HofmannJ
 * 
 */
public class M_TSFWeiterSchaltenAntwort
{
	/**
	 * SystemObjekt, auf welches sich diese Antwort bezieht.
	 */
	private SystemObject _so = null;

	/**
	 * Eindeutige Kennung fr den Dialog.
	 */
	private String _kennung;

	/**
	 * Mgliche Zustnde des Antwortdialogs zu Weiterschlten der TSF.
	 */
	private E_TSFWeiterSchaltenAntwort _befehl;

	public M_TSFWeiterSchaltenAntwort()
	{
	}

	public M_TSFWeiterSchaltenAntwort(SystemObject so)
	{
		setSo(so);
	}

	public SystemObject getSo()
	{
		return _so;
	}

	public void setSo(SystemObject so)
	{
		_so = so;
	}

	public String getKennung()
	{
		return _kennung;
	}

	public void setKennung(String kennung)
	{
		_kennung = kennung;
	}

	/**
	 * Liefert die ID dieser GUI
	 * 
	 * @return
	 */
	public String getId()
	{
		return Defs.getClientId();
	}

	public E_TSFWeiterSchaltenAntwort getBefehl()
	{
		return _befehl;
	}

	public void setBefehl(E_TSFWeiterSchaltenAntwort befehl)
	{
		_befehl = befehl;
	}

	@Override
	public String toString()
	{
		StringBuffer sb = new StringBuffer();

		sb.append(this.getClass().getSimpleName());
		sb.append("\n");

		// SystemObjekt
		sb.append("\tSystemObjekt: ");
		if (getSo() != null)
		{
			sb.append(getSo());
		} else
		{
			sb.append("-");
		}

		// Kennung
		sb.append("\tKennung: ");
		if (getKennung() != null)
		{
			sb.append(getKennung());
		} else
		{
			sb.append("-");
		}
		sb.append("\n");

		// Befehl
		sb.append("\tBefehl: ");
		if (getBefehl() != null)
		{
			sb.append(getBefehl().toString());
		} else
		{
			sb.append("-");
		}

		return sb.toString();
	}

}
