/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.sts.buv.plugin.workflow.tsf.dlg;

import java.awt.Toolkit;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.Timer;
import java.util.TimerTask;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.events.ShellEvent;
import org.eclipse.swt.events.ShellListener;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.PlatformUI;

import de.bsvrz.dav.daf.main.config.SystemObject;
import de.sts.buv.plugin.workflow.tsf.Activator;
import de.sts.buv.plugin.workflow.tsf.DefsFonts;
import de.sts.buv.plugin.workflow.tsf.ImageGetter;
import de.sts.buv.plugin.workflow.tsf.PreferenceInit;
import de.sts.buv.plugin.workflow.tsf.dav.DaVKomTSFAbschnittBefehl;
import de.sts.buv.plugin.workflow.tsf.dav.DaVKomTSFSteuerung;
import de.sts.buv.plugin.workflow.tsf.dav.Defs;
import de.sts.buv.plugin.workflow.tsf.dav.E_TSFBefehl;
import de.sts.buv.plugin.workflow.tsf.dav.E_TSFProgrammZustand;
import de.sts.buv.plugin.workflow.tsf.dav.GUIManager_WorkflowDialog;
import de.sts.buv.plugin.workflow.tsf.dav.M_TSFAbschnittBefehl;
import de.sts.buv.plugin.workflow.tsf.dav.M_TSFWorkflowAbschnitt;
import de.sts.buv.plugin.workflow.tsf.dav.WiedervorlageTSFWorkflowAbschnitt;
import de.sts.buv.plugin.workflow.tsf.dav.WrapperULDInfo;
import de.sts.buv.plugin.workflow.tsf.dav.GUIModelTSFSteuerung.ZustandSammlung;
import de.sts.buv.plugin.workflow.tsf.snd.AePlayWave;

/**
 * 
 * Vereinfachter Workflow zum Bearbeiten eines {@link M_TSFWorkflowAbschnitt}es.
 * Je nach dem wieviele Abschnitte ein Workflow hat, kann dieser Mehrmals
 * auftauchen.
 * 
 * @author HofmannJ
 * 
 */
public class DialogWFEinfach extends Dialog
{
	/**
	 * Shell
	 */
	private Shell shell;

	private static final String HELP_ID = Activator.PLUGIN_ID
			+ ".dialogworkflowabfrage";

	private final int BREITE = 600;
	private final int HOEHE = 350;

	private Object _re = null;

	private Timer _sndTimer;

	private Label _lAbschnitt;

	private Text _tAktion;

	private Text _tUrsache;

	/**
	 * Daten des Workflow-Abschnittes
	 */
	private M_TSFWorkflowAbschnitt _tsfWorkflowAbschnitt = null;

	private Button _buttonTonAusschalten;

	private Button _bSchalten;

	// private PropertyChangeListenerSteuerung _listenerSteuerung;

	private GUIManager_WorkflowDialog _guiManagerWorkflowDialog = null;

	private Button _buttonAblehnen;

	public DialogWFEinfach(Shell parent,
			GUIManager_WorkflowDialog guiManagerWorkflowDialog)
	{
		super(parent);
		this._guiManagerWorkflowDialog = guiManagerWorkflowDialog;
	}

	public Object oeffne(M_TSFWorkflowAbschnitt tsfWorkflowAbschnitt)
	{
		System.out
				.println(">>>>>>>>>>>>>>>>>>>>>>>>>>>> DialogWFEinfach.oeffne() <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<");

		shell = ShellOnTop.getShell(getParent(), SWT.TITLE | SWT.BORDER);

		// shell = ShellOnTop.getShell(getParent(), SWT.TITLE | SWT.BORDER);
		
		 //Fr die F1 Taste
	    PlatformUI.getWorkbench().getHelpSystem().setHelp( shell, HELP_ID );

		shell.addShellListener(new ShellListener()
		{
			@Override
			public void shellActivated(ShellEvent e)
			{
			}

			@Override
			public void shellClosed(ShellEvent e)
			{
				dispose();
			}

			@Override
			public void shellDeactivated(ShellEvent e)
			{
			}

			@Override
			public void shellDeiconified(ShellEvent e)
			{
			}

			@Override
			public void shellIconified(ShellEvent e)
			{
			}
		});

		shell.setText("Empfehlung");

		shell.setLayout(new FillLayout());

		createCompositeImage();

		setData(tsfWorkflowAbschnitt);

		// Zentrieren des Dialogs
		Display display = getParent().getDisplay();

		// Grsse Bildschirm

		Toolkit test = java.awt.Toolkit.getDefaultToolkit();

		/*
		 * Auflsung durch 2 subtrahiert durch die Hlfte der in der Shell
		 * angegebenen Horizontalen, damit der Dialog mittig am Bildschirm erscheint
		 */

		int x = test.getScreenSize().width / 2 - BREITE / 2;

		/*
		 * Auflsung durch 2 subtrahiert durch die Hlfte der in der Shell
		 * angegebenen Verzikalen
		 */

		int y = test.getScreenSize().height / 2 - HOEHE / 2;

		shell.setLocation(x, y);
		shell.setSize(BREITE, HOEHE);

		// shell.pack();

		/*
		 * Statische Anordnung des Dialoges auf dem Bildschirm
		 */
		if ((tsfWorkflowAbschnitt != null)
				&& (tsfWorkflowAbschnitt.getAbschnitt() != null)
				&& (tsfWorkflowAbschnitt.getAbschnitt().getPid() != null))
		{
			Point location = StaticDialogLocation.getInstance().getDlgLoc(
					this.getClass().getName(),
					tsfWorkflowAbschnitt.getAbschnitt().getPid());
			if (location != null)
			{
				shell.setLocation(location);
			}
		}

		shell.open();

		startSoundTimer();

		while (!shell.isDisposed())
			if (!display.readAndDispatch())
				display.sleep();

		return _re;
	}

	public void setData(M_TSFWorkflowAbschnitt tsfWorkflowAbschnitt)
	{
		this._tsfWorkflowAbschnitt = tsfWorkflowAbschnitt;

		// Abschnitt
		if (_tsfWorkflowAbschnitt != null)
		{
			if (_tsfWorkflowAbschnitt.getAbschnitt() != null)
			{
				_lAbschnitt.setText("Abschnitt "
						+ _tsfWorkflowAbschnitt.getAbschnitt().getNameOrPidOrId());
			}
		}

		// Aktion
		if (_tsfWorkflowAbschnitt.getAktion() != null)
		{
			_tAktion.setText(_tsfWorkflowAbschnitt.getAktion().toString());
		} else
		{
			_tAktion.setText("-");
		}

		// Ursache
		if (_tsfWorkflowAbschnitt.getUrsache() != null)
		{
			_tUrsache.setText(_tsfWorkflowAbschnitt.getUrsache().toString());
		} else
		{
			_tUrsache.setText("-");
		}

		// // Listener auf die Steuerung
		// if (_listenerSteuerung == null)
		// {
		// _listenerSteuerung = new PropertyChangeListenerSteuerung(_bSchalten,
		// _tsfWorkflowAbschnitt);
		// }
	}

	public M_TSFWorkflowAbschnitt getData()
	{
		return _tsfWorkflowAbschnitt;
	}

	/**
	 * This method initializes compositeImage
	 * 
	 */
	private void createCompositeImage()
	{
		Composite top = new Composite(shell, SWT.NONE);
		top.setLayout(new GridLayout(1, true));

		// Zeile 0 - Fahrrichtung darstellen
		GridData gdZeile0 = new GridData();
		gdZeile0.grabExcessHorizontalSpace = true;
		gdZeile0.horizontalAlignment = GridData.FILL;
		Composite zeile0 = new Composite(top, SWT.BORDER);
		zeile0.setLayout(new GridLayout(1, false));
		zeile0.setLayoutData(gdZeile0);

		// Zeile 1

		GridData gdZeile1 = new GridData();
		gdZeile1.horizontalAlignment = GridData.FILL;
		gdZeile1.verticalAlignment = GridData.FILL;
		gdZeile1.grabExcessHorizontalSpace = true;
		gdZeile1.grabExcessVerticalSpace = true;

		Composite zeile1 = new Composite(top, SWT.BORDER);
		zeile1.setLayout(new GridLayout(1, false));
		zeile1.setLayoutData(gdZeile1);

		// Zeile 2

		GridData gdZeile2 = new GridData();
		gdZeile2.horizontalAlignment = GridData.FILL;
		gdZeile2.grabExcessHorizontalSpace = true;

		Composite zeile2 = new Composite(top, SWT.BORDER);
		zeile2.setLayout(new GridLayout(5, false));
		zeile2.setLayoutData(gdZeile2);

		addFahrtrichtung(zeile0);
		addProgrammVorschlagHeadline(zeile1);
		addProgrammVorschlagInhalt(zeile1);
		addProgrammButtons(zeile2);
	}

	private void addFahrtrichtung(Composite parent)
	{

		_lAbschnitt = new Label(parent, SWT.None);
//		Font f1 = new Font(null, "Arial", 12, SWT.BOLD);
		_lAbschnitt.setFont(DefsFonts.FONT_ARIAL_12_PKT_BOLD);
		_lAbschnitt.setText("Abschnitt: ");

		GridData gdLAbschnitt = new GridData();
		gdLAbschnitt.grabExcessHorizontalSpace = true;
		gdLAbschnitt.horizontalAlignment = GridData.CENTER;
		_lAbschnitt.setLayoutData(gdLAbschnitt);
	}

	/**
	 * Methode realisiert das Composite mit dem Programmvorschlag
	 * 
	 * @param parent
	 */
	private void addProgrammVorschlagHeadline(Composite parent)
	{
		Composite neu = new Composite(parent, SWT.NONE);
		neu.setLayout(new GridLayout(3, false));
		GridData gdInfoText = new GridData();
		gdInfoText.horizontalAlignment = GridData.FILL;
		gdInfoText.grabExcessHorizontalSpace = true;
		neu.setLayoutData(gdInfoText);

		// Achtung Symbol links

		Label achtungLinks = new Label(neu, SWT.NONE);
		achtungLinks.setImage(ImageGetter.getImage("icons/achtung.png"));

		GridData gridDataAchtungLinks = new GridData();
		gridDataAchtungLinks.horizontalAlignment = GridData.BEGINNING;
		achtungLinks.setLayoutData(gridDataAchtungLinks);

		// Textfeld
		GridData gridDataText = new GridData();
		gridDataText.grabExcessHorizontalSpace = true;
		gridDataText.horizontalAlignment = GridData.CENTER;
		gridDataText.verticalAlignment = GridData.BEGINNING;

		Label labelProgrammVorschlag = new Label(neu, SWT.NONE);
		labelProgrammVorschlag.setLayoutData(gridDataText);

//		Font f1 = new Font(null, "Arial", 16, SWT.BOLD);
		labelProgrammVorschlag.setFont(DefsFonts.FONT_ARIAL_16_PKT_BOLD);

		String v = "\n" + "Aufgrund genderter Indikatoren\n"
				+ "werden vom Steuermodell\n" + "folgende Schaltungen empfohlen:\n\n";

		labelProgrammVorschlag.setText(v);
		labelProgrammVorschlag.setAlignment(SWT.CENTER);

		// Achtung Symbol rechts

		Label achtungRechts = new Label(neu, SWT.NONE);
		achtungRechts.setText("Achtung");
		achtungRechts.setImage(ImageGetter.getImage("icons/achtung.png"));

		GridData gridDataAchtungRechts = new GridData();
		gridDataAchtungRechts.horizontalAlignment = GridData.BEGINNING;
		achtungRechts.setLayoutData(gridDataAchtungLinks);
	}

	private void addProgrammVorschlagInhalt(Composite parent)
	{
		Composite neu = new Composite(parent, SWT.BORDER);

		Label lAktion = new Label(neu, SWT.NONE);
		lAktion.setText("Aktion: ");

		_tAktion = new Text(neu, SWT.BORDER);
		_tAktion.setEditable(false);

		Label lUrsache = new Label(neu, SWT.NONE);
		lUrsache.setText("Ursache: ");

		_tUrsache = new Text(neu, SWT.BORDER);
		_tUrsache.setEditable(false);

		/*
		 * Layout
		 */
		neu.setLayout(new GridLayout(2, false));

		GridData gdCompNeu = new GridData();
		gdCompNeu.grabExcessHorizontalSpace = true;
		gdCompNeu.grabExcessVerticalSpace = true;
		gdCompNeu.horizontalAlignment = GridData.FILL;
		gdCompNeu.verticalAlignment = GridData.FILL;
		neu.setLayoutData(gdCompNeu);

		GridData gdTAktion = new GridData();
		gdTAktion.grabExcessHorizontalSpace = true;
		gdTAktion.horizontalAlignment = GridData.FILL;
		_tAktion.setLayoutData(gdTAktion);

		GridData gdTUrsasche = new GridData();
		gdTUrsasche.grabExcessHorizontalSpace = true;
		gdTUrsasche.horizontalAlignment = GridData.FILL;
		_tUrsache.setLayoutData(gdTUrsasche);

	}

	private void addProgrammButtons(Composite parent)
	{
		GridData gridDataButton = new GridData();
		gridDataButton.horizontalAlignment = GridData.CENTER;
		gridDataButton.grabExcessHorizontalSpace = true;
		gridDataButton.grabExcessVerticalSpace = true;
		gridDataButton.verticalAlignment = GridData.CENTER;
		gridDataButton.minimumWidth = 100;

		_buttonTonAusschalten = new Button(parent, SWT.CENTER);
		_buttonTonAusschalten.setText("&Ton ausschalten");
		_buttonTonAusschalten.setLayoutData(gridDataButton);
		// buttonTonAusschalten.setEnabled(false);
		_buttonTonAusschalten.addSelectionListener(new SelectionListener()
		{
			public void widgetDefaultSelected(SelectionEvent e)
			{
			}

			public void widgetSelected(SelectionEvent e)
			{
				if (_sndTimer != null)
				{
					schalteTonAus();
					_buttonTonAusschalten.setText("&Ton einschalten");
				} else
				{
					startSoundTimer();
					if (_sndTimer != null)
					{
						_buttonTonAusschalten.setText("&Ton ausschalten");
					}
				}
			}
		});
		_buttonTonAusschalten.setEnabled(PreferenceInit.isSndWfAktiv());

		_bSchalten = new Button(parent, SWT.PUSH);
		_bSchalten.setText("&Schalten");
		_bSchalten.setLayoutData(gridDataButton);
		_bSchalten.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionSchalten();
			}
		});

		// Wiedervorlage
		Button buttonWiedervorlage = new Button(parent, SWT.PUSH);
		buttonWiedervorlage.setText("&Wiedervorlage");
		buttonWiedervorlage.setLayoutData(gridDataButton);
		buttonWiedervorlage.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionWiedervorlage();
			}
		});

		// Schalten

		_buttonAblehnen = new Button(parent, SWT.CENTER);
		_buttonAblehnen.setText("&Ablehnen");
		_buttonAblehnen.setLayoutData(gridDataButton);

		_buttonAblehnen.addSelectionListener(new SelectionListener()
		{
			public void widgetDefaultSelected(SelectionEvent e)
			{
			}

			public void widgetSelected(SelectionEvent e)
			{
				aktionAblehnen();
			}
		});

		Button bHilfe = new Button(parent, SWT.PUSH);
		bHilfe.setText("&Hilfe");
		bHilfe.setLayoutData(gridDataButton);
		bHilfe.addSelectionListener(new SelectionListener()
		{

			@Override
			public void widgetDefaultSelected(SelectionEvent e)
			{
			}

			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionHilfe(); //TODO AKTION HILFE
			}

		});

		parent.pack();
	}

	/**
	 * Ordnet einen Butten mit der Pid eines Abschnitts einen
	 * {@link PropertyChangeListener} zu.
	 * 
	 * @author HofmannJ
	 * 
	 */
	private class PropertyChangeListenerSteuerung implements
			PropertyChangeListener
	{
		private Button _button = null;
		private M_TSFWorkflowAbschnitt _tsfWorkflowAbschnitt;

		private PropertyChangeListenerSteuerung(Button button,
				M_TSFWorkflowAbschnitt tsfWorkflowAbschnitt)
		{
			this._button = button;
			this._tsfWorkflowAbschnitt = tsfWorkflowAbschnitt;
			listenerAnmelden();
		}

		public SystemObject getSoTfsAbschnitt()
		{
			SystemObject soTfsAbschnitt = null;

			if (getTsfWorkflowAbschnitt() != null)
			{
				soTfsAbschnitt = getTsfWorkflowAbschnitt().getAbschnitt();
			}

			return soTfsAbschnitt;
		}

		public M_TSFWorkflowAbschnitt getTsfWorkflowAbschnitt()
		{
			return _tsfWorkflowAbschnitt;
		}

		public Button getButton()
		{
			return _button;
		}

		/**
		 * Liefert das lt. Workflow geforderte Zielprogramm
		 * 
		 * @return
		 */
		public E_TSFBefehl getZielProgrammWf()
		{
			E_TSFBefehl zielProgrammWf = null;

			if (getTsfWorkflowAbschnitt() != null)
			{
				M_TSFWorkflowAbschnitt tsfWorkflowAbschnitt = getTsfWorkflowAbschnitt();
				zielProgrammWf = tsfWorkflowAbschnitt.getAktion();

			}

			return zielProgrammWf;
		}

		private void listenerAnmelden()
		{
			if (getSoTfsAbschnitt() != null)
			{
				DaVKomTSFSteuerung.getInstance().getModelVorgabe().addListener(
						getSoTfsAbschnitt(), this);
			}
		}

		private void listenerAbmelden()
		{
			if (getSoTfsAbschnitt() != null)
			{
				DaVKomTSFSteuerung.getInstance().getModelVorgabe().removeListener(
						getSoTfsAbschnitt(), this);
			}
		}

		@Override
		public void propertyChange(PropertyChangeEvent evt)
		{
			if ((evt != null)
					&& (evt.getNewValue() instanceof ZustandSammlung))
			{
				E_TSFBefehl zielProgrammWf = getZielProgrammWf();

				if (zielProgrammWf != null)
				{
					ZustandSammlung sammlung = (ZustandSammlung) evt
							.getNewValue();

					if (sammlung.getSoTfsAbschnitt() == getSoTfsAbschnitt())
					{
						/*
						 * ZielProgramm lt. Steuerung muss dem geforderten Zielprogramm des
						 * Workflows entsprechen.
						 */
						boolean istZielPrgGeschaltet = false;
						boolean istSchaltvorgangImGange = false;
						if ((sammlung.getZielProgramm() != null)
								&& (sammlung.getZielProgramm() == zielProgrammWf))
						{
							if ((sammlung.getProgrammZustand() != null)
									&& (sammlung.getProgrammZustand() == E_TSFProgrammZustand.Geschaltet))
							{
								istZielPrgGeschaltet = true;
							}

							if (sammlung.getProgrammZustand() == E_TSFProgrammZustand.In_Bearbeitung)
							{
								istSchaltvorgangImGange = true;
							}
						}

						boolean buttonAktivieren = ((!istZielPrgGeschaltet) && (!istSchaltvorgangImGange));

						if (getButton() != null)
						{
							final boolean fButtonAktivieren = buttonAktivieren;

							Runnable run = new Runnable()
							{
								@Override
								public void run()
								{
									/*
									 * Button aktivieren/deaktivieren nur wenn ntig.
									 */
									if (getButton().isEnabled() != fButtonAktivieren)
									{
										getButton().setEnabled(fButtonAktivieren);
										System.out
												.println(">>> Setze Button auf " + fButtonAktivieren
														+ " fr Abs " + getSoTfsAbschnitt());
									}

								}
							};
							PlatformUI.getWorkbench().getDisplay().asyncExec(run);

						}
					}
				}
			}
		}

		public void dispose()
		{
			listenerAbmelden();
		}
	}

	private void aktionSchalten()
	{
		if (getData() != null)
		{
			M_TSFWorkflowAbschnitt workflowAbschnitt = getData();
			E_TSFBefehl aktion = workflowAbschnitt.getAktion();
			M_TSFAbschnittBefehl befehl = new M_TSFAbschnittBefehl(
					Defs.getClientId(), workflowAbschnitt.getAbschnitt(), aktion,
					E_TSFProgrammZustand.Undefiniert);
			WrapperULDInfo sendeAbschnittBefehl = DaVKomTSFAbschnittBefehl
					.getInstance().sendeAbschnittBefehl(befehl);
			// if (sendeAbschnittBefehl != null)
			// {
			// /*
			// * Nur Schlieen wenn erfolgreich versandt
			// */
			// if ((sendeAbschnittBefehl.getFehlerInfo() == null)
			// && (sendeAbschnittBefehl.getUldInfo().getEingabeOk()))
			// {
			// _bSchalten.setEnabled(false);
			// dispose();
			// }
			// }
			_bSchalten.setEnabled(false);
			dispose();
		}
	}

	/**
	 * Als Aktion zum Ablehnen soll nach Absprache mit Rolf Asal die
	 * Schnellfreigabe gesendet werden.
	 */
	private void aktionAblehnen()
	{
		if (getData() != null)
		{
			M_TSFWorkflowAbschnitt workflowAbschnitt = getData();
			M_TSFAbschnittBefehl befehl = new M_TSFAbschnittBefehl(
					Defs.getClientId(), workflowAbschnitt.getAbschnitt(),
					E_TSFBefehl.Schnellfreigabe, E_TSFProgrammZustand.Undefiniert);
			WrapperULDInfo sendeAbschnittBefehl = DaVKomTSFAbschnittBefehl
					.getInstance().sendeAbschnittBefehl(befehl);
			// /*
			// * Nur Schlieen wenn erfolgreich versandt.
			// */
			// if (sendeAbschnittBefehl != null)
			// {
			// if ((sendeAbschnittBefehl.getFehlerInfo() == null)
			// && (sendeAbschnittBefehl.getUldInfo().getEingabeOk()))
			// {
			// _bSchalten.setEnabled(false);
			// _buttonAblehnen.setEnabled(false);
			// // dispose();
			// }
			// }
			_bSchalten.setEnabled(false);
			_buttonAblehnen.setEnabled(false);
			dispose();
		}
	}

	private void aktionWiedervorlage()
	{
		if (getData() != null)
		{
			new WiedervorlageTSFWorkflowAbschnitt(getData(), null);
			dispose();
		}
	}

	public void dispose()
	{
		// /*
		// * Listener auf die Steuerung abmelden.
		// */
		// if (_listenerSteuerung != null)
		// {
		// _listenerSteuerung.dispose();
		// _listenerSteuerung = null;
		// }

		/*
		 * Von Gui-Manager entfernen
		 */
		if (_guiManagerWorkflowDialog != null)
		{
			_guiManagerWorkflowDialog.removeDialogEinfach(this);
		}

		/*
		 * Sound aus
		 */
		schalteTonAus();

		// Shell disposen
		if (!shell.isDisposed())
			shell.dispose();
	}

	private Timer startSoundTimer()
	{
		if (PreferenceInit.isSndWfAktiv())
		{
			if (_sndTimer == null)
			{
				int delaySndWf = PreferenceInit.getDelaySndWf();
				final String pathSndWf = PreferenceInit.getPathSndWf();

				TimerTask sndTask = new TimerTask()
				{
					@Override
					public void run()
					{
						new AePlayWave(pathSndWf).start();
					}
				};

				_sndTimer = new Timer("WF Timer");
				_sndTimer.schedule(sndTask, 0l, delaySndWf * 1000l);
			}
		}

		return _sndTimer;
	}

	private void schalteTonAus()
	{
		if (_sndTimer != null)
		{
			_sndTimer.cancel();
			_sndTimer = null;
		}
	}

	private void aktionHilfe()
	{
		 PlatformUI.getWorkbench().getHelpSystem().displayHelp(HELP_ID);
	}
}
