/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.sts.buv.plugin.workflow.tsf.jface;

import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.PlatformUI;

public class ShellTools
{
	public static Shell getRootShell()
	{
		Shell rootShell = null;
		Shell activeShell = PlatformUI.getWorkbench().getDisplay().getActiveShell();
		if (activeShell != null)
		{
			rootShell = bestimmeRootShell(activeShell);
		}
		return rootShell;
	}

	/**
	 * Bestimmt ausgehend von einer Shell an Hand deren Parent-Widgets rekursiv
	 * die Wurzel-Shell des Systems.
	 * 
	 * @param shell
	 *          Shell, deren Wurzel-Shell bestimmt werden soll.
	 * @return Wurzel-Shell (kann <code>null</code> sein wenn nicht bestimmbar
	 *         oder die bergebene Shell).
	 */
	public static Shell bestimmeRootShell(Shell shell)
	{
		Shell root = null;

		if (shell != null)
		{
			if ((shell.getParent() != null) && (!shell.getParent().isDisposed())
					&& (shell.getParent() instanceof Shell))
			{
				root = bestimmeRootShell((Shell) shell.getParent());
			} else
			{
				root = shell;
			}
		}

		return root;
	}
}
