/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.sts.buv.plugin.workflow.tsf.jface;

import java.util.Timer;
import java.util.TimerTask;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IPartListener;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.part.ViewPart;

import de.sts.buv.plugin.workflow.tsf.dlg.TestPerspectiveListener;
import de.sts.buv.plugin.workflow.tsf.dlg.ViewWeiterschalten;

public class ViewTestShellModality extends ViewPart
{
	public static final String ID = "de.sts.buv.plugin.workflow.tsf.jface.ID";

	@Override
	public void createPartControl(Composite parent)
	{
		PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage()
				.addPartListener(new IPartListener()
				{

					@Override
					public void partOpened(IWorkbenchPart part)
					{
					}

					@Override
					public void partDeactivated(IWorkbenchPart part)
					{
					}

					@Override
					public void partClosed(IWorkbenchPart part)
					{
//						System.out.println("=> " + part.getClass().getName());
//						if (part instanceof ViewTestShellModality)
//						{
//							ViewTestShellModality view = (ViewTestShellModality) part;
//							Shell shella = view.getSite().getShell();
//							if (shella != null)
//							{
//								System.out.println("SHELL=> " + shella + " SIZE="
//										+ shella.getSize());
//							}
//
//							IWorkbenchWindow dw = PlatformUI.getWorkbench()
//									.getActiveWorkbenchWindow();
//							IWorkbenchPage page = dw.getActivePage();
//
//							try
//							{
//								page.showView(ViewTestShellModality.ID);
//
//								IViewReference ref = page
//										.findViewReference(ViewTestShellModality.ID);
//								((WorkbenchPage) page).getActivePerspective().getPresentation()
//										.detachPart(ref);
//								IWorkbenchPart wbPart = ref.getPart(false);
//								Shell shell = wbPart.getSite().getShell();
//								shell.setSize(400, 200);
//								shell.setLocation(10, 10);
//
//								// Wieder in den Vordergrund bringen.
//								shell.setActive();
//
//							} catch (PartInitException e)
//							{
//								e.printStackTrace();
//							}
//
//							PlatformUI.getWorkbench().getActiveWorkbenchWindow()
//									.getActivePage().removePartListener(this);
//							System.out.println("PartListener entfernt");
//						}
					}

					@Override
					public void partBroughtToTop(IWorkbenchPart part)
					{
					}

					@Override
					public void partActivated(IWorkbenchPart part)
					{
					}
				});

	
		/*
		 * Gre Registrieren
		 */
		final Shell shell = this.getViewSite().getWorkbenchWindow().getShell();
		shell.addListener (SWT.Resize,  new Listener () {
	    public void handleEvent (Event e) {
	      Rectangle rect = shell.getClientArea ();
	      System.out.println(rect);
	    }
	  });
//		final Shell shell = this.getSite().getShell();
//		shell.addListener (SWT.Resize,  new Listener () {
//			public void handleEvent (Event e) {
//				Rectangle rect = shell.getClientArea ();
//				System.out.println(rect);
//			}
//		});
		
		
		

		
		
		
		

		parent.setLayout(new RowLayout());

		Button bu = new Button(parent, SWT.PUSH);
		bu.setText("Test Modalitt");
		bu.addSelectionListener(new SelectionAdapter()
		{

			@Override
			public void widgetSelected(SelectionEvent e)
			{
				// Shell shell =
				// PlatformUI.getWorkbench().getDisplay().getActiveShell();
				Shell shell = ShellTools.getRootShell();

				new ShellTest(shell);
			}

		});

		Button ak = new Button(parent, SWT.PUSH);
		ak.setText("Erzeuge Shells Zeitverzgert");
		ak.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				TimerTask task = new TimerTask()
				{
					@Override
					public void run()
					{
						Runnable run = new Runnable()
						{
							@Override
							public void run()
							{
								// Shell shell = PlatformUI.getWorkbench().getDisplay()
								// .getActiveShell();
								Shell shell = ShellTools.getRootShell();
								for (int i = 0; i < 4; i++)
								{
									ShellTest.createChildWindow(shell, "Verzgert #" + i,
											20 + (i * 200), 50);
								}
							}
						};

						PlatformUI.getWorkbench().getDisplay().asyncExec(run);
					}
				};

				Timer timer = new Timer("Do it l8r");
				timer.schedule(task, 5000l);
			}
		});
		
		
		Button bTestViewWeiterschalten = new Button(parent, SWT.PUSH);
		bTestViewWeiterschalten.setText("Weiterschalten View Anzeigen");
		bTestViewWeiterschalten.addSelectionListener(new SelectionAdapter()
		{

			@Override
			public void widgetSelected(SelectionEvent e)
			{
				ViewWeiterschalten.zeigeViewWeiterschalten("tsf.mainzerring.bereich1.abschnitt2.FRKaiserslautern");
			}
			
		});
		
		
		Button bTestPerspectiveListener = new Button(parent, SWT.PUSH);
		bTestPerspectiveListener.setText("Test PerspectiveListener");
		bTestPerspectiveListener.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				new TestPerspectiveListener();
			}
		});
	}

	@Override
	public void setFocus()
	{
	}

}
